  PROGRAM carre
  USE netcdf
  IMPLICIT none
!
! pgf90 -r8 analyse_divergence_nwp.F90 -I/distrib/local/netcdf-4.0.1/pgi_7.1-6_32/include -L/distrib/local/netcdf-4.0.1/pgi_7.1-6_32/lib -lnetcdf
!
!***********************************************************************
!
  INTEGER, PARAMETER :: nbsimuls=16
  CHARACTER(len=2) :: simul(0:nbsimuls)=(/"01","01","02","03","04","05","06","07","08",&
                                               "09","10","11","12","13","14","15","16"/)
!
  REAL, allocatable :: mask(:,:)
  LOGICAL, allocatable :: ok(:,:)
  REAL, PARAMETER :: missing=-99999.0
!
  INTEGER :: iim, jjm, nb
!
  CHARACTER(LEN=80) :: tapename ! File to deal with
!
  INTEGER :: mid, ierr, varid
!
  REAL, ALLOCATABLE :: x(:), y(:) ! longitudes, latitudes
  REAL, ALLOCATABLE :: t2m(:,:,:,:), ave_t2m(:,:), cor_t2m(:,:), rms_t2m(:,:)
  REAL, ALLOCATABLE :: slp(:,:,:,:), ave_slp(:,:), cor_slp(:,:), rms_slp(:,:)
  REAL, ALLOCATABLE :: z500(:,:,:,:), ave_z500(:,:), cor_z500(:,:), rms_z500(:,:)
!
  INTEGER :: i, j, k, n, ns
!
!!  tapename=simul(0)//"/histday_surface.nc"
  tapename=simul(0)//"/histday_select.nc"
!
  CALL lire_dims2d(tapename,"x",iim,"y",jjm,"time_counter",nb)
  PRINT*, iim,jjm,nb
!
  ALLOCATE ( x(iim), y(jjm) ) ! longitudes, latitudes et pressions
!
  ALLOCATE (mask(iim,jjm))
  ALLOCATE (ok(iim,jjm))
  mask = 1.0
  ok = .TRUE.
!
  CALL lire_xy(tapename, iim,"x",x,jjm,"y",y)
!
  DO j = 1, jjm
  DO i = 1, iim
     IF (y(j).GE.30.0) THEN
        ok(i,j) = .TRUE.
     ELSE
        ok(i,j) = .FALSE.
     ENDIF
  ENDDO
  ENDDO
!
  ALLOCATE ( t2m(iim,jjm,nb,0:nbsimuls), ave_t2m(iim,jjm), cor_t2m(nb,nbsimuls), rms_t2m(nb,nbsimuls) )
  ALLOCATE ( slp(iim,jjm,nb,0:nbsimuls), ave_slp(iim,jjm), cor_slp(nb,nbsimuls), rms_slp(nb,nbsimuls) )
  ALLOCATE ( z500(iim,jjm,nb,0:nbsimuls), ave_z500(iim,jjm), cor_z500(nb,nbsimuls), rms_z500(nb,nbsimuls) )
!
  DO ns = 0, nbsimuls
!!     ierr = NF90_OPEN (simul(ns)//"/histday_surface.nc", NF90_NOWRITE,mid)
     ierr = NF90_OPEN (simul(ns)//"/histday_select.nc", NF90_NOWRITE,mid)
     IF (ierr.NE.NF90_NOERR) THEN
        PRINT*, "Probleme d ouverture du fichier:"//simul(ns)
        CALL abort
     ENDIF
     DO n = 1, nb
        CALL lire_var3d(mid,"t2m",iim,jjm,n,t2m(1:iim,1:jjm,n,ns))
        CALL lire_var3d(mid,"slp",iim,jjm,n,slp(1:iim,1:jjm,n,ns))
     ENDDO
     ierr = NF90_CLOSE(mid)
  ENDDO
  slp = slp/100.0
  t2m = t2m - 273.16
!
  DO ns = 0, nbsimuls
!!     ierr = NF90_OPEN (simul(ns)//"/histday_stdlevs.nc", NF90_NOWRITE,mid)
     ierr = NF90_OPEN (simul(ns)//"/histday_select.nc", NF90_NOWRITE,mid)
     IF (ierr.NE.NF90_NOERR) THEN
        PRINT*, "Probleme d ouverture du fichier:"//simul(ns)
        CALL abort
     ENDIF
     DO n = 1, nb
        CALL lire_var_hpa(mid,"geop",iim,jjm,n,z500(1:iim,1:jjm,n,ns))
     ENDDO
     ierr = NF90_CLOSE(mid)
  ENDDO
  z500 = z500/9.81
!
  ave_t2m = 0.0
  ave_slp = 0.0
  ave_z500 = 0.0
  DO ns = 0, nbsimuls
  DO n = 1, nb
  DO j = 1, jjm
  DO i = 1, iim
     ave_t2m(i,j) = ave_t2m(i,j) + t2m(i,j,n,ns)/(nbsimuls+1)/nb
     ave_slp(i,j) = ave_slp(i,j) + slp(i,j,n,ns)/(nbsimuls+1)/nb
     ave_z500(i,j) = ave_z500(i,j) + z500(i,j,n,ns)/(nbsimuls+1)/nb
  ENDDO
  ENDDO
  ENDDO
  ENDDO
!
  CALL ecrit_netcdf2d("ave_t2m.nc",iim,jjm,x,y,mask,missing,1,ave_t2m)
  CALL ecrit_netcdf2d("ave_slp.nc",iim,jjm,x,y,mask,missing,1,ave_slp)
  CALL ecrit_netcdf2d("ave_z500.nc",iim,jjm,x,y,mask,missing,1,ave_z500)
!
  DO ns = 0, nbsimuls
  DO n = 1, nb
  DO j = 1, jjm
  DO i = 1, iim
     t2m(i,j,n,ns) = t2m(i,j,n,ns) - ave_t2m(i,j)
     slp(i,j,n,ns) = slp(i,j,n,ns) - ave_slp(i,j)
     z500(i,j,n,ns) = z500(i,j,n,ns) - ave_z500(i,j)
  ENDDO
  ENDDO
  ENDDO
  ENDDO
!
  DO ns = 1, nbsimuls
  DO n = 1, nb
  CALL correlation(t2m(1:iim,1:jjm,n,0), t2m(1:iim,1:jjm,n,ns), ok, iim*jjm, cor_t2m(n,ns))
  CALL rootmeansquare(t2m(1:iim,1:jjm,n,0), t2m(1:iim,1:jjm,n,ns), ok, iim*jjm, rms_t2m(n,ns))
  CALL correlation(slp(1:iim,1:jjm,n,0), slp(1:iim,1:jjm,n,ns), ok, iim*jjm, cor_slp(n,ns))
  CALL rootmeansquare(slp(1:iim,1:jjm,n,0), slp(1:iim,1:jjm,n,ns), ok, iim*jjm, rms_slp(n,ns))
  CALL correlation(z500(1:iim,1:jjm,n,0), z500(1:iim,1:jjm,n,ns), ok, iim*jjm, cor_z500(n,ns))
  CALL rootmeansquare(z500(1:iim,1:jjm,n,0), z500(1:iim,1:jjm,n,ns), ok, iim*jjm, rms_z500(n,ns))
  ENDDO
  ENDDO
!
  PRINT*, "cor_slp:"
  DO n = 1, nb
     WRITE(*,'(16f6.2)') (cor_slp(n,ns),ns=1,nbsimuls)
  ENDDO
  DO n = 1, nb
     WRITE(*,'(16f6.1)') (rms_slp(n,ns),ns=1,nbsimuls)
  ENDDO
!
  PRINT*, "cor_t2m:"
  DO n = 1, nb
     WRITE(*,'(16f6.2)') (cor_t2m(n,ns),ns=1,nbsimuls)
  ENDDO
  DO n = 1, nb
     WRITE(*,'(16f6.1)') (rms_t2m(n,ns),ns=1,nbsimuls)
  ENDDO
!
  PRINT*, "cor_z500:"
  DO n = 1, nb
     WRITE(*,'(16f6.2)') (cor_z500(n,ns),ns=1,nbsimuls)
  ENDDO
  DO n = 1, nb
     WRITE(*,'(16f6.1)') (rms_z500(n,ns),ns=1,nbsimuls)
  ENDDO
!
  END
!
  SUBROUTINE lire_dims2d(ficnom,lon,iim,lat,jjm,time,nb)
!
! Evaluer la longeur des dimensions du fichier LMDZ
!
  USE netcdf
  IMPLICIT none
!
  CHARACTER(len=*), INTENT(in) :: ficnom
  CHARACTER(len=*), INTENT(in) :: lon, lat, time
  INTEGER, INTENT(out) :: iim, jjm, nb
  INTEGER :: ierr, id_nc, id_tmp
!
  ierr = NF90_OPEN(ficnom, NF90_NOWRITE, id_nc)
  IF (ierr.NE.NF90_NOERR) THEN
     PRINT*, "Probleme d ouverture du fichier", ficnom
     CALL abort
  ENDIF
!
  ierr = NF90_INQ_DIMID (id_nc,lon,id_tmp)
  IF (ierr.NE.NF90_NOERR) THEN
     PRINT*, "Probleme pour avoir identificateur dim lon"
     CALL abort
  ENDIF
  ierr = NF90_INQUIRE_DIMENSION(id_nc, id_tmp, LEN=iim)
  IF (ierr.NE.NF90_NOERR) THEN
     PRINT*, "Probleme pour evaluer la longeur de lon"
     CALL abort
  ENDIF
!
  ierr = NF90_INQ_DIMID (id_nc,lat,id_tmp)
  IF (ierr.NE.NF90_NOERR) THEN
     PRINT*, "Probleme pour avoir identificateur dim lat"
     CALL abort
  ENDIF
  ierr = NF90_INQUIRE_DIMENSION(id_nc, id_tmp, LEN=jjm)
  IF (ierr.NE.NF90_NOERR) THEN
     PRINT*, "Probleme pour evaluer la longeur de lat"
     CALL abort
  ENDIF
!
  ierr = NF90_INQ_DIMID (id_nc,time,id_tmp)
  IF (ierr.NE.NF90_NOERR) THEN
     PRINT*, "Probleme pour avoir identificateur dim time"
     CALL abort
  ENDIF
  ierr = NF90_INQUIRE_DIMENSION(id_nc, id_tmp, LEN=nb)
  IF (ierr.NE.NF90_NOERR) THEN
     PRINT*, "Probleme pour evaluer la longeur de time"
     CALL abort
  ENDIF
!
  ierr = NF90_CLOSE(id_nc)
!
  END SUBROUTINE lire_dims2d
!
  SUBROUTINE lire_xy(tapename,iim,lon,x,jjm,lat,y)
  USE netcdf
  IMPLICIT none
!
  CHARACTER(len=*), INTENT(IN) :: tapename
!
  INTEGER, INTENT(IN) :: iim, jjm
  CHARACTER(LEN=*), INTENT(IN) :: lon, lat
  REAL, INTENT(OUT) :: x(iim), y(jjm)
!
  INTEGER :: mid
  INTEGER :: ierr, varid, i, j, k
!
! Ouvrir le fichier brut pour extraire les coordonnees:
!
  ierr = NF90_OPEN (tapename, NF90_NOWRITE,mid)
  IF (ierr.NE.NF90_NOERR) THEN
     PRINT*, "Probleme d ouverture du fichier coordonnees"
     CALL abort
  ENDIF

  ierr = NF90_INQ_DIMID(mid,lon,varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour avoir DIMidentificateur de lon"
         CALL abort
      ENDIF
  ierr = NF90_INQUIRE_DIMENSION(mid,varid,LEN=i)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour avoir la longueur de lon"
         CALL abort
      ENDIF
      IF (i.NE.iim) THEN
         PRINT*, "Dimension lon fausse:", i, iim
         CALL abort
      ENDIF
  ierr = NF90_INQ_VARID (mid,lon,varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur lon"
         CALL abort
      ENDIF
  ierr = NF90_GET_VAR(mid, varid, x, START=(/1/),COUNT=(/iim/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour extraire lon"
         CALL abort
      ENDIF
!
  ierr = NF90_INQ_DIMID(mid,lat,varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour avoir DIMidentificateur de lat"
         CALL abort
      ENDIF
  ierr = NF90_INQUIRE_DIMENSION(mid,varid,LEN=j)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour avoir la longueur de y"
         CALL abort
      ENDIF
      IF (j.NE.jjm) THEN
         PRINT*, "Dimension lat fausse:", j, jjm
         CALL abort
      ENDIF
  ierr = NF90_INQ_VARID (mid,lat,varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur lat"
         CALL abort
      ENDIF
      ierr = NF90_GET_VAR(mid, varid, y, START=(/1/),COUNT=(/jjm/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour extraire lat"
         CALL abort
      ENDIF
!
  ierr = NF90_CLOSE(mid)
!
  END SUBROUTINE lire_xy
!
  SUBROUTINE lire_var3d(lid,varname,iim,jjm,n,var)
      USE netcdf
      IMPLICIT none
!
      INTEGER lid, iim,jjm,n,debut3(3), epais3(3)
      REAL var(iim,jjm)
      CHARACTER*(*) varname
      INTEGER varid, ierr
!
      REAL scale_factor, add_offset
!
      debut3(1) = 1
      debut3(2) = 1
      debut3(3) = n
      epais3(1) = iim
      epais3(2) = jjm
      epais3(3) = 1
!
      ierr = NF90_INQ_VARID(lid,varname, varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur"
         CALL abort
      ENDIF
      ierr = NF90_GET_VAR(lid,varid,var,debut3,epais3)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour extraire"
         CALL abort
      ENDIF
!
      ierr = NF90_GET_ATT(lid,varid,"scale_factor",scale_factor)
      IF (ierr.NE.NF90_NOERR) THEN
!cc         PRINT*, "Probleme pour extraire scale_factor"
!cc         CALL abort
         scale_factor = 1.0
      ENDIF
      ierr = NF90_GET_ATT(lid,varid,"add_offset",add_offset)
      IF (ierr.NE.NF90_NOERR) THEN
!cc         PRINT*, "Probleme pour extraire add_offset"
!cc         CALL abort
         add_offset = 0.0
      ENDIF
      var = var * scale_factor + add_offset
!
  END SUBROUTINE lire_var3d
!
  SUBROUTINE lire_var_hpa(lid,varname,iim,jjm,n,var)
      USE netcdf
      IMPLICIT none
!
      INTEGER lid, iim,jjm,n,debut4(4), epais4(4)
      REAL var(iim,jjm)
      CHARACTER*(*) varname
      INTEGER varid, ierr
      REAL scale_factor, add_offset
!
!!      INTEGER, PARAMETER :: hpa = 6 ! 500 hPa
      INTEGER, PARAMETER :: hpa = 1 ! 500 hPa
!
      debut4(1) = 1
      debut4(2) = 1
      debut4(3) = hpa
      debut4(4) = n
      epais4(1) = iim
      epais4(2) = jjm
      epais4(3) = 1
      epais4(4) = 1
!
      ierr = NF90_INQ_VARID(lid,varname, varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur"
         CALL abort
      ENDIF
      ierr = NF90_GET_VAR(lid,varid,var,debut4,epais4)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour extraire"
         CALL abort
      ENDIF
!
      ierr = NF90_GET_ATT(lid,varid,"scale_factor",scale_factor)
      IF (ierr.NE.NF90_NOERR) THEN
!cc         PRINT*, "Probleme pour extraire scale_factor"
!cc         CALL abort
         scale_factor = 1.0
      ENDIF
      ierr = NF90_GET_ATT(lid,varid,"add_offset",add_offset)
      IF (ierr.NE.NF90_NOERR) THEN
!cc         PRINT*, "Probleme pour extraire add_offset"
!cc         CALL abort
         add_offset = 0.0
      ENDIF
      var = var * scale_factor + add_offset
!
      RETURN
  END SUBROUTINE lire_var_hpa
!
  SUBROUTINE ecrit_netcdf2d(ficnom,iim,jjm,x,y,mask,missing,nb,vari)
      USE netcdf
      IMPLICIT none
!
! write quickly a time-varying horizontal 2D variable
!
      CHARACTER*(*) ficnom
      INTEGER iim, jjm, nb
      REAL x(iim), y(jjm), mask(iim,jjm)
      REAL vari(iim,jjm,nb)
      REAL missing
      REAL bidon
!
      INTEGER ierr, mid, varid
      INTEGER idim_x, idim_y, idim_t
      INTEGER dims2(2), dims3(3)
!
      INTEGER id_time, id_vari, n
!
      INTEGER debu3(3), epai3(3)
!
! Ouvrir le fichier a ecrire:
!
      ierr = NF90_CREATE(ficnom, NF90_CLOBBER, mid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme d ouverture du fichier:"//ficnom
         CALL abort
      ENDIF
!
! Preciser quelques attributs globaux:
!
      ierr = NF90_PUT_ATT (mid, NF90_GLOBAL, "title", &
                             "Ecriture rapide d un champ 2D")
      ierr = NF90_PUT_ATT (mid, NF90_GLOBAL, "model", &
                             "Resultats issus d un diagnostique")
!
! Definir les dimensions du fichier:
!
      ierr = NF90_DEF_DIM(mid,"x",iim,idim_x)
      ierr = NF90_DEF_DIM(mid,"y",jjm,idim_y)
      ierr = NF90_DEF_DIM(mid, "time", NF90_UNLIMITED, idim_t)
!
      ierr = NF90_ENDDEF(mid) ! sortir du mode de definition
!
! Definir et enregistrer certains champs invariants:
!
      ierr = NF90_REDEF (mid)
      ierr = NF90_DEF_VAR (mid,"x",NF90_FLOAT,(/idim_x/),varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir x"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT (mid, varid, "long_name", "Longitudes")
      ierr = NF90_PUT_ATT (mid, varid, "short_name", "x")
      ierr = NF90_PUT_ATT (mid, varid, "units", "degrees_east")
      ierr = NF90_ENDDEF(mid)
      ierr = NF90_PUT_VAR(mid,varid,x,(/1/),(/iim/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer x"
         CALL abort
      ENDIF
!
      ierr = NF90_REDEF (mid)
      ierr = NF90_DEF_VAR (mid,"y",NF90_FLOAT,(/idim_y/),varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir y"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT (mid, varid, "long_name", "Latitudes")
      ierr = NF90_PUT_ATT (mid, varid, "short_name", "y")
      ierr = NF90_PUT_ATT (mid, varid, "units", "degrees_north")
      ierr = NF90_ENDDEF(mid)
      ierr = NF90_PUT_VAR(mid,varid,y,(/1/),(/jjm/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer y"
         CALL abort
      ENDIF
!
      dims2(1) = idim_x
      dims2(2) = idim_y
!
      ierr = NF90_REDEF (mid)
      ierr = NF90_DEF_VAR (mid,"mask",NF90_FLOAT,(/dims2/),varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir mask"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT (mid,varid,"long_name","Masque")
      ierr = NF90_PUT_ATT (mid, varid, "short_name", "mask")
      ierr = NF90_PUT_ATT (mid, varid, "units", "-")
      ierr = NF90_ENDDEF(mid)
      ierr = NF90_PUT_VAR(mid,varid,mask,(/1,1/),(/iim,jjm/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer mask"
         CALL abort
      ENDIF
!
! Definir les variables pour enregistrement ulterieur:
!
      ierr = NF90_REDEF (mid)
!
      ierr = NF90_DEF_VAR (mid,"time", NF90_FLOAT,(/idim_t/),id_time)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir time"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT(mid,id_time,"long_name","time counter")
      ierr = NF90_PUT_ATT(mid,id_time,"short_name","time")
      ierr = NF90_PUT_ATT(mid,id_time,"units","days since 1-1-1")
      ierr = NF90_PUT_ATT(mid,id_time,"note", "Il peut etre n importe quoi")
!
      dims3(1) = idim_x
      dims3(2) = idim_y
      dims3(3) = idim_t
!
      ierr = NF90_DEF_VAR (mid,"vari",NF90_FLOAT,(/dims3/),id_vari)
      ierr = NF90_PUT_ATT(mid,id_vari,"long_name","Variable")
      ierr = NF90_PUT_ATT(mid,id_vari,"short_name","vari")
      ierr = NF90_PUT_ATT(mid,id_vari,"units","-")
      ierr = NF90_PUT_ATT(mid,id_vari,"missing_value",missing)
!
      ierr = NF90_ENDDEF(mid)
!
      DO 99999 n = 1, nb
!
        bidon = FLOAT(n)
        ierr = NF90_PUT_VAR(mid,id_time,bidon,START=(/n/))
        IF (ierr.NE.NF90_NOERR) THEN
           PRINT*, "Probleme pour enregistrer time"
           CALL abort
        ENDIF
!
        debu3(1) = 1
        debu3(2) = 1
        debu3(3) = n
        epai3(1) = iim
        epai3(2) = jjm
        epai3(3) = 1
!
        ierr = NF90_PUT_VAR(mid,id_vari,vari(1:iim,1:jjm,n:n),START=debu3,COUNT=epai3)
        IF (ierr.NE.NF90_NOERR) THEN
           PRINT*, "Probleme pour enregistrer vari"
           CALL abort
        ENDIF
!
99999 CONTINUE
      ierr = NF90_CLOSE(mid)
!
  END SUBROUTINE ecrit_netcdf2d
!
  SUBROUTINE ecrit_netcdf3d(ficnom,iim,jjm,kkm,x,y,z,mask,missing,nb,vari)
      USE netcdf
      IMPLICIT none
!
! write quickly a time-varying 3D variable
!
      CHARACTER*(*) ficnom
      INTEGER iim, jjm, kkm, nb
      REAL x(iim), y(jjm), z(kkm), mask(iim,jjm)
      REAL vari(iim,jjm,kkm,nb)
      REAL missing
      REAL bidon
!
      INTEGER ierr, mid, varid
      INTEGER idim_x, idim_y, idim_z, idim_t
      INTEGER dims2(2), dims4(4)
!
      INTEGER id_time, id_vari, n
!
      INTEGER debu4(4), epai4(4)
!
! Ouvrir le fichier a ecrire:
!
      ierr = NF90_CREATE(ficnom, NF90_CLOBBER, mid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme d ouverture du fichier:"//ficnom
         CALL abort
      ENDIF
!
! Preciser quelques attributs globaux:
!
      ierr = NF90_PUT_ATT (mid, NF90_GLOBAL, "title", &
                             "Ecriture rapide d un champ 3D")
      ierr = NF90_PUT_ATT (mid, NF90_GLOBAL, "model", &
                             "Resultats issus d un diagnostique")
!
! Definir les dimensions du fichier:
!
      ierr = NF90_DEF_DIM(mid,"x",iim,idim_x)
      ierr = NF90_DEF_DIM(mid,"y",jjm,idim_y)
      ierr = NF90_DEF_DIM(mid,"z",kkm,idim_z)
      ierr = NF90_DEF_DIM(mid, "time", NF90_UNLIMITED, idim_t)
!
      ierr = NF90_ENDDEF(mid) ! sortir du mode de definition
!
! Definir et enregistrer certains champs invariants:
!
      ierr = NF90_REDEF (mid)
      ierr = NF90_DEF_VAR (mid,"x",NF90_FLOAT,(/idim_x/),varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir x"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT (mid, varid, "long_name", "Longitudes")
      ierr = NF90_PUT_ATT (mid, varid, "short_name", "x")
      ierr = NF90_PUT_ATT (mid, varid, "units", "degrees_east")
      ierr = NF90_ENDDEF(mid)
      ierr = NF90_PUT_VAR(mid,varid,x,(/1/),(/iim/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer x"
         CALL abort
      ENDIF
!
      ierr = NF90_REDEF (mid)
      ierr = NF90_DEF_VAR (mid,"y",NF90_FLOAT,(/idim_y/),varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir y"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT (mid, varid, "long_name", "Latitudes")
      ierr = NF90_PUT_ATT (mid, varid, "short_name", "y")
      ierr = NF90_PUT_ATT (mid, varid, "units", "degrees_north")
      ierr = NF90_ENDDEF(mid)
      ierr = NF90_PUT_VAR(mid,varid,y,(/1/),(/jjm/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer y"
         CALL abort
      ENDIF
!
      ierr = NF90_REDEF (mid)
      ierr = NF90_DEF_VAR (mid,"z",NF90_FLOAT,(/idim_z/),varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir z"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT (mid, varid, "long_name", "Vertical")
      ierr = NF90_PUT_ATT (mid, varid, "short_name", "z")
      ierr = NF90_PUT_ATT (mid, varid, "units", "layers")
      ierr = NF90_ENDDEF(mid)
      ierr = NF90_PUT_VAR(mid,varid,z,(/1/),(/kkm/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer z"
         CALL abort
      ENDIF
!
      dims2(1) = idim_x
      dims2(2) = idim_y
!
      ierr = NF90_REDEF (mid)
      ierr = NF90_DEF_VAR (mid,"mask",NF90_FLOAT,dims2,varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir mask"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT (mid,varid,"long_name","Masque")
      ierr = NF90_PUT_ATT (mid, varid, "short_name", "mask")
      ierr = NF90_PUT_ATT (mid, varid, "units", "-")
      ierr = NF90_ENDDEF(mid)
      ierr = NF90_PUT_VAR(mid,varid,mask,(/1,1/),(/iim,jjm/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer mask"
         CALL abort
      ENDIF
!
! Definir les variables pour enregistrement ulterieur:
!
      ierr = NF90_REDEF (mid)
!
      ierr = NF90_DEF_VAR (mid,"time", NF90_FLOAT,(/idim_t/),id_time)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir time"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT(mid,id_time,"long_name","time counter")
      ierr = NF90_PUT_ATT(mid,id_time,"short_name","time")
      ierr = NF90_PUT_ATT(mid,id_time,"units","days since 1-1-1")
      ierr = NF90_PUT_ATT(mid,id_time,"note", "Il peut etre n importe quoi")
!
      dims4(1) = idim_x
      dims4(2) = idim_y
      dims4(3) = idim_z
      dims4(4) = idim_t
!
      ierr = NF90_DEF_VAR (mid,"vari",NF90_FLOAT,dims4,id_vari)
      ierr = NF90_PUT_ATT(mid,id_vari,"long_name","Variable")
      ierr = NF90_PUT_ATT(mid,id_vari,"short_name","vari")
      ierr = NF90_PUT_ATT(mid,id_vari,"units","-")
      ierr = NF90_PUT_ATT(mid,id_vari,"missing_value",missing)
!
      ierr = NF90_ENDDEF(mid)
!
      DO 99999 n = 1, nb
!
        bidon = FLOAT(n)
        ierr = NF90_PUT_VAR(mid,id_time,bidon,START=(/n/))
        IF (ierr.NE.NF90_NOERR) THEN
           PRINT*, "Probleme pour enregistrer time"
           CALL abort
        ENDIF
!
        debu4(1) = 1
        debu4(2) = 1
        debu4(3) = 1
        debu4(4) = n
        epai4(1) = iim
        epai4(2) = jjm
        epai4(3) = kkm
        epai4(4) = 1
!
        ierr = NF90_PUT_VAR(mid,id_vari,vari(1:iim,1:jjm,1:kkm,n:n),START=debu4,COUNT=epai4)
        IF (ierr.NE.NF90_NOERR) THEN
           PRINT*, "Probleme pour enregistrer vari"
           CALL abort
        ENDIF
!
99999 CONTINUE
      ierr = NF90_CLOSE(mid)
!
  END SUBROUTINE ecrit_netcdf3d
!
  SUBROUTINE correlation(x, y, ok, n, corr)
      IMPLICIT none
!
      INTEGER, INTENT(IN) :: n
      LOGICAL, INTENT(IN) :: ok(n)
      REAL, INTENT(IN) :: x(n), y(n)
      REAL, INTENT(OUT) :: corr
!
      REAL*8 :: moyx, moyy, sigmax, sigmay, var, counter
      INTEGER :: i
!
      moyx = 0.0
      moyy = 0.0
      sigmax = 0.0
      sigmay = 0.0
      var = 0.0
      counter = 0.0
      DO i = 1, n
      IF (ok(i)) THEN
        moyx = moyx + x(i)
        moyy = moyy + y(i)
        sigmax = sigmax + x(i)*x(i)
        sigmay = sigmay + y(i)*y(i)
        var = var + x(i)*y(i)
        counter = counter + 1.0
      ENDIF
      ENDDO
      moyx = moyx / counter
      moyy = moyy / counter
      sigmax = sigmax / counter
      sigmay = sigmay / counter
      var = var / counter
!
      sigmax = sigmax - moyx*moyx
      sigmay = sigmay - moyy*moyy
      var = var - moyx*moyy
      corr = var/(sqrt(sigmax)*sqrt(sigmay))
!
  END SUBROUTINE correlation
!
  SUBROUTINE rootmeansquare(x, y, ok, n, rms)
      IMPLICIT none
!
      INTEGER, INTENT(IN) :: n
      LOGICAL, INTENT(IN) :: ok(n)
      REAL, INTENT(IN) :: x(n), y(n)
      REAL, INTENT(OUT) :: rms
!
      INTEGER :: i
      REAL*8 :: accu, bidon
!
      accu = 0.0
      bidon = 0.0
      DO i = 1, n
      IF (ok(i)) THEN
         accu =  accu + (x(i)-y(i))**2
         bidon = bidon + 1.0
      ENDIF
      ENDDO
      rms = SQRT(accu/bidon)
  END SUBROUTINE rootmeansquare
