      PROGRAM carre
      IMPLICIT none
c
c pgf90 ncep_analyse.F -L/distrib/local/netcdf/pgi_6.0-5_32/lib -lnetcdf
c
#include "netcdf.inc"
c***********************************************************************
      INTEGER iim, jjm, kkm, nb
      PARAMETER (iim=72, jjm=46, kkm=15)
c
      CHARACTER*64 tapename ! Fichier a traiter
      INTEGER mid
c
      CHARACTER*64 depart   ! Fichier d'accumulation au depart
      PARAMETER (depart="accu_data.nc")
      INTEGER lid
c
      CHARACTER*64 arrivee   ! Fichier d'accumulation a l'arrivee
      PARAMETER (arrivee="tmp_data.nc")
      INTEGER nid
c
      INTEGER iargc
ccc      EXTERNAL iargc
c
      INTEGER ierr, varid
      INTEGER idim_x, idim_y, idim_levs, idim_t
      INTEGER dims3(3), dims4(4)
      INTEGER debut3(3), epais3(3)
      INTEGER debut4(4), epais4(4)

      REAL x(iim), y(jjm), z(kkm) ! longitudes, latitudes et pressions
c
      REAL r, cp, lv, rg, rad
      PARAMETER (r=287.0, cp=1004.0, lv=2.5008E+06, rg=9.81)
      PARAMETER (rad=6400000.0)
      REAL pi
c
      REAL u0(iim,jjm,kkm) ! Vitesse U
      REAL v0(iim,jjm,kkm) ! Vitesse V
      REAL t0(iim,jjm,kkm)! Temperature
      REAL s0(iim,jjm,kkm)! Temperature potentielle
      REAL g0(iim,jjm,kkm) ! Geopotentiel
      REAL r0(iim,jjm,kkm) ! Humidite
      REAL q0(iim,jjm,kkm) ! Humidite
      REAL e0(iim,jjm,kkm) ! Energie totale
      REAL pres0(iim,jjm,kkm)
      REAL ps0(iim,jjm)
c
      REAL dsdp0(iim,jjm,kkm)
c
      REAL var3d(iim,jjm,kkm)
c
      REAL counter, bidon
      REAL temps
      INTEGER id_time
c
      REAL um(iim,jjm,kkm) ! Accumulation pour U
      REAL vm(iim,jjm,kkm) ! Accumulation pour V
      REAL tm(iim,jjm,kkm) ! Accumulation pour T
      REAL sm(iim,jjm,kkm)
      REAL gm(iim,jjm,kkm)
      REAL qm(iim,jjm,kkm)
      REAL rm(iim,jjm,kkm)
      REAL em(iim,jjm,kkm)
      REAL uu(iim,jjm,kkm) ! Accumulation pour U*U
      REAL vv(iim,jjm,kkm) ! Accumulation pour V*V
      REAL tt(iim,jjm,kkm) ! Accumulation pour T*T
      REAL ss(iim,jjm,kkm)
      REAL gg(iim,jjm,kkm)
      REAL qq(iim,jjm,kkm)
      REAL vt(iim,jjm,kkm) ! Accumulation pour V*T
      REAL vu(iim,jjm,kkm) ! Accumulation pour V*U
      REAL vs(iim,jjm,kkm)
      REAL dsdpm(iim,jjm,kkm)
      REAL vg(iim,jjm,kkm)
      REAL vq(iim,jjm,kkm)
      REAL ve(iim,jjm,kkm)
      REAL uq(iim,jjm,kkm)
      REAL ue(iim,jjm,kkm)
      REAL psm(iim,jjm)
      REAL presm(iim,jjm,kkm)
c
      REAL psm_z(jjm)
      REAL presm_z(jjm,kkm)
c
      REAL vq_z_total(jjm,kkm), vq_z_vi_total(jjm)
      REAL vq_z_moyen(jjm,kkm), vq_z_vi_moyen(jjm)
      REAL vq_z_trans(jjm,kkm), vq_z_vi_trans(jjm)
      REAL vq_z_stati(jjm,kkm), vq_z_vi_stati(jjm)
c
      REAL vt_z_total(jjm,kkm), vt_z_vi_total(jjm)
      REAL vt_z_moyen(jjm,kkm), vt_z_vi_moyen(jjm)
      REAL vt_z_trans(jjm,kkm), vt_z_vi_trans(jjm)
      REAL vt_z_stati(jjm,kkm), vt_z_vi_stati(jjm)
c
      REAL vg_z_total(jjm,kkm), vg_z_vi_total(jjm)
      REAL vg_z_moyen(jjm,kkm), vg_z_vi_moyen(jjm)
      REAL vg_z_trans(jjm,kkm), vg_z_vi_trans(jjm)
      REAL vg_z_stati(jjm,kkm), vg_z_vi_stati(jjm)
c
      REAL vu_z_total(jjm,kkm), vu_z_vi_total(jjm)
      REAL vu_z_moyen(jjm,kkm), vu_z_vi_moyen(jjm)
      REAL vu_z_trans(jjm,kkm), vu_z_vi_trans(jjm)
      REAL vu_z_stati(jjm,kkm), vu_z_vi_stati(jjm)
c
      REAL ve_z_total(jjm,kkm), ve_z_vi_total(jjm)
      REAL ve_z_moyen(jjm,kkm), ve_z_vi_moyen(jjm)
      REAL ve_z_trans(jjm,kkm), ve_z_vi_trans(jjm)
      REAL ve_z_stati(jjm,kkm), ve_z_vi_stati(jjm)
c
      REAL stream(jjm,kkm)
c
      REAL vq_vi_total(iim,jjm), vq_vi_moyen(iim,jjm)
      REAL vt_vi_total(iim,jjm), vt_vi_moyen(iim,jjm)
      REAL vg_vi_total(iim,jjm), vg_vi_moyen(iim,jjm)
      REAL vu_vi_total(iim,jjm), vu_vi_moyen(iim,jjm)
      REAL ve_vi_total(iim,jjm), ve_vi_moyen(iim,jjm)
      REAL uq_vi_total(iim,jjm), uq_vi_moyen(iim,jjm)
      REAL ue_vi_total(iim,jjm), ue_vi_moyen(iim,jjm)
c
      REAL qm_vi(iim,jjm), em_vi(iim,jjm)
c
      INTEGER i, j, k, n
      LOGICAL debut
c
      pi = 4.0 * ATAN(1.0)
c
      i = iargc()
      IF (i.NE.1) THEN
         PRINT*, "Argument (nom de fichier) non-compatible"
         CALL abort
      ENDIF
      CALL getarg(1,tapename)
c
c Ouvrir le fichier brut pour extraire les coordonnees:
c
      ierr = NF_OPEN (tapename, NF_NOWRITE,mid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme d ouverture du fichier coordonnees"
         CALL abort
      ENDIF
c
      CALL lire_xyz(mid,iim,"x",x,jjm,"y",y,kkm,"levels",z)
c
c Obtenir la longueur du temps:
c
      ierr = NF_INQ_DIMID(mid,"time_counter",varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir DIMidentificateur de time"
         CALL abort
      ENDIF
      ierr = NF_INQ_DIMLEN(mid,varid,n)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir la longueur de time"
         CALL abort
      ENDIF
      nb = n
c
c Fermer le fichier de coordonnees
c
      ierr = NF_CLOSE(mid)
c
c Ouvrir le fichier de depart
c
      ierr = NF_OPEN (depart, NF_NOWRITE,lid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Le fichier de depart n existe pas: Initialisation"
         debut = .TRUE.
      ELSE
         debut = .FALSE.
      ENDIF
c
      IF (debut) THEN
         counter = 0.0
      ELSE
#ifdef NC_DOUBLE
      ierr = NF_GET_ATT_DOUBLE (lid, NF_GLOBAL, "counter", counter)
#else
      ierr = NF_GET_ATT_REAL (lid, NF_GLOBAL, "counter", counter)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour obtenir counter"
         CALL abort
      ENDIF
      PRINT*, "Compteur=", counter
      ENDIF
c
      IF (debut) THEN
c
      um = 0.0
      vm = 0.0
      tm = 0.0
      gm = 0.0
      qm = 0.0
      rm = 0.0
      em = 0.0
      uu = 0.0
      vv = 0.0
      tt = 0.0
      gg = 0.0
      qq = 0.0
      vt = 0.0
      vu = 0.0
      vg = 0.0
      vq = 0.0
      ve = 0.0
      uq = 0.0
      ue = 0.0
      psm = 0.0
      presm = 0.0
      sm = 0.0
      ss = 0.0
      vs = 0.0
      dsdpm = 0.0
c
      ELSE ! test sur debut
c
      n = 1
c
      ierr = NF_INQ_VARID(lid,"time_counter", varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur de time"
         CALL abort
      ENDIF
#ifdef NC_DOUBLE
      ierr = NF_GET_VARA_DOUBLE(lid,varid,n,1,temps)
#else
      ierr = NF_GET_VARA_REAL(lid,varid,n,1,temps)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour extraire time"
         CALL abort
      ENDIF
c
      CALL lire_var3d(lid,"psm",iim,jjm,n,psm)
      CALL lire_var4d(lid,"presm",iim,jjm,kkm,n,presm)
      CALL lire_var4d(lid,"um",iim,jjm,kkm,n,um)
      CALL lire_var4d(lid,"vm",iim,jjm,kkm,n,vm)
      CALL lire_var4d(lid,"tm",iim,jjm,kkm,n,tm)
      CALL lire_var4d(lid,"gm",iim,jjm,kkm,n,gm)
      CALL lire_var4d(lid,"qm",iim,jjm,kkm,n,qm)
      CALL lire_var4d(lid,"rm",iim,jjm,kkm,n,rm)
      CALL lire_var4d(lid,"em",iim,jjm,kkm,n,em)
      CALL lire_var4d(lid,"uu",iim,jjm,kkm,n,uu)
      CALL lire_var4d(lid,"vv",iim,jjm,kkm,n,vv)
      CALL lire_var4d(lid,"tt",iim,jjm,kkm,n,tt)
      CALL lire_var4d(lid,"gg",iim,jjm,kkm,n,gg)
      CALL lire_var4d(lid,"qq",iim,jjm,kkm,n,qq)
      CALL lire_var4d(lid,"vu",iim,jjm,kkm,n,vu)
      CALL lire_var4d(lid,"vt",iim,jjm,kkm,n,vt)
      CALL lire_var4d(lid,"vg",iim,jjm,kkm,n,vg)
      CALL lire_var4d(lid,"vq",iim,jjm,kkm,n,vq)
      CALL lire_var4d(lid,"ve",iim,jjm,kkm,n,ve)
      CALL lire_var4d(lid,"uq",iim,jjm,kkm,n,uq)
      CALL lire_var4d(lid,"ue",iim,jjm,kkm,n,ue)
      CALL lire_var4d(lid,"sm",iim,jjm,kkm,n,sm)
      CALL lire_var4d(lid,"ss",iim,jjm,kkm,n,ss)
      CALL lire_var4d(lid,"vs",iim,jjm,kkm,n,vs)
      CALL lire_var4d(lid,"dsdpm",iim,jjm,kkm,n,dsdpm)
c
      ENDIF ! fin de test sur debut
c
      ierr = NF_CLOSE(lid)
c
      ierr = NF_OPEN (tapename, NF_NOWRITE,mid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme d ouverture du fichier:"//tapename
         CALL abort
      ENDIF
c
      DO 99999 n = 1, nb
c
      CALL lire_var3d(mid,"psol",iim,jjm,n,ps0)
c
      CALL lire_var4d(mid,"vitu",iim,jjm,kkm,n,u0)
      CALL lire_var4d(mid,"vitv",iim,jjm,kkm,n,v0)
      CALL lire_var4d(mid,"geop",iim,jjm,kkm,n,g0)
      CALL lire_var4d(mid,"temp",iim,jjm,kkm,n,t0)
      CALL lire_var4d(mid,"ovap",iim,jjm,kkm,n,q0)

      DO k = 1, kkm
      DO j = 1, jjm
      DO i = 1, iim
         g0(i,j,k) = g0(i,j,k)/rg
      ENDDO
      ENDDO
      ENDDO
c
c Mettre le vent zero si la couche est sous la terre:
      DO k = 1, kkm
      DO j = 1, jjm
      DO i = 1, iim
         IF (ps0(i,j).LT.z(k)*100.0) THEN
            u0(i,j,k) = 0.0
            v0(i,j,k) = 0.0
         ENDIF
      ENDDO
      ENDDO
      ENDDO
c
c Pressions atmospheriques:
c (Attention: valeurs de surface, 
c             si la couche est au-dessous de la surface !)
      DO k = 1, kkm
      DO j = 1, jjm
      DO i = 1, iim
         pres0(i,j,k) = z(k)*100.0
         pres0(i,j,k) = MIN(pres0(i,j,k),ps0(i,j))
      ENDDO
      ENDDO
      ENDDO
c
c Calculer l'humidite relative:
      CALL q_sat(iim*jjm*kkm,t0,pres0,r0)
      DO k = 1, kkm
      DO j = 1, jjm
      DO i = 1, iim
         r0(i,j,k) = q0(i,j,k)/r0(i,j,k)*100.0
      ENDDO
      ENDDO
      ENDDO
c
c Calculer la temperature potentielle:
      DO k = 1, kkm
      DO j = 1, jjm
      DO i = 1, iim
         s0(i,j,k) = t0(i,j,k) * (1000.0/pres0(i,j,k))**(r/cp)
      ENDDO
      ENDDO
      ENDDO
c
c Calculer l'energie totale:
      DO k = 1, kkm
      DO j = 1, jjm
      DO i = 1, iim
         e0(i,j,k) = cp*t0(i,j,k) + lv*q0(i,j,k) + rg*g0(i,j,k) 
     .             + (u0(i,j,k)**2 + v0(i,j,k)**2)/2.0
      ENDDO
      ENDDO
      ENDDO
c
c Derivee verticale de la temperature potentielle:
      dsdp0 = 0.0
      DO j = 1, jjm
      DO i = 1, iim
         bidon = pres0(i,j,2) - pres0(i,j,1)
         IF (ABS(bidon).GT.1.0e-2) THEN
         dsdp0(i,j,1) = (s0(i,j,2)-s0(i,j,1)) / bidon
         ENDIF
         bidon = pres0(i,j,kkm) - pres0(i,j,kkm-1)
         IF (ABS(bidon).GT.1.0e-2) THEN
         dsdp0(i,j,kkm) = (s0(i,j,kkm)-s0(i,j,kkm-1))/bidon
         ENDIF
      ENDDO
      ENDDO
      DO k = 2, kkm-1
      DO j = 1, jjm
      DO i = 1, iim
         bidon = pres0(i,j,k+1) - pres0(i,j,k-1)
         IF (ABS(bidon).GT.1.0e-2) THEN
         dsdp0(i,j,k) = (s0(i,j,k+1)-s0(i,j,k-1))/bidon
         ENDIF
      ENDDO
      ENDDO
      ENDDO
c
c Accumuler les variables:
      bidon = 1.0/(1.0+counter)
      DO k = 1, kkm
      DO j = 1, jjm
      DO i = 1, iim
         presm(i,j,k) = presm(i,j,k)*(1.0-bidon) 
     .                + MIN(ps0(i,j),pres0(i,j,k))*bidon
         um(i,j,k) = um(i,j,k)*(1.0-bidon) + u0(i,j,k)*bidon
         vm(i,j,k) = vm(i,j,k)*(1.0-bidon) + v0(i,j,k)*bidon
         tm(i,j,k) = tm(i,j,k)*(1.0-bidon) + t0(i,j,k)*bidon
         gm(i,j,k) = gm(i,j,k)*(1.0-bidon) + g0(i,j,k)*bidon
         qm(i,j,k) = qm(i,j,k)*(1.0-bidon) + q0(i,j,k)*bidon
         rm(i,j,k) = rm(i,j,k)*(1.0-bidon) + r0(i,j,k)*bidon
         em(i,j,k) = em(i,j,k)*(1.0-bidon) + e0(i,j,k)*bidon
         uu(i,j,k) = uu(i,j,k)*(1.0-bidon) + u0(i,j,k)*u0(i,j,k)*bidon
         vv(i,j,k) = vv(i,j,k)*(1.0-bidon) + v0(i,j,k)*v0(i,j,k)*bidon
         tt(i,j,k) = tt(i,j,k)*(1.0-bidon) + t0(i,j,k)*t0(i,j,k)*bidon
         gg(i,j,k) = gg(i,j,k)*(1.0-bidon) + g0(i,j,k)*g0(i,j,k)*bidon
         qq(i,j,k) = qq(i,j,k)*(1.0-bidon) + q0(i,j,k)*q0(i,j,k)*bidon
         vu(i,j,k) = vu(i,j,k)*(1.0-bidon) + v0(i,j,k)*u0(i,j,k)*bidon
         vt(i,j,k) = vt(i,j,k)*(1.0-bidon) + v0(i,j,k)*t0(i,j,k)*bidon
         vg(i,j,k) = vg(i,j,k)*(1.0-bidon) + v0(i,j,k)*g0(i,j,k)*bidon
         vq(i,j,k) = vq(i,j,k)*(1.0-bidon) + v0(i,j,k)*q0(i,j,k)*bidon
         ve(i,j,k) = ve(i,j,k)*(1.0-bidon) + v0(i,j,k)*e0(i,j,k)*bidon
         uq(i,j,k) = uq(i,j,k)*(1.0-bidon) + u0(i,j,k)*q0(i,j,k)*bidon
         ue(i,j,k) = ue(i,j,k)*(1.0-bidon) + u0(i,j,k)*e0(i,j,k)*bidon
         sm(i,j,k) = sm(i,j,k)*(1.0-bidon) + s0(i,j,k)*bidon
         ss(i,j,k) = ss(i,j,k)*(1.0-bidon) + s0(i,j,k)*s0(i,j,k)*bidon
         vs(i,j,k) = vs(i,j,k)*(1.0-bidon) + v0(i,j,k)*s0(i,j,k)*bidon
         dsdpm(i,j,k) = dsdpm(i,j,k)*(1.0-bidon) + dsdp0(i,j,k)*bidon
      ENDDO
      ENDDO
      ENDDO
      DO j = 1, jjm
      DO i = 1, iim
         psm(i,j) = psm(i,j)*(1.0-bidon) + ps0(i,j)*bidon
      ENDDO
      ENDDO
c
      counter = counter + 1.0
c
99999 CONTINUE
      ierr = NF_CLOSE(mid)
c
c Ecrire le fichier d'arrivee
c
      CALL ecrit_accu(arrivee,counter,temps,iim,jjm,kkm,x,y,z,psm,
     .  presm,um,vm,tm,gm,qm,rm,em,uu,vv,tt,gg,qq,vu,vt,vg,vq,
     .  ve,uq,ue,sm,ss,vs,dsdpm)
c
c====================================================================
c FAIRE DES DIAGNOSTIQUES
c
      CALL vintegral(iim,jjm,kkm, psm, presm, qm, qm_vi)
      CALL vintegral(iim,jjm,kkm, psm, presm, em, em_vi)
c
c CALCULER L'INTEGRATION VERTICALE DES TRANSPORTS:
c
      CALL vintegral(iim,jjm,kkm, psm, presm, vq, vq_vi_total)
      var3d = vm * qm
      CALL vintegral(iim,jjm,kkm, psm, presm, var3d, vq_vi_moyen)
c
      CALL vintegral(iim,jjm,kkm, psm, presm, vt, vt_vi_total)
      var3d = vm * tm
      CALL vintegral(iim,jjm,kkm, psm, presm, var3d, vt_vi_moyen)
c
      CALL vintegral(iim,jjm,kkm, psm, presm, vg, vg_vi_total)
      var3d = vm * gm
      CALL vintegral(iim,jjm,kkm, psm, presm, var3d, vg_vi_moyen)
c
      CALL vintegral(iim,jjm,kkm, psm, presm, vu, vu_vi_total)
      var3d = vm * um
      CALL vintegral(iim,jjm,kkm, psm, presm, var3d, vu_vi_moyen)
c
      CALL vintegral(iim,jjm,kkm, psm, presm, ve, ve_vi_total)
      var3d = vm * em
      CALL vintegral(iim,jjm,kkm, psm, presm, var3d, ve_vi_moyen)
c
      CALL vintegral(iim,jjm,kkm, psm, presm, uq, uq_vi_total)
      var3d = um * qm
      CALL vintegral(iim,jjm,kkm, psm, presm, var3d, uq_vi_moyen)
c
      CALL vintegral(iim,jjm,kkm, psm, presm, ue, ue_vi_total)
      var3d = um * em
      CALL vintegral(iim,jjm,kkm, psm, presm, var3d, ue_vi_moyen)
c
c EN MOYENNE ZONALE:
c
      CALL transp_meri(iim,jjm,kkm,y,vm,qm,vq,psm,presm,
     .        vq_z_total,vq_z_moyen,vq_z_trans,vq_z_stati,
     .        vq_z_vi_total,vq_z_vi_moyen,vq_z_vi_trans,vq_z_vi_stati)
c
      CALL transp_meri(iim,jjm,kkm,y,vm,tm,vt,psm,presm,
     .        vt_z_total,vt_z_moyen,vt_z_trans,vt_z_stati,
     .        vt_z_vi_total,vt_z_vi_moyen,vt_z_vi_trans,vt_z_vi_stati)
c
      CALL transp_meri(iim,jjm,kkm,y,vm,gm,vg,psm,presm,
     .        vg_z_total,vg_z_moyen,vg_z_trans,vg_z_stati,
     .        vg_z_vi_total,vg_z_vi_moyen,vg_z_vi_trans,vg_z_vi_stati)
c
      CALL transp_meri(iim,jjm,kkm,y,vm,um,vu,psm,presm,
     .        vu_z_total,vu_z_moyen,vu_z_trans,vu_z_stati,
     .        vu_z_vi_total,vu_z_vi_moyen,vu_z_vi_trans,vu_z_vi_stati)
c
      CALL transp_meri(iim,jjm,kkm,y,vm,em,ve,psm,presm,
     .        ve_z_total,ve_z_moyen,ve_z_trans,ve_z_stati,
     .        ve_z_vi_total,ve_z_vi_moyen,ve_z_vi_trans,ve_z_vi_stati)
c
      CALL hadley_cell(iim,jjm,kkm,y,vm,psm,presm,stream)
c
c Enregistrer les diagnostiques:
c
ccc      CALL ecrit_diag
      CALL ecrit_diag_bis
     .  ("diagnostic.nc",iim,jjm,kkm,x,y,z,
     .  vq_vi_total,vq_vi_moyen,vt_vi_total,vt_vi_moyen,
     .  vg_vi_total,vg_vi_moyen,vu_vi_total,vu_vi_moyen,
     .  ve_vi_total,ve_vi_moyen,
     .  uq_vi_total,uq_vi_moyen,ue_vi_total,ue_vi_moyen,
     .  vq_z_total,vq_z_moyen,vq_z_trans,vq_z_stati,
     .  vq_z_vi_total,vq_z_vi_moyen,vq_z_vi_trans,vq_z_vi_stati,
     .  vt_z_total,vt_z_moyen,vt_z_trans,vt_z_stati,
     .  vt_z_vi_total,vt_z_vi_moyen,vt_z_vi_trans,vt_z_vi_stati,
     .  vg_z_total,vg_z_moyen,vg_z_trans,vg_z_stati,
     .  vg_z_vi_total,vg_z_vi_moyen,vg_z_vi_trans,vg_z_vi_stati,
     .  vu_z_total,vu_z_moyen,vu_z_trans,vu_z_stati,
     .  vu_z_vi_total,vu_z_vi_moyen,vu_z_vi_trans,vu_z_vi_stati,
     .  ve_z_total,ve_z_moyen,ve_z_trans,ve_z_stati,
     .  ve_z_vi_total,ve_z_vi_moyen,ve_z_vi_trans,ve_z_vi_stati,
     .  stream,qm_vi,em_vi)
c
c Calculer les E-P fluxes:
c
      CALL epflux(iim,jjm,kkm,x,y,z,presm,um,vm,sm,uu,vv,vs,vu,dsdpm)
c
      STOP 
      END
      subroutine q_sat(np,temp,pres,qsat)
c
      IMPLICIT none
c======================================================================
c Autheur(s): Z.X. Li (LMD/CNRS)
c  reecriture vectorisee par F. Hourdin.
c Objet: calculer la vapeur d'eau saturante (formule Centre Euro.)
c======================================================================
c Arguments:
c kelvin---input-R: temperature en Kelvin
c millibar--input-R: pression en mb
c
c q_sat----output-R: vapeur d'eau saturante en kg/kg
c======================================================================
c
      integer np
      REAL temp(np),pres(np),qsat(np)
c
      REAL r2es
      PARAMETER (r2es=611.14 *18.0153/28.9644)
c
      REAL r3les, r3ies, r3es
      PARAMETER (R3LES=17.269)
      PARAMETER (R3IES=21.875)
c
      REAL r4les, r4ies, r4es
      PARAMETER (R4LES=35.86)
      PARAMETER (R4IES=7.66)
c
      REAL rtt
      PARAMETER (rtt=273.16)
c
      REAL retv
      PARAMETER (retv=28.9644/18.0153 - 1.0)

      real zqsat
      integer ip
c
      do ip=1,np

c      write(*,*)'kelvin,millibar=',kelvin,millibar
c       write(*,*)'temp,pres=',temp(ip),pres(ip)
c
         IF (temp(ip) .LE. rtt) THEN
            r3es = r3ies
            r4es = r4ies
         ELSE
            r3es = r3les
            r4es = r4les
         ENDIF
c
         zqsat=r2es/pres(ip)*EXP(r3es*(temp(ip)-rtt)/(temp(ip)-r4es))
         zqsat=MIN(0.5,ZQSAT)
         zqsat=zqsat/(1.-retv *zqsat)
c
         qsat(ip)= zqsat
c      write(*,*)'qsat=',qsat(ip)

      enddo
c
      RETURN
      END
      SUBROUTINE transp_meri(iim,jjm,kkm,y,vm,qm,vq,psm,presm,
     .        vq_z_total,vq_z_moyen,vq_z_trans,vq_z_stati,
     .        vq_z_vi_total,vq_z_vi_moyen,vq_z_vi_trans,vq_z_vi_stati)
      IMPLICIT none
c
c***********************************************************************
      INTEGER iim, jjm, kkm
      REAL y(jjm)

      REAL vm(iim,jjm,kkm) ! Accumulation pour V
      REAL qm(iim,jjm,kkm)
      REAL vq(iim,jjm,kkm)
      REAL psm(iim,jjm)
      REAL presm(iim,jjm,kkm)
c
      REAL psm_z(jjm)
      REAL presm_z(jjm,kkm)
c
      REAL vq_z_total(jjm,kkm), vq_z_vi_total(jjm)
      REAL vq_z_moyen(jjm,kkm), vq_z_vi_moyen(jjm)
      REAL vq_z_trans(jjm,kkm), vq_z_vi_trans(jjm)
      REAL vq_z_stati(jjm,kkm), vq_z_vi_stati(jjm)
c
      REAL var1_z(jjm,kkm)
      REAL var2_z(jjm,kkm)
c
      INTEGER i, j, k
c
      REAL pi, rad
c
      pi = 4.0*ATAN(1.0)
      rad = 6400000.0
c
c pression au sol:
      DO j = 1, jjm
      psm_z(j) = 0.0
         DO i = 1, iim
            psm_z(j) = psm_z(j) + psm(i,j)/FLOAT(iim)
         ENDDO
      ENDDO
c
c pression dans l'atmosphere:
      DO k = 1, kkm
      DO j = 1, jjm
         presm_z(j,k) = 0.0
         DO i = 1, iim
            presm_z(j,k) = presm_z(j,k) 
     .                   + MIN(presm(i,j,k),psm(i,j))/FLOAT(iim)
         ENDDO
      ENDDO
      ENDDO
c
c transport total:
      DO k = 1, kkm
      DO j = 1, jjm
      vq_z_total(j,k) = 0.0
         DO i = 1, iim
            vq_z_total(j,k) = vq_z_total(j,k) + vq(i,j,k)/FLOAT(iim)
         ENDDO
      ENDDO
      ENDDO
      CALL vintegral(1,jjm,kkm,psm_z,presm_z, vq_z_total,vq_z_vi_total)
      DO j = 1, jjm
      vq_z_vi_total(j) = vq_z_vi_total(j) *
     .                   COS(y(j)*pi/180.)*rad*2.0*pi
      ENDDO
c
c transport par circulation moyenne:
      DO k = 1, kkm
      DO j = 1, jjm
      var1_z(j,k) = 0.0
      var2_z(j,k) = 0.0
         DO i = 1, iim
            var1_z(j,k) = var1_z(j,k) + vm(i,j,k)/FLOAT(iim)
            var2_z(j,k) = var2_z(j,k) + qm(i,j,k)/FLOAT(iim)
         ENDDO
      vq_z_moyen(j,k) = var1_z(j,k) * var2_z(j,k)
      ENDDO
      ENDDO
      CALL vintegral(1,jjm,kkm,psm_z,presm_z, vq_z_moyen,vq_z_vi_moyen)
      DO j = 1, jjm
      vq_z_vi_moyen(j) = vq_z_vi_moyen(j) *
     .                   COS(y(j)*pi/180.)*rad*2.0*pi
      ENDDO
c
c transport par toubillions transitoires:
      DO k = 1, kkm
      DO j = 1, jjm
      vq_z_trans(j,k) = 0.0
         DO i = 1, iim
            vq_z_trans(j,k) = vq_z_trans(j,k) 
     .            + (vq(i,j,k)-vm(i,j,k)*qm(i,j,k))/FLOAT(iim)
         ENDDO
      ENDDO
      ENDDO
      CALL vintegral(1,jjm,kkm,psm_z,presm_z, vq_z_trans,vq_z_vi_trans)
      DO j = 1, jjm
      vq_z_vi_trans(j) = vq_z_vi_trans(j) *
     .                   COS(y(j)*pi/180.)*rad*2.0*pi
      ENDDO
c
c transport par tourbillions stationnaire:
      DO k = 1, kkm
      DO j = 1, jjm
      vq_z_stati(j,k) = 0.0
         DO i = 1, iim
            vq_z_stati(j,k) = vq_z_stati(j,k) 
     .            + vm(i,j,k)*qm(i,j,k)/FLOAT(iim)
         ENDDO
      vq_z_stati(j,k) = vq_z_stati(j,k) - vq_z_moyen(j,k)
      ENDDO
      ENDDO
      CALL vintegral(1,jjm,kkm,psm_z,presm_z, vq_z_stati,vq_z_vi_stati)
      DO j = 1, jjm
      vq_z_vi_stati(j) = vq_z_vi_stati(j) *
     .                   COS(y(j)*pi/180.)*rad*2.0*pi
      ENDDO
c
      RETURN
      END
      SUBROUTINE vintegral(iim,jjm,kkm, ps, p, q, qi)
      IMPLICIT none
      INTEGER iim, jjm, kkm
      REAL ps(iim,jjm)
      REAL p(iim,jjm,kkm), q(iim,jjm,kkm)
      REAL qi(iim,jjm)
c
      REAL pr(iim,jjm,0:kkm+1)
      REAL qq(iim,jjm,0:kkm+1)
c
      INTEGER i, j, k
      REAL RG
      PARAMETER (RG=9.81)
c
      DO k = 1, kkm
      DO j = 1, jjm
      DO i = 1, iim
         pr(i,j,k) = p(i,j,k)
         qq(i,j,k) = q(i,j,k)
      ENDDO
      ENDDO
      ENDDO

c
      DO k = kkm-1, 1, -1
      DO j = 1, jjm
      DO i = 1, iim
         IF (pr(i,j,k).GT.ps(i,j)) THEN
            pr(i,j,k) = ps(i,j)
            qq(i,j,k) = qq(i,j,k+1)
         ENDIF
      ENDDO
      ENDDO
      ENDDO
c
      DO j = 1, jjm
      DO i = 1, iim
         pr(i,j,0) = ps(i,j)
         pr(i,j,kkm+1) = 0.0
         qq(i,j,0) = qq(i,j,1)
         qq(i,j,kkm+1) = qq(i,j,kkm)
      ENDDO
      ENDDO
c
      DO j = 1, jjm
      DO i = 1, iim
         qi(i,j) = 0.0
      ENDDO
      ENDDO
c
      DO k = 0, kkm
      DO j = 1, jjm
      DO i = 1, iim
         qi(i,j) = qi(i,j) + (qq(i,j,k)+qq(i,j,k+1))/2.0
     .                      *(pr(i,j,k)-pr(i,j,k+1))/RG
      ENDDO
      ENDDO
      ENDDO
c
      RETURN
      END
      SUBROUTINE hadley_cell(iim,jjm,kkm,y,vm,psm,presm,stream)
      IMPLICIT none
c
c***********************************************************************
      INTEGER iim, jjm, kkm

      REAL y(jjm)
      REAL vm(iim,jjm,kkm) ! Accumulation pour V
      REAL psm(iim,jjm)
      REAL presm(iim,jjm,kkm)
c
      REAL psm_z(jjm)
      REAL presm_z(jjm,kkm)
c
      REAL stream(jjm,kkm)
c
      REAL var1_z(jjm,kkm)
c
      INTEGER i, j, k
      REAL pi, rad, RG
c
      pi = 4.0*ATAN(1.0)
      rad = 6400000.0
      RG = 9.81
c
      DO j = 1, jjm
      psm_z(j) = 0.0
         DO i = 1, iim
            psm_z(j) = psm_z(j) + psm(i,j)/FLOAT(iim)
         ENDDO
      ENDDO
c
      DO k = 1, kkm
      DO j = 1, jjm
         presm_z(j,k) = 0.0
         var1_z(j,k) = 0.0
         DO i = 1, iim
         IF (presm(i,j,k).GT.psm(i,j)) THEN
            presm_z(j,k) = presm_z(j,k) + psm(i,j)/FLOAT(iim)
            var1_z(j,k) = var1_z(j,k) + 0.0
         ELSE
            presm_z(j,k) = presm_z(j,k) + presm(i,j,k)/FLOAT(iim)
            var1_z(j,k) = var1_z(j,k) + vm(i,j,k)/FLOAT(iim)
         ENDIF
         ENDDO
      ENDDO
      ENDDO
c
c
      DO j = 1, jjm
         stream(j,kkm) = (presm_z(j,kkm)-0.0) * var1_z(j,kkm)
     .                  *COS(y(j)*pi/180.)*rad*2.0*pi/RG
         DO k = kkm-1, 1, -1
         stream(j,k) = stream(j,k+1) 
     .               + (presm_z(j,k)-presm_z(j,k+1)) *
     .                 (var1_z(j,k)+var1_z(j,k+1))*0.5
     .                *COS(y(j)*pi/180.)*rad*2.0*pi/RG
         ENDDO
      ENDDO
c
      RETURN
      END

      SUBROUTINE lire_xyz(mid,iim,lon,x,jjm,lat,y,kkm,level,z)
      IMPLICIT none
c
#include "netcdf.inc"
c
      INTEGER mid, iim, jjm, kkm
      REAL x(iim), y(jjm), z(kkm)
      CHARACTER*(*) lon, lat, level
c
      INTEGER ierr, varid, i, j, k

      ierr = NF_INQ_DIMID(mid,lon,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir DIMidentificateur de lon"
         CALL abort
      ENDIF
      ierr = NF_INQ_DIMLEN(mid,varid,i)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir la longueur de lon"
         CALL abort
      ENDIF
      IF (i.NE.iim) THEN
         PRINT*, "Dimension lon fausse:", i, iim
         CALL abort
      ENDIF
      ierr = NF_INQ_VARID (mid,lon,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur lon"
         CALL abort
      ENDIF
#ifdef NC_DOUBLE
      ierr = NF_GET_VARA_DOUBLE(mid, varid, 1,iim, x)
#else
      ierr = NF_GET_VARA_REAL(mid, varid, 1,iim, x)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour extraire lon"
         CALL abort
      ENDIF
c
      ierr = NF_INQ_DIMID(mid,lat,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir DIMidentificateur de lat"
         CALL abort
      ENDIF
      ierr = NF_INQ_DIMLEN(mid,varid,j)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir la longueur de y"
         CALL abort
      ENDIF
      IF (j.NE.jjm) THEN
         PRINT*, "Dimension lat fausse:", j, jjm
         CALL abort
      ENDIF
      ierr = NF_INQ_VARID (mid,lat,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur lat"
         CALL abort
      ENDIF
#ifdef NC_DOUBLE
      ierr = NF_GET_VARA_DOUBLE(mid, varid, 1,jjm, y)
#else
      ierr = NF_GET_VARA_REAL(mid, varid, 1,jjm, y)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour extraire lat"
         CALL abort
      ENDIF
c
      ierr = NF_INQ_DIMID(mid,level,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir DIMidentificateur de level"
         CALL abort
      ENDIF
      ierr = NF_INQ_DIMLEN(mid,varid,k)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir la longueur de level"
         CALL abort
      ENDIF
      IF (k.NE.kkm) THEN
         PRINT*, "Dimension levs fausse:", k, kkm
         CALL abort
      ENDIF
      ierr = NF_INQ_VARID (mid,level,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur level"
         CALL abort
      ENDIF
#ifdef NC_DOUBLE
      ierr = NF_GET_VARA_DOUBLE(mid, varid, 1,kkm, z)
#else
      ierr = NF_GET_VARA_REAL(mid, varid, 1,kkm, z)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour extraire level"
         CALL abort
      ENDIF
c
      RETURN
      END
c
      SUBROUTINE lire_var3d(lid,varname,iim,jjm,n,var)
      IMPLICIT none
c
      INTEGER lid, iim,jjm,n,debut3(3), epais3(3)
      REAL var(iim,jjm)
      CHARACTER*(*) varname
      INTEGER varid, ierr
c
      REAL scale_factor, add_offset
c
#include "netcdf.inc"
c
      debut3(1) = 1
      debut3(2) = 1
      debut3(3) = n
      epais3(1) = iim
      epais3(2) = jjm
      epais3(3) = 1
c
      ierr = NF_INQ_VARID(lid,varname, varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur"
         CALL abort
      ENDIF
#ifdef NC_DOUBLE
      ierr = NF_GET_VARA_DOUBLE(lid,varid,debut3,epais3,var)
#else
      ierr = NF_GET_VARA_REAL(lid,varid,debut3,epais3,var)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour extraire"
         CALL abort
      ENDIF
c
#ifdef NC_DOUBLE
      ierr = NF_GET_ATT_DOUBLE(lid,varid,"scale_factor",scale_factor)
#else
      ierr = NF_GET_ATT_REAL(lid,varid,"scale_factor",scale_factor)
#endif
      IF (ierr.NE.NF_NOERR) THEN
ccc         PRINT*, "Probleme pour extraire scale_factor"
ccc         CALL abort
         scale_factor = 1.0
      ENDIF
#ifdef NC_DOUBLE
      ierr = NF_GET_ATT_DOUBLE(lid,varid,"add_offset",add_offset)
#else
      ierr = NF_GET_ATT_REAL(lid,varid,"add_offset",add_offset)
#endif
      IF (ierr.NE.NF_NOERR) THEN
ccc         PRINT*, "Probleme pour extraire add_offset"
ccc         CALL abort
         add_offset = 0.0
      ENDIF
      var = var * scale_factor + add_offset
c
      RETURN
      END
      SUBROUTINE lire_var4d(lid,varname,iim,jjm,kkm,n,var)
      IMPLICIT none
c
      INTEGER lid, iim,jjm,kkm,n,debut4(4), epais4(4)
      REAL var(iim,jjm,kkm)
      CHARACTER*(*) varname
      INTEGER varid, ierr
      REAL scale_factor, add_offset
c
#include "netcdf.inc"
c
      debut4(1) = 1
      debut4(2) = 1
      debut4(3) = 1
      debut4(4) = n
      epais4(1) = iim
      epais4(2) = jjm
      epais4(3) = kkm
      epais4(4) = 1
c
      ierr = NF_INQ_VARID(lid,varname, varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur"
         CALL abort
      ENDIF
#ifdef NC_DOUBLE
      ierr = NF_GET_VARA_DOUBLE(lid,varid,debut4,epais4,var)
#else
      ierr = NF_GET_VARA_REAL(lid,varid,debut4,epais4,var)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour extraire"
         CALL abort
      ENDIF
c
#ifdef NC_DOUBLE
      ierr = NF_GET_ATT_DOUBLE(lid,varid,"scale_factor",scale_factor)
#else
      ierr = NF_GET_ATT_REAL(lid,varid,"scale_factor",scale_factor)
#endif
      IF (ierr.NE.NF_NOERR) THEN
ccc         PRINT*, "Probleme pour extraire scale_factor"
ccc         CALL abort
         scale_factor = 1.0
      ENDIF
#ifdef NC_DOUBLE
      ierr = NF_GET_ATT_DOUBLE(lid,varid,"add_offset",add_offset)
#else
      ierr = NF_GET_ATT_REAL(lid,varid,"add_offset",add_offset)
#endif
      IF (ierr.NE.NF_NOERR) THEN
ccc         PRINT*, "Probleme pour extraire add_offset"
ccc         CALL abort
         add_offset = 0.0
      ENDIF
      var = var * scale_factor + add_offset
c
      RETURN
      END
      SUBROUTINE ecritnd(nid,taille, var, nb_dims, dims, debut, epais,
     .                   name, longname, unit)
      IMPLICIT none
#include "netcdf.inc"
      INTEGER nid, taille
      INTEGER nb_dims, dims(nb_dims), debut(nb_dims), epais(nb_dims)
      REAL var(taille)
      CHARACTER*(*) name,longname,unit
      INTEGER ierr, varid, i

      ierr = NF_REDEF (nid)
      ierr = NF_DEF_VAR (nid,name,NF_FLOAT,nb_dims,dims,varid)
      i = len_trim(longname)
      ierr = NF_PUT_ATT_TEXT (nid,varid,"long_name",i,longname)
      i = len_trim(unit)
      ierr = NF_PUT_ATT_TEXT (nid,varid,"units",i,unit)
#ifdef NC_DOUBLE
      ierr=NF_PUT_ATT_DOUBLE(nid,varid,"scale_factor",NF_FLOAT,1,1.0)
      ierr=NF_PUT_ATT_DOUBLE(nid,varid,"add_offset",NF_FLOAT,1,0.0)
      ierr=NF_PUT_ATT_DOUBLE(nid,varid,"missing_value",NF_FLOAT,
     .                       1,1.0e25)
#else
      ierr=NF_PUT_ATT_REAL(nid,varid,"scale_factor",NF_FLOAT,1,1.0)
      ierr=NF_PUT_ATT_REAL(nid,varid,"add_offset",NF_FLOAT,1,0.0)
      ierr=NF_PUT_ATT_REAL(nid,varid,"missing_value",NF_FLOAT,1,1.0e25)
#endif
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VARA_DOUBLE(nid,varid,debut,epais,var)
#else
      ierr = NF_PUT_VARA_REAL(nid,varid,debut,epais,var)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer var"
         CALL abort
      ENDIF
c
      RETURN
      END
      SUBROUTINE ecrit_accu(arrivee,counter,temps,iim,jjm,kkm,x,y,z,psm,
     .  presm,um,vm,tm,gm,qm,rm,em,uu,vv,tt,gg,qq,vu,vt,vg,vq,ve,
     .  uq,ue,sm,ss,vs,dsdpm)
      IMPLICIT none
c
#include "netcdf.inc"
c***********************************************************************
      INTEGER iim, jjm, kkm
      REAL counter
c
      CHARACTER*(*) arrivee   ! Fichier d'accumulation a l'arrivee
      INTEGER nid
c
      INTEGER ierr, varid
      INTEGER idim_x, idim_y, idim_z, idim_t
      INTEGER dims4(4), dims3(3), dims2(2)
      INTEGER debut4(4), epais4(4)
      INTEGER debut3(3), epais3(3)
      INTEGER debut2(2), epais2(2)

      REAL x(iim), y(jjm), z(kkm) ! longitudes, latitudes et pressions
      REAL temps
c
      REAL um(iim,jjm,kkm)
      REAL vm(iim,jjm,kkm)
      REAL tm(iim,jjm,kkm)
      REAL gm(iim,jjm,kkm)
      REAL qm(iim,jjm,kkm)
      REAL rm(iim,jjm,kkm)
      REAL em(iim,jjm,kkm)
      REAL uu(iim,jjm,kkm)
      REAL vv(iim,jjm,kkm)
      REAL tt(iim,jjm,kkm)
      REAL gg(iim,jjm,kkm)
      REAL qq(iim,jjm,kkm)
      REAL vu(iim,jjm,kkm)
      REAL vt(iim,jjm,kkm)
      REAL vg(iim,jjm,kkm)
      REAL vq(iim,jjm,kkm)
      REAL ve(iim,jjm,kkm)
      REAL uq(iim,jjm,kkm)
      REAL ue(iim,jjm,kkm)
      REAL presm(iim,jjm,kkm)
      REAL psm(iim,jjm)
c
      REAL sm(iim,jjm,kkm)
      REAL ss(iim,jjm,kkm)
      REAL vs(iim,jjm,kkm)
      REAL dsdpm(iim,jjm,kkm)
c
      REAL bidon
c
      INTEGER i, j, k
c
c Ouvrir le fichier d'arrivee
c
      ierr = NF_CREATE (arrivee, NF_CLOBBER,nid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme de creation du fichier d arrivee"
         CALL abort
      ENDIF
c
c Preciser quelques attributs globaux:
c
      ierr = NF_PUT_ATT_TEXT (nid, NF_GLOBAL, "title", 37,
     .                       "Fichier carre en coordonnees pression")
      ierr = NF_PUT_ATT_TEXT (nid, NF_GLOBAL, "model", 30,
     .                       "Modele de circulation generale")
#ifdef NC_DOUBLE
      ierr = NF_PUT_ATT_DOUBLE 
#else
      ierr = NF_PUT_ATT_REAL 
#endif
     .       (nid,NF_GLOBAL,"counter",NF_FLOAT,1,counter)
c
c Definir les dimensions du fichier:
c
      ierr = NF_DEF_DIM(nid,"x",iim,idim_x)
      ierr = NF_DEF_DIM(nid,"y",jjm,idim_y)
      ierr = NF_DEF_DIM(nid,"levels",kkm,idim_z)
      ierr = NF_DEF_DIM(nid, "time", NF_UNLIMITED, idim_t)
c
      ierr = NF_ENDDEF(nid) ! sortir du mode de definition
c
c Definir et enregistrer certains champs invariants:
c
      ierr = NF_REDEF (nid)
      ierr = NF_DEF_VAR (nid,"x",NF_FLOAT,1,idim_x,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir x"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (nid, varid, "long_name", 10,"Longitudes")
      ierr = NF_PUT_ATT_TEXT (nid, varid, "units", 12,"degrees_east")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VARA_DOUBLE(nid,varid,1,iim,x)
#else
      ierr = NF_PUT_VARA_REAL(nid,varid,1,iim,x)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer x"
         CALL abort
      ENDIF
c
      ierr = NF_REDEF (nid)
      ierr = NF_DEF_VAR (nid,"y",NF_FLOAT,1,idim_y,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir y"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (nid, varid, "long_name", 9,"Latitudes")
      ierr = NF_PUT_ATT_TEXT (nid, varid, "units", 13,"degrees_north")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VARA_DOUBLE(nid,varid,1,jjm,y)
#else
      ierr = NF_PUT_VARA_REAL(nid,varid,1,jjm,y)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer y"
         CALL abort
      ENDIF
c
      ierr = NF_REDEF (nid)
      ierr = NF_DEF_VAR (nid,"levels",NF_FLOAT,1,idim_z,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir levs"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (nid, varid, "long_name", 7,"Presure")
      ierr = NF_PUT_ATT_TEXT (nid, varid, "units", 9,"millibars")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VARA_DOUBLE(nid,varid,1,kkm,z)
#else
      ierr = NF_PUT_VARA_REAL(nid,varid,1,kkm,z)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer levs"
         CALL abort
      ENDIF
c
      ierr = NF_REDEF (nid)
      ierr = NF_DEF_VAR (nid,"time", NF_FLOAT,1,idim_t,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir time"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT(nid,varid,"long_name",12,"time counter")
      ierr = NF_PUT_ATT_TEXT(nid,varid,"units",16,"days since 1-1-1")
      ierr = NF_PUT_ATT_TEXT(nid,varid,"note",18,"units may be wrong")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR1_DOUBLE(nid,varid,1,temps)
#else
      ierr = NF_PUT_VAR1_REAL(nid,varid,1,temps)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer time"
         CALL abort
      ENDIF
c
c
c
      dims3(1) = idim_x
      dims3(2) = idim_y
      dims3(3) = idim_t
      debut3(1) = 1
      debut3(2) = 1
      debut3(3) = 1
      epais3(1) = iim
      epais3(2) = jjm
      epais3(3) = 1
c
      CALL ecritnd(nid,iim*jjm, psm, 3, dims3, debut3, epais3, 
     .            "psm","PSM","Pa")

      dims4(1) = idim_x
      dims4(2) = idim_y
      dims4(3) = idim_z
      dims4(4) = idim_t
      debut4(1) = 1
      debut4(2) = 1
      debut4(3) = 1
      debut4(4) = 1
      epais4(1) = iim
      epais4(2) = jjm
      epais4(3) = kkm
      epais4(4) = 1
c
      CALL ecritnd(nid,iim*jjm*kkm, presm, 4, dims4,debut4,epais4,
     .             "presm", "PRESM", "Pa")
c
      CALL ecritnd(nid,iim*jjm*kkm, um, 4, dims4,debut4,epais4,
     .             "um", "UM", "m/s")
c
      CALL ecritnd(nid,iim*jjm*kkm, vm, 4, dims4,debut4,epais4,
     .             "vm", "VM", "m/s")
c
      CALL ecritnd(nid,iim*jjm*kkm, tm, 4, dims4,debut4,epais4,
     .             "tm", "TM", "K")
c
      CALL ecritnd(nid,iim*jjm*kkm, gm, 4, dims4,debut4,epais4,
     .             "gm", "GM", "m")
c
      CALL ecritnd(nid,iim*jjm*kkm, qm, 4, dims4,debut4,epais4,
     .             "qm", "QM", "kg/kg")
c
      CALL ecritnd(nid,iim*jjm*kkm, rm, 4, dims4,debut4,epais4,
     .             "rm", "RM", "%")
c
      CALL ecritnd(nid,iim*jjm*kkm, em, 4, dims4,debut4,epais4,
     .             "em", "EM", "J/kg")
c
c
      CALL ecritnd(nid,iim*jjm*kkm, uu, 4, dims4,debut4,epais4,
     .             "uu", "UU", "m2/s2")
c
      CALL ecritnd(nid,iim*jjm*kkm, vv, 4, dims4,debut4,epais4,
     .             "vv", "VV", "m2/s2")
c
      CALL ecritnd(nid,iim*jjm*kkm, tt, 4, dims4,debut4,epais4,
     .             "tt", "TT", "K2")
c
      CALL ecritnd(nid,iim*jjm*kkm, gg, 4, dims4,debut4,epais4,
     .             "gg", "GG", "m2")
c
      CALL ecritnd(nid,iim*jjm*kkm, qq, 4, dims4,debut4,epais4,
     .             "qq", "QQ", "kg2/kg2")
c
      CALL ecritnd(nid,iim*jjm*kkm, vu, 4, dims4,debut4,epais4,
     .             "vu", "VU", "m2/s2")
c
      CALL ecritnd(nid,iim*jjm*kkm, vt, 4, dims4,debut4,epais4,
     .             "vt", "VT", "K m/s")
c
      CALL ecritnd(nid,iim*jjm*kkm, vg, 4, dims4,debut4,epais4,
     .             "vg", "VG", "m2/s")
c
      CALL ecritnd(nid,iim*jjm*kkm, vq, 4, dims4,debut4,epais4,
     .             "vq", "VQ", "kg/kg m/s")
c
      CALL ecritnd(nid,iim*jjm*kkm, ve, 4, dims4,debut4,epais4,
     .             "ve", "VE", "J/kg m/s")
c
      CALL ecritnd(nid,iim*jjm*kkm, uq, 4, dims4,debut4,epais4,
     .             "uq", "UQ", "kg/kg m/s")
c
      CALL ecritnd(nid,iim*jjm*kkm, ue, 4, dims4,debut4,epais4,
     .             "ue", "UE", "J/kg m/s")
c
c
      CALL ecritnd(nid,iim*jjm*kkm, sm, 4, dims4,debut4,epais4,
     .             "sm", "SM", "K")
c
      CALL ecritnd(nid,iim*jjm*kkm, ss, 4, dims4,debut4,epais4,
     .             "ss", "SS", "K2")
c
      CALL ecritnd(nid,iim*jjm*kkm, vs, 4, dims4,debut4,epais4,
     .             "vs", "VS", "Km/s")
c
      CALL ecritnd(nid,iim*jjm*kkm, dsdpm, 4, dims4,debut4,epais4,
     .             "dsdpm", "DSDPM", "K/pa")
c
      ierr = NF_CLOSE(nid)
c
      RETURN 
      END
      SUBROUTINE ecrit_diag(filename,iim,jjm,kkm,x,y,z,
     .  vq_vi_total,vq_vi_moyen,vt_vi_total,vt_vi_moyen,
     .  vg_vi_total,vg_vi_moyen,vu_vi_total,vu_vi_moyen,
     .  ve_vi_total,ve_vi_moyen,
     .  uq_vi_total,uq_vi_moyen,ue_vi_total,ue_vi_moyen,
     .  vq_z_total,vq_z_moyen,vq_z_trans,vq_z_stati,
     .  vq_z_vi_total,vq_z_vi_moyen,vq_z_vi_trans,vq_z_vi_stati,
     .  vt_z_total,vt_z_moyen,vt_z_trans,vt_z_stati,
     .  vt_z_vi_total,vt_z_vi_moyen,vt_z_vi_trans,vt_z_vi_stati,
     .  vg_z_total,vg_z_moyen,vg_z_trans,vg_z_stati,
     .  vg_z_vi_total,vg_z_vi_moyen,vg_z_vi_trans,vg_z_vi_stati,
     .  vu_z_total,vu_z_moyen,vu_z_trans,vu_z_stati,
     .  vu_z_vi_total,vu_z_vi_moyen,vu_z_vi_trans,vu_z_vi_stati,
     .  ve_z_total,ve_z_moyen,ve_z_trans,ve_z_stati,
     .  ve_z_vi_total,ve_z_vi_moyen,ve_z_vi_trans,ve_z_vi_stati,
     .  stream,qm_vi,em_vi)
      IMPLICIT none
c
#include "netcdf.inc"
c***********************************************************************
      INTEGER iim, jjm, kkm
c
      CHARACTER*(*) filename   ! Fichier d'accumulation a l'arrivee
      INTEGER nid

c
      REAL temps
c
      INTEGER ierr, varid
      INTEGER idim_x, idim_y, idim_z, idim_t
      INTEGER dims4(4), dims3(3), dims2(2)
      INTEGER debut4(4), epais4(4)
      INTEGER debut3(3), epais3(3)
      INTEGER debut2(2), epais2(2)

      REAL x(iim), y(jjm), z(kkm) ! longitudes, latitudes et pressions
c
      REAL vq_vi_total(iim,jjm), vq_vi_moyen(iim,jjm)
      REAL vt_vi_total(iim,jjm), vt_vi_moyen(iim,jjm)
      REAL vg_vi_total(iim,jjm), vg_vi_moyen(iim,jjm)
      REAL vu_vi_total(iim,jjm), vu_vi_moyen(iim,jjm)
      REAL ve_vi_total(iim,jjm), ve_vi_moyen(iim,jjm)
      REAL uq_vi_total(iim,jjm), uq_vi_moyen(iim,jjm)
      REAL ue_vi_total(iim,jjm), ue_vi_moyen(iim,jjm)
c
      REAL qm_vi(iim,jjm), em_vi(iim,jjm)
c
      REAL vq_z_total(jjm,kkm), vq_z_vi_total(jjm)
      REAL vq_z_moyen(jjm,kkm), vq_z_vi_moyen(jjm)
      REAL vq_z_trans(jjm,kkm), vq_z_vi_trans(jjm)
      REAL vq_z_stati(jjm,kkm), vq_z_vi_stati(jjm)
c
      REAL vt_z_total(jjm,kkm), vt_z_vi_total(jjm)
      REAL vt_z_moyen(jjm,kkm), vt_z_vi_moyen(jjm)
      REAL vt_z_trans(jjm,kkm), vt_z_vi_trans(jjm)
      REAL vt_z_stati(jjm,kkm), vt_z_vi_stati(jjm)
c
      REAL vg_z_total(jjm,kkm), vg_z_vi_total(jjm)
      REAL vg_z_moyen(jjm,kkm), vg_z_vi_moyen(jjm)
      REAL vg_z_trans(jjm,kkm), vg_z_vi_trans(jjm)
      REAL vg_z_stati(jjm,kkm), vg_z_vi_stati(jjm)
c
      REAL vu_z_total(jjm,kkm), vu_z_vi_total(jjm)
      REAL vu_z_moyen(jjm,kkm), vu_z_vi_moyen(jjm)
      REAL vu_z_trans(jjm,kkm), vu_z_vi_trans(jjm)
      REAL vu_z_stati(jjm,kkm), vu_z_vi_stati(jjm)
c
      REAL ve_z_total(jjm,kkm), ve_z_vi_total(jjm)
      REAL ve_z_moyen(jjm,kkm), ve_z_vi_moyen(jjm)
      REAL ve_z_trans(jjm,kkm), ve_z_vi_trans(jjm)
      REAL ve_z_stati(jjm,kkm), ve_z_vi_stati(jjm)
c
      REAL stream(jjm,kkm)
c
      REAL bidon
c
      INTEGER i, j, k
c
      temps = 1.0
c
c Ouvrir le fichier d'arrivee
c
      ierr = NF_CREATE (filename, NF_CLOBBER,nid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme de creation du fichier d arrivee"
         CALL abort
      ENDIF
c
c Preciser quelques attributs globaux:
c
      ierr = NF_PUT_ATT_TEXT (nid, NF_GLOBAL, "title", 37,
     .                       "Fichier carre en coordonnees pression")
      ierr = NF_PUT_ATT_TEXT (nid, NF_GLOBAL, "model", 30,
     .                       "Modele de circulation generale")
c
c Definir les dimensions du fichier:
c
      ierr = NF_DEF_DIM(nid,"x",iim,idim_x)
      ierr = NF_DEF_DIM(nid,"y",jjm,idim_y)
      ierr = NF_DEF_DIM(nid,"levels",kkm,idim_z)
      ierr = NF_DEF_DIM(nid, "time", NF_UNLIMITED, idim_t)
c
      ierr = NF_ENDDEF(nid) ! sortir du mode de definition
c
c Definir et enregistrer certains champs invariants:
c
      ierr = NF_REDEF (nid)
      ierr = NF_DEF_VAR (nid,"x",NF_FLOAT,1,idim_x,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir x"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (nid, varid, "long_name", 10,"Longitudes")
      ierr = NF_PUT_ATT_TEXT (nid, varid, "units", 12,"degrees_east")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VARA_DOUBLE(nid,varid,1,iim,x)
#else
      ierr = NF_PUT_VARA_REAL(nid,varid,1,iim,x)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer x"
         CALL abort
      ENDIF
c
      ierr = NF_REDEF (nid)
      ierr = NF_DEF_VAR (nid,"y",NF_FLOAT,1,idim_y,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir y"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (nid, varid, "long_name", 9,"Latitudes")
      ierr = NF_PUT_ATT_TEXT (nid, varid, "units", 13,"degrees_north")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VARA_DOUBLE(nid,varid,1,jjm,y)
#else
      ierr = NF_PUT_VARA_REAL(nid,varid,1,jjm,y)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer y"
         CALL abort
      ENDIF
c
      ierr = NF_REDEF (nid)
      ierr = NF_DEF_VAR (nid,"levels",NF_FLOAT,1,idim_z,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir levs"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (nid, varid, "long_name", 7,"Presure")
      ierr = NF_PUT_ATT_TEXT (nid, varid, "units", 9,"millibars")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VARA_DOUBLE(nid,varid,1,kkm,z)
#else
      ierr = NF_PUT_VARA_REAL(nid,varid,1,kkm,z)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer levs"
         CALL abort
      ENDIF
c
      ierr = NF_REDEF (nid)
      ierr = NF_DEF_VAR (nid,"time", NF_FLOAT,1,idim_t,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir time"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT(nid,varid,"long_name",12,"time counter")
      ierr = NF_PUT_ATT_TEXT(nid,varid,"units",16,"days since 1-1-1")
      ierr = NF_PUT_ATT_TEXT(nid,varid,"note",18,"units may be wrong")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR1_DOUBLE(nid,varid,1,temps)
#else
      ierr = NF_PUT_VAR1_REAL(nid,varid,1,temps)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer time"
         CALL abort
      ENDIF
c
c
c
      dims3(1) = idim_x
      dims3(2) = idim_y
      dims3(3) = idim_t
      debut3(1) = 1
      debut3(2) = 1
      debut3(3) = 1
      epais3(1) = iim
      epais3(2) = jjm
      epais3(3) = 1
c
      CALL ecritnd(nid,iim*jjm, vq_vi_total, 3, dims3,debut3,epais3,
     .             "vq_vi_total", "VQ", "kg/m/s")
c
      CALL ecritnd(nid,iim*jjm, vq_vi_moyen, 3, dims3,debut3,epais3,
     .             "vq_vi_moyen", "VQ", "kg/m/s")
c
      CALL ecritnd(nid,iim*jjm, vt_vi_total, 3, dims3,debut3,epais3,
     .             "vt_vi_total", "VT", "K kg/m/s")
c
      CALL ecritnd(nid,iim*jjm, vt_vi_moyen, 3, dims3,debut3,epais3,
     .             "vt_vi_moyen", "VT", "K kg/m/s")
c
      CALL ecritnd(nid,iim*jjm, vg_vi_total, 3, dims3,debut3,epais3,
     .             "vg_vi_total", "VG", "m kg/m/s")
c
      CALL ecritnd(nid,iim*jjm, vg_vi_moyen, 3, dims3,debut3,epais3,
     .             "vg_vi_moyen", "VG", "m kg/m/s")
c
      CALL ecritnd(nid,iim*jjm, vu_vi_total, 3, dims3,debut3,epais3,
     .             "vu_vi_total", "VU", "m/s kg/m/s")
c
      CALL ecritnd(nid,iim*jjm, vu_vi_moyen, 3, dims3,debut3,epais3,
     .             "vu_vi_moyen", "VU", "m/s kg/m/s")
c
      CALL ecritnd(nid,iim*jjm, ve_vi_total, 3, dims3,debut3,epais3,
     .             "ve_vi_total", "VE", "J/m/s")
c
      CALL ecritnd(nid,iim*jjm, ve_vi_moyen, 3, dims3,debut3,epais3,
     .             "ve_vi_moyen", "VE", "J/m/s")
c
      CALL ecritnd(nid,iim*jjm, uq_vi_total, 3, dims3,debut3,epais3,
     .             "uq_vi_total", "UQ", "kg/m/s")
c
      CALL ecritnd(nid,iim*jjm, uq_vi_moyen, 3, dims3,debut3,epais3,
     .             "uq_vi_moyen", "UQ", "kg/m/s")
c
      CALL ecritnd(nid,iim*jjm, ue_vi_total, 3, dims3,debut3,epais3,
     .             "ue_vi_total", "UE", "J/m/s")
c
      CALL ecritnd(nid,iim*jjm, ue_vi_moyen, 3, dims3,debut3,epais3,
     .             "ue_vi_moyen", "UE", "J/m/s")
c
      CALL ecritnd(nid,iim*jjm, qm_vi, 3, dims3,debut3,epais3,
     .             "qm_vi", "QM", "kg/m2")
c
      CALL ecritnd(nid,iim*jjm, em_vi, 3, dims3,debut3,epais3,
     .             "em_vi", "EM", "J/m2")
c
c
      dims3(1) = idim_y
      dims3(2) = idim_z
      dims3(3) = idim_t
      debut3(1) = 1
      debut3(2) = 1
      debut3(3) = 1
      epais3(1) = jjm
      epais3(2) = kkm
      epais3(3) = 1
c
      CALL ecritnd(nid,jjm*kkm, vq_z_total, 3, dims3,debut3,epais3,
     .             "vq_z_total", "VQ", "kg/kg m/s")
c
      CALL ecritnd(nid,jjm*kkm, vq_z_moyen, 3, dims3,debut3,epais3,
     .             "vq_z_moyen", "VQ", "kg/kg m/s")
c
      CALL ecritnd(nid,jjm*kkm, vq_z_trans, 3, dims3,debut3,epais3,
     .             "vq_z_trans", "VQ", "kg/kg m/s")
c
      CALL ecritnd(nid,jjm*kkm, vq_z_stati, 3, dims3,debut3,epais3,
     .             "vq_z_stati", "VQ", "kg/kg m/s")
c
      CALL ecritnd(nid,jjm*kkm, vt_z_total, 3, dims3,debut3,epais3,
     .             "vt_z_total", "VT", "K m/s")
c
      CALL ecritnd(nid,jjm*kkm, vt_z_moyen, 3, dims3,debut3,epais3,
     .             "vt_z_moyen", "VT", "K m/s")
c
      CALL ecritnd(nid,jjm*kkm, vt_z_trans, 3, dims3,debut3,epais3,
     .             "vt_z_trans", "VT", "K m/s")
c
      CALL ecritnd(nid,jjm*kkm, vt_z_stati, 3, dims3,debut3,epais3,
     .             "vt_z_stati", "VT", "K m/s")
c
      CALL ecritnd(nid,jjm*kkm, vg_z_total, 3, dims3,debut3,epais3,
     .             "vg_z_total", "VG", "m m/s")
c
      CALL ecritnd(nid,jjm*kkm, vg_z_moyen, 3, dims3,debut3,epais3,
     .             "vg_z_moyen", "VG", "m m/s")
c
      CALL ecritnd(nid,jjm*kkm, vg_z_trans, 3, dims3,debut3,epais3,
     .             "vg_z_trans", "VG", "m m/s")
c
      CALL ecritnd(nid,jjm*kkm, vg_z_stati, 3, dims3,debut3,epais3,
     .             "vg_z_stati", "VG", "m m/s")
c
      CALL ecritnd(nid,jjm*kkm, vu_z_total, 3, dims3,debut3,epais3,
     .             "vu_z_total", "VU", "m2/s2")
c
      CALL ecritnd(nid,jjm*kkm, vu_z_moyen, 3, dims3,debut3,epais3,
     .             "vu_z_moyen", "VU", "m2/s2")
c
      CALL ecritnd(nid,jjm*kkm, vu_z_trans, 3, dims3,debut3,epais3,
     .             "vu_z_trans", "VU", "m2/s2")
c
      CALL ecritnd(nid,jjm*kkm, vu_z_stati, 3, dims3,debut3,epais3,
     .             "vu_z_stati", "VU", "m2/s2")
c
      CALL ecritnd(nid,jjm*kkm, ve_z_total, 3, dims3,debut3,epais3,
     .             "ve_z_total", "VE", "J/kg m/s")
c
      CALL ecritnd(nid,jjm*kkm, ve_z_moyen, 3, dims3,debut3,epais3,
     .             "ve_z_moyen", "VE", "J/kg m/s")
c
      CALL ecritnd(nid,jjm*kkm, ve_z_trans, 3, dims3,debut3,epais3,
     .             "ve_z_trans", "VE", "J/kg m/s")
c
      CALL ecritnd(nid,jjm*kkm, ve_z_stati, 3, dims3,debut3,epais3,
     .             "ve_z_stati", "VE", "J/kg m/s")
c
c
      CALL ecritnd(nid,jjm*kkm, stream, 3, dims3,debut3,epais3,
     .             "stream", "Hadley cell", "kg/s")
c
      dims2(1) = idim_y
      dims2(2) = idim_t
      debut2(1) = 1
      debut2(2) = 1
      epais2(1) = jjm
      epais2(2) = 1
c
      CALL ecritnd(nid,jjm,vq_z_vi_total,2,dims2,debut2,epais2,
     .             "vq_z_vi_total", "VQ", "kg/s")
c
      CALL ecritnd(nid,jjm,vq_z_vi_moyen,2,dims2,debut2,epais2,
     .             "vq_z_vi_moyen", "VQ", "kg/s")
c
      CALL ecritnd(nid,jjm,vq_z_vi_trans,2,dims2,debut2,epais2,
     .             "vq_z_vi_trans", "VQ", "kg/s")
c
      CALL ecritnd(nid,jjm,vq_z_vi_stati,2,dims2,debut2,epais2,
     .             "vq_z_vi_stati", "VQ", "kg/s")
c
      CALL ecritnd(nid,jjm,vt_z_vi_total,2,dims2,debut2,epais2,
     .             "vt_z_vi_total", "VT", "Kkg/s")
c
      CALL ecritnd(nid,jjm,vt_z_vi_moyen,2,dims2,debut2,epais2,
     .             "vt_z_vi_moyen", "VT", "Kkg/s")
c
      CALL ecritnd(nid,jjm,vt_z_vi_trans,2,dims2,debut2,epais2,
     .             "vt_z_vi_trans", "VT", "Kkg/s")
c
      CALL ecritnd(nid,jjm,vt_z_vi_stati,2,dims2,debut2,epais2,
     .             "vt_z_vi_stati", "VT", "Kkg/s")
c
      CALL ecritnd(nid,jjm,vg_z_vi_total,2,dims2,debut2,epais2,
     .             "vg_z_vi_total", "VG", "kgm/s")
c
      CALL ecritnd(nid,jjm,vg_z_vi_moyen,2,dims2,debut2,epais2,
     .             "vg_z_vi_moyen", "VG", "kgm/s")
c
      CALL ecritnd(nid,jjm,vg_z_vi_trans,2,dims2,debut2,epais2,
     .             "vg_z_vi_trans", "VG", "kgm/s")
c
      CALL ecritnd(nid,jjm,vg_z_vi_stati,2,dims2,debut2,epais2,
     .             "vg_z_vi_stati", "VG", "kgm/s")
c
      CALL ecritnd(nid,jjm,vu_z_vi_total,2,dims2,debut2,epais2,
     .             "vu_z_vi_total", "VU", "kgm/s2")
c
      CALL ecritnd(nid,jjm,vu_z_vi_moyen,2,dims2,debut2,epais2,
     .             "vu_z_vi_moyen", "VU", "kgm/s2")
c
      CALL ecritnd(nid,jjm,vu_z_vi_trans,2,dims2,debut2,epais2,
     .             "vu_z_vi_trans", "VU", "kgm/s2")
c
      CALL ecritnd(nid,jjm,vu_z_vi_stati,2,dims2,debut2,epais2,
     .             "vu_z_vi_stati", "VU", "kgm/s2")
c
      CALL ecritnd(nid,jjm,ve_z_vi_total,2,dims2,debut2,epais2,
     .             "ve_z_vi_total", "VE", "J/s")
c
      CALL ecritnd(nid,jjm,ve_z_vi_moyen,2,dims2,debut2,epais2,
     .             "ve_z_vi_moyen", "VE", "J/s")
c
      CALL ecritnd(nid,jjm,ve_z_vi_trans,2,dims2,debut2,epais2,
     .             "ve_z_vi_trans", "VE", "J/s")
c
      CALL ecritnd(nid,jjm,ve_z_vi_stati,2,dims2,debut2,epais2,
     .             "ve_z_vi_stati", "VE", "J/s")
c
      ierr = NF_CLOSE(nid)
c
      RETURN 
      END
      SUBROUTINE ecrit_diag_bis(filename,iim,jjm,kkm,x,y,z,
     .  vq_vi_total,vq_vi_moyen,vt_vi_total,vt_vi_moyen,
     .  vg_vi_total,vg_vi_moyen,vu_vi_total,vu_vi_moyen,
     .  ve_vi_total,ve_vi_moyen,
     .  uq_vi_total,uq_vi_moyen,ue_vi_total,ue_vi_moyen,
     .  vq_z_total,vq_z_moyen,vq_z_trans,vq_z_stati,
     .  vq_z_vi_total,vq_z_vi_moyen,vq_z_vi_trans,vq_z_vi_stati,
     .  vt_z_total,vt_z_moyen,vt_z_trans,vt_z_stati,
     .  vt_z_vi_total,vt_z_vi_moyen,vt_z_vi_trans,vt_z_vi_stati,
     .  vg_z_total,vg_z_moyen,vg_z_trans,vg_z_stati,
     .  vg_z_vi_total,vg_z_vi_moyen,vg_z_vi_trans,vg_z_vi_stati,
     .  vu_z_total,vu_z_moyen,vu_z_trans,vu_z_stati,
     .  vu_z_vi_total,vu_z_vi_moyen,vu_z_vi_trans,vu_z_vi_stati,
     .  ve_z_total,ve_z_moyen,ve_z_trans,ve_z_stati,
     .  ve_z_vi_total,ve_z_vi_moyen,ve_z_vi_trans,ve_z_vi_stati,
     .  stream,qm_vi,em_vi)
      IMPLICIT none
c
#include "netcdf.inc"
c***********************************************************************
      INTEGER iim, jjm, kkm
c
      CHARACTER*(*) filename   ! Fichier d'accumulation a l'arrivee
      INTEGER nid
c
      REAL temps
c
      INTEGER ierr, varid
      INTEGER idim_x, idim_y, idim_z, idim_t
      INTEGER dims4(4)
      INTEGER debut4(4), epais4(4)

      REAL x(iim), y(jjm), z(kkm) ! longitudes, latitudes et pressions
c
      REAL vq_vi_total(iim,jjm), vq_vi_moyen(iim,jjm)
      REAL vt_vi_total(iim,jjm), vt_vi_moyen(iim,jjm)
      REAL vg_vi_total(iim,jjm), vg_vi_moyen(iim,jjm)
      REAL vu_vi_total(iim,jjm), vu_vi_moyen(iim,jjm)
      REAL ve_vi_total(iim,jjm), ve_vi_moyen(iim,jjm)
      REAL uq_vi_total(iim,jjm), uq_vi_moyen(iim,jjm)
      REAL ue_vi_total(iim,jjm), ue_vi_moyen(iim,jjm)
c
      REAL qm_vi(iim,jjm), em_vi(iim,jjm)
c
      REAL vq_z_total(jjm,kkm), vq_z_vi_total(jjm)
      REAL vq_z_moyen(jjm,kkm), vq_z_vi_moyen(jjm)
      REAL vq_z_trans(jjm,kkm), vq_z_vi_trans(jjm)
      REAL vq_z_stati(jjm,kkm), vq_z_vi_stati(jjm)
c
      REAL vt_z_total(jjm,kkm), vt_z_vi_total(jjm)
      REAL vt_z_moyen(jjm,kkm), vt_z_vi_moyen(jjm)
      REAL vt_z_trans(jjm,kkm), vt_z_vi_trans(jjm)
      REAL vt_z_stati(jjm,kkm), vt_z_vi_stati(jjm)
c
      REAL vg_z_total(jjm,kkm), vg_z_vi_total(jjm)
      REAL vg_z_moyen(jjm,kkm), vg_z_vi_moyen(jjm)
      REAL vg_z_trans(jjm,kkm), vg_z_vi_trans(jjm)
      REAL vg_z_stati(jjm,kkm), vg_z_vi_stati(jjm)
c
      REAL vu_z_total(jjm,kkm), vu_z_vi_total(jjm)
      REAL vu_z_moyen(jjm,kkm), vu_z_vi_moyen(jjm)
      REAL vu_z_trans(jjm,kkm), vu_z_vi_trans(jjm)
      REAL vu_z_stati(jjm,kkm), vu_z_vi_stati(jjm)
c
      REAL ve_z_total(jjm,kkm), ve_z_vi_total(jjm)
      REAL ve_z_moyen(jjm,kkm), ve_z_vi_moyen(jjm)
      REAL ve_z_trans(jjm,kkm), ve_z_vi_trans(jjm)
      REAL ve_z_stati(jjm,kkm), ve_z_vi_stati(jjm)
c
      REAL stream(jjm,kkm)
c
      REAL bidon
c
      INTEGER i, j, k
c
      temps = 1.0
c
c Ouvrir le fichier d'arrivee
c
      ierr = NF_CREATE ("map_"//filename, NF_CLOBBER,nid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme de creation du fichier d arrivee"
         CALL abort
      ENDIF
c
c Preciser quelques attributs globaux:
c
      ierr = NF_PUT_ATT_TEXT (nid, NF_GLOBAL, "title", 37,
     .                       "Fichier carre en coordonnees pression")
      ierr = NF_PUT_ATT_TEXT (nid, NF_GLOBAL, "model", 30,
     .                       "Modele de circulation generale")
c
c Definir les dimensions du fichier:
c
      ierr = NF_DEF_DIM(nid,"x",iim,idim_x)
      ierr = NF_DEF_DIM(nid,"y",jjm,idim_y)
      ierr = NF_DEF_DIM(nid,"levels",1,idim_z)
      ierr = NF_DEF_DIM(nid, "time", NF_UNLIMITED, idim_t)
c
      ierr = NF_ENDDEF(nid) ! sortir du mode de definition
c
c Definir et enregistrer certains champs invariants:
c
      ierr = NF_REDEF (nid)
      ierr = NF_DEF_VAR (nid,"x",NF_FLOAT,1,idim_x,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir x"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (nid, varid, "long_name", 10,"Longitudes")
      ierr = NF_PUT_ATT_TEXT (nid, varid, "units", 12,"degrees_east")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VARA_DOUBLE(nid,varid,1,iim,x)
#else
      ierr = NF_PUT_VARA_REAL(nid,varid,1,iim,x)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer x"
         CALL abort
      ENDIF
c
      ierr = NF_REDEF (nid)
      ierr = NF_DEF_VAR (nid,"y",NF_FLOAT,1,idim_y,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir y"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (nid, varid, "long_name", 9,"Latitudes")
      ierr = NF_PUT_ATT_TEXT (nid, varid, "units", 13,"degrees_north")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VARA_DOUBLE(nid,varid,1,jjm,y)
#else
      ierr = NF_PUT_VARA_REAL(nid,varid,1,jjm,y)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer y"
         CALL abort
      ENDIF
c
      ierr = NF_REDEF (nid)
      ierr = NF_DEF_VAR (nid,"levels",NF_FLOAT,1,idim_z,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir levs"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (nid, varid, "long_name", 7,"Presure")
      ierr = NF_PUT_ATT_TEXT (nid, varid, "units", 9,"millibars")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VARA_DOUBLE(nid,varid,1,1,z(1))
#else
      ierr = NF_PUT_VARA_REAL(nid,varid,1,1,z(1))
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer levs"
         CALL abort
      ENDIF
c
      ierr = NF_REDEF (nid)
      ierr = NF_DEF_VAR (nid,"time", NF_FLOAT,1,idim_t,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir time"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT(nid,varid,"long_name",12,"time counter")
      ierr = NF_PUT_ATT_TEXT(nid,varid,"units",16,"days since 1-1-1")
      ierr = NF_PUT_ATT_TEXT(nid,varid,"note",18,"units may be wrong")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR1_DOUBLE(nid,varid,1,temps)
#else
      ierr = NF_PUT_VAR1_REAL(nid,varid,1,temps)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer time"
         CALL abort
      ENDIF
c
      dims4(1) = idim_x
      dims4(2) = idim_y
      dims4(3) = idim_z
      dims4(4) = idim_t
      debut4(1) = 1
      debut4(2) = 1
      debut4(3) = 1
      debut4(4) = 1
      epais4(1) = iim
      epais4(2) = jjm
      epais4(3) = 1
      epais4(4) = 1
c
      CALL ecritnd(nid,iim*jjm, vq_vi_total, 4, dims4,debut4,epais4,
     .             "vq_vi_total", "VQ", "kg/m/s")
c
      CALL ecritnd(nid,iim*jjm, vq_vi_moyen, 4, dims4,debut4,epais4,
     .             "vq_vi_moyen", "VQ", "kg/m/s")
c
      CALL ecritnd(nid,iim*jjm, vt_vi_total, 4, dims4,debut4,epais4,
     .             "vt_vi_total", "VT", "K kg/m/s")
c
      CALL ecritnd(nid,iim*jjm, vt_vi_moyen, 4, dims4,debut4,epais4,
     .             "vt_vi_moyen", "VT", "K kg/m/s")
c
      CALL ecritnd(nid,iim*jjm, vg_vi_total, 4, dims4,debut4,epais4,
     .             "vg_vi_total", "VG", "m kg/m/s")
c
      CALL ecritnd(nid,iim*jjm, vg_vi_moyen, 4, dims4,debut4,epais4,
     .             "vg_vi_moyen", "VG", "m kg/m/s")
c
      CALL ecritnd(nid,iim*jjm, vu_vi_total, 4, dims4,debut4,epais4,
     .             "vu_vi_total", "VU", "m/s kg/m/s")
c
      CALL ecritnd(nid,iim*jjm, vu_vi_moyen, 4, dims4,debut4,epais4,
     .             "vu_vi_moyen", "VU", "m/s kg/m/s")
c
      CALL ecritnd(nid,iim*jjm, ve_vi_total, 4, dims4,debut4,epais4,
     .             "ve_vi_total", "VE", "J/m/s")
c
      CALL ecritnd(nid,iim*jjm, ve_vi_moyen, 4, dims4,debut4,epais4,
     .             "ve_vi_moyen", "VE", "J/m/s")
c
      CALL ecritnd(nid,iim*jjm, uq_vi_total, 4, dims4,debut4,epais4,
     .             "uq_vi_total", "UQ", "kg/m/s")
c
      CALL ecritnd(nid,iim*jjm, uq_vi_moyen, 4, dims4,debut4,epais4,
     .             "uq_vi_moyen", "UQ", "kg/m/s")
c
      CALL ecritnd(nid,iim*jjm, ue_vi_total, 4, dims4,debut4,epais4,
     .             "ue_vi_total", "UE", "J/m/s")
c
      CALL ecritnd(nid,iim*jjm, ue_vi_moyen, 4, dims4,debut4,epais4,
     .             "ue_vi_moyen", "UE", "J/m/s")
c
      CALL ecritnd(nid,iim*jjm, qm_vi, 4, dims4,debut4,epais4,
     .             "qm_vi", "QM", "kg/m2")
c
      CALL ecritnd(nid,iim*jjm, em_vi, 4, dims4,debut4,epais4,
     .             "em_vi", "EM", "J/m2")
c
      ierr = NF_CLOSE(nid)
c
      ierr = NF_CREATE ("section_"//filename, NF_CLOBBER,nid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme de creation du fichier d arrivee"
         CALL abort
      ENDIF
c
c Preciser quelques attributs globaux:
c
      ierr = NF_PUT_ATT_TEXT (nid, NF_GLOBAL, "title", 37,
     .                       "Fichier carre en coordonnees pression")
      ierr = NF_PUT_ATT_TEXT (nid, NF_GLOBAL, "model", 30,
     .                       "Modele de circulation generale")
c
c Definir les dimensions du fichier:
c
      ierr = NF_DEF_DIM(nid,"x",1,idim_x)
      ierr = NF_DEF_DIM(nid,"y",jjm,idim_y)
      ierr = NF_DEF_DIM(nid,"levels",kkm,idim_z)
      ierr = NF_DEF_DIM(nid, "time", NF_UNLIMITED, idim_t)
c
      ierr = NF_ENDDEF(nid) ! sortir du mode de definition
c
c Definir et enregistrer certains champs invariants:
c
      ierr = NF_REDEF (nid)
      ierr = NF_DEF_VAR (nid,"x",NF_FLOAT,1,idim_x,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir x"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (nid, varid, "long_name", 10,"Longitudes")
      ierr = NF_PUT_ATT_TEXT (nid, varid, "units", 12,"degrees_east")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VARA_DOUBLE(nid,varid,1,1,x(1))
#else
      ierr = NF_PUT_VARA_REAL(nid,varid,1,1,x(1))
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer x"
         CALL abort
      ENDIF
c
      ierr = NF_REDEF (nid)
      ierr = NF_DEF_VAR (nid,"y",NF_FLOAT,1,idim_y,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir y"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (nid, varid, "long_name", 9,"Latitudes")
      ierr = NF_PUT_ATT_TEXT (nid, varid, "units", 13,"degrees_north")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VARA_DOUBLE(nid,varid,1,jjm,y)
#else
      ierr = NF_PUT_VARA_REAL(nid,varid,1,jjm,y)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer y"
         CALL abort
      ENDIF
c
      ierr = NF_REDEF (nid)
      ierr = NF_DEF_VAR (nid,"levels",NF_FLOAT,1,idim_z,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir levs"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (nid, varid, "long_name", 7,"Presure")
      ierr = NF_PUT_ATT_TEXT (nid, varid, "units", 9,"millibars")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VARA_DOUBLE(nid,varid,1,kkm,z)
#else
      ierr = NF_PUT_VARA_REAL(nid,varid,1,kkm,z)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer levs"
         CALL abort
      ENDIF
c
      ierr = NF_REDEF (nid)
      ierr = NF_DEF_VAR (nid,"time", NF_FLOAT,1,idim_t,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir time"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT(nid,varid,"long_name",12,"time counter")
      ierr = NF_PUT_ATT_TEXT(nid,varid,"units",16,"days since 1-1-1")
      ierr = NF_PUT_ATT_TEXT(nid,varid,"note",18,"units may be wrong")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR1_DOUBLE(nid,varid,1,temps)
#else
      ierr = NF_PUT_VAR1_REAL(nid,varid,1,temps)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer time"
         CALL abort
      ENDIF
c
      dims4(1) = idim_x
      dims4(2) = idim_y
      dims4(3) = idim_z
      dims4(4) = idim_t
      debut4(1) = 1
      debut4(2) = 1
      debut4(3) = 1
      debut4(4) = 1
      epais4(1) = 1
      epais4(2) = jjm
      epais4(3) = kkm
      epais4(4) = 1
c
      CALL ecritnd(nid,jjm*kkm, vq_z_total, 4, dims4,debut4,epais4,
     .             "vq_z_total", "VQ", "kg/kg m/s")
c
      CALL ecritnd(nid,jjm*kkm, vq_z_moyen, 4, dims4,debut4,epais4,
     .             "vq_z_moyen", "VQ", "kg/kg m/s")
c
      CALL ecritnd(nid,jjm*kkm, vq_z_trans, 4, dims4,debut4,epais4,
     .             "vq_z_trans", "VQ", "kg/kg m/s")
c
      CALL ecritnd(nid,jjm*kkm, vq_z_stati, 4, dims4,debut4,epais4,
     .             "vq_z_stati", "VQ", "kg/kg m/s")
c
      CALL ecritnd(nid,jjm*kkm, vt_z_total, 4, dims4,debut4,epais4,
     .             "vt_z_total", "VT", "K m/s")
c
      CALL ecritnd(nid,jjm*kkm, vt_z_moyen, 4, dims4,debut4,epais4,
     .             "vt_z_moyen", "VT", "K m/s")
c
      CALL ecritnd(nid,jjm*kkm, vt_z_trans, 4, dims4,debut4,epais4,
     .             "vt_z_trans", "VT", "K m/s")
c
      CALL ecritnd(nid,jjm*kkm, vt_z_stati, 4, dims4,debut4,epais4,
     .             "vt_z_stati", "VT", "K m/s")
c
      CALL ecritnd(nid,jjm*kkm, vg_z_total, 4, dims4,debut4,epais4,
     .             "vg_z_total", "VG", "m m/s")
c
      CALL ecritnd(nid,jjm*kkm, vg_z_moyen, 4, dims4,debut4,epais4,
     .             "vg_z_moyen", "VG", "m m/s")
c
      CALL ecritnd(nid,jjm*kkm, vg_z_trans, 4, dims4,debut4,epais4,
     .             "vg_z_trans", "VG", "m m/s")
c
      CALL ecritnd(nid,jjm*kkm, vg_z_stati, 4, dims4,debut4,epais4,
     .             "vg_z_stati", "VG", "m m/s")
c
      CALL ecritnd(nid,jjm*kkm, vu_z_total, 4, dims4,debut4,epais4,
     .             "vu_z_total", "VU", "m2/s2")
c
      CALL ecritnd(nid,jjm*kkm, vu_z_moyen, 4, dims4,debut4,epais4,
     .             "vu_z_moyen", "VU", "m2/s2")
c
      CALL ecritnd(nid,jjm*kkm, vu_z_trans, 4, dims4,debut4,epais4,
     .             "vu_z_trans", "VU", "m2/s2")
c
      CALL ecritnd(nid,jjm*kkm, vu_z_stati, 4, dims4,debut4,epais4,
     .             "vu_z_stati", "VU", "m2/s2")
c
      CALL ecritnd(nid,jjm*kkm, ve_z_total, 4, dims4,debut4,epais4,
     .             "ve_z_total", "VE", "J/kg m/s")
c
      CALL ecritnd(nid,jjm*kkm, ve_z_moyen, 4, dims4,debut4,epais4,
     .             "ve_z_moyen", "VE", "J/kg m/s")
c
      CALL ecritnd(nid,jjm*kkm, ve_z_trans, 4, dims4,debut4,epais4,
     .             "ve_z_trans", "VE", "J/kg m/s")
c
      CALL ecritnd(nid,jjm*kkm, ve_z_stati, 4, dims4,debut4,epais4,
     .             "ve_z_stati", "VE", "J/kg m/s")
c
      CALL ecritnd(nid,jjm*kkm, stream, 4, dims4,debut4,epais4,
     .             "stream", "Hadley cell", "kg/s")
c
      ierr = NF_CLOSE(nid)
c
c Ouvrir le fichier d'arrivee
c
      ierr = NF_CREATE ("curve_"//filename, NF_CLOBBER,nid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme de creation du fichier d arrivee"
         CALL abort
      ENDIF
c
c Preciser quelques attributs globaux:
c
      ierr = NF_PUT_ATT_TEXT (nid, NF_GLOBAL, "title", 37,
     .                       "Fichier carre en coordonnees pression")
      ierr = NF_PUT_ATT_TEXT (nid, NF_GLOBAL, "model", 30,
     .                       "Modele de circulation generale")
c
c Definir les dimensions du fichier:
c
      ierr = NF_DEF_DIM(nid,"x",1,idim_x)
      ierr = NF_DEF_DIM(nid,"y",jjm,idim_y)
      ierr = NF_DEF_DIM(nid,"levels",1,idim_z)
      ierr = NF_DEF_DIM(nid, "time", NF_UNLIMITED, idim_t)
c
      ierr = NF_ENDDEF(nid) ! sortir du mode de definition
c
c Definir et enregistrer certains champs invariants:
c
      ierr = NF_REDEF (nid)
      ierr = NF_DEF_VAR (nid,"x",NF_FLOAT,1,idim_x,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir x"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (nid, varid, "long_name", 10,"Longitudes")
      ierr = NF_PUT_ATT_TEXT (nid, varid, "units", 12,"degrees_east")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VARA_DOUBLE(nid,varid,1,1,x(1))
#else
      ierr = NF_PUT_VARA_REAL(nid,varid,1,1,x(1))
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer x"
         CALL abort
      ENDIF
c
      ierr = NF_REDEF (nid)
      ierr = NF_DEF_VAR (nid,"y",NF_FLOAT,1,idim_y,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir y"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (nid, varid, "long_name", 9,"Latitudes")
      ierr = NF_PUT_ATT_TEXT (nid, varid, "units", 13,"degrees_north")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VARA_DOUBLE(nid,varid,1,jjm,y)
#else
      ierr = NF_PUT_VARA_REAL(nid,varid,1,jjm,y)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer y"
         CALL abort
      ENDIF
c
      ierr = NF_REDEF (nid)
      ierr = NF_DEF_VAR (nid,"levels",NF_FLOAT,1,idim_z,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir levs"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (nid, varid, "long_name", 7,"Presure")
      ierr = NF_PUT_ATT_TEXT (nid, varid, "units", 9,"millibars")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VARA_DOUBLE(nid,varid,1,1,z(1))
#else
      ierr = NF_PUT_VARA_REAL(nid,varid,1,1,z(1))
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer levs"
         CALL abort
      ENDIF
c
      ierr = NF_REDEF (nid)
      ierr = NF_DEF_VAR (nid,"time", NF_FLOAT,1,idim_t,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir time"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT(nid,varid,"long_name",12,"time counter")
      ierr = NF_PUT_ATT_TEXT(nid,varid,"units",16,"days since 1-1-1")
      ierr = NF_PUT_ATT_TEXT(nid,varid,"note",18,"units may be wrong")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR1_DOUBLE(nid,varid,1,temps)
#else
      ierr = NF_PUT_VAR1_REAL(nid,varid,1,temps)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer time"
         CALL abort
      ENDIF
c
      dims4(1) = idim_x
      dims4(2) = idim_y
      dims4(3) = idim_z
      dims4(4) = idim_t
      debut4(1) = 1
      debut4(2) = 1
      debut4(3) = 1
      debut4(4) = 1
      epais4(1) = 1
      epais4(2) = jjm
      epais4(3) = 1
      epais4(4) = 1
c
      CALL ecritnd(nid,jjm,vq_z_vi_total,4,dims4,debut4,epais4,
     .             "vq_z_vi_total", "VQ", "kg/s")
c
      CALL ecritnd(nid,jjm,vq_z_vi_moyen,4,dims4,debut4,epais4,
     .             "vq_z_vi_moyen", "VQ", "kg/s")
c
      CALL ecritnd(nid,jjm,vq_z_vi_trans,4,dims4,debut4,epais4,
     .             "vq_z_vi_trans", "VQ", "kg/s")
c
      CALL ecritnd(nid,jjm,vq_z_vi_stati,4,dims4,debut4,epais4,
     .             "vq_z_vi_stati", "VQ", "kg/s")
c
      CALL ecritnd(nid,jjm,vt_z_vi_total,4,dims4,debut4,epais4,
     .             "vt_z_vi_total", "VT", "Kkg/s")
c
      CALL ecritnd(nid,jjm,vt_z_vi_moyen,4,dims4,debut4,epais4,
     .             "vt_z_vi_moyen", "VT", "Kkg/s")
c
      CALL ecritnd(nid,jjm,vt_z_vi_trans,4,dims4,debut4,epais4,
     .             "vt_z_vi_trans", "VT", "Kkg/s")
c
      CALL ecritnd(nid,jjm,vt_z_vi_stati,4,dims4,debut4,epais4,
     .             "vt_z_vi_stati", "VT", "Kkg/s")
c
      CALL ecritnd(nid,jjm,vg_z_vi_total,4,dims4,debut4,epais4,
     .             "vg_z_vi_total", "VG", "kgm/s")
c
      CALL ecritnd(nid,jjm,vg_z_vi_moyen,4,dims4,debut4,epais4,
     .             "vg_z_vi_moyen", "VG", "kgm/s")
c
      CALL ecritnd(nid,jjm,vg_z_vi_trans,4,dims4,debut4,epais4,
     .             "vg_z_vi_trans", "VG", "kgm/s")
c
      CALL ecritnd(nid,jjm,vg_z_vi_stati,4,dims4,debut4,epais4,
     .             "vg_z_vi_stati", "VG", "kgm/s")
c
      CALL ecritnd(nid,jjm,vu_z_vi_total,4,dims4,debut4,epais4,
     .             "vu_z_vi_total", "VU", "kgm/s4")
c
      CALL ecritnd(nid,jjm,vu_z_vi_moyen,4,dims4,debut4,epais4,
     .             "vu_z_vi_moyen", "VU", "kgm/s4")
c
      CALL ecritnd(nid,jjm,vu_z_vi_trans,4,dims4,debut4,epais4,
     .             "vu_z_vi_trans", "VU", "kgm/s4")
c
      CALL ecritnd(nid,jjm,vu_z_vi_stati,4,dims4,debut4,epais4,
     .             "vu_z_vi_stati", "VU", "kgm/s4")
c
      CALL ecritnd(nid,jjm,ve_z_vi_total,4,dims4,debut4,epais4,
     .             "ve_z_vi_total", "VE", "J/s")
c
      CALL ecritnd(nid,jjm,ve_z_vi_moyen,4,dims4,debut4,epais4,
     .             "ve_z_vi_moyen", "VE", "J/s")
c
      CALL ecritnd(nid,jjm,ve_z_vi_trans,4,dims4,debut4,epais4,
     .             "ve_z_vi_trans", "VE", "J/s")
c
      CALL ecritnd(nid,jjm,ve_z_vi_stati,4,dims4,debut4,epais4,
     .             "ve_z_vi_stati", "VE", "J/s")
c
      ierr = NF_CLOSE(nid)
c
      RETURN 
      END
      SUBROUTINE ecrit_netcdf2d(ficnom,iim,jjm,x,y,mask,missing,nb,vari)
      IMPLICIT none
c
      CHARACTER*(*) ficnom
      INTEGER iim, jjm, nb
      REAL x(iim), y(jjm), mask(iim,jjm)
      REAL vari(iim,jjm,nb)
      REAL missing
c
#include "netcdf.inc"
c
      INTEGER ierr, mid, varid
      INTEGER idim_x, idim_y, idim_t
      INTEGER dims2(2), dims3(3)
c
      INTEGER id_time, id_vari, n
c
      INTEGER debu3(3), epai3(3)
c
c Ouvrir le fichier a ecrire:
c
      ierr = NF_CREATE(ficnom, NF_CLOBBER, mid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme d ouverture du fichier:"//ficnom
         CALL abort
      ENDIF
c
c Preciser quelques attributs globaux:
c
      ierr = NF_PUT_ATT_TEXT (mid, NF_GLOBAL, "title", 29,
     .                       "Ecriture rapide d un champ 2D")
      ierr = NF_PUT_ATT_TEXT (mid, NF_GLOBAL, "model", 33,
     .                       "Resultats issus d un diagnostique")
c
c Definir les dimensions du fichier:
c
      ierr = NF_DEF_DIM(mid,"x",iim,idim_x)
      ierr = NF_DEF_DIM(mid,"y",jjm,idim_y)
      ierr = NF_DEF_DIM(mid, "time", NF_UNLIMITED, idim_t)
c
      ierr = NF_ENDDEF(mid) ! sortir du mode de definition
c
c Definir et enregistrer certains champs invariants:
c
      ierr = NF_REDEF (mid)
      ierr = NF_DEF_VAR (mid,"x",NF_FLOAT,1,idim_x,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir x"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (mid, varid, "long_name", 10,"Longitudes")
      ierr = NF_PUT_ATT_TEXT (mid, varid, "short_name", 1,"x")
      ierr = NF_PUT_ATT_TEXT (mid, varid, "units", 12,"degrees_east")
      ierr = NF_ENDDEF(mid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE(mid,varid,x)
#else
      ierr = NF_PUT_VAR_REAL(mid,varid,x)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer x"
         CALL abort
      ENDIF
c
      ierr = NF_REDEF (mid)
      ierr = NF_DEF_VAR (mid,"y",NF_FLOAT,1,idim_y,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir y"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (mid, varid, "long_name", 9,"Latitudes")
      ierr = NF_PUT_ATT_TEXT (mid, varid, "short_name", 1,"y")
      ierr = NF_PUT_ATT_TEXT (mid, varid, "units", 13,"degrees_north")
      ierr = NF_ENDDEF(mid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE(mid,varid,y)
#else
      ierr = NF_PUT_VAR_REAL(mid,varid,y)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer y"
         CALL abort
      ENDIF
c
      dims2(1) = idim_x
      dims2(2) = idim_y
c
      ierr = NF_REDEF (mid)
      ierr = NF_DEF_VAR (mid,"mask",NF_FLOAT,2,dims2,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir mask"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (mid,varid,"long_name",6,"Masque")
      ierr = NF_PUT_ATT_TEXT (mid, varid, "short_name", 4,"mask")
      ierr = NF_PUT_ATT_TEXT (mid, varid, "units", 1,"-")
      ierr = NF_ENDDEF(mid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE(mid,varid,mask)
#else
      ierr = NF_PUT_VAR_REAL(mid,varid,mask)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer mask"
         CALL abort
      ENDIF
c
c Definir les variables pour enregistrement ulterieur:
c
      ierr = NF_REDEF (mid)
c
      ierr = NF_DEF_VAR (mid,"time", NF_FLOAT,1,idim_t,id_time)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir time"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT(mid,id_time,"long_name",12,"time counter")
      ierr = NF_PUT_ATT_TEXT(mid,id_time,"short_name",4,"time")
      ierr = NF_PUT_ATT_TEXT(mid,id_time,"units",16,"days since 1-1-1")
      ierr = NF_PUT_ATT_TEXT(mid,id_time,"note",27,
     .                       "Il peut etre n importe quoi")
c
      dims3(1) = idim_x
      dims3(2) = idim_y
      dims3(3) = idim_t
c
      ierr = NF_DEF_VAR (mid,"vari",NF_FLOAT,3,dims3,id_vari)
      ierr = NF_PUT_ATT_TEXT(mid,id_vari,"long_name",8,"Variable")
      ierr = NF_PUT_ATT_TEXT(mid,id_vari,"short_name",4,"vari")
      ierr = NF_PUT_ATT_TEXT(mid,id_vari,"units",1,"-")
#ifdef NC_DOUBLE
      ierr = NF_PUT_ATT_DOUBLE(mid,id_vari,"missing_value",
     .                                   NF_FLOAT,1,missing)
#else
      ierr = NF_PUT_ATT_REAL(mid,id_vari,"missing_value",
     .                                   NF_FLOAT,1,missing)
#endif
c
      ierr = NF_ENDDEF(mid)
c
      DO 99999 n = 1, nb
c
#ifdef NC_DOUBLE
        ierr = NF_PUT_VAR1_DOUBLE(mid,id_time,n,FLOAT(n))
#else
        ierr = NF_PUT_VAR1_REAL(mid,id_time,n,FLOAT(n))
#endif
        IF (ierr.NE.NF_NOERR) THEN
           PRINT*, "Probleme pour enregistrer time"
           CALL abort
        ENDIF
c
        debu3(1) = 1
        debu3(2) = 1
        debu3(3) = n
        epai3(1) = iim
        epai3(2) = jjm
        epai3(3) = 1
c
#ifdef NC_DOUBLE
        ierr = NF_PUT_VARA_DOUBLE(mid,id_vari,debu3,epai3,vari(1,1,n))
#else
        ierr = NF_PUT_VARA_REAL(mid,id_vari,debu3,epai3,vari(1,1,n))
#endif
        IF (ierr.NE.NF_NOERR) THEN
           PRINT*, "Probleme pour enregistrer vari"
           CALL abort
        ENDIF
c
99999 CONTINUE
      ierr = NF_CLOSE(mid)
c
      RETURN 
      END
      SUBROUTINE ecrit_netcdf3d(ficnom,iim,jjm,kkm,x,y,z,
     .                        mask,missing,nb,vari)
      IMPLICIT none
c
      CHARACTER*(*) ficnom
      INTEGER iim, jjm, kkm, nb
      REAL x(iim), y(jjm), z(kkm), mask(iim,jjm)
      REAL vari(iim,jjm,kkm,nb)
      REAL missing
c
#include "netcdf.inc"
c
      INTEGER ierr, mid, varid
      INTEGER idim_x, idim_y, idim_z, idim_t
      INTEGER dims2(2), dims4(4)
c
      INTEGER id_time, id_vari, n
c
      INTEGER debu4(4), epai4(4)
c
c Ouvrir le fichier a ecrire:
c
      ierr = NF_CREATE(ficnom, NF_CLOBBER, mid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme d ouverture du fichier:"//ficnom
         CALL abort
      ENDIF
c
c Preciser quelques attributs globaux:
c
      ierr = NF_PUT_ATT_TEXT (mid, NF_GLOBAL, "title", 29,
     .                       "Ecriture rapide d un champ 3D")
      ierr = NF_PUT_ATT_TEXT (mid, NF_GLOBAL, "model", 33,
     .                       "Resultats issus d un diagnostique")
c
c Definir les dimensions du fichier:
c
      ierr = NF_DEF_DIM(mid,"x",iim,idim_x)
      ierr = NF_DEF_DIM(mid,"y",jjm,idim_y)
      ierr = NF_DEF_DIM(mid,"z",kkm,idim_z)
      ierr = NF_DEF_DIM(mid, "time", NF_UNLIMITED, idim_t)
c
      ierr = NF_ENDDEF(mid) ! sortir du mode de definition
c
c Definir et enregistrer certains champs invariants:
c
      ierr = NF_REDEF (mid)
      ierr = NF_DEF_VAR (mid,"x",NF_FLOAT,1,idim_x,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir x"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (mid, varid, "long_name", 10,"Longitudes")
      ierr = NF_PUT_ATT_TEXT (mid, varid, "short_name", 1,"x")
      ierr = NF_PUT_ATT_TEXT (mid, varid, "units", 12,"degrees_east")
      ierr = NF_ENDDEF(mid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE(mid,varid,x)
#else
      ierr = NF_PUT_VAR_REAL(mid,varid,x)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer x"
         CALL abort
      ENDIF
c
      ierr = NF_REDEF (mid)
      ierr = NF_DEF_VAR (mid,"y",NF_FLOAT,1,idim_y,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir y"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (mid, varid, "long_name", 9,"Latitudes")
      ierr = NF_PUT_ATT_TEXT (mid, varid, "short_name", 1,"y")
      ierr = NF_PUT_ATT_TEXT (mid, varid, "units", 13,"degrees_north")
      ierr = NF_ENDDEF(mid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE(mid,varid,y)
#else
      ierr = NF_PUT_VAR_REAL(mid,varid,y)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer y"
         CALL abort
      ENDIF
c
      ierr = NF_REDEF (mid)
      ierr = NF_DEF_VAR (mid,"z",NF_FLOAT,1,idim_z,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir z"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (mid, varid, "long_name", 9,"Vertical")
      ierr = NF_PUT_ATT_TEXT (mid, varid, "short_name", 1,"z")
      ierr = NF_PUT_ATT_TEXT (mid, varid, "units", 6,"layers")
      ierr = NF_ENDDEF(mid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE(mid,varid,z)
#else
      ierr = NF_PUT_VAR_REAL(mid,varid,z)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer z"
         CALL abort
      ENDIF
c
      dims2(1) = idim_x
      dims2(2) = idim_y
c
      ierr = NF_REDEF (mid)
      ierr = NF_DEF_VAR (mid,"mask",NF_FLOAT,2,dims2,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir mask"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (mid,varid,"long_name",6,"Masque")
      ierr = NF_PUT_ATT_TEXT (mid, varid, "short_name", 4,"mask")
      ierr = NF_PUT_ATT_TEXT (mid, varid, "units", 1,"-")
      ierr = NF_ENDDEF(mid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE(mid,varid,mask)
#else
      ierr = NF_PUT_VAR_REAL(mid,varid,mask)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer mask"
         CALL abort
      ENDIF
c
c Definir les variables pour enregistrement ulterieur:
c
      ierr = NF_REDEF (mid)
c
      ierr = NF_DEF_VAR (mid,"time", NF_FLOAT,1,idim_t,id_time)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir time"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT(mid,id_time,"long_name",12,"time counter")
      ierr = NF_PUT_ATT_TEXT(mid,id_time,"short_name",4,"time")
      ierr = NF_PUT_ATT_TEXT(mid,id_time,"units",16,"days since 1-1-1")
      ierr = NF_PUT_ATT_TEXT(mid,id_time,"note",27,
     .                       "Il peut etre n importe quoi")
c
      dims4(1) = idim_x
      dims4(2) = idim_y
      dims4(3) = idim_z
      dims4(4) = idim_t
c
      ierr = NF_DEF_VAR (mid,"vari",NF_FLOAT,4,dims4,id_vari)
      ierr = NF_PUT_ATT_TEXT(mid,id_vari,"long_name",8,"Variable")
      ierr = NF_PUT_ATT_TEXT(mid,id_vari,"short_name",4,"vari")
      ierr = NF_PUT_ATT_TEXT(mid,id_vari,"units",1,"-")
#ifdef NC_DOUBLE
      ierr = NF_PUT_ATT_DOUBLE(mid,id_vari,"missing_value",
     .                                   NF_FLOAT,1,missing)
#else
      ierr = NF_PUT_ATT_REAL(mid,id_vari,"missing_value",
     .                                   NF_FLOAT,1,missing)
#endif
c
      ierr = NF_ENDDEF(mid)
c
      DO 99999 n = 1, nb
c
#ifdef NC_DOUBLE
        ierr = NF_PUT_VAR1_DOUBLE(mid,id_time,n,FLOAT(n))
#else
        ierr = NF_PUT_VAR1_REAL(mid,id_time,n,FLOAT(n))
#endif
        IF (ierr.NE.NF_NOERR) THEN
           PRINT*, "Probleme pour enregistrer time"
           CALL abort
        ENDIF
c
        debu4(1) = 1
        debu4(2) = 1
        debu4(3) = 1
        debu4(4) = n
        epai4(1) = iim
        epai4(2) = jjm
        epai4(3) = kkm
        epai4(4) = 1
c
#ifdef NC_DOUBLE
        ierr = NF_PUT_VARA_DOUBLE(mid,id_vari,debu4,epai4,vari(1,1,1,n))
#else
        ierr = NF_PUT_VARA_REAL(mid,id_vari,debu4,epai4,vari(1,1,1,n))
#endif
        IF (ierr.NE.NF_NOERR) THEN
           PRINT*, "Probleme pour enregistrer vari"
           CALL abort
        ENDIF
c
99999 CONTINUE
      ierr = NF_CLOSE(mid)
c
      RETURN
      END
      SUBROUTINE epflux(iim,jjm,kkm,x,y,z,presm,um,vm,sm,
     .                  uu,vv,vs,vu,dsdpm)
      IMPLICIT none
c
#include "netcdf.inc"
c
      INTEGER iim, jjm, kkm
      REAL x(iim)  ! longitudes
      REAL y(jjm)  ! latitudes
      REAL z(kkm)  ! pressions
      REAL presm(iim,jjm,kkm)
      REAL um(iim,jjm,kkm) ! accumulation de U
      REAL vm(iim,jjm,kkm) ! accumulation de V
      REAL sm(iim,jjm,kkm) ! accumulation de T
      REAL uu(iim,jjm,kkm) ! accumulation de U**2
      REAL vv(iim,jjm,kkm) ! accumulation de V**2
      REAL vs(iim,jjm,kkm) ! accumulation de V*T
      REAL vu(iim,jjm,kkm) ! accumulation de V*U
      REAL dsdpm(iim,jjm,kkm)
c
      REAL epx(iim,jjm,kkm) ! Composante X du flux EP
      REAL epy(iim,jjm,kkm) ! Composante Y du flux EP
      REAL epz(iim,jjm,kkm) ! Composante Z du flux EP
c
      REAL divx(iim,jjm,kkm) ! Divergence X du flux EP
      REAL divy(iim,jjm,kkm) ! Divergence Y du flux EP
      REAL divz(iim,jjm,kkm) ! Divergence Z du flux EP
c
      REAL coriolis(iim,jjm) ! 2 omega SIN(latitude)
      REAL pi, radius
      PARAMETER (radius=6371000.)
c
      INTEGER ierr, varid, nid
      INTEGER idim_x, idim_y, idim_z, idim_t
      INTEGER id_divx, id_divy, id_divz, id_epx, id_epy, id_epz
      INTEGER dims4(4), debut4(4), epais4(4)
c
      REAL var, temps
      INTEGER id_time
c
      INTEGER i, j, k, n
c
      pi = 4.0 * ATAN(1.0)
      DO j = 1, jjm
      DO i = 1, iim
         coriolis(i,j) = 2.0*(2.0*pi/86400.0) * SIN(y(j)*pi/180.0)
      ENDDO
      ENDDO
c
      DO k = 1, kkm
      DO j = 1, jjm
      DO i = 1, iim
         epx(i,j,k) = (vv(i,j,k)-vm(i,j,k)*vm(i,j,k))
     .              - (uu(i,j,k)-um(i,j,k)*um(i,j,k))
         epy(i,j,k) = - (vu(i,j,k)-vm(i,j,k)*um(i,j,k))
      ENDDO
      ENDDO
      ENDDO
c
      DO k = 1, kkm
      DO j = 1, jjm
      DO i = 1, iim
         epz(i,j,k) = 0.0
         IF (ABS(dsdpm(i,j,k)).GT.1.0e-5) THEN
         epz(i,j,k) = coriolis(i,j) / dsdpm(i,j,k) *
     .                (vs(i,j,k)-vm(i,j,k)*sm(i,j,k))
         ENDIF
      ENDDO
      ENDDO
      ENDDO
c
c Divergence en X (m/s2)
c
      DO k = 1, kkm
      DO j = 1, jjm
         DO i = 2, iim-1
            divx(i,j,k) = (epx(i+1,j,k)-epx(i-1,j,k))
     .                  / (radius*pi/180.0*(x(i+1)-x(i-1)))
     .                  * COS(y(j)*pi/180.0)
         ENDDO
         divx(1,j,k) = (epx(2,j,k)-epx(iim,j,k))
     .               / (radius*pi/180.0*(x(2)-(x(iim)-360.)))
     .               * COS(y(j)*pi/180.0)
         divx(iim,j,k) = (epx(1,j,k)-epx(iim-1,j,k))
     .                 / (radius*pi/180.0*(x(1)-(x(iim-1)-360.)))
     .                 * COS(y(j)*pi/180.0)
      ENDDO
      ENDDO
c
c Divergence en Y (m/s2)
c
      DO k = 1, kkm
      DO j = 2, jjm-1
      DO i = 1, iim
         divy(i,j,k) = (epy(i,j+1,k)-epy(i,j-1,k))
     .               / (radius*pi/180.0*(y(j+1)-y(j-1)))
     &               - epy(i,j,k)*TAN(y(j)*pi/180.0)/radius
      ENDDO
      ENDDO
      DO i = 1, iim
         divy(i,1,k) = divy(i,2,k)
         divy(i,jjm,k) = divy(i,jjm-1,k)
      ENDDO
      ENDDO
c
c Divergence en Pression (m/s2)
c
      divz = 0.0
c
      DO j = 1, jjm
      DO i = 1, iim
         var = presm(i,j,2)-presm(i,j,1)  ! z(2)-z(1)
         IF (ABS(var).GT.1.0e-2) THEN
            divz(i,j,1) = (epz(i,j,2)-epz(i,j,1)) / var
         ENDIF
         var = presm(i,j,kkm)-presm(i,j,kkm-1) ! z(kkm)-z(kkm-1)
         IF (ABS(var).GT.1.0e-2) THEN
         divz(i,j,kkm) = (epz(i,j,kkm)-epz(i,j,kkm-1)) / var
         ENDIF
      ENDDO
      ENDDO
      DO k = 2, kkm-1
      DO j = 1, jjm
      DO i = 1, iim
      var = presm(i,j,k+1)-presm(i,j,k-1) ! z(k+1)-z(k-1)
      IF (ABS(var).GT.1.0e-2) THEN
         divz(i,j,k) = (epz(i,j,k+1)-epz(i,j,k-1))/var
      ENDIF
      ENDDO
      ENDDO
      ENDDO
c
      ierr = NF_CREATE ("epflux.nc", NF_CLOBBER,nid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme de creation du fichier epflux"
         CALL abort
      ENDIF
c
c Preciser quelques attributs globaux:
c
      ierr = NF_PUT_ATT_TEXT (nid, NF_GLOBAL, "title", 37,
     .                       "Fichier carre en coordonnees pression")
      ierr = NF_PUT_ATT_TEXT (nid, NF_GLOBAL, "model", 30,
     .                       "Modele de circulation generale")
c
c Definir les dimensions du fichier:
c
      ierr = NF_DEF_DIM(nid,"x",iim,idim_x)
      ierr = NF_DEF_DIM(nid,"y",jjm,idim_y)
      ierr = NF_DEF_DIM(nid,"z",kkm,idim_z)
      ierr = NF_DEF_DIM(nid, "time", NF_UNLIMITED, idim_t)
c
      ierr = NF_ENDDEF(nid) ! sortir du mode de definition
c
c Definir et enregistrer certains champs invariants:
c
      ierr = NF_REDEF (nid)
      ierr = NF_DEF_VAR (nid,"x",NF_FLOAT,1,idim_x,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir x"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (nid, varid, "long_name", 10,"Longitudes")
      ierr = NF_PUT_ATT_TEXT (nid, varid, "units", 12,"degrees_east")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VARA_DOUBLE(nid,varid,1,iim,x)
#else
      ierr = NF_PUT_VARA_REAL(nid,varid,1,iim,x)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer x"
         CALL abort
      ENDIF
c
      ierr = NF_REDEF (nid)
      ierr = NF_DEF_VAR (nid,"y",NF_FLOAT,1,idim_y,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir y"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (nid, varid, "long_name", 9,"Latitudes")
      ierr = NF_PUT_ATT_TEXT (nid, varid, "units", 13,"degrees_north")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VARA_DOUBLE(nid,varid,1,jjm,y)
#else
      ierr = NF_PUT_VARA_REAL(nid,varid,1,jjm,y)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer y"
         CALL abort
      ENDIF
c
      ierr = NF_REDEF (nid)
      ierr = NF_DEF_VAR (nid,"z",NF_FLOAT,1,idim_z,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir z"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (nid, varid, "long_name", 7,"Presure")
      ierr = NF_PUT_ATT_TEXT (nid, varid, "units", 9,"millibars")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VARA_DOUBLE(nid,varid,1,kkm,z)
#else
      ierr = NF_PUT_VARA_REAL(nid,varid,1,kkm,z)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer z"
         CALL abort
      ENDIF
c Definir les variables pour enregistrement ulterieur:
c
      ierr = NF_REDEF (nid)
c
      ierr = NF_DEF_VAR (nid,"time", NF_FLOAT,1,idim_t,id_time)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir time"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT(nid,id_time,"long_name",12,"time counter")
      ierr = NF_PUT_ATT_TEXT(nid,id_time,"units",16,"days since 1-1-1")
      ierr = NF_PUT_ATT_TEXT(nid,id_time,"note",18,"units may be wrong")
c
      dims4(1) = idim_x
      dims4(2) = idim_y
      dims4(3) = idim_z
      dims4(4) = idim_t
c
      ierr = NF_DEF_VAR (nid,"epx",NF_FLOAT,4,dims4,id_epx)
      ierr = NF_PUT_ATT_TEXT (nid,id_epx,"long_name",3,"EPX")
      ierr = NF_PUT_ATT_TEXT (nid,id_epx,"units",5,"m2/s2")
c
      ierr = NF_DEF_VAR (nid,"epy",NF_FLOAT,4,dims4,id_epy)
      ierr = NF_PUT_ATT_TEXT (nid,id_epy,"long_name",3,"EPY")
      ierr = NF_PUT_ATT_TEXT (nid,id_epy,"units",5,"m2/s2")
c
      ierr = NF_DEF_VAR (nid,"epz",NF_FLOAT,4,dims4,id_epz)
      ierr = NF_PUT_ATT_TEXT (nid,id_epz,"long_name",3,"EPZ")
      ierr = NF_PUT_ATT_TEXT (nid,id_epz,"units",7,"m/s2 mb")
c
      ierr = NF_DEF_VAR (nid,"divx",NF_FLOAT,4,dims4,id_divx)
      ierr = NF_PUT_ATT_TEXT (nid,id_divx,"long_name",4,"DIVX")
      ierr = NF_PUT_ATT_TEXT (nid,id_divx,"units",4,"m/s2")
c
      ierr = NF_DEF_VAR (nid,"divy",NF_FLOAT,4,dims4,id_divy)
      ierr = NF_PUT_ATT_TEXT (nid,id_divy,"long_name",4,"DIVY")
      ierr = NF_PUT_ATT_TEXT (nid,id_divy,"units",4,"m/s2")
c
      ierr = NF_DEF_VAR (nid,"divz",NF_FLOAT,4,dims4,id_divz)
      ierr = NF_PUT_ATT_TEXT (nid,id_divz,"long_name",4,"DIVZ")
      ierr = NF_PUT_ATT_TEXT (nid,id_divz,"units",4,"m/s2")
c
      ierr = NF_ENDDEF(nid)
c
      n = 1
      temps = 1.0
c
      debut4(1) = 1
      debut4(2) = 1
      debut4(3) = 1
      debut4(4) = n
      epais4(1) = iim
      epais4(2) = jjm
      epais4(3) = kkm
      epais4(4) = 1
c
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR1_DOUBLE(nid,id_time,n,temps)
#else
      ierr = NF_PUT_VAR1_REAL(nid,id_time,n,temps)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer time"
         CALL abort
      ENDIF
c
#ifdef NC_DOUBLE
      ierr = NF_PUT_VARA_DOUBLE(nid,id_epx,debut4,epais4,epx)
#else
      ierr = NF_PUT_VARA_REAL(nid,id_epx,debut4,epais4,epx)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer epx"
         CALL abort
      ENDIF
c
#ifdef NC_DOUBLE
      ierr = NF_PUT_VARA_DOUBLE(nid,id_epy,debut4,epais4,epy)
#else
      ierr = NF_PUT_VARA_REAL(nid,id_epy,debut4,epais4,epy)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer epy"
         CALL abort
      ENDIF
c
#ifdef NC_DOUBLE
      ierr = NF_PUT_VARA_DOUBLE(nid,id_epz,debut4,epais4,epz)
#else
      ierr = NF_PUT_VARA_REAL(nid,id_epz,debut4,epais4,epz)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer epz"
         CALL abort
      ENDIF
c
#ifdef NC_DOUBLE
      ierr = NF_PUT_VARA_DOUBLE(nid,id_divx,debut4,epais4,divx)
#else
      ierr = NF_PUT_VARA_REAL(nid,id_divx,debut4,epais4,divx)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer divx"
         CALL abort
      ENDIF
c
#ifdef NC_DOUBLE
      ierr = NF_PUT_VARA_DOUBLE(nid,id_divy,debut4,epais4,divy)
#else
      ierr = NF_PUT_VARA_REAL(nid,id_divy,debut4,epais4,divy)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer divy"
         CALL abort
      ENDIF
c
#ifdef NC_DOUBLE
      ierr = NF_PUT_VARA_DOUBLE(nid,id_divz,debut4,epais4,divz)
#else
      ierr = NF_PUT_VARA_REAL(nid,id_divz,debut4,epais4,divz)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer divz"
         CALL abort
      ENDIF
c
      ierr = NF_CLOSE(nid)
c
      RETURN
      END
      SUBROUTINE vintegral_bis(iim,jjm,kkm, ptop, pbot, p, q, qi)
      IMPLICIT none
      INTEGER iim, jjm, kkm
      REAL ptop(iim,jjm)
      REAL pbot(iim,jjm)
      REAL p(iim,jjm,kkm), q(iim,jjm,kkm)
      REAL qi(iim,jjm)
c
      REAL pr(iim,jjm,0:kkm+1)
      REAL qq(iim,jjm,0:kkm+1)
c
      INTEGER i, j, k
      REAL RG
      PARAMETER (RG=9.81)
c
      DO k = 1, kkm
      DO j = 1, jjm
      DO i = 1, iim
         pr(i,j,k) = p(i,j,k)
         qq(i,j,k) = q(i,j,k)
      ENDDO
      ENDDO
      ENDDO

c
      DO k = kkm-1, 1, -1
      DO j = 1, jjm
      DO i = 1, iim
         IF (pr(i,j,k).GT.pbot(i,j)) THEN
            pr(i,j,k) = pbot(i,j)
            qq(i,j,k) = qq(i,j,k+1)
         ENDIF
      ENDDO
      ENDDO
      ENDDO
c
      DO k = 2, kkm
      DO j = 1, jjm
      DO i = 1, iim
         IF (pr(i,j,k).LT.ptop(i,j)) THEN
            pr(i,j,k) = ptop(i,j)
            qq(i,j,k) = qq(i,j,k-1)
         ENDIF
      ENDDO
      ENDDO
      ENDDO
c
      DO j = 1, jjm
      DO i = 1, iim
         pr(i,j,0) = pbot(i,j)
         pr(i,j,kkm+1) = ptop(i,j)
         qq(i,j,0) = qq(i,j,1)
         qq(i,j,kkm+1) = qq(i,j,kkm)
      ENDDO
      ENDDO
c
      DO j = 1, jjm
      DO i = 1, iim
         qi(i,j) = 0.0
      ENDDO
      ENDDO
c
      DO k = 0, kkm
      DO j = 1, jjm
      DO i = 1, iim
         qi(i,j) = qi(i,j) + (qq(i,j,k)+qq(i,j,k+1))/2.0
     .                      *(pr(i,j,k)-pr(i,j,k+1))/RG
      ENDDO
      ENDDO
      ENDDO
c
      RETURN
      END
