      PROGRAM carre
      USE netcdf
      IMPLICIT none
!
! pgf90 -r8 analyse_lmdz.F90 -I/distrib/local/netcdf-4.0.1/pgi_7.1-6_32/include -L/distrib/local/netcdf-4.0.1/pgi_7.1-6_32/lib -lnetcdf
!
!***********************************************************************
      INTEGER :: iim, jjm, kkm, nb
!
      CHARACTER(LEN=80) :: tapename ! File to deal with
      INTEGER mid
!
      CHARACTER(LEN=80), PARAMETER :: depart="accu_data.nc" ! Accumulated file at departure
      INTEGER lid
!
      CHARACTER(LEN=80), PARAMETER :: arrivee="tmp_data.nc" ! Accumulated file at arrival
      INTEGER nid
!
      INTEGER :: iargc
!
      INTEGER :: ierr, varid
      INTEGER :: idim_x, idim_y, idim_levs, idim_t
      INTEGER :: dims3(3), dims4(4)
      INTEGER :: debut3(3), epais3(3)
      INTEGER :: debut4(4), epais4(4)

      REAL, ALLOCATABLE :: x(:), y(:), z(:) ! longitudes, latitudes et pressions
!
      REAL, PARAMETER :: r=287.0, cp=1004.0, lv=2.5008E+06, rg=9.81, rad=6400000.0
      REAL :: pi
!
      REAL, ALLOCATABLE :: u0(:,:,:) ! Vitesse U
      REAL, ALLOCATABLE :: v0(:,:,:) ! Vitesse V
      REAL, ALLOCATABLE :: t0(:,:,:)! Temperature
      REAL, ALLOCATABLE :: s0(:,:,:)! Temperature potentielle
      REAL, ALLOCATABLE :: g0(:,:,:) ! Geopotentiel
      REAL, ALLOCATABLE :: r0(:,:,:) ! Humidite
      REAL, ALLOCATABLE :: q0(:,:,:) ! Humidite
      REAL, ALLOCATABLE :: e0(:,:,:) ! Energie totale
      REAL, ALLOCATABLE :: pres0(:,:,:)
      REAL, ALLOCATABLE :: ps0(:,:)
!
      REAL, ALLOCATABLE :: dsdp0(:,:,:)
      REAL, ALLOCATABLE :: var3d(:,:,:)
!
      REAL :: counter, bidon
      REAL :: temps
      INTEGER :: id_time
!
      REAL, ALLOCATABLE :: um(:,:,:) ! Accumulation pour U
      REAL, ALLOCATABLE :: vm(:,:,:) ! Accumulation pour V
      REAL, ALLOCATABLE :: tm(:,:,:) ! Accumulation pour T
      REAL, ALLOCATABLE :: sm(:,:,:)
      REAL, ALLOCATABLE :: gm(:,:,:)
      REAL, ALLOCATABLE :: qm(:,:,:)
      REAL, ALLOCATABLE :: rm(:,:,:)
      REAL, ALLOCATABLE :: em(:,:,:)
      REAL, ALLOCATABLE :: uu(:,:,:) ! Accumulation pour U*U
      REAL, ALLOCATABLE :: vv(:,:,:) ! Accumulation pour V*V
      REAL, ALLOCATABLE :: tt(:,:,:) ! Accumulation pour T*T
      REAL, ALLOCATABLE :: ss(:,:,:)
      REAL, ALLOCATABLE :: gg(:,:,:)
      REAL, ALLOCATABLE :: qq(:,:,:)
      REAL, ALLOCATABLE :: vt(:,:,:) ! Accumulation pour V*T
      REAL, ALLOCATABLE :: vu(:,:,:) ! Accumulation pour V*U
      REAL, ALLOCATABLE :: vs(:,:,:)
      REAL, ALLOCATABLE :: dsdpm(:,:,:)
      REAL, ALLOCATABLE :: vg(:,:,:)
      REAL, ALLOCATABLE :: vq(:,:,:)
      REAL, ALLOCATABLE :: ve(:,:,:)
      REAL, ALLOCATABLE :: uq(:,:,:)
      REAL, ALLOCATABLE :: ue(:,:,:)
      REAL, ALLOCATABLE :: psm(:,:)
      REAL, ALLOCATABLE :: presm(:,:,:)
!
      REAL, ALLOCATABLE :: psm_z(:)
      REAL, ALLOCATABLE :: presm_z(:,:)
!
      REAL, ALLOCATABLE :: vq_z_total(:,:), vq_z_vi_total(:)
      REAL, ALLOCATABLE :: vq_z_moyen(:,:), vq_z_vi_moyen(:)
      REAL, ALLOCATABLE :: vq_z_trans(:,:), vq_z_vi_trans(:)
      REAL, ALLOCATABLE :: vq_z_stati(:,:), vq_z_vi_stati(:)
!
      REAL, ALLOCATABLE :: vt_z_total(:,:), vt_z_vi_total(:)
      REAL, ALLOCATABLE :: vt_z_moyen(:,:), vt_z_vi_moyen(:)
      REAL, ALLOCATABLE :: vt_z_trans(:,:), vt_z_vi_trans(:)
      REAL, ALLOCATABLE :: vt_z_stati(:,:), vt_z_vi_stati(:)
!
      REAL, ALLOCATABLE :: vg_z_total(:,:), vg_z_vi_total(:)
      REAL, ALLOCATABLE :: vg_z_moyen(:,:), vg_z_vi_moyen(:)
      REAL, ALLOCATABLE :: vg_z_trans(:,:), vg_z_vi_trans(:)
      REAL, ALLOCATABLE :: vg_z_stati(:,:), vg_z_vi_stati(:)
!
      REAL, ALLOCATABLE :: vu_z_total(:,:), vu_z_vi_total(:)
      REAL, ALLOCATABLE :: vu_z_moyen(:,:), vu_z_vi_moyen(:)
      REAL, ALLOCATABLE :: vu_z_trans(:,:), vu_z_vi_trans(:)
      REAL, ALLOCATABLE :: vu_z_stati(:,:), vu_z_vi_stati(:)
!
      REAL, ALLOCATABLE :: ve_z_total(:,:), ve_z_vi_total(:)
      REAL, ALLOCATABLE :: ve_z_moyen(:,:), ve_z_vi_moyen(:)
      REAL, ALLOCATABLE :: ve_z_trans(:,:), ve_z_vi_trans(:)
      REAL, ALLOCATABLE :: ve_z_stati(:,:), ve_z_vi_stati(:)
!
      REAL, ALLOCATABLE :: ke_z_total(:,:), ke_z_vi_total(:)
      REAL, ALLOCATABLE :: ke_z_moyen(:,:), ke_z_vi_moyen(:)
      REAL, ALLOCATABLE :: ke_z_trans(:,:), ke_z_vi_trans(:)
      REAL, ALLOCATABLE :: ke_z_stati(:,:), ke_z_vi_stati(:)
!
      REAL, ALLOCATABLE :: stream(:,:)
!
      REAL, ALLOCATABLE :: vq_vi_total(:,:), vq_vi_moyen(:,:)
      REAL, ALLOCATABLE :: vt_vi_total(:,:), vt_vi_moyen(:,:)
      REAL, ALLOCATABLE :: vg_vi_total(:,:), vg_vi_moyen(:,:)
      REAL, ALLOCATABLE :: vu_vi_total(:,:), vu_vi_moyen(:,:)
      REAL, ALLOCATABLE :: ve_vi_total(:,:), ve_vi_moyen(:,:)
      REAL, ALLOCATABLE :: uq_vi_total(:,:), uq_vi_moyen(:,:)
      REAL, ALLOCATABLE :: ue_vi_total(:,:), ue_vi_moyen(:,:)
!
      REAL, ALLOCATABLE :: qm_vi(:,:) ! Integration verticale de vapeur d'eau
      REAL, ALLOCATABLE :: em_vi(:,:) ! Integration verticale d'energie totale
      REAL, ALLOCATABLE :: ke_vi_total(:,:), ke_vi_moyen(:,:) ! Energie cinetique
!
      INTEGER i, j, k, n
      LOGICAL debut
!
      pi = 4.0 * ATAN(1.0)
!
      i = iargc()
      IF (i.NE.1) THEN
         PRINT*, "Argument (nom de fichier) non-compatible"
         CALL abort
      ENDIF
      CALL getarg(1,tapename)
!
      CALL lire_dims(tapename,"x",iim,"y",jjm,"levels",kkm,"time_counter",nb)
!
      ALLOCATE ( x(iim), y(jjm), z(kkm) ) ! longitudes, latitudes et pressions
!
      CALL lire_xyz(tapename, iim,"x",x,jjm,"y",y,kkm,"levels",z)
!
      ALLOCATE ( u0(iim,jjm,kkm) )! Vitesse U
      ALLOCATE ( v0(iim,jjm,kkm) )! Vitesse V
      ALLOCATE ( t0(iim,jjm,kkm) )! Temperature
      ALLOCATE ( s0(iim,jjm,kkm) )! Temperature potentielle
      ALLOCATE ( g0(iim,jjm,kkm) )! Geopotentiel
      ALLOCATE ( r0(iim,jjm,kkm) )! Humidite
      ALLOCATE ( q0(iim,jjm,kkm) )! Humidite
      ALLOCATE ( e0(iim,jjm,kkm) )! Energie totale
      ALLOCATE ( pres0(iim,jjm,kkm) )
      ALLOCATE ( ps0(iim,jjm) )
      ALLOCATE ( dsdp0(iim,jjm,kkm) )
      ALLOCATE ( var3d(iim,jjm,kkm) )
!
      ALLOCATE ( um(iim,jjm,kkm) ) ! Accumulation pour U
      ALLOCATE ( vm(iim,jjm,kkm) ) ! Accumulation pour V
      ALLOCATE ( tm(iim,jjm,kkm) ) ! Accumulation pour T
      ALLOCATE ( sm(iim,jjm,kkm) )
      ALLOCATE ( gm(iim,jjm,kkm) )
      ALLOCATE ( qm(iim,jjm,kkm) )
      ALLOCATE ( rm(iim,jjm,kkm) )
      ALLOCATE ( em(iim,jjm,kkm) )
      ALLOCATE ( uu(iim,jjm,kkm) ) ! Accumulation pour U*U
      ALLOCATE ( vv(iim,jjm,kkm) ) ! Accumulation pour V*V
      ALLOCATE ( tt(iim,jjm,kkm) ) ! Accumulation pour T*T
      ALLOCATE ( ss(iim,jjm,kkm) )
      ALLOCATE ( gg(iim,jjm,kkm) )
      ALLOCATE ( qq(iim,jjm,kkm) )
      ALLOCATE ( vt(iim,jjm,kkm) ) ! Accumulation pour V*T
      ALLOCATE ( vu(iim,jjm,kkm) ) ! Accumulation pour V*U
      ALLOCATE ( vs(iim,jjm,kkm) )
      ALLOCATE ( dsdpm(iim,jjm,kkm) )
      ALLOCATE ( vg(iim,jjm,kkm) )
      ALLOCATE ( vq(iim,jjm,kkm) )
      ALLOCATE ( ve(iim,jjm,kkm) )
      ALLOCATE ( uq(iim,jjm,kkm) )
      ALLOCATE ( ue(iim,jjm,kkm) )
      ALLOCATE ( psm(iim,jjm) )
      ALLOCATE ( presm(iim,jjm,kkm) )
!
      ALLOCATE ( psm_z(jjm) )
      ALLOCATE ( presm_z(jjm,kkm) )
!
      ALLOCATE ( vq_z_total(jjm,kkm), vq_z_vi_total(jjm) )
      ALLOCATE ( vq_z_moyen(jjm,kkm), vq_z_vi_moyen(jjm) )
      ALLOCATE ( vq_z_trans(jjm,kkm), vq_z_vi_trans(jjm) )
      ALLOCATE ( vq_z_stati(jjm,kkm), vq_z_vi_stati(jjm) )
!
      ALLOCATE ( vt_z_total(jjm,kkm), vt_z_vi_total(jjm) )
      ALLOCATE ( vt_z_moyen(jjm,kkm), vt_z_vi_moyen(jjm) )
      ALLOCATE ( vt_z_trans(jjm,kkm), vt_z_vi_trans(jjm) )
      ALLOCATE ( vt_z_stati(jjm,kkm), vt_z_vi_stati(jjm) )
!
      ALLOCATE ( vg_z_total(jjm,kkm), vg_z_vi_total(jjm) )
      ALLOCATE ( vg_z_moyen(jjm,kkm), vg_z_vi_moyen(jjm) )
      ALLOCATE ( vg_z_trans(jjm,kkm), vg_z_vi_trans(jjm) )
      ALLOCATE ( vg_z_stati(jjm,kkm), vg_z_vi_stati(jjm) )
!
      ALLOCATE ( vu_z_total(jjm,kkm), vu_z_vi_total(jjm) )
      ALLOCATE ( vu_z_moyen(jjm,kkm), vu_z_vi_moyen(jjm) )
      ALLOCATE ( vu_z_trans(jjm,kkm), vu_z_vi_trans(jjm) )
      ALLOCATE ( vu_z_stati(jjm,kkm), vu_z_vi_stati(jjm) )
!
      ALLOCATE ( ve_z_total(jjm,kkm), ve_z_vi_total(jjm) )
      ALLOCATE ( ve_z_moyen(jjm,kkm), ve_z_vi_moyen(jjm) )
      ALLOCATE ( ve_z_trans(jjm,kkm), ve_z_vi_trans(jjm) )
      ALLOCATE ( ve_z_stati(jjm,kkm), ve_z_vi_stati(jjm) )
!
      ALLOCATE ( ke_z_total(jjm,kkm), ke_z_vi_total(jjm) )
      ALLOCATE ( ke_z_moyen(jjm,kkm), ke_z_vi_moyen(jjm) )
      ALLOCATE ( ke_z_trans(jjm,kkm), ke_z_vi_trans(jjm) )
      ALLOCATE ( ke_z_stati(jjm,kkm), ke_z_vi_stati(jjm) )
!
      ALLOCATE ( stream(jjm,kkm) )
!
      ALLOCATE ( vq_vi_total(iim,jjm), vq_vi_moyen(iim,jjm) )
      ALLOCATE ( vt_vi_total(iim,jjm), vt_vi_moyen(iim,jjm) )
      ALLOCATE ( vg_vi_total(iim,jjm), vg_vi_moyen(iim,jjm) )
      ALLOCATE ( vu_vi_total(iim,jjm), vu_vi_moyen(iim,jjm) )
      ALLOCATE ( ve_vi_total(iim,jjm), ve_vi_moyen(iim,jjm) )
      ALLOCATE ( uq_vi_total(iim,jjm), uq_vi_moyen(iim,jjm) )
      ALLOCATE ( ue_vi_total(iim,jjm), ue_vi_moyen(iim,jjm) )
!
      ALLOCATE ( qm_vi(iim,jjm) )
      ALLOCATE ( em_vi(iim,jjm) )
      ALLOCATE ( ke_vi_total(iim,jjm), ke_vi_moyen(iim,jjm) )
!
! Ouvrir le fichier de depart
!
      ierr = NF90_OPEN (depart, NF90_NOWRITE,lid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Le fichier de depart n existe pas: Initialisation"
         debut = .TRUE.
      ELSE
         debut = .FALSE.
      ENDIF
!
      IF (debut) THEN
         counter = 0.0
      ELSE
      ierr = NF90_GET_ATT(lid, NF90_GLOBAL, "counter", counter)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour obtenir counter"
         CALL abort
      ENDIF
      PRINT*, "Compteur=", counter
      ENDIF
!
      IF (debut) THEN
!
      um = 0.0
      vm = 0.0
      tm = 0.0
      gm = 0.0
      qm = 0.0
      rm = 0.0
      em = 0.0
      uu = 0.0
      vv = 0.0
      tt = 0.0
      gg = 0.0
      qq = 0.0
      vt = 0.0
      vu = 0.0
      vg = 0.0
      vq = 0.0
      ve = 0.0
      uq = 0.0
      ue = 0.0
      psm = 0.0
      presm = 0.0
      sm = 0.0
      ss = 0.0
      vs = 0.0
      dsdpm = 0.0
!
      ELSE ! test sur debut
!
      n = 1
!
      ierr = NF90_INQ_VARID(lid,"time_counter", varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur de time"
         CALL abort
      ENDIF
      ierr = NF90_GET_VAR(lid,varid,temps,START=(/n/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour extraire time"
         CALL abort
      ENDIF
!
      CALL lire_var3d(lid,"psm",iim,jjm,n,psm)
      CALL lire_var4d(lid,"presm",iim,jjm,kkm,n,presm)
      CALL lire_var4d(lid,"um",iim,jjm,kkm,n,um)
      CALL lire_var4d(lid,"vm",iim,jjm,kkm,n,vm)
      CALL lire_var4d(lid,"tm",iim,jjm,kkm,n,tm)
      CALL lire_var4d(lid,"gm",iim,jjm,kkm,n,gm)
      CALL lire_var4d(lid,"qm",iim,jjm,kkm,n,qm)
      CALL lire_var4d(lid,"rm",iim,jjm,kkm,n,rm)
      CALL lire_var4d(lid,"em",iim,jjm,kkm,n,em)
      CALL lire_var4d(lid,"uu",iim,jjm,kkm,n,uu)
      CALL lire_var4d(lid,"vv",iim,jjm,kkm,n,vv)
      CALL lire_var4d(lid,"tt",iim,jjm,kkm,n,tt)
      CALL lire_var4d(lid,"gg",iim,jjm,kkm,n,gg)
      CALL lire_var4d(lid,"qq",iim,jjm,kkm,n,qq)
      CALL lire_var4d(lid,"vu",iim,jjm,kkm,n,vu)
      CALL lire_var4d(lid,"vt",iim,jjm,kkm,n,vt)
      CALL lire_var4d(lid,"vg",iim,jjm,kkm,n,vg)
      CALL lire_var4d(lid,"vq",iim,jjm,kkm,n,vq)
      CALL lire_var4d(lid,"ve",iim,jjm,kkm,n,ve)
      CALL lire_var4d(lid,"uq",iim,jjm,kkm,n,uq)
      CALL lire_var4d(lid,"ue",iim,jjm,kkm,n,ue)
      CALL lire_var4d(lid,"sm",iim,jjm,kkm,n,sm)
      CALL lire_var4d(lid,"ss",iim,jjm,kkm,n,ss)
      CALL lire_var4d(lid,"vs",iim,jjm,kkm,n,vs)
      CALL lire_var4d(lid,"dsdpm",iim,jjm,kkm,n,dsdpm)
!
      ENDIF ! fin de test sur debut
!
      ierr = NF90_CLOSE(lid)
!
      ierr = NF90_OPEN (tapename, NF90_NOWRITE,mid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme d ouverture du fichier:"//tapename
         CALL abort
      ENDIF
!
      DO 99999 n = 1, nb
!
      CALL lire_var3d(mid,"psol",iim,jjm,n,ps0)
!
      CALL lire_var4d(mid,"vitu",iim,jjm,kkm,n,u0)
      CALL lire_var4d(mid,"vitv",iim,jjm,kkm,n,v0)
      CALL lire_var4d(mid,"geop",iim,jjm,kkm,n,g0)
      CALL lire_var4d(mid,"temp",iim,jjm,kkm,n,t0)
      CALL lire_var4d(mid,"ovap",iim,jjm,kkm,n,q0)

      DO k = 1, kkm
      DO j = 1, jjm
      DO i = 1, iim
         g0(i,j,k) = g0(i,j,k)/rg
      ENDDO
      ENDDO
      ENDDO
!
! Mettre le vent zero si la couche est sous la terre:
      DO k = 1, kkm
      DO j = 1, jjm
      DO i = 1, iim
         IF (ps0(i,j).LT.z(k)*100.0) THEN
            u0(i,j,k) = 0.0
            v0(i,j,k) = 0.0
         ENDIF
      ENDDO
      ENDDO
      ENDDO
!
! Pressions atmospheriques:
! (Attention: valeurs de surface, 
!             si la couche est au-dessous de la surface !)
      DO k = 1, kkm
      DO j = 1, jjm
      DO i = 1, iim
         pres0(i,j,k) = z(k)*100.0
         pres0(i,j,k) = MIN(pres0(i,j,k),ps0(i,j))
      ENDDO
      ENDDO
      ENDDO
!
! Calculer l'humidite relative:
      CALL q_sat(iim*jjm*kkm,t0,pres0,r0)
      DO k = 1, kkm
      DO j = 1, jjm
      DO i = 1, iim
         r0(i,j,k) = q0(i,j,k)/r0(i,j,k)*100.0
      ENDDO
      ENDDO
      ENDDO
!
! Calculer la temperature potentielle:
      DO k = 1, kkm
      DO j = 1, jjm
      DO i = 1, iim
         s0(i,j,k) = t0(i,j,k) * (1000.0/pres0(i,j,k))**(r/cp)
      ENDDO
      ENDDO
      ENDDO
!
! Calculer l'energie totale:
      DO k = 1, kkm
      DO j = 1, jjm
      DO i = 1, iim
         e0(i,j,k) = cp*t0(i,j,k) + lv*q0(i,j,k) + rg*g0(i,j,k) &
                   + (u0(i,j,k)**2 + v0(i,j,k)**2)/2.0
      ENDDO
      ENDDO
      ENDDO
!
! Derivee verticale de la temperature potentielle:
      dsdp0 = 0.0
      DO j = 1, jjm
      DO i = 1, iim
         bidon = pres0(i,j,2) - pres0(i,j,1)
         IF (ABS(bidon).GT.1.0e-2) THEN
         dsdp0(i,j,1) = (s0(i,j,2)-s0(i,j,1)) / bidon
         ENDIF
         bidon = pres0(i,j,kkm) - pres0(i,j,kkm-1)
         IF (ABS(bidon).GT.1.0e-2) THEN
         dsdp0(i,j,kkm) = (s0(i,j,kkm)-s0(i,j,kkm-1))/bidon
         ENDIF
      ENDDO
      ENDDO
      DO k = 2, kkm-1
      DO j = 1, jjm
      DO i = 1, iim
         bidon = pres0(i,j,k+1) - pres0(i,j,k-1)
         IF (ABS(bidon).GT.1.0e-2) THEN
         dsdp0(i,j,k) = (s0(i,j,k+1)-s0(i,j,k-1))/bidon
         ENDIF
      ENDDO
      ENDDO
      ENDDO
!
! Accumuler les variables:
      bidon = 1.0/(1.0+counter)
      DO k = 1, kkm
      DO j = 1, jjm
      DO i = 1, iim
         presm(i,j,k) = presm(i,j,k)*(1.0-bidon) &
                      + MIN(ps0(i,j),pres0(i,j,k))*bidon
         um(i,j,k) = um(i,j,k)*(1.0-bidon) + u0(i,j,k)*bidon
         vm(i,j,k) = vm(i,j,k)*(1.0-bidon) + v0(i,j,k)*bidon
         tm(i,j,k) = tm(i,j,k)*(1.0-bidon) + t0(i,j,k)*bidon
         gm(i,j,k) = gm(i,j,k)*(1.0-bidon) + g0(i,j,k)*bidon
         qm(i,j,k) = qm(i,j,k)*(1.0-bidon) + q0(i,j,k)*bidon
         rm(i,j,k) = rm(i,j,k)*(1.0-bidon) + r0(i,j,k)*bidon
         em(i,j,k) = em(i,j,k)*(1.0-bidon) + e0(i,j,k)*bidon
         uu(i,j,k) = uu(i,j,k)*(1.0-bidon) + u0(i,j,k)*u0(i,j,k)*bidon
         vv(i,j,k) = vv(i,j,k)*(1.0-bidon) + v0(i,j,k)*v0(i,j,k)*bidon
         tt(i,j,k) = tt(i,j,k)*(1.0-bidon) + t0(i,j,k)*t0(i,j,k)*bidon
         gg(i,j,k) = gg(i,j,k)*(1.0-bidon) + g0(i,j,k)*g0(i,j,k)*bidon
         qq(i,j,k) = qq(i,j,k)*(1.0-bidon) + q0(i,j,k)*q0(i,j,k)*bidon
         vu(i,j,k) = vu(i,j,k)*(1.0-bidon) + v0(i,j,k)*u0(i,j,k)*bidon
         vt(i,j,k) = vt(i,j,k)*(1.0-bidon) + v0(i,j,k)*t0(i,j,k)*bidon
         vg(i,j,k) = vg(i,j,k)*(1.0-bidon) + v0(i,j,k)*g0(i,j,k)*bidon
         vq(i,j,k) = vq(i,j,k)*(1.0-bidon) + v0(i,j,k)*q0(i,j,k)*bidon
         ve(i,j,k) = ve(i,j,k)*(1.0-bidon) + v0(i,j,k)*e0(i,j,k)*bidon
         uq(i,j,k) = uq(i,j,k)*(1.0-bidon) + u0(i,j,k)*q0(i,j,k)*bidon
         ue(i,j,k) = ue(i,j,k)*(1.0-bidon) + u0(i,j,k)*e0(i,j,k)*bidon
         sm(i,j,k) = sm(i,j,k)*(1.0-bidon) + s0(i,j,k)*bidon
         ss(i,j,k) = ss(i,j,k)*(1.0-bidon) + s0(i,j,k)*s0(i,j,k)*bidon
         vs(i,j,k) = vs(i,j,k)*(1.0-bidon) + v0(i,j,k)*s0(i,j,k)*bidon
         dsdpm(i,j,k) = dsdpm(i,j,k)*(1.0-bidon) + dsdp0(i,j,k)*bidon
      ENDDO
      ENDDO
      ENDDO
      DO j = 1, jjm
      DO i = 1, iim
         psm(i,j) = psm(i,j)*(1.0-bidon) + ps0(i,j)*bidon
      ENDDO
      ENDDO
!
      counter = counter + 1.0
!
99999 CONTINUE
      ierr = NF90_CLOSE(mid)
!
! Ecrire le fichier d'arrivee
!
      CALL ecrit_accu(arrivee,counter,temps,iim,jjm,kkm,x,y,z,psm, &
        presm,um,vm,tm,gm,qm,rm,em,uu,vv,tt,gg,qq,vu,vt,vg,vq, &
        ve,uq,ue,sm,ss,vs,dsdpm)
!
!====================================================================
! FAIRE DES DIAGNOSTIQUES
!
      CALL vintegral(iim,jjm,kkm, psm, presm, qm, qm_vi)
      CALL vintegral(iim,jjm,kkm, psm, presm, em, em_vi)
!
      var3d = 0.5 * (vv+uu)
      CALL vintegral(iim,jjm,kkm, psm, presm, var3d, ke_vi_total)
      var3d = 0.5 * (vm*vm+um*um)
      CALL vintegral(iim,jjm,kkm, psm, presm, var3d, ke_vi_moyen)
!
! CALCULER L'INTEGRATION VERTICALE DES TRANSPORTS:
!
      CALL vintegral(iim,jjm,kkm, psm, presm, vq, vq_vi_total)
      var3d = vm * qm
      CALL vintegral(iim,jjm,kkm, psm, presm, var3d, vq_vi_moyen)
!
      CALL vintegral(iim,jjm,kkm, psm, presm, vt, vt_vi_total)
      var3d = vm * tm
      CALL vintegral(iim,jjm,kkm, psm, presm, var3d, vt_vi_moyen)
!
      CALL vintegral(iim,jjm,kkm, psm, presm, vg, vg_vi_total)
      var3d = vm * gm
      CALL vintegral(iim,jjm,kkm, psm, presm, var3d, vg_vi_moyen)
!
      CALL vintegral(iim,jjm,kkm, psm, presm, vu, vu_vi_total)
      var3d = vm * um
      CALL vintegral(iim,jjm,kkm, psm, presm, var3d, vu_vi_moyen)
!
      CALL vintegral(iim,jjm,kkm, psm, presm, ve, ve_vi_total)
      var3d = vm * em
      CALL vintegral(iim,jjm,kkm, psm, presm, var3d, ve_vi_moyen)
!
      CALL vintegral(iim,jjm,kkm, psm, presm, uq, uq_vi_total)
      var3d = um * qm
      CALL vintegral(iim,jjm,kkm, psm, presm, var3d, uq_vi_moyen)
!
      CALL vintegral(iim,jjm,kkm, psm, presm, ue, ue_vi_total)
      var3d = um * em
      CALL vintegral(iim,jjm,kkm, psm, presm, var3d, ue_vi_moyen)
!
! EN MOYENNE ZONALE:
!
      CALL transp_meri(iim,jjm,kkm,y,vm,qm,vq,psm,presm, &
              vq_z_total,vq_z_moyen,vq_z_trans,vq_z_stati, &
              vq_z_vi_total,vq_z_vi_moyen,vq_z_vi_trans,vq_z_vi_stati)
!
      CALL transp_meri(iim,jjm,kkm,y,vm,tm,vt,psm,presm, &
              vt_z_total,vt_z_moyen,vt_z_trans,vt_z_stati, &
              vt_z_vi_total,vt_z_vi_moyen,vt_z_vi_trans,vt_z_vi_stati)
!
      CALL transp_meri(iim,jjm,kkm,y,vm,gm,vg,psm,presm, &
              vg_z_total,vg_z_moyen,vg_z_trans,vg_z_stati, &
              vg_z_vi_total,vg_z_vi_moyen,vg_z_vi_trans,vg_z_vi_stati)
!
      CALL transp_meri(iim,jjm,kkm,y,vm,um,vu,psm,presm, &
              vu_z_total,vu_z_moyen,vu_z_trans,vu_z_stati, &
              vu_z_vi_total,vu_z_vi_moyen,vu_z_vi_trans,vu_z_vi_stati)
!
      CALL transp_meri(iim,jjm,kkm,y,vm,em,ve,psm,presm, &
              ve_z_total,ve_z_moyen,ve_z_trans,ve_z_stati, &
              ve_z_vi_total,ve_z_vi_moyen,ve_z_vi_trans,ve_z_vi_stati)
!
      CALL hadley_cell(iim,jjm,kkm,y,vm,psm,presm,stream)
!
      CALL kinetic_energy(iim,jjm,kkm,y,vm,um,vv,uu,psm,presm, &
              ke_z_total,ke_z_moyen,ke_z_trans,ke_z_stati, &
              ke_z_vi_total,ke_z_vi_moyen,ke_z_vi_trans,ke_z_vi_stati)
!
! Enregistrer les diagnostiques:
!
      CALL ecrit_diag &
        ("diagnostic.nc",iim,jjm,kkm,x,y,z, &
        vq_vi_total,vq_vi_moyen,vt_vi_total,vt_vi_moyen, &
        vg_vi_total,vg_vi_moyen,vu_vi_total,vu_vi_moyen, &
        ve_vi_total,ve_vi_moyen, &
        uq_vi_total,uq_vi_moyen,ue_vi_total,ue_vi_moyen, &
        vq_z_total,vq_z_moyen,vq_z_trans,vq_z_stati, &
        vq_z_vi_total,vq_z_vi_moyen,vq_z_vi_trans,vq_z_vi_stati, &
        vt_z_total,vt_z_moyen,vt_z_trans,vt_z_stati, &
        vt_z_vi_total,vt_z_vi_moyen,vt_z_vi_trans,vt_z_vi_stati, &
        vg_z_total,vg_z_moyen,vg_z_trans,vg_z_stati, &
        vg_z_vi_total,vg_z_vi_moyen,vg_z_vi_trans,vg_z_vi_stati, &
        vu_z_total,vu_z_moyen,vu_z_trans,vu_z_stati, &
        vu_z_vi_total,vu_z_vi_moyen,vu_z_vi_trans,vu_z_vi_stati, &
        ve_z_total,ve_z_moyen,ve_z_trans,ve_z_stati, &
        ve_z_vi_total,ve_z_vi_moyen,ve_z_vi_trans,ve_z_vi_stati, &
        ke_z_total,ke_z_moyen,ke_z_trans,ke_z_stati, &
        ke_z_vi_total,ke_z_vi_moyen,ke_z_vi_trans,ke_z_vi_stati, &
        stream,qm_vi,em_vi,ke_vi_total,ke_vi_moyen)
!
! Calculer les E-P fluxes:
!
      CALL epflux(iim,jjm,kkm,x,y,z,presm,um,vm,sm,uu,vv,vs,vu,dsdpm)
!
      STOP 
      END
      SUBROUTINE q_sat(np,temp,pres,qsat)
      IMPLICIT none
!
! calculer la vapeur d'eau saturante (formule Centre Euro.)
!
      INTEGER, INTENT(IN) :: np
      REAL, INTENT(IN) :: temp(np)
      REAL, INTENT(IN) :: pres(np)
      REAL, INTENT(OUT) :: qsat(np)
!
      REAL, PARAMETER :: r2es=611.14 *18.0153/28.9644
      REAL :: r3es
      REAL, PARAMETER :: R3LES=17.269, R3IES=21.875
      REAL :: r4es
      REAL, PARAMETER :: R4LES=35.86, R4IES=7.66
!
      REAL, PARAMETER :: rtt=273.16
      REAL, PARAMETER :: retv=28.9644/18.0153-1.0
!
      REAL :: zqsat
      INTEGER :: ip
!
      do ip=1,np
!
         IF (temp(ip) .LE. rtt) THEN
            r3es = r3ies
            r4es = r4ies
         ELSE
            r3es = r3les
            r4es = r4les
         ENDIF
!
         zqsat=r2es/pres(ip)*EXP(r3es*(temp(ip)-rtt)/(temp(ip)-r4es))
         zqsat=MIN(0.5,ZQSAT)
         zqsat=zqsat/(1.-retv *zqsat)
!
         qsat(ip)= zqsat

      enddo
!
      RETURN
      END SUBROUTINE q_sat
      SUBROUTINE kinetic_energy(iim,jjm,kkm,y,vm,um,vv,uu,psm,presm, &
              ke_z_total,ke_z_moyen,ke_z_trans,ke_z_stati, &
              ke_z_vi_total,ke_z_vi_moyen,ke_z_vi_trans,ke_z_vi_stati)
      IMPLICIT none
!
! Calculate the kinetic energy in zonal-mean form, 
! with vertical integration in addition.
!
      INTEGER iim, jjm, kkm
      REAL y(jjm)

      REAL vm(iim,jjm,kkm) ! Accumulation pour V
      REAL um(iim,jjm,kkm)
      REAL vv(iim,jjm,kkm)
      REAL uu(iim,jjm,kkm)
      REAL psm(iim,jjm)
      REAL presm(iim,jjm,kkm)
!
      REAL psm_z(jjm)
      REAL presm_z(jjm,kkm)
!
      REAL ke_z_total(jjm,kkm), ke_z_vi_total(jjm)
      REAL ke_z_moyen(jjm,kkm), ke_z_vi_moyen(jjm)
      REAL ke_z_trans(jjm,kkm), ke_z_vi_trans(jjm)
      REAL ke_z_stati(jjm,kkm), ke_z_vi_stati(jjm)
!
      INTEGER i, j, k
!
      REAL var1_z(jjm,kkm)
      REAL var2_z(jjm,kkm)
!
! pression au sol:
      DO j = 1, jjm
      psm_z(j) = 0.0
         DO i = 1, iim
            psm_z(j) = psm_z(j) + psm(i,j)/FLOAT(iim)
         ENDDO
      ENDDO
!
! pression dans l'atmosphere:
      DO k = 1, kkm
      DO j = 1, jjm
         presm_z(j,k) = 0.0
         DO i = 1, iim
            presm_z(j,k) = presm_z(j,k) &
                         + MIN(presm(i,j,k),psm(i,j))/FLOAT(iim)
         ENDDO
      ENDDO
      ENDDO
!
! energie cinetique totale:
      DO k = 1, kkm
      DO j = 1, jjm
      ke_z_total(j,k) = 0.0
         DO i = 1, iim
            ke_z_total(j,k) = ke_z_total(j,k) + 0.5*(vv(i,j,k)+uu(i,j,k))/FLOAT(iim)
         ENDDO
      ENDDO
      ENDDO
      CALL vintegral(1,jjm,kkm,psm_z,presm_z, ke_z_total,ke_z_vi_total)
!
! energie cinetique dans la circulation moyenne:
      DO k = 1, kkm
      DO j = 1, jjm
      var1_z(j,k) = 0.0
      var2_z(j,k) = 0.0
         DO i = 1, iim
            var1_z(j,k) = var1_z(j,k) + vm(i,j,k)/FLOAT(iim)
            var2_z(j,k) = var2_z(j,k) + um(i,j,k)/FLOAT(iim)
         ENDDO
      ke_z_moyen(j,k) = 0.5*(var1_z(j,k)*var1_z(j,k)) + 0.5*(var2_z(j,k)*var2_z(j,k))
      ENDDO
      ENDDO
      CALL vintegral(1,jjm,kkm,psm_z,presm_z, ke_z_moyen,ke_z_vi_moyen)
!
! energie cinetique dans les toubillions transitoires:
      DO k = 1, kkm
      DO j = 1, jjm
      ke_z_trans(j,k) = 0.0
         DO i = 1, iim
            ke_z_trans(j,k) = ke_z_trans(j,k) &
                  + 0.5*(vv(i,j,k)-vm(i,j,k)*vm(i,j,k))/FLOAT(iim) &
                  + 0.5*(uu(i,j,k)-um(i,j,k)*um(i,j,k))/FLOAT(iim)
         ENDDO
      ENDDO
      ENDDO
      CALL vintegral(1,jjm,kkm,psm_z,presm_z, ke_z_trans,ke_z_vi_trans)
!
! energie cinetique dans les tourbillions stationnaire:
      DO k = 1, kkm
      DO j = 1, jjm
      ke_z_stati(j,k) = 0.0
         DO i = 1, iim
            ke_z_stati(j,k) = ke_z_stati(j,k) &
                  + 0.5*(vm(i,j,k)*vm(i,j,k)+um(i,j,k)*um(i,j,k))/FLOAT(iim)
         ENDDO
      ke_z_stati(j,k) = ke_z_stati(j,k) - ke_z_moyen(j,k)
      ENDDO
      ENDDO
      CALL vintegral(1,jjm,kkm,psm_z,presm_z, ke_z_stati,ke_z_vi_stati)
!
      RETURN
      END SUBROUTINE kinetic_energy
      SUBROUTINE transp_meri(iim,jjm,kkm,y,vm,qm,vq,psm,presm, &
              vq_z_total,vq_z_moyen,vq_z_trans,vq_z_stati, &
              vq_z_vi_total,vq_z_vi_moyen,vq_z_vi_trans,vq_z_vi_stati)
      IMPLICIT none
!
! Calculate the meridional transport in zonal-mean form,
! with vertical integration in addition.
!
      INTEGER iim, jjm, kkm
      REAL y(jjm)

      REAL vm(iim,jjm,kkm) ! Accumulation pour V
      REAL qm(iim,jjm,kkm)
      REAL vq(iim,jjm,kkm)
      REAL psm(iim,jjm)
      REAL presm(iim,jjm,kkm)
!
      REAL psm_z(jjm)
      REAL presm_z(jjm,kkm)
!
      REAL vq_z_total(jjm,kkm), vq_z_vi_total(jjm)
      REAL vq_z_moyen(jjm,kkm), vq_z_vi_moyen(jjm)
      REAL vq_z_trans(jjm,kkm), vq_z_vi_trans(jjm)
      REAL vq_z_stati(jjm,kkm), vq_z_vi_stati(jjm)
!
      REAL var1_z(jjm,kkm)
      REAL var2_z(jjm,kkm)
!
      INTEGER i, j, k
!
      REAL pi, rad
!
      pi = 4.0*ATAN(1.0)
      rad = 6400000.0
!
! pression au sol:
      DO j = 1, jjm
      psm_z(j) = 0.0
         DO i = 1, iim
            psm_z(j) = psm_z(j) + psm(i,j)/FLOAT(iim)
         ENDDO
      ENDDO
!
! pression dans l'atmosphere:
      DO k = 1, kkm
      DO j = 1, jjm
         presm_z(j,k) = 0.0
         DO i = 1, iim
            presm_z(j,k) = presm_z(j,k) &
                         + MIN(presm(i,j,k),psm(i,j))/FLOAT(iim)
         ENDDO
      ENDDO
      ENDDO
!
! transport total:
      DO k = 1, kkm
      DO j = 1, jjm
      vq_z_total(j,k) = 0.0
         DO i = 1, iim
            vq_z_total(j,k) = vq_z_total(j,k) + vq(i,j,k)/FLOAT(iim)
         ENDDO
      ENDDO
      ENDDO
      CALL vintegral(1,jjm,kkm,psm_z,presm_z, vq_z_total,vq_z_vi_total)
      DO j = 1, jjm
      vq_z_vi_total(j) = vq_z_vi_total(j) * &
                         COS(y(j)*pi/180.)*rad*2.0*pi
      ENDDO
!
! transport par circulation moyenne:
      DO k = 1, kkm
      DO j = 1, jjm
      var1_z(j,k) = 0.0
      var2_z(j,k) = 0.0
         DO i = 1, iim
            var1_z(j,k) = var1_z(j,k) + vm(i,j,k)/FLOAT(iim)
            var2_z(j,k) = var2_z(j,k) + qm(i,j,k)/FLOAT(iim)
         ENDDO
      vq_z_moyen(j,k) = var1_z(j,k) * var2_z(j,k)
      ENDDO
      ENDDO
      CALL vintegral(1,jjm,kkm,psm_z,presm_z, vq_z_moyen,vq_z_vi_moyen)
      DO j = 1, jjm
      vq_z_vi_moyen(j) = vq_z_vi_moyen(j) * &
                         COS(y(j)*pi/180.)*rad*2.0*pi
      ENDDO
!
! transport par toubillions transitoires:
      DO k = 1, kkm
      DO j = 1, jjm
      vq_z_trans(j,k) = 0.0
         DO i = 1, iim
            vq_z_trans(j,k) = vq_z_trans(j,k) &
                  + (vq(i,j,k)-vm(i,j,k)*qm(i,j,k))/FLOAT(iim)
         ENDDO
      ENDDO
      ENDDO
      CALL vintegral(1,jjm,kkm,psm_z,presm_z, vq_z_trans,vq_z_vi_trans)
      DO j = 1, jjm
      vq_z_vi_trans(j) = vq_z_vi_trans(j) * &
                         COS(y(j)*pi/180.)*rad*2.0*pi
      ENDDO
!
! transport par tourbillions stationnaire:
      DO k = 1, kkm
      DO j = 1, jjm
      vq_z_stati(j,k) = 0.0
         DO i = 1, iim
            vq_z_stati(j,k) = vq_z_stati(j,k) &
                  + vm(i,j,k)*qm(i,j,k)/FLOAT(iim)
         ENDDO
      vq_z_stati(j,k) = vq_z_stati(j,k) - vq_z_moyen(j,k)
      ENDDO
      ENDDO
      CALL vintegral(1,jjm,kkm,psm_z,presm_z, vq_z_stati,vq_z_vi_stati)
      DO j = 1, jjm
      vq_z_vi_stati(j) = vq_z_vi_stati(j) * &
                         COS(y(j)*pi/180.)*rad*2.0*pi
      ENDDO
!
      RETURN
      END SUBROUTINE transp_meri
      SUBROUTINE vintegral(iim,jjm,kkm, ps, p, q, qi)
      IMPLICIT none
!
! Vertical integration of a whatever physical variable
!
      INTEGER, INTENT(IN) :: iim, jjm, kkm
      REAL, INTENT(IN) :: ps(iim,jjm)
      REAL, INTENT(IN) :: p(iim,jjm,kkm), q(iim,jjm,kkm)
      REAL, INTENT(OUT) :: qi(iim,jjm)
!
      REAL, DIMENSION(:,:,:), ALLOCATABLE :: pr, qq
!
      INTEGER i, j, k
      REAL, PARAMETER :: RG=9.81
!
      ALLOCATE (pr(iim,jjm,0:kkm+1), qq(iim,jjm,0:kkm+1))
!
      DO k = 1, kkm
      DO j = 1, jjm
      DO i = 1, iim
         pr(i,j,k) = p(i,j,k)
         qq(i,j,k) = q(i,j,k)
      ENDDO
      ENDDO
      ENDDO
!
      DO k = kkm-1, 1, -1
      DO j = 1, jjm
      DO i = 1, iim
         IF (pr(i,j,k).GT.ps(i,j)) THEN
            pr(i,j,k) = ps(i,j)
            qq(i,j,k) = qq(i,j,k+1)
         ENDIF
      ENDDO
      ENDDO
      ENDDO
!
      DO j = 1, jjm
      DO i = 1, iim
         pr(i,j,0) = ps(i,j)
         pr(i,j,kkm+1) = 0.0
         qq(i,j,0) = qq(i,j,1)
         qq(i,j,kkm+1) = qq(i,j,kkm)
      ENDDO
      ENDDO
!
      DO j = 1, jjm
      DO i = 1, iim
         qi(i,j) = 0.0
      ENDDO
      ENDDO
!
      DO k = 0, kkm
      DO j = 1, jjm
      DO i = 1, iim
         qi(i,j) = qi(i,j) + (qq(i,j,k)+qq(i,j,k+1))/2.0 &
                            *(pr(i,j,k)-pr(i,j,k+1))/RG
      ENDDO
      ENDDO
      ENDDO
!
      DEALLOCATE (pr, qq)
!
      RETURN
      END SUBROUTINE vintegral
      SUBROUTINE vintegral_bis(iim,jjm,kkm, ptop, pbot, p, q, qi)
      IMPLICIT none
!
! Vertical integration of a whatever physical variable
! between two prescribed pressure levels
!
      INTEGER iim, jjm, kkm
      REAL ptop(iim,jjm)
      REAL pbot(iim,jjm)
      REAL p(iim,jjm,kkm), q(iim,jjm,kkm)
      REAL qi(iim,jjm)
!
      REAL, DIMENSION(:,:,:), ALLOCATABLE :: pr, qq
!
      INTEGER :: i, j, k
      REAL, PARAMETER :: RG=9.81
!
      ALLOCATE (pr(iim,jjm,0:kkm+1), qq(iim,jjm,0:kkm+1))
!
      DO k = 1, kkm
      DO j = 1, jjm
      DO i = 1, iim
         pr(i,j,k) = p(i,j,k)
         qq(i,j,k) = q(i,j,k)
      ENDDO
      ENDDO
      ENDDO
!
      DO k = kkm-1, 1, -1
      DO j = 1, jjm
      DO i = 1, iim
         IF (pr(i,j,k).GT.pbot(i,j)) THEN
            pr(i,j,k) = pbot(i,j)
            qq(i,j,k) = qq(i,j,k+1)
         ENDIF
      ENDDO
      ENDDO
      ENDDO
!
      DO k = 2, kkm
      DO j = 1, jjm
      DO i = 1, iim
         IF (pr(i,j,k).LT.ptop(i,j)) THEN
            pr(i,j,k) = ptop(i,j)
            qq(i,j,k) = qq(i,j,k-1)
         ENDIF
      ENDDO
      ENDDO
      ENDDO
!
      DO j = 1, jjm
      DO i = 1, iim
         pr(i,j,0) = pbot(i,j)
         pr(i,j,kkm+1) = ptop(i,j)
         qq(i,j,0) = qq(i,j,1)
         qq(i,j,kkm+1) = qq(i,j,kkm)
      ENDDO
      ENDDO
!
      DO j = 1, jjm
      DO i = 1, iim
         qi(i,j) = 0.0
      ENDDO
      ENDDO
!
      DO k = 0, kkm
      DO j = 1, jjm
      DO i = 1, iim
         qi(i,j) = qi(i,j) + (qq(i,j,k)+qq(i,j,k+1))/2.0 &
                            *(pr(i,j,k)-pr(i,j,k+1))/RG
      ENDDO
      ENDDO
      ENDDO
!
      DEALLOCATE (pr, qq)
!
      RETURN
      END SUBROUTINE vintegral_bis
      SUBROUTINE hadley_cell(iim,jjm,kkm,y,vm,psm,presm,stream)
      IMPLICIT none
!
! Calculate the meridional stream function
!
      INTEGER, INTENT(IN) :: iim, jjm, kkm

      REAL, INTENT(IN) :: y(jjm)
      REAL, INTENT(IN) :: vm(iim,jjm,kkm) ! Accumulation pour V
      REAL, INTENT(IN) :: psm(iim,jjm)
      REAL, INTENT(IN) :: presm(iim,jjm,kkm)
      REAL, INTENT(OUT) :: stream(jjm,kkm)
!
      REAL, ALLOCATABLE :: psm_z(:)
      REAL, ALLOCATABLE :: presm_z(:,:)
      REAL, ALLOCATABLE :: var1_z(:,:)
!
      INTEGER :: i, j, k
      REAL :: pi, rad, RG
!
      pi = 4.0*ATAN(1.0)
      rad = 6400000.0
      RG = 9.81
!
      ALLOCATE (psm_z(jjm), presm_z(jjm,kkm), var1_z(jjm,kkm))
!
      DO j = 1, jjm
      psm_z(j) = 0.0
         DO i = 1, iim
            psm_z(j) = psm_z(j) + psm(i,j)/FLOAT(iim)
         ENDDO
      ENDDO
!
      DO k = 1, kkm
      DO j = 1, jjm
         presm_z(j,k) = 0.0
         var1_z(j,k) = 0.0
         DO i = 1, iim
         IF (presm(i,j,k).GT.psm(i,j)) THEN
            presm_z(j,k) = presm_z(j,k) + psm(i,j)/FLOAT(iim)
            var1_z(j,k) = var1_z(j,k) + 0.0
         ELSE
            presm_z(j,k) = presm_z(j,k) + presm(i,j,k)/FLOAT(iim)
            var1_z(j,k) = var1_z(j,k) + vm(i,j,k)/FLOAT(iim)
         ENDIF
         ENDDO
      ENDDO
      ENDDO
!
      DO j = 1, jjm
         stream(j,kkm) = (presm_z(j,kkm)-0.0) * var1_z(j,kkm) &
                        *COS(y(j)*pi/180.)*rad*2.0*pi/RG
         DO k = kkm-1, 1, -1
         stream(j,k) = stream(j,k+1) &
                     + (presm_z(j,k)-presm_z(j,k+1)) * &
                       (var1_z(j,k)+var1_z(j,k+1))*0.5 &
                      *COS(y(j)*pi/180.)*rad*2.0*pi/RG
         ENDDO
      ENDDO
!
      DEALLOCATE (psm_z, presm_z, var1_z)
!
      RETURN
      END SUBROUTINE hadley_cell

  SUBROUTINE lire_dims(ficnom,lon,iim,lat,jjm,lev,kkm,time,nb)
!
! Evaluer la longeur des dimensions du fichier LMDZ
!
  USE netcdf
  IMPLICIT none
!
  CHARACTER(len=*), INTENT(in) :: ficnom
  CHARACTER(len=*), INTENT(in) :: lon, lat, lev, time
  INTEGER, INTENT(out) :: iim, jjm, kkm, nb
  INTEGER :: ierr, id_nc, id_tmp
!
  ierr = NF90_OPEN(ficnom, NF90_NOWRITE, id_nc)
  IF (ierr.NE.NF90_NOERR) THEN
     PRINT*, "Probleme d ouverture du fichier", ficnom
     CALL abort
  ENDIF
!
  ierr = NF90_INQ_DIMID (id_nc,lon,id_tmp)
  IF (ierr.NE.NF90_NOERR) THEN
     PRINT*, "Probleme pour avoir identificateur dim lon"
     CALL abort
  ENDIF
  ierr = NF90_INQUIRE_DIMENSION(id_nc, id_tmp, LEN=iim)
  IF (ierr.NE.NF90_NOERR) THEN
     PRINT*, "Probleme pour evaluer la longeur de lon"
     CALL abort
  ENDIF
!
  ierr = NF90_INQ_DIMID (id_nc,lat,id_tmp)
  IF (ierr.NE.NF90_NOERR) THEN
     PRINT*, "Probleme pour avoir identificateur dim lat"
     CALL abort
  ENDIF
  ierr = NF90_INQUIRE_DIMENSION(id_nc, id_tmp, LEN=jjm)
  IF (ierr.NE.NF90_NOERR) THEN
     PRINT*, "Probleme pour evaluer la longeur de lat"
     CALL abort
  ENDIF
!
  ierr = NF90_INQ_DIMID (id_nc,lev,id_tmp)
  IF (ierr.NE.NF90_NOERR) THEN
     PRINT*, "Probleme pour avoir identificateur dim lev"
     CALL abort
  ENDIF
  ierr = NF90_INQUIRE_DIMENSION(id_nc, id_tmp, LEN=kkm)
  IF (ierr.NE.NF90_NOERR) THEN
     PRINT*, "Probleme pour evaluer la longeur de lev"
     CALL abort
  ENDIF
!
  ierr = NF90_INQ_DIMID (id_nc,time,id_tmp)
  IF (ierr.NE.NF90_NOERR) THEN
     PRINT*, "Probleme pour avoir identificateur dim time"
     CALL abort
  ENDIF
  ierr = NF90_INQUIRE_DIMENSION(id_nc, id_tmp, LEN=nb)
  IF (ierr.NE.NF90_NOERR) THEN
     PRINT*, "Probleme pour evaluer la longeur de time"
     CALL abort
  ENDIF
!
  ierr = NF90_CLOSE(id_nc)
!
  END SUBROUTINE lire_dims
!
  SUBROUTINE lire_xyz(tapename,iim,lon,x,jjm,lat,y,kkm,level,z)
  USE netcdf
  IMPLICIT none
!
  CHARACTER(len=*), INTENT(IN) :: tapename
!
  INTEGER, INTENT(IN) :: iim, jjm, kkm
  CHARACTER(LEN=*), INTENT(IN) :: lon, lat, level
  REAL, INTENT(OUT) :: x(iim), y(jjm), z(kkm)
!
  INTEGER :: mid
  INTEGER :: ierr, varid, i, j, k
!
! Ouvrir le fichier brut pour extraire les coordonnees:
!
  ierr = NF90_OPEN (tapename, NF90_NOWRITE,mid)
  IF (ierr.NE.NF90_NOERR) THEN
     PRINT*, "Probleme d ouverture du fichier coordonnees"
     CALL abort
  ENDIF

  ierr = NF90_INQ_DIMID(mid,lon,varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour avoir DIMidentificateur de lon"
         CALL abort
      ENDIF
  ierr = NF90_INQUIRE_DIMENSION(mid,varid,LEN=i)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour avoir la longueur de lon"
         CALL abort
      ENDIF
      IF (i.NE.iim) THEN
         PRINT*, "Dimension lon fausse:", i, iim
         CALL abort
      ENDIF
  ierr = NF90_INQ_VARID (mid,lon,varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur lon"
         CALL abort
      ENDIF
  ierr = NF90_GET_VAR(mid, varid, x, START=(/1/),COUNT=(/iim/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour extraire lon"
         CALL abort
      ENDIF
!
  ierr = NF90_INQ_DIMID(mid,lat,varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour avoir DIMidentificateur de lat"
         CALL abort
      ENDIF
  ierr = NF90_INQUIRE_DIMENSION(mid,varid,LEN=j)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour avoir la longueur de y"
         CALL abort
      ENDIF
      IF (j.NE.jjm) THEN
         PRINT*, "Dimension lat fausse:", j, jjm
         CALL abort
      ENDIF
  ierr = NF90_INQ_VARID (mid,lat,varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur lat"
         CALL abort
      ENDIF
      ierr = NF90_GET_VAR(mid, varid, y, START=(/1/),COUNT=(/jjm/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour extraire lat"
         CALL abort
      ENDIF
!
  ierr = NF90_INQ_DIMID(mid,level,varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour avoir DIMidentificateur de level"
         CALL abort
      ENDIF
  ierr = NF90_INQUIRE_DIMENSION(mid,varid,LEN=k)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour avoir la longueur de level"
         CALL abort
      ENDIF
      IF (k.NE.kkm) THEN
         PRINT*, "Dimension levs fausse:", k, kkm
         CALL abort
      ENDIF
  ierr = NF90_INQ_VARID (mid,level,varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur level"
         CALL abort
      ENDIF
  ierr = NF90_GET_VAR(mid, varid, z, START=(/1/),COUNT=(/kkm/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour extraire level"
         CALL abort
      ENDIF
!
  ierr = NF90_CLOSE(mid)
!
  END SUBROUTINE lire_xyz
!
      SUBROUTINE lire_var3d(lid,varname,iim,jjm,n,var)
      USE netcdf
      IMPLICIT none
!
      INTEGER lid, iim,jjm,n,debut3(3), epais3(3)
      REAL var(iim,jjm)
      CHARACTER*(*) varname
      INTEGER varid, ierr
!
      REAL scale_factor, add_offset
!
      debut3(1) = 1
      debut3(2) = 1
      debut3(3) = n
      epais3(1) = iim
      epais3(2) = jjm
      epais3(3) = 1
!
      ierr = NF90_INQ_VARID(lid,varname, varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur"
         CALL abort
      ENDIF
      ierr = NF90_GET_VAR(lid,varid,var,debut3,epais3)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour extraire"
         CALL abort
      ENDIF
!
      ierr = NF90_GET_ATT(lid,varid,"scale_factor",scale_factor)
      IF (ierr.NE.NF90_NOERR) THEN
!cc         PRINT*, "Probleme pour extraire scale_factor"
!cc         CALL abort
         scale_factor = 1.0
      ENDIF
      ierr = NF90_GET_ATT(lid,varid,"add_offset",add_offset)
      IF (ierr.NE.NF90_NOERR) THEN
!cc         PRINT*, "Probleme pour extraire add_offset"
!cc         CALL abort
         add_offset = 0.0
      ENDIF
      var = var * scale_factor + add_offset
!
      END SUBROUTINE lire_var3d
      SUBROUTINE lire_var4d(lid,varname,iim,jjm,kkm,n,var)
      USE netcdf
      IMPLICIT none
!
      INTEGER lid, iim,jjm,kkm,n,debut4(4), epais4(4)
      REAL var(iim,jjm,kkm)
      CHARACTER*(*) varname
      INTEGER varid, ierr
      REAL scale_factor, add_offset
!
      debut4(1) = 1
      debut4(2) = 1
      debut4(3) = 1
      debut4(4) = n
      epais4(1) = iim
      epais4(2) = jjm
      epais4(3) = kkm
      epais4(4) = 1
!
      ierr = NF90_INQ_VARID(lid,varname, varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur"
         CALL abort
      ENDIF
      ierr = NF90_GET_VAR(lid,varid,var,debut4,epais4)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour extraire"
         CALL abort
      ENDIF
!
      ierr = NF90_GET_ATT(lid,varid,"scale_factor",scale_factor)
      IF (ierr.NE.NF90_NOERR) THEN
!cc         PRINT*, "Probleme pour extraire scale_factor"
!cc         CALL abort
         scale_factor = 1.0
      ENDIF
      ierr = NF90_GET_ATT(lid,varid,"add_offset",add_offset)
      IF (ierr.NE.NF90_NOERR) THEN
!cc         PRINT*, "Probleme pour extraire add_offset"
!cc         CALL abort
         add_offset = 0.0
      ENDIF
      var = var * scale_factor + add_offset
!
      RETURN
      END SUBROUTINE lire_var4d
      SUBROUTINE ecritnd(nid,taille, var, nb_dims, dims, debut, epais, &
                         name, longname, unit)
      USE netcdf
      IMPLICIT none
!
! general writting programme in netcdf format
! with definition of a variable and its immediate writting
!
      INTEGER, INTENT(IN) :: nid, taille
      INTEGER, INTENT(IN) :: nb_dims, dims(nb_dims), debut(nb_dims), epais(nb_dims)
      REAL, INTENT(IN) :: var(taille)
      CHARACTER(LEN=*) name,longname,unit
      INTEGER :: ierr, varid, i

      ierr = NF90_REDEF (nid)
      ierr = NF90_DEF_VAR (nid,name,NF90_FLOAT,dims,varid)
      ierr = NF90_PUT_ATT (nid,varid,"long_name",longname)
      ierr = NF90_PUT_ATT (nid,varid,"units",unit)
!!      ierr=NF90_PUT_ATT(nid,varid,"scale_factor",1.0)
!!      ierr=NF90_PUT_ATT(nid,varid,"add_offset",0.0)
      ierr=NF90_PUT_ATT(nid,varid,"missing_value",1.0e25)
      ierr = NF90_ENDDEF(nid)
      ierr = NF90_PUT_VAR(nid,varid,var,debut,epais)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer var"
         CALL abort
      ENDIF
!
      END SUBROUTINE ecritnd
      SUBROUTINE ecrit_accu(arrivee,counter,temps,iim,jjm,kkm,x,y,z,psm,&
        presm,um,vm,tm,gm,qm,rm,em,uu,vv,tt,gg,qq,vu,vt,vg,vq,ve,&
        uq,ue,sm,ss,vs,dsdpm)
      USE netcdf
      IMPLICIT none
!
!
      INTEGER iim, jjm, kkm
      REAL counter
!
      CHARACTER*(*) arrivee   ! Fichier d'accumulation a l'arrivee
      INTEGER nid
!
      INTEGER ierr, varid
      INTEGER idim_x, idim_y, idim_z, idim_t
      INTEGER dims4(4), dims3(3), dims2(2)
      INTEGER debut4(4), epais4(4)
      INTEGER debut3(3), epais3(3)
      INTEGER debut2(2), epais2(2)

      REAL x(iim), y(jjm), z(kkm) ! longitudes, latitudes et pressions
      REAL temps
!
      REAL um(iim,jjm,kkm)
      REAL vm(iim,jjm,kkm)
      REAL tm(iim,jjm,kkm)
      REAL gm(iim,jjm,kkm)
      REAL qm(iim,jjm,kkm)
      REAL rm(iim,jjm,kkm)
      REAL em(iim,jjm,kkm)
      REAL uu(iim,jjm,kkm)
      REAL vv(iim,jjm,kkm)
      REAL tt(iim,jjm,kkm)
      REAL gg(iim,jjm,kkm)
      REAL qq(iim,jjm,kkm)
      REAL vu(iim,jjm,kkm)
      REAL vt(iim,jjm,kkm)
      REAL vg(iim,jjm,kkm)
      REAL vq(iim,jjm,kkm)
      REAL ve(iim,jjm,kkm)
      REAL uq(iim,jjm,kkm)
      REAL ue(iim,jjm,kkm)
      REAL presm(iim,jjm,kkm)
      REAL psm(iim,jjm)
!
      REAL sm(iim,jjm,kkm)
      REAL ss(iim,jjm,kkm)
      REAL vs(iim,jjm,kkm)
      REAL dsdpm(iim,jjm,kkm)
!
      REAL bidon
!
      INTEGER i, j, k
!
! Ouvrir le fichier d'arrivee
!
      ierr = NF90_CREATE (arrivee, NF90_CLOBBER,nid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme de creation du fichier d arrivee"
         CALL abort
      ENDIF
!
! Preciser quelques attributs globaux:
!
      ierr = NF90_PUT_ATT(nid, NF90_GLOBAL, "title", &
                             "Fichier carre en coordonnees pression")
      ierr = NF90_PUT_ATT(nid, NF90_GLOBAL, "model", &
                             "Modele de circulation generale")
      ierr = NF90_PUT_ATT &
             (nid,NF90_GLOBAL,"counter",counter)
!
! Definir les dimensions du fichier:
!
      ierr = NF90_DEF_DIM(nid,"x",iim,idim_x)
      ierr = NF90_DEF_DIM(nid,"y",jjm,idim_y)
      ierr = NF90_DEF_DIM(nid,"levels",kkm,idim_z)
      ierr = NF90_DEF_DIM(nid, "time", NF90_UNLIMITED, idim_t)
!
      ierr = NF90_ENDDEF(nid) ! sortir du mode de definition
!
! Definir et enregistrer certains champs invariants:
!
      ierr = NF90_REDEF (nid)
      ierr = NF90_DEF_VAR (nid,"x",NF90_FLOAT,(/idim_x/),varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir x"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT (nid, varid, "long_name", "Longitudes")
      ierr = NF90_PUT_ATT (nid, varid, "units", "degrees_east")
      ierr = NF90_ENDDEF(nid)
      ierr = NF90_PUT_VAR(nid,varid,x,START=(/1/),COUNT=(/iim/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer x"
         CALL abort
      ENDIF
!
      ierr = NF90_REDEF (nid)
      ierr = NF90_DEF_VAR (nid,"y",NF90_FLOAT,(/idim_y/),varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir y"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT (nid, varid, "long_name", "Latitudes")
      ierr = NF90_PUT_ATT (nid, varid, "units", "degrees_north")
      ierr = NF90_ENDDEF(nid)
      ierr = NF90_PUT_VAR(nid,varid,y,START=(/1/),COUNT=(/jjm/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer y"
         CALL abort
      ENDIF
!
      ierr = NF90_REDEF (nid)
      ierr = NF90_DEF_VAR (nid,"levels",NF90_FLOAT,(/idim_z/),varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir levs"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT (nid, varid, "long_name", "Presure")
      ierr = NF90_PUT_ATT (nid, varid, "units", "millibars")
      ierr = NF90_ENDDEF(nid)
      ierr = NF90_PUT_VAR(nid,varid,z,START=(/1/),COUNT=(/kkm/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer levs"
         CALL abort
      ENDIF
!
      ierr = NF90_REDEF (nid)
      ierr = NF90_DEF_VAR (nid,"time", NF90_FLOAT,(/idim_t/),varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir time"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT(nid,varid,"long_name","time counter")
      ierr = NF90_PUT_ATT(nid,varid,"units","days since 1-1-1")
      ierr = NF90_PUT_ATT(nid,varid,"note","units may be wrong")
      ierr = NF90_ENDDEF(nid)
      ierr = NF90_PUT_VAR(nid,varid,temps,START=(/1/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer time"
         CALL abort
      ENDIF
!
!
!
      dims3(1) = idim_x
      dims3(2) = idim_y
      dims3(3) = idim_t
      debut3(1) = 1
      debut3(2) = 1
      debut3(3) = 1
      epais3(1) = iim
      epais3(2) = jjm
      epais3(3) = 1
!
      CALL ecritnd(nid,iim*jjm, psm, 3, dims3, debut3, epais3, &
                  "psm","PSM","Pa")

      dims4(1) = idim_x
      dims4(2) = idim_y
      dims4(3) = idim_z
      dims4(4) = idim_t
      debut4(1) = 1
      debut4(2) = 1
      debut4(3) = 1
      debut4(4) = 1
      epais4(1) = iim
      epais4(2) = jjm
      epais4(3) = kkm
      epais4(4) = 1
!
      CALL ecritnd(nid,iim*jjm*kkm, presm, 4, dims4,debut4,epais4, "presm", "PRESM", "Pa")
!
      CALL ecritnd(nid,iim*jjm*kkm, um, 4, dims4,debut4,epais4, "um", "UM", "m/s")
!
      CALL ecritnd(nid,iim*jjm*kkm, vm, 4, dims4,debut4,epais4, "vm", "VM", "m/s")
!
      CALL ecritnd(nid,iim*jjm*kkm, tm, 4, dims4,debut4,epais4, "tm", "TM", "K")
!
      CALL ecritnd(nid,iim*jjm*kkm, gm, 4, dims4,debut4,epais4, "gm", "GM", "m")
!
      CALL ecritnd(nid,iim*jjm*kkm, qm, 4, dims4,debut4,epais4, "qm", "QM", "kg/kg")
!
      CALL ecritnd(nid,iim*jjm*kkm, rm, 4, dims4,debut4,epais4, "rm", "RM", "%")
!
      CALL ecritnd(nid,iim*jjm*kkm, em, 4, dims4,debut4,epais4, "em", "EM", "J/kg")
!
!
      CALL ecritnd(nid,iim*jjm*kkm, uu, 4, dims4,debut4,epais4, "uu", "UU", "m2/s2")
!
      CALL ecritnd(nid,iim*jjm*kkm, vv, 4, dims4,debut4,epais4, "vv", "VV", "m2/s2")
!
      CALL ecritnd(nid,iim*jjm*kkm, tt, 4, dims4,debut4,epais4, "tt", "TT", "K2")
!
      CALL ecritnd(nid,iim*jjm*kkm, gg, 4, dims4,debut4,epais4, "gg", "GG", "m2")
!
      CALL ecritnd(nid,iim*jjm*kkm, qq, 4, dims4,debut4,epais4, "qq", "QQ", "kg2/kg2")
!
      CALL ecritnd(nid,iim*jjm*kkm, vu, 4, dims4,debut4,epais4, "vu", "VU", "m2/s2")
!
      CALL ecritnd(nid,iim*jjm*kkm, vt, 4, dims4,debut4,epais4, "vt", "VT", "K m/s")
!
      CALL ecritnd(nid,iim*jjm*kkm, vg, 4, dims4,debut4,epais4, "vg", "VG", "m2/s")
!
      CALL ecritnd(nid,iim*jjm*kkm, vq, 4, dims4,debut4,epais4, "vq", "VQ", "kg/kg m/s")
!
      CALL ecritnd(nid,iim*jjm*kkm, ve, 4, dims4,debut4,epais4, "ve", "VE", "J/kg m/s")
!
      CALL ecritnd(nid,iim*jjm*kkm, uq, 4, dims4,debut4,epais4, "uq", "UQ", "kg/kg m/s")
!
      CALL ecritnd(nid,iim*jjm*kkm, ue, 4, dims4,debut4,epais4, "ue", "UE", "J/kg m/s")
!
!
      CALL ecritnd(nid,iim*jjm*kkm, sm, 4, dims4,debut4,epais4, "sm", "SM", "K")
!
      CALL ecritnd(nid,iim*jjm*kkm, ss, 4, dims4,debut4,epais4, "ss", "SS", "K2")
!
      CALL ecritnd(nid,iim*jjm*kkm, vs, 4, dims4,debut4,epais4, "vs", "VS", "Km/s")
!
      CALL ecritnd(nid,iim*jjm*kkm, dsdpm, 4, dims4,debut4,epais4, "dsdpm", "DSDPM", "K/pa")
!
      ierr = NF90_CLOSE(nid)
!
      END SUBROUTINE ecrit_accu
      SUBROUTINE ecrit_diag(filename,iim,jjm,kkm,x,y,z, &
        vq_vi_total,vq_vi_moyen,vt_vi_total,vt_vi_moyen, &
        vg_vi_total,vg_vi_moyen,vu_vi_total,vu_vi_moyen, &
        ve_vi_total,ve_vi_moyen, &
        uq_vi_total,uq_vi_moyen,ue_vi_total,ue_vi_moyen, &
        vq_z_total,vq_z_moyen,vq_z_trans,vq_z_stati, &
        vq_z_vi_total,vq_z_vi_moyen,vq_z_vi_trans,vq_z_vi_stati, &
        vt_z_total,vt_z_moyen,vt_z_trans,vt_z_stati, &
        vt_z_vi_total,vt_z_vi_moyen,vt_z_vi_trans,vt_z_vi_stati, &
        vg_z_total,vg_z_moyen,vg_z_trans,vg_z_stati, &
        vg_z_vi_total,vg_z_vi_moyen,vg_z_vi_trans,vg_z_vi_stati, &
        vu_z_total,vu_z_moyen,vu_z_trans,vu_z_stati, &
        vu_z_vi_total,vu_z_vi_moyen,vu_z_vi_trans,vu_z_vi_stati, &
        ve_z_total,ve_z_moyen,ve_z_trans,ve_z_stati, &
        ve_z_vi_total,ve_z_vi_moyen,ve_z_vi_trans,ve_z_vi_stati, &
        ke_z_total,ke_z_moyen,ke_z_trans,ke_z_stati, &
        ke_z_vi_total,ke_z_vi_moyen,ke_z_vi_trans,ke_z_vi_stati, &
        stream,qm_vi,em_vi,ke_vi_total,ke_vi_moyen)
      USE netcdf
      IMPLICIT none
!
! Writting programme for different diagnostics
!
      CHARACTER(LEN=*), INTENT(IN) :: filename   ! file name
      INTEGER, INTENT(IN) :: iim, jjm, kkm
      REAL, INTENT(IN) :: x(iim), y(jjm), z(kkm) ! longitudes, latitudes et pressions
!
      REAL, INTENT(IN) :: vq_vi_total(iim,jjm), vq_vi_moyen(iim,jjm)
      REAL, INTENT(IN) :: vt_vi_total(iim,jjm), vt_vi_moyen(iim,jjm)
      REAL, INTENT(IN) :: vg_vi_total(iim,jjm), vg_vi_moyen(iim,jjm)
      REAL, INTENT(IN) :: vu_vi_total(iim,jjm), vu_vi_moyen(iim,jjm)
      REAL, INTENT(IN) :: ve_vi_total(iim,jjm), ve_vi_moyen(iim,jjm)
      REAL, INTENT(IN) :: uq_vi_total(iim,jjm), uq_vi_moyen(iim,jjm)
      REAL, INTENT(IN) :: ue_vi_total(iim,jjm), ue_vi_moyen(iim,jjm)
!
      REAL, INTENT(IN) :: qm_vi(iim,jjm), em_vi(iim,jjm)
      REAL, INTENT(IN) :: ke_vi_total(iim,jjm), ke_vi_moyen(iim,jjm)
!
      REAL, INTENT(IN) :: vq_z_total(jjm,kkm), vq_z_vi_total(jjm)
      REAL, INTENT(IN) :: vq_z_moyen(jjm,kkm), vq_z_vi_moyen(jjm)
      REAL, INTENT(IN) :: vq_z_trans(jjm,kkm), vq_z_vi_trans(jjm)
      REAL, INTENT(IN) :: vq_z_stati(jjm,kkm), vq_z_vi_stati(jjm)
!
      REAL, INTENT(IN) :: vt_z_total(jjm,kkm), vt_z_vi_total(jjm)
      REAL, INTENT(IN) :: vt_z_moyen(jjm,kkm), vt_z_vi_moyen(jjm)
      REAL, INTENT(IN) :: vt_z_trans(jjm,kkm), vt_z_vi_trans(jjm)
      REAL, INTENT(IN) :: vt_z_stati(jjm,kkm), vt_z_vi_stati(jjm)
!
      REAL, INTENT(IN) :: vg_z_total(jjm,kkm), vg_z_vi_total(jjm)
      REAL, INTENT(IN) :: vg_z_moyen(jjm,kkm), vg_z_vi_moyen(jjm)
      REAL, INTENT(IN) :: vg_z_trans(jjm,kkm), vg_z_vi_trans(jjm)
      REAL, INTENT(IN) :: vg_z_stati(jjm,kkm), vg_z_vi_stati(jjm)
!
      REAL, INTENT(IN) :: vu_z_total(jjm,kkm), vu_z_vi_total(jjm)
      REAL, INTENT(IN) :: vu_z_moyen(jjm,kkm), vu_z_vi_moyen(jjm)
      REAL, INTENT(IN) :: vu_z_trans(jjm,kkm), vu_z_vi_trans(jjm)
      REAL, INTENT(IN) :: vu_z_stati(jjm,kkm), vu_z_vi_stati(jjm)
!
      REAL, INTENT(IN) :: ve_z_total(jjm,kkm), ve_z_vi_total(jjm)
      REAL, INTENT(IN) :: ve_z_moyen(jjm,kkm), ve_z_vi_moyen(jjm)
      REAL, INTENT(IN) :: ve_z_trans(jjm,kkm), ve_z_vi_trans(jjm)
      REAL, INTENT(IN) :: ve_z_stati(jjm,kkm), ve_z_vi_stati(jjm)
!
      REAL, INTENT(IN) :: ke_z_total(jjm,kkm), ke_z_vi_total(jjm)
      REAL, INTENT(IN) :: ke_z_moyen(jjm,kkm), ke_z_vi_moyen(jjm)
      REAL, INTENT(IN) :: ke_z_trans(jjm,kkm), ke_z_vi_trans(jjm)
      REAL, INTENT(IN) :: ke_z_stati(jjm,kkm), ke_z_vi_stati(jjm)
!
      REAL, INTENT(IN) :: stream(jjm,kkm)
!
      REAL :: bidon
      REAL :: temps
!
      INTEGER :: nid, ierr, varid
      INTEGER :: idim_x, idim_y, idim_z, idim_t
      INTEGER :: dims4(4), debut4(4), epais4(4)
      INTEGER :: i, j, k
!
      temps = 1.0
!
! Write horizontal 2-D variables
!
      ierr = NF90_CREATE ("map_"//filename, NF90_CLOBBER,nid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme de creation du fichier d arrivee"
         CALL abort
      ENDIF
!
! Preciser quelques attributs globaux:
!
      ierr = NF90_PUT_ATT (nid, NF90_GLOBAL, "title", &
                             "Vertically-integrated transport maps")
      ierr = NF90_PUT_ATT (nid, NF90_GLOBAL, "model", &
                             "Modele de circulation generale")
!
! Definir les dimensions du fichier:
!
      ierr = NF90_DEF_DIM(nid,"x",iim,idim_x)
      ierr = NF90_DEF_DIM(nid,"y",jjm,idim_y)
      ierr = NF90_DEF_DIM(nid,"levels",1,idim_z)
      ierr = NF90_DEF_DIM(nid, "time", NF90_UNLIMITED, idim_t)
!
      ierr = NF90_ENDDEF(nid) ! sortir du mode de definition
!
! Definir et enregistrer certains champs invariants:
!
      ierr = NF90_REDEF (nid)
      ierr = NF90_DEF_VAR (nid,"x",NF90_FLOAT,(/idim_x/),varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir x"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT (nid, varid, "long_name", "Longitudes")
      ierr = NF90_PUT_ATT (nid, varid, "units", "degrees_east")
      ierr = NF90_ENDDEF(nid)
      ierr = NF90_PUT_VAR(nid,varid,x,START=(/1/),COUNT=(/iim/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer x"
         CALL abort
      ENDIF
!
      ierr = NF90_REDEF (nid)
      ierr = NF90_DEF_VAR (nid,"y",NF90_FLOAT,(/idim_y/),varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir y"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT (nid, varid, "long_name", "Latitudes")
      ierr = NF90_PUT_ATT (nid, varid, "units", "degrees_north")
      ierr = NF90_ENDDEF(nid)
      ierr = NF90_PUT_VAR(nid,varid,y,START=(/1/),COUNT=(/jjm/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer y"
         CALL abort
      ENDIF
!
      ierr = NF90_REDEF (nid)
      ierr = NF90_DEF_VAR (nid,"levels",NF90_FLOAT,(/idim_z/),varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir levs"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT (nid, varid, "long_name", "Presure")
      ierr = NF90_PUT_ATT (nid, varid, "units", "millibars")
      ierr = NF90_ENDDEF(nid)
      ierr = NF90_PUT_VAR(nid,varid,z(1),START=(/1/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer levs"
         CALL abort
      ENDIF
!
      ierr = NF90_REDEF (nid)
      ierr = NF90_DEF_VAR (nid,"time", NF90_FLOAT,(/idim_t/),varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir time"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT(nid,varid,"long_name","time counter")
      ierr = NF90_PUT_ATT(nid,varid,"units","days since 1-1-1")
      ierr = NF90_PUT_ATT(nid,varid,"note","units may be wrong")
      ierr = NF90_ENDDEF(nid)
      ierr = NF90_PUT_VAR(nid,varid,temps,START=(/1/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer time"
         CALL abort
      ENDIF
!
      dims4(1) = idim_x
      dims4(2) = idim_y
      dims4(3) = idim_z
      dims4(4) = idim_t
      debut4(1) = 1
      debut4(2) = 1
      debut4(3) = 1
      debut4(4) = 1
      epais4(1) = iim
      epais4(2) = jjm
      epais4(3) = 1
      epais4(4) = 1
!
      CALL ecritnd(nid,iim*jjm, vq_vi_total, 4, dims4,debut4,epais4, &
           "vq_vi_total", "water-vapour meridional transport: Total", "kg/m/s")
!
      CALL ecritnd(nid,iim*jjm, vq_vi_moyen, 4, dims4,debut4,epais4, &
                   "vq_vi_moyen", "water-vapour meridional transport: Mean", "kg/m/s")
!
      CALL ecritnd(nid,iim*jjm, vt_vi_total, 4, dims4,debut4,epais4, &
                   "vt_vi_total", "temperature meridional transport: Total", "K kg/m/s")
!
      CALL ecritnd(nid,iim*jjm, vt_vi_moyen, 4, dims4,debut4,epais4, &
                   "vt_vi_moyen", "temperature meridional transport: Mean", "K kg/m/s")
!
      CALL ecritnd(nid,iim*jjm, vg_vi_total, 4, dims4,debut4,epais4, &
                   "vg_vi_total", "geopotential meridional transport: Total", "m kg/m/s")
!
      CALL ecritnd(nid,iim*jjm, vg_vi_moyen, 4, dims4,debut4,epais4, &
                   "vg_vi_moyen", "geopotential meridional transport: Mean", "m kg/m/s")
!
      CALL ecritnd(nid,iim*jjm, vu_vi_total, 4, dims4,debut4,epais4, &
                   "vu_vi_total", "momentum meridional transport: Total", "m/s kg/m/s")
!
      CALL ecritnd(nid,iim*jjm, vu_vi_moyen, 4, dims4,debut4,epais4, &
                   "vu_vi_moyen", "momentum meridional transport: Mean", "m/s kg/m/s")
!
      CALL ecritnd(nid,iim*jjm, ve_vi_total, 4, dims4,debut4,epais4, &
                   "ve_vi_total", "total-energy meridional transport: Total", "J/m/s")
!
      CALL ecritnd(nid,iim*jjm, ve_vi_moyen, 4, dims4,debut4,epais4, &
                   "ve_vi_moyen", "total-energy meridional transport: Mean", "J/m/s")
!
      CALL ecritnd(nid,iim*jjm, uq_vi_total, 4, dims4,debut4,epais4, &
                   "uq_vi_total", "water-vapour zonal transport: Total", "kg/m/s")
!
      CALL ecritnd(nid,iim*jjm, uq_vi_moyen, 4, dims4,debut4,epais4, &
                   "uq_vi_moyen", "water-vapour zonal transport: Mean", "kg/m/s")
!
      CALL ecritnd(nid,iim*jjm, ue_vi_total, 4, dims4,debut4,epais4, &
                   "ue_vi_total", "total-energy zonal transport: Total", "J/m/s")
!
      CALL ecritnd(nid,iim*jjm, ue_vi_moyen, 4, dims4,debut4,epais4, &
                   "ue_vi_moyen", "total-energy zonal transport: Mean", "J/m/s")
!
      CALL ecritnd(nid,iim*jjm, qm_vi, 4, dims4,debut4,epais4, &
                  "qm_vi","Integrated water-vapor content", "kg/m2")
!
      CALL ecritnd(nid,iim*jjm, em_vi, 4, dims4,debut4,epais4, &
                  "em_vi", "Integrated total-energy content", "J/m2")
!
      CALL ecritnd(nid,iim*jjm, ke_vi_total, 4, dims4,debut4,epais4, &
                   "ke_vi_total", "Integrated kinetic energy: Total", "J")
!
      CALL ecritnd(nid,iim*jjm, ke_vi_moyen, 4, dims4,debut4,epais4, &
                   "ke_vi_moyen", "Integrated kinetic energy: Mean", "J")
!
      ierr = NF90_CLOSE(nid)
!
      ierr = NF90_CREATE ("section_"//filename, NF90_CLOBBER,nid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme de creation du fichier d arrivee"
         CALL abort
      ENDIF
!
! Preciser quelques attributs globaux:

      ierr = NF90_PUT_ATT (nid, NF90_GLOBAL, "title", &
                             "Vertical section of meridional transport")
      ierr = NF90_PUT_ATT (nid, NF90_GLOBAL, "model", &
                             "Modele de circulation generale")
!
! Definir les dimensions du fichier:
!
      ierr = NF90_DEF_DIM(nid,"x",1,idim_x)
      ierr = NF90_DEF_DIM(nid,"y",jjm,idim_y)
      ierr = NF90_DEF_DIM(nid,"levels",kkm,idim_z)
      ierr = NF90_DEF_DIM(nid, "time", NF90_UNLIMITED, idim_t)
!
      ierr = NF90_ENDDEF(nid) ! sortir du mode de definition
!
! Definir et enregistrer certains champs invariants:
!
      ierr = NF90_REDEF (nid)
      ierr = NF90_DEF_VAR (nid,"x",NF90_FLOAT,(/idim_x/),varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir x"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT (nid, varid, "long_name", "Longitudes")
      ierr = NF90_PUT_ATT (nid, varid, "units", "degrees_east")
      ierr = NF90_ENDDEF(nid)
      ierr = NF90_PUT_VAR(nid,varid,x(1),START=(/1/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer x"
         CALL abort
      ENDIF
!
      ierr = NF90_REDEF (nid)
      ierr = NF90_DEF_VAR (nid,"y",NF90_FLOAT,(/idim_y/),varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir y"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT (nid, varid, "long_name", "Latitudes")
      ierr = NF90_PUT_ATT (nid, varid, "units", "degrees_north")
      ierr = NF90_ENDDEF(nid)
      ierr = NF90_PUT_VAR(nid,varid,y,START=(/1/),COUNT=(/jjm/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer y"
         CALL abort
      ENDIF
!
      ierr = NF90_REDEF (nid)
      ierr = NF90_DEF_VAR (nid,"levels",NF90_FLOAT,(/idim_z/),varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir levs"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT (nid, varid, "long_name", "Presure")
      ierr = NF90_PUT_ATT (nid, varid, "units", "millibars")
      ierr = NF90_ENDDEF(nid)
      ierr = NF90_PUT_VAR(nid,varid,z,START=(/1/),COUNT=(/kkm/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer levs"
         CALL abort
      ENDIF
!
      ierr = NF90_REDEF (nid)
      ierr = NF90_DEF_VAR (nid,"time", NF90_FLOAT,(/idim_t/),varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir time"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT(nid,varid,"long_name","time counter")
      ierr = NF90_PUT_ATT(nid,varid,"units","days since 1-1-1")
      ierr = NF90_PUT_ATT(nid,varid,"note","units may be wrong")
      ierr = NF90_ENDDEF(nid)
      ierr = NF90_PUT_VAR(nid,varid,temps,START=(/1/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer time"
         CALL abort
      ENDIF
!
      dims4(1) = idim_x
      dims4(2) = idim_y
      dims4(3) = idim_z
      dims4(4) = idim_t
      debut4(1) = 1
      debut4(2) = 1
      debut4(3) = 1
      debut4(4) = 1
      epais4(1) = 1
      epais4(2) = jjm
      epais4(3) = kkm
      epais4(4) = 1
!
      CALL ecritnd(nid,jjm*kkm, vq_z_total, 4, dims4,debut4,epais4, &
                   "vq_z_total", "water-vapour transport: total circulation", "kg/kg m/s")
!
      CALL ecritnd(nid,jjm*kkm, vq_z_moyen, 4, dims4,debut4,epais4, &
                   "vq_z_moyen", "water-vapour transport: mean circulation", "kg/kg m/s")
!
      CALL ecritnd(nid,jjm*kkm, vq_z_trans, 4, dims4,debut4,epais4, &
                   "vq_z_trans", "water-vapour transport: transient eddies", "kg/kg m/s")
!
      CALL ecritnd(nid,jjm*kkm, vq_z_stati, 4, dims4,debut4,epais4, &
                   "vq_z_stati", "water-vapour transport: stationary eddies", "kg/kg m/s")
!
      CALL ecritnd(nid,jjm*kkm, vt_z_total, 4, dims4,debut4,epais4, &
                   "vt_z_total", "temperature transport: total circulation", "K m/s")
!
      CALL ecritnd(nid,jjm*kkm, vt_z_moyen, 4, dims4,debut4,epais4, &
                   "vt_z_moyen", "temperature transport: mean circulation", "K m/s")
!
      CALL ecritnd(nid,jjm*kkm, vt_z_trans, 4, dims4,debut4,epais4, &
                   "vt_z_trans", "temperature transport: transient eddies", "K m/s")
!
      CALL ecritnd(nid,jjm*kkm, vt_z_stati, 4, dims4,debut4,epais4, &
                   "vt_z_stati", "temperature transport: stationary eddies", "K m/s")
!
      CALL ecritnd(nid,jjm*kkm, vg_z_total, 4, dims4,debut4,epais4, &
                   "vg_z_total", "geopotential transport: total circulation", "m m/s")
!
      CALL ecritnd(nid,jjm*kkm, vg_z_moyen, 4, dims4,debut4,epais4, &
                   "vg_z_moyen", "geopotential transport: mean circulation", "m m/s")
!
      CALL ecritnd(nid,jjm*kkm, vg_z_trans, 4, dims4,debut4,epais4, &
                   "vg_z_trans", "geopotential transport: transient eddies", "m m/s")
!
      CALL ecritnd(nid,jjm*kkm, vg_z_stati, 4, dims4,debut4,epais4, &
                   "vg_z_stati", "geopotential transport: stationary eddies", "m m/s")
!
      CALL ecritnd(nid,jjm*kkm, vu_z_total, 4, dims4,debut4,epais4, &
                   "vu_z_total", "momentum transport: total circulation", "m2/s2")
!
      CALL ecritnd(nid,jjm*kkm, vu_z_moyen, 4, dims4,debut4,epais4, &
                   "vu_z_moyen", "momentum transport: mean circulation", "m2/s2")
!
      CALL ecritnd(nid,jjm*kkm, vu_z_trans, 4, dims4,debut4,epais4, &
                   "vu_z_trans", "momentum transport: transient eddies", "m2/s2")
!
      CALL ecritnd(nid,jjm*kkm, vu_z_stati, 4, dims4,debut4,epais4, &
                   "vu_z_stati", "momentum transport: stationary eddies", "m2/s2")
!
      CALL ecritnd(nid,jjm*kkm, ve_z_total, 4, dims4,debut4,epais4, &
                   "ve_z_total", "total-energy transport: total circulation", "J/kg m/s")
!
      CALL ecritnd(nid,jjm*kkm, ve_z_moyen, 4, dims4,debut4,epais4, &
                   "ve_z_moyen", "total-energy transport: mean circulation", "J/kg m/s")
!
      CALL ecritnd(nid,jjm*kkm, ve_z_trans, 4, dims4,debut4,epais4, &
                   "ve_z_trans", "total-energy transport: transient eddies", "J/kg m/s")
!
      CALL ecritnd(nid,jjm*kkm, ve_z_stati, 4, dims4,debut4,epais4, &
                   "ve_z_stati", "total-energy transport: stationary eddies", "J/kg m/s")
!
      CALL ecritnd(nid,jjm*kkm, ke_z_total, 4, dims4,debut4,epais4, &
                   "ke_z_total", "kinetic energy: total circulation", "J/kg")
!
      CALL ecritnd(nid,jjm*kkm, ke_z_moyen, 4, dims4,debut4,epais4, &
                   "ke_z_moyen", "kinetic energy: mean circulation", "J/kg")
!
      CALL ecritnd(nid,jjm*kkm, ke_z_trans, 4, dims4,debut4,epais4, &
                   "ke_z_trans", "kinetic energy: transient eddies", "J/kg")
!
      CALL ecritnd(nid,jjm*kkm, ke_z_stati, 4, dims4,debut4,epais4, &
                   "ke_z_stati", "kinetic energy: stationary eddies", "J/kg")
!
      CALL ecritnd(nid,jjm*kkm, stream, 4, dims4,debut4,epais4, &
           "stream", "Hadley cell streamfunction: mass circulation", "kg/s")
!
      ierr = NF90_CLOSE(nid)
!
! Ouvrir le fichier d'arrivee
!
      ierr = NF90_CREATE ("curve_"//filename, NF90_CLOBBER,nid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme de creation du fichier d arrivee"
         CALL abort
      ENDIF
!
! Preciser quelques attributs globaux:
!
      ierr = NF90_PUT_ATT (nid, NF90_GLOBAL, "title", &
                             "Integrated meridional transport")
      ierr = NF90_PUT_ATT (nid, NF90_GLOBAL, "model", &
                             "Modele de circulation generale LMDZ")
!
! Definir les dimensions du fichier:
!
      ierr = NF90_DEF_DIM(nid,"x",1,idim_x)
      ierr = NF90_DEF_DIM(nid,"y",jjm,idim_y)
      ierr = NF90_DEF_DIM(nid,"levels",1,idim_z)
      ierr = NF90_DEF_DIM(nid, "time", NF90_UNLIMITED, idim_t)
!
      ierr = NF90_ENDDEF(nid) ! sortir du mode de definition
!
! Definir et enregistrer certains champs invariants:
!
      ierr = NF90_REDEF (nid)
      ierr = NF90_DEF_VAR (nid,"x",NF90_FLOAT,(/idim_x/),varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir x"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT (nid, varid, "long_name", "Longitudes")
      ierr = NF90_PUT_ATT (nid, varid, "units", "degrees_east")
      ierr = NF90_ENDDEF(nid)
      ierr = NF90_PUT_VAR(nid,varid,x(1),START=(/1/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer x"
         CALL abort
      ENDIF
!
      ierr = NF90_REDEF (nid)
      ierr = NF90_DEF_VAR (nid,"y",NF90_FLOAT,(/idim_y/),varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir y"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT (nid, varid, "long_name", "Latitudes")
      ierr = NF90_PUT_ATT (nid, varid, "units", "degrees_north")
      ierr = NF90_ENDDEF(nid)
      ierr = NF90_PUT_VAR(nid,varid,y,START=(/1/),COUNT=(/jjm/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer y"
         CALL abort
      ENDIF
!
      ierr = NF90_REDEF (nid)
      ierr = NF90_DEF_VAR (nid,"levels",NF90_FLOAT,(/idim_z/),varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir levs"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT (nid, varid, "long_name", "Presure")
      ierr = NF90_PUT_ATT (nid, varid, "units", "millibars")
      ierr = NF90_ENDDEF(nid)
      ierr = NF90_PUT_VAR(nid,varid,z(1),START=(/1/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer levs"
         CALL abort
      ENDIF
!
      ierr = NF90_REDEF (nid)
      ierr = NF90_DEF_VAR (nid,"time", NF90_FLOAT,(/idim_t/),varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir time"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT(nid,varid,"long_name","time counter")
      ierr = NF90_PUT_ATT(nid,varid,"units","days since 1-1-1")
      ierr = NF90_PUT_ATT(nid,varid,"note","units may be wrong")
      ierr = NF90_ENDDEF(nid)
      ierr = NF90_PUT_VAR(nid,varid,temps,START=(/1/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer time"
         CALL abort
      ENDIF
!
      dims4(1) = idim_x
      dims4(2) = idim_y
      dims4(3) = idim_z
      dims4(4) = idim_t
      debut4(1) = 1
      debut4(2) = 1
      debut4(3) = 1
      debut4(4) = 1
      epais4(1) = 1
      epais4(2) = jjm
      epais4(3) = 1
      epais4(4) = 1
!
      CALL ecritnd(nid,jjm,vq_z_vi_total,4,dims4,debut4,epais4, &
                   "vq_z_vi_total",  "water-vapour transport: total circ.",  "kg/s")
!
      CALL ecritnd(nid,jjm,vq_z_vi_moyen,4,dims4,debut4,epais4, &
                   "vq_z_vi_moyen",  "water-vapour transport: mean circ.", "kg/s")
!
      CALL ecritnd(nid,jjm,vq_z_vi_trans,4,dims4,debut4,epais4, &
                   "vq_z_vi_trans", "water-vapour transport: transient eddies", "kg/s")
!
      CALL ecritnd(nid,jjm,vq_z_vi_stati,4,dims4,debut4,epais4, &
                   "vq_z_vi_stati", "water-vapour transport: stationary eddies", "kg/s")
!
      CALL ecritnd(nid,jjm,vt_z_vi_total,4,dims4,debut4,epais4, &
                   "vt_z_vi_total", "temperature transport: total circ.", "Kkg/s")
!
      CALL ecritnd(nid,jjm,vt_z_vi_moyen,4,dims4,debut4,epais4, &
                   "vt_z_vi_moyen", "temperature transport: mean circ.", "Kkg/s")
!
      CALL ecritnd(nid,jjm,vt_z_vi_trans,4,dims4,debut4,epais4, &
                   "vt_z_vi_trans", "temperature transport: transient eddies", "Kkg/s")
!
      CALL ecritnd(nid,jjm,vt_z_vi_stati,4,dims4,debut4,epais4, &
                   "vt_z_vi_stati", "temperature transport: stationary eddies", "Kkg/s")
!
      CALL ecritnd(nid,jjm,vg_z_vi_total,4,dims4,debut4,epais4, &
                   "vg_z_vi_total", "potential transport: total circ.", "kgm/s")
!
      CALL ecritnd(nid,jjm,vg_z_vi_moyen,4,dims4,debut4,epais4, &
                   "vg_z_vi_moyen", "geopotential transport: mean circ.", "kgm/s")
!
      CALL ecritnd(nid,jjm,vg_z_vi_trans,4,dims4,debut4,epais4, &
                   "vg_z_vi_trans", "geopotential transport: transient eddies", "kgm/s")
!
      CALL ecritnd(nid,jjm,vg_z_vi_stati,4,dims4,debut4,epais4, &
                   "vg_z_vi_stati", "geopotential transport: stationary eddies", "kgm/s")
!
      CALL ecritnd(nid,jjm,vu_z_vi_total,4,dims4,debut4,epais4, &
                   "vu_z_vi_total", "momentum transport: total circ.", "kgm/s4")
!
      CALL ecritnd(nid,jjm,vu_z_vi_moyen,4,dims4,debut4,epais4, &
                   "vu_z_vi_moyen", "momentum transport: mean circ.", "kgm/s4")
!
      CALL ecritnd(nid,jjm,vu_z_vi_trans,4,dims4,debut4,epais4, &
                   "vu_z_vi_trans", "momentum transport: transient eddies", "kgm/s4")
!
      CALL ecritnd(nid,jjm,vu_z_vi_stati,4,dims4,debut4,epais4, &
                   "vu_z_vi_stati", "momentum transport: stationary eddies", "kgm/s4")
!
      CALL ecritnd(nid,jjm,ve_z_vi_total,4,dims4,debut4,epais4, &
                   "ve_z_vi_total", "total-energy transport: total circ.", "J/s")
!
      CALL ecritnd(nid,jjm,ve_z_vi_moyen,4,dims4,debut4,epais4, &
                   "ve_z_vi_moyen", "total-energy transport: mean circ.", "J/s")
!
      CALL ecritnd(nid,jjm,ve_z_vi_trans,4,dims4,debut4,epais4, &
                   "ve_z_vi_trans", "total-energy transport: transient eddies", "J/s")
!
      CALL ecritnd(nid,jjm,ve_z_vi_stati,4,dims4,debut4,epais4, &
                   "ve_z_vi_stati", "total-energy transport: stationary eddies", "J/s")
!
      CALL ecritnd(nid,jjm,ke_z_vi_total,4,dims4,debut4,epais4, &
                   "ke_z_vi_total", "kinetic energy: total circ.", "J")
!
      CALL ecritnd(nid,jjm,ke_z_vi_moyen,4,dims4,debut4,epais4, &
                   "ke_z_vi_moyen", "kinetic energy: mean circ.", "J")
!
      CALL ecritnd(nid,jjm,ke_z_vi_trans,4,dims4,debut4,epais4, &
                   "ke_z_vi_trans", "kinetic energy: transient eddies", "J")
!
      CALL ecritnd(nid,jjm,ke_z_vi_stati,4,dims4,debut4,epais4, &
                   "ke_z_vi_stati", "kinetic energy: stationary eddies", "J")
!
      ierr = NF90_CLOSE(nid)
!
      END SUBROUTINE ecrit_diag
      SUBROUTINE ecrit_netcdf2d(ficnom,iim,jjm,x,y,mask,missing,nb,vari)
      USE netcdf
      IMPLICIT none
!
! write quickly a time-varying horizontal 2D variable
!
      CHARACTER*(*) ficnom
      INTEGER iim, jjm, nb
      REAL x(iim), y(jjm), mask(iim,jjm)
      REAL vari(iim,jjm,nb)
      REAL missing
      REAL bidon
!
      INTEGER ierr, mid, varid
      INTEGER idim_x, idim_y, idim_t
      INTEGER dims2(2), dims3(3)
!
      INTEGER id_time, id_vari, n
!
      INTEGER debu3(3), epai3(3)
!
! Ouvrir le fichier a ecrire:
!
      ierr = NF90_CREATE(ficnom, NF90_CLOBBER, mid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme d ouverture du fichier:"//ficnom
         CALL abort
      ENDIF
!
! Preciser quelques attributs globaux:
!
      ierr = NF90_PUT_ATT (mid, NF90_GLOBAL, "title", &
                             "Ecriture rapide d un champ 2D")
      ierr = NF90_PUT_ATT (mid, NF90_GLOBAL, "model", &
                             "Resultats issus d un diagnostique")
!
! Definir les dimensions du fichier:
!
      ierr = NF90_DEF_DIM(mid,"x",iim,idim_x)
      ierr = NF90_DEF_DIM(mid,"y",jjm,idim_y)
      ierr = NF90_DEF_DIM(mid, "time", NF90_UNLIMITED, idim_t)
!
      ierr = NF90_ENDDEF(mid) ! sortir du mode de definition
!
! Definir et enregistrer certains champs invariants:
!
      ierr = NF90_REDEF (mid)
      ierr = NF90_DEF_VAR (mid,"x",NF90_FLOAT,(/idim_x/),varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir x"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT (mid, varid, "long_name", "Longitudes")
      ierr = NF90_PUT_ATT (mid, varid, "short_name", "x")
      ierr = NF90_PUT_ATT (mid, varid, "units", "degrees_east")
      ierr = NF90_ENDDEF(mid)
      ierr = NF90_PUT_VAR(mid,varid,x,(/1/),(/iim/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer x"
         CALL abort
      ENDIF
!
      ierr = NF90_REDEF (mid)
      ierr = NF90_DEF_VAR (mid,"y",NF90_FLOAT,(/idim_y/),varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir y"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT (mid, varid, "long_name", "Latitudes")
      ierr = NF90_PUT_ATT (mid, varid, "short_name", "y")
      ierr = NF90_PUT_ATT (mid, varid, "units", "degrees_north")
      ierr = NF90_ENDDEF(mid)
      ierr = NF90_PUT_VAR(mid,varid,y,(/1/),(/jjm/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer y"
         CALL abort
      ENDIF
!
      dims2(1) = idim_x
      dims2(2) = idim_y
!
      ierr = NF90_REDEF (mid)
      ierr = NF90_DEF_VAR (mid,"mask",NF90_FLOAT,(/dims2/),varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir mask"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT (mid,varid,"long_name","Masque")
      ierr = NF90_PUT_ATT (mid, varid, "short_name", "mask")
      ierr = NF90_PUT_ATT (mid, varid, "units", "-")
      ierr = NF90_ENDDEF(mid)
      ierr = NF90_PUT_VAR(mid,varid,mask,(/1,1/),(/iim,jjm/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer mask"
         CALL abort
      ENDIF
!
! Definir les variables pour enregistrement ulterieur:
!
      ierr = NF90_REDEF (mid)
!
      ierr = NF90_DEF_VAR (mid,"time", NF90_FLOAT,(/idim_t/),id_time)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir time"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT(mid,id_time,"long_name","time counter")
      ierr = NF90_PUT_ATT(mid,id_time,"short_name","time")
      ierr = NF90_PUT_ATT(mid,id_time,"units","days since 1-1-1")
      ierr = NF90_PUT_ATT(mid,id_time,"note", "Il peut etre n importe quoi")
!
      dims3(1) = idim_x
      dims3(2) = idim_y
      dims3(3) = idim_t
!
      ierr = NF90_DEF_VAR (mid,"vari",NF90_FLOAT,(/dims3/),id_vari)
      ierr = NF90_PUT_ATT(mid,id_vari,"long_name","Variable")
      ierr = NF90_PUT_ATT(mid,id_vari,"short_name","vari")
      ierr = NF90_PUT_ATT(mid,id_vari,"units","-")
      ierr = NF90_PUT_ATT(mid,id_vari,"missing_value",missing)
!
      ierr = NF90_ENDDEF(mid)
!
      DO 99999 n = 1, nb
!
        bidon = FLOAT(n)
        ierr = NF90_PUT_VAR(mid,id_time,bidon,START=(/n/))
        IF (ierr.NE.NF90_NOERR) THEN
           PRINT*, "Probleme pour enregistrer time"
           CALL abort
        ENDIF
!
        debu3(1) = 1
        debu3(2) = 1
        debu3(3) = n
        epai3(1) = iim
        epai3(2) = jjm
        epai3(3) = 1
!
        ierr = NF90_PUT_VAR(mid,id_vari,vari(1:iim,1:jjm,n:n),START=debu3,COUNT=epai3)
        IF (ierr.NE.NF90_NOERR) THEN
           PRINT*, "Probleme pour enregistrer vari"
           CALL abort
        ENDIF
!
99999 CONTINUE
      ierr = NF90_CLOSE(mid)
!
      RETURN 
      END SUBROUTINE ecrit_netcdf2d
      SUBROUTINE ecrit_netcdf3d(ficnom,iim,jjm,kkm,x,y,z,mask,missing,nb,vari)
      USE netcdf
      IMPLICIT none
!
! write quickly a time-varying 3D variable
!
      CHARACTER*(*) ficnom
      INTEGER iim, jjm, kkm, nb
      REAL x(iim), y(jjm), z(kkm), mask(iim,jjm)
      REAL vari(iim,jjm,kkm,nb)
      REAL missing
      REAL bidon
!
      INTEGER ierr, mid, varid
      INTEGER idim_x, idim_y, idim_z, idim_t
      INTEGER dims2(2), dims4(4)
!
      INTEGER id_time, id_vari, n
!
      INTEGER debu4(4), epai4(4)
!
! Ouvrir le fichier a ecrire:
!
      ierr = NF90_CREATE(ficnom, NF90_CLOBBER, mid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme d ouverture du fichier:"//ficnom
         CALL abort
      ENDIF
!
! Preciser quelques attributs globaux:
!
      ierr = NF90_PUT_ATT (mid, NF90_GLOBAL, "title", &
                             "Ecriture rapide d un champ 3D")
      ierr = NF90_PUT_ATT (mid, NF90_GLOBAL, "model", &
                             "Resultats issus d un diagnostique")
!
! Definir les dimensions du fichier:
!
      ierr = NF90_DEF_DIM(mid,"x",iim,idim_x)
      ierr = NF90_DEF_DIM(mid,"y",jjm,idim_y)
      ierr = NF90_DEF_DIM(mid,"z",kkm,idim_z)
      ierr = NF90_DEF_DIM(mid, "time", NF90_UNLIMITED, idim_t)
!
      ierr = NF90_ENDDEF(mid) ! sortir du mode de definition
!
! Definir et enregistrer certains champs invariants:
!
      ierr = NF90_REDEF (mid)
      ierr = NF90_DEF_VAR (mid,"x",NF90_FLOAT,(/idim_x/),varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir x"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT (mid, varid, "long_name", "Longitudes")
      ierr = NF90_PUT_ATT (mid, varid, "short_name", "x")
      ierr = NF90_PUT_ATT (mid, varid, "units", "degrees_east")
      ierr = NF90_ENDDEF(mid)
      ierr = NF90_PUT_VAR(mid,varid,x,(/1/),(/iim/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer x"
         CALL abort
      ENDIF
!
      ierr = NF90_REDEF (mid)
      ierr = NF90_DEF_VAR (mid,"y",NF90_FLOAT,(/idim_y/),varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir y"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT (mid, varid, "long_name", "Latitudes")
      ierr = NF90_PUT_ATT (mid, varid, "short_name", "y")
      ierr = NF90_PUT_ATT (mid, varid, "units", "degrees_north")
      ierr = NF90_ENDDEF(mid)
      ierr = NF90_PUT_VAR(mid,varid,y,(/1/),(/jjm/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer y"
         CALL abort
      ENDIF
!
      ierr = NF90_REDEF (mid)
      ierr = NF90_DEF_VAR (mid,"z",NF90_FLOAT,(/idim_z/),varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir z"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT (mid, varid, "long_name", "Vertical")
      ierr = NF90_PUT_ATT (mid, varid, "short_name", "z")
      ierr = NF90_PUT_ATT (mid, varid, "units", "layers")
      ierr = NF90_ENDDEF(mid)
      ierr = NF90_PUT_VAR(mid,varid,z,(/1/),(/kkm/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer z"
         CALL abort
      ENDIF
!
      dims2(1) = idim_x
      dims2(2) = idim_y
!
      ierr = NF90_REDEF (mid)
      ierr = NF90_DEF_VAR (mid,"mask",NF90_FLOAT,dims2,varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir mask"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT (mid,varid,"long_name","Masque")
      ierr = NF90_PUT_ATT (mid, varid, "short_name", "mask")
      ierr = NF90_PUT_ATT (mid, varid, "units", "-")
      ierr = NF90_ENDDEF(mid)
      ierr = NF90_PUT_VAR(mid,varid,mask,(/1,1/),(/iim,jjm/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer mask"
         CALL abort
      ENDIF
!
! Definir les variables pour enregistrement ulterieur:
!
      ierr = NF90_REDEF (mid)
!
      ierr = NF90_DEF_VAR (mid,"time", NF90_FLOAT,(/idim_t/),id_time)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir time"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT(mid,id_time,"long_name","time counter")
      ierr = NF90_PUT_ATT(mid,id_time,"short_name","time")
      ierr = NF90_PUT_ATT(mid,id_time,"units","days since 1-1-1")
      ierr = NF90_PUT_ATT(mid,id_time,"note", "Il peut etre n importe quoi")
!
      dims4(1) = idim_x
      dims4(2) = idim_y
      dims4(3) = idim_z
      dims4(4) = idim_t
!
      ierr = NF90_DEF_VAR (mid,"vari",NF90_FLOAT,dims4,id_vari)
      ierr = NF90_PUT_ATT(mid,id_vari,"long_name","Variable")
      ierr = NF90_PUT_ATT(mid,id_vari,"short_name","vari")
      ierr = NF90_PUT_ATT(mid,id_vari,"units","-")
      ierr = NF90_PUT_ATT(mid,id_vari,"missing_value",missing)
!
      ierr = NF90_ENDDEF(mid)
!
      DO 99999 n = 1, nb
!
        bidon = FLOAT(n)
        ierr = NF90_PUT_VAR(mid,id_time,bidon,START=(/n/))
        IF (ierr.NE.NF90_NOERR) THEN
           PRINT*, "Probleme pour enregistrer time"
           CALL abort
        ENDIF
!
        debu4(1) = 1
        debu4(2) = 1
        debu4(3) = 1
        debu4(4) = n
        epai4(1) = iim
        epai4(2) = jjm
        epai4(3) = kkm
        epai4(4) = 1
!
        ierr = NF90_PUT_VAR(mid,id_vari,vari(1:iim,1:jjm,1:kkm,n:n),START=debu4,COUNT=epai4)
        IF (ierr.NE.NF90_NOERR) THEN
           PRINT*, "Probleme pour enregistrer vari"
           CALL abort
        ENDIF
!
99999 CONTINUE
      ierr = NF90_CLOSE(mid)
!
      RETURN
      END SUBROUTINE ecrit_netcdf3d
      SUBROUTINE epflux(iim,jjm,kkm,x,y,z,presm,um,vm,sm,uu,vv,vs,vu,dsdpm)
      USE netcdf
      IMPLICIT none
!
! EP-flux diagnostics and output writting in NetCDF
!
      INTEGER, INTENT(IN) :: iim, jjm, kkm
      REAL, INTENT(IN) :: x(iim)  ! longitudes
      REAL, INTENT(IN) :: y(jjm)  ! latitudes
      REAL, INTENT(IN) :: z(kkm)  ! pressions
      REAL, INTENT(IN) :: presm(iim,jjm,kkm)
      REAL, INTENT(IN) :: um(iim,jjm,kkm) ! accumulation de U
      REAL, INTENT(IN) :: vm(iim,jjm,kkm) ! accumulation de V
      REAL, INTENT(IN) :: sm(iim,jjm,kkm) ! accumulation de T
      REAL, INTENT(IN) :: uu(iim,jjm,kkm) ! accumulation de U**2
      REAL, INTENT(IN) :: vv(iim,jjm,kkm) ! accumulation de V**2
      REAL, INTENT(IN) :: vs(iim,jjm,kkm) ! accumulation de V*T
      REAL, INTENT(IN) :: vu(iim,jjm,kkm) ! accumulation de V*U
      REAL, INTENT(IN) :: dsdpm(iim,jjm,kkm)
!
      REAL, ALLOCATABLE :: epx(:,:,:) ! Composante X du flux EP
      REAL, ALLOCATABLE :: epy(:,:,:) ! Composante Y du flux EP
      REAL, ALLOCATABLE :: epz(:,:,:) ! Composante Z du flux EP
      REAL, ALLOCATABLE :: divx(:,:,:) ! Divergence X du flux EP
      REAL, ALLOCATABLE :: divy(:,:,:) ! Divergence Y du flux EP
      REAL, ALLOCATABLE :: divz(:,:,:) ! Divergence Z du flux EP
      REAL, ALLOCATABLE :: coriolis(:,:) ! 2 omega SIN(latitude)
!
      REAL :: pi, radius
!
      INTEGER :: ierr, varid, nid
      INTEGER :: idim_x, idim_y, idim_z, idim_t
      INTEGER :: id_divx, id_divy, id_divz, id_epx, id_epy, id_epz
      INTEGER :: dims4(4), debut4(4), epais4(4)
!
      REAL :: var, temps
      INTEGER :: id_time
      INTEGER :: i, j, k, n
!
      ALLOCATE (epx(iim,jjm,kkm), epy(iim,jjm,kkm), epz(iim,jjm,kkm))
      ALLOCATE (divx(iim,jjm,kkm), divy(iim,jjm,kkm), divz(iim,jjm,kkm))
      ALLOCATE (coriolis(iim,jjm))
!
      pi = 4.0 * ATAN(1.0)
      radius=6371000.
      DO j = 1, jjm
      DO i = 1, iim
         coriolis(i,j) = 2.0*(2.0*pi/86400.0) * SIN(y(j)*pi/180.0)
      ENDDO
      ENDDO
!
      DO k = 1, kkm
      DO j = 1, jjm
      DO i = 1, iim
         epx(i,j,k) = (vv(i,j,k)-vm(i,j,k)*vm(i,j,k)) &
                    - (uu(i,j,k)-um(i,j,k)*um(i,j,k))
         epy(i,j,k) = - (vu(i,j,k)-vm(i,j,k)*um(i,j,k))
      ENDDO
      ENDDO
      ENDDO
!
      DO k = 1, kkm
      DO j = 1, jjm
      DO i = 1, iim
         epz(i,j,k) = 0.0
         IF (ABS(dsdpm(i,j,k)).GT.1.0e-5) THEN
         epz(i,j,k) = coriolis(i,j) / dsdpm(i,j,k) * &
                      (vs(i,j,k)-vm(i,j,k)*sm(i,j,k))
         ENDIF
      ENDDO
      ENDDO
      ENDDO
!
! Divergence en X (m/s2)
!
      DO k = 1, kkm
      DO j = 1, jjm
         DO i = 2, iim-1
            divx(i,j,k) = (epx(i+1,j,k)-epx(i-1,j,k)) &
                        / (radius*pi/180.0*(x(i+1)-x(i-1))) &
                        * COS(y(j)*pi/180.0)
         ENDDO
         divx(1,j,k) = (epx(2,j,k)-epx(iim,j,k)) &
                     / (radius*pi/180.0*(x(2)-(x(iim)-360.))) &
                     * COS(y(j)*pi/180.0)
         divx(iim,j,k) = (epx(1,j,k)-epx(iim-1,j,k)) &
                       / (radius*pi/180.0*(x(1)-(x(iim-1)-360.))) &
                       * COS(y(j)*pi/180.0)
      ENDDO
      ENDDO
!
! Divergence en Y (m/s2)
!
      DO k = 1, kkm
      DO j = 2, jjm-1
      DO i = 1, iim
         divy(i,j,k) = (epy(i,j+1,k)-epy(i,j-1,k)) &
                     / (radius*pi/180.0*(y(j+1)-y(j-1))) &
                     - epy(i,j,k)*TAN(y(j)*pi/180.0)/radius
      ENDDO
      ENDDO
      DO i = 1, iim
         divy(i,1,k) = divy(i,2,k)
         divy(i,jjm,k) = divy(i,jjm-1,k)
      ENDDO
      ENDDO
!
! Divergence en Pression (m/s2)
!
      divz = 0.0
!
      DO j = 1, jjm
      DO i = 1, iim
         var = presm(i,j,2)-presm(i,j,1)  ! z(2)-z(1)
         IF (ABS(var).GT.1.0e-2) THEN
            divz(i,j,1) = (epz(i,j,2)-epz(i,j,1)) / var
         ENDIF
         var = presm(i,j,kkm)-presm(i,j,kkm-1) ! z(kkm)-z(kkm-1)
         IF (ABS(var).GT.1.0e-2) THEN
         divz(i,j,kkm) = (epz(i,j,kkm)-epz(i,j,kkm-1)) / var
         ENDIF
      ENDDO
      ENDDO
      DO k = 2, kkm-1
      DO j = 1, jjm
      DO i = 1, iim
      var = presm(i,j,k+1)-presm(i,j,k-1) ! z(k+1)-z(k-1)
      IF (ABS(var).GT.1.0e-2) THEN
         divz(i,j,k) = (epz(i,j,k+1)-epz(i,j,k-1))/var
      ENDIF
      ENDDO
      ENDDO
      ENDDO
!
      ierr = NF90_CREATE ("epflux.nc", NF90_CLOBBER,nid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme de creation du fichier epflux"
         CALL abort
      ENDIF
!
! Preciser quelques attributs globaux:
!
      ierr = NF90_PUT_ATT (nid, NF90_GLOBAL, "title", &
                             "Fichier carre en coordonnees pression")
      ierr = NF90_PUT_ATT (nid, NF90_GLOBAL, "model", &
                             "Modele de circulation generale")
!
! Definir les dimensions du fichier:
!
      ierr = NF90_DEF_DIM(nid,"x",iim,idim_x)
      ierr = NF90_DEF_DIM(nid,"y",jjm,idim_y)
      ierr = NF90_DEF_DIM(nid,"z",kkm,idim_z)
      ierr = NF90_DEF_DIM(nid, "time", NF90_UNLIMITED, idim_t)
!
      ierr = NF90_ENDDEF(nid) ! sortir du mode de definition
!
! Definir et enregistrer certains champs invariants:
!
      ierr = NF90_REDEF (nid)
      ierr = NF90_DEF_VAR (nid,"x",NF90_FLOAT,(/idim_x/),varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir x"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT (nid, varid, "long_name", "Longitudes")
      ierr = NF90_PUT_ATT (nid, varid, "units", "degrees_east")
      ierr = NF90_ENDDEF(nid)
      ierr = NF90_PUT_VAR(nid,varid,x,START=(/1/),COUNT=(/iim/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer x"
         CALL abort
      ENDIF
!
      ierr = NF90_REDEF (nid)
      ierr = NF90_DEF_VAR (nid,"y",NF90_FLOAT,(/idim_y/),varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir y"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT (nid, varid, "long_name", "Latitudes")
      ierr = NF90_PUT_ATT (nid, varid, "units", "degrees_north")
      ierr = NF90_ENDDEF(nid)
      ierr = NF90_PUT_VAR(nid,varid,y,START=(/1/),COUNT=(/jjm/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer y"
         CALL abort
      ENDIF
!
      ierr = NF90_REDEF (nid)
      ierr = NF90_DEF_VAR (nid,"z",NF90_FLOAT,(/idim_z/),varid)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir z"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT (nid, varid, "long_name", "Presure")
      ierr = NF90_PUT_ATT (nid, varid, "units", "millibars")
      ierr = NF90_ENDDEF(nid)
      ierr = NF90_PUT_VAR(nid,varid,z,START=(/1/),COUNT=(/kkm/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer z"
         CALL abort
      ENDIF
! Definir les variables pour enregistrement ulterieur:
!
      ierr = NF90_REDEF (nid)
!
      ierr = NF90_DEF_VAR (nid,"time", NF90_FLOAT,(/idim_t/),id_time)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour definir time"
         CALL abort
      ENDIF
      ierr = NF90_PUT_ATT(nid,id_time,"long_name","time counter")
      ierr = NF90_PUT_ATT(nid,id_time,"units","days since 1-1-1")
      ierr = NF90_PUT_ATT(nid,id_time,"note","units may be wrong")
!
      dims4(1) = idim_x
      dims4(2) = idim_y
      dims4(3) = idim_z
      dims4(4) = idim_t
!
      ierr = NF90_DEF_VAR (nid,"epx",NF90_FLOAT,dims4,id_epx)
      ierr = NF90_PUT_ATT (nid,id_epx,"long_name","EPX")
      ierr = NF90_PUT_ATT (nid,id_epx,"units","m2/s2")
!
      ierr = NF90_DEF_VAR (nid,"epy",NF90_FLOAT,dims4,id_epy)
      ierr = NF90_PUT_ATT (nid,id_epy,"long_name","EPY")
      ierr = NF90_PUT_ATT (nid,id_epy,"units","m2/s2")
!
      ierr = NF90_DEF_VAR (nid,"epz",NF90_FLOAT,dims4,id_epz)
      ierr = NF90_PUT_ATT (nid,id_epz,"long_name","EPZ")
      ierr = NF90_PUT_ATT (nid,id_epz,"units","m/s2 mb")
!
      ierr = NF90_DEF_VAR (nid,"divx",NF90_FLOAT,dims4,id_divx)
      ierr = NF90_PUT_ATT (nid,id_divx,"long_name","DIVX")
      ierr = NF90_PUT_ATT (nid,id_divx,"units","m/s2")
!
      ierr = NF90_DEF_VAR (nid,"divy",NF90_FLOAT,dims4,id_divy)
      ierr = NF90_PUT_ATT (nid,id_divy,"long_name","DIVY")
      ierr = NF90_PUT_ATT (nid,id_divy,"units","m/s2")
!
      ierr = NF90_DEF_VAR (nid,"divz",NF90_FLOAT,dims4,id_divz)
      ierr = NF90_PUT_ATT (nid,id_divz,"long_name","DIVZ")
      ierr = NF90_PUT_ATT (nid,id_divz,"units","m/s2")
!
      ierr = NF90_ENDDEF(nid)
!
      n = 1
      temps = 1.0
!
      debut4(1) = 1
      debut4(2) = 1
      debut4(3) = 1
      debut4(4) = n
      epais4(1) = iim
      epais4(2) = jjm
      epais4(3) = kkm
      epais4(4) = 1
!
      ierr = NF90_PUT_VAR(nid,id_time,temps,START=(/n/))
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer time"
         CALL abort
      ENDIF
!
      ierr = NF90_PUT_VAR(nid,id_epx,epx,debut4,epais4)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer epx"
         CALL abort
      ENDIF
!
      ierr = NF90_PUT_VAR(nid,id_epy,epy,debut4,epais4)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer epy"
         CALL abort
      ENDIF
!
      ierr = NF90_PUT_VAR(nid,id_epz,epz,debut4,epais4)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer epz"
         CALL abort
      ENDIF
!
      ierr = NF90_PUT_VAR(nid,id_divx,divx,debut4,epais4)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer divx"
         CALL abort
      ENDIF
!
      ierr = NF90_PUT_VAR(nid,id_divy,divy,debut4,epais4)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer divy"
         CALL abort
      ENDIF
!
      ierr = NF90_PUT_VAR(nid,id_divz,divz,debut4,epais4)
      IF (ierr.NE.NF90_NOERR) THEN
         PRINT*, "Probleme pour enregistrer divz"
         CALL abort
      ENDIF
!
      ierr = NF90_CLOSE(nid)
!
      DEALLOCATE (epx, epy, epz)
      DEALLOCATE (divx, divy, divz)
      DEALLOCATE (coriolis)
!
      END SUBROUTINE epflux
