      PROGRAM limite
      IMPLICIT none
c
c This programme prescribes the SST, through analytical functions,
c for a model configuration of Aqua-planet
c
c g95 modif_limit_aqua.F -I$HOME/netcdf/include -L$HOME/netcdf/lib -lnetcdf
      INTEGER iim, jjm
      PARAMETER (iim=72, jjm=45)
      INTEGER klon
      PARAMETER (klon=iim*(jjm-1)+2)
      INTEGER jours
      PARAMETER (jours=1)
c
      REAL nat_day(klon,jours)
      REAL sst_day(klon,jours)
      REAL alb_day(klon,jours)
      REAL rug_day(klon,jours)
      REAL bil_day(klon,jours)
      REAL temps(jours)
c
#include "netcdf.inc"
      INTEGER nid, idvar, ierr
c
      INTEGER i, j, ig, jr
c
      REAL rlon(klon), rlat(klon)
      REAL xlon(iim,jjm+1), ylat(iim,jjm+1)
c
      REAL x(iim), y(jjm+1)
      REAL mask(iim,jjm+1)
c
      REAL sste(iim,jjm+1,jours)
c
      REAL aqua2d(iim,jjm+1), aqua(klon)
c
      ierr = NF_OPEN ("startphy.nc", NF_NOWRITE, nid)
      IF (ierr.NE.NF_NOERR) THEN
        write(6,*)' Pb d''ouverture du fichier startphy.nc'
        write(6,*)' ierr = ', ierr
        CALL ABORT
      ENDIF
c
      ierr = NF_INQ_VARID (nid, "longitude", idvar)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "Le champ <longitude> est absent"
         CALL abort
      ENDIF
      ierr = NF_GET_VAR_REAL(nid, idvar, rlon)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "Lecture echoue pour <longitude>"
         CALL abort
      ENDIF
c
      ierr = NF_INQ_VARID (nid, "latitude", idvar)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "Le champ <longitude> est absent"
         CALL abort
      ENDIF
      ierr = NF_GET_VAR_REAL(nid, idvar, rlat)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "Lecture echoue pour <latitude>"
         CALL abort
      ENDIF
c
      ierr=NF_CLOSE(nid)
c
      ig = 1
      DO i = 1, iim
         xlon(i,1) = rlon(ig)
         ylat(i,1) = rlat(ig)
      ENDDO
      DO j = 2, jjm
      DO i = 1, iim
         ig = ig + 1
         xlon(i,j) = rlon(ig)
         ylat(i,j) = rlat(ig)
      ENDDO
      ENDDO
      ig = ig + 1
      DO i = 1, iim
         xlon(i,jjm+1) = rlon(ig)
         ylat(i,jjm+1) = rlat(ig)
      ENDDO
c
      DO i = 1, iim
         x(i) = xlon(i,2)
      ENDDO
      DO j = 1, jjm+1
         y(j) = ylat(1,j)
      ENDDO
c
      CALL lirlim(klon,jours,temps,nat_day,sst_day
     .           ,alb_day,rug_day,bil_day)
c
c
      DO j = 1, jjm+1
      DO i = 1, iim
         mask(i,j) = -1.0
      ENDDO
      ENDDO
c
      ig = 1
      DO i = 1, iim
         IF (NINT(nat_day(ig,1)).EQ.0) mask(i,1) = 1.0
      ENDDO
      DO j = 2, jjm
      DO i = 1, iim
         ig = ig + 1
         IF (NINT(nat_day(ig,1)).EQ.0) mask(i,j) = 1.0
      ENDDO
      ENDDO
      ig = ig + 1
      DO i = 1, iim
         IF (NINT(nat_day(ig,1)).EQ.0) mask(i,jjm+1) = 1.0
      ENDDO
c
      CALL aqua_sst(iim,jjm+1,x,y,aqua2d)
c
      CALL ecrit_netcdf2d("anomalie.nc",iim,jjm+1,x,y,mask,1.0e+30,
     .                     jours,aqua2d)
c
      ig = 1
      aqua(ig) = 0.0
      DO i = 1, iim
         aqua(ig) = aqua(ig) + aqua2d(i,1)/FLOAT(iim)
      ENDDO
      DO j = 2, jjm
      DO i = 1, iim
         ig = ig + 1
         aqua(ig) = aqua2d(i,j)
      ENDDO
      ENDDO
      ig = ig + 1
      aqua(ig) = 0.0
      DO i = 1, iim
         aqua(ig) = aqua(ig) + aqua2d(i,jjm+1)/FLOAT(iim)
      ENDDO
c
c
      DO jr = 1, jours
      ig = 1
      DO i = 1, iim
         sste(i,1,jr) = sst_day(ig,jr)
      ENDDO
      DO j = 2, jjm
      DO i = 1, iim
         ig = ig + 1
         sste(i,j,jr) = sst_day(ig,jr)
      ENDDO
      ENDDO
      ig = ig + 1
      DO i = 1, iim
         sste(i,jjm+1,jr) = sst_day(ig,jr)
      ENDDO
      ENDDO
      CALL ecrit_netcdf2d("sste0.nc",iim,jjm+1,x,y,mask,1.0e+30,
     .                     jours,sste)
c
c
      DO jr = 1, jours
      DO ig = 1, klon
         nat_day(ig,jr) = 0.0
         sst_day(ig,jr) = aqua(ig)
      ENDDO
      ENDDO
c
      CALL enrlim(klon,jours,temps,nat_day,sst_day
     .           ,alb_day,rug_day,bil_day)
c
c
      DO jr = 1, jours
      ig = 1
      DO i = 1, iim
         sste(i,1,jr) = sst_day(ig,jr)
      ENDDO
      DO j = 2, jjm
      DO i = 1, iim
         ig = ig + 1
         sste(i,j,jr) = sst_day(ig,jr)
      ENDDO
      ENDDO
      ig = ig + 1
      DO i = 1, iim
         sste(i,jjm+1,jr) = sst_day(ig,jr)
      ENDDO
      ENDDO
      CALL ecrit_netcdf2d("sste1.nc",iim,jjm+1,x,y,mask,1.0e+30,
     .                     jours,sste)
c
      STOP
      END
c
      SUBROUTINE enrlim(klon,jours,temps,nat,sst,alb,rug,bil)
      IMPLICIT none
c
      INTEGER klon
      INTEGER jours
c
      REAL temps(jours)
      REAL nat(klon,jours)
      REAL sst(klon,jours)
      REAL alb(klon,jours)
      REAL rug(klon,jours)
      REAL bil(klon,jours)
c
#include "netcdf.inc"
c
      INTEGER nid, ndim, ntim, ierr
      INTEGER dims(2), debut(2), epais(2)
      INTEGER id_tim
      INTEGER id_NAT, id_SST, id_BILS, id_RUG, id_ALB
c
      INTEGER k
c
      ierr = NF_CREATE ("newlimit.nc", NF_CLOBBER, nid)
c
      ierr = NF_PUT_ATT_TEXT (nid, NF_GLOBAL, "title", 30,
     .                       "Fichier conditions aux limites")
      ierr = NF_DEF_DIM (nid, "points_physiques", klon, ndim)
      ierr = NF_DEF_DIM (nid, "time", NF_UNLIMITED, ntim)
c
      dims(1) = ndim
      dims(2) = ntim
c
      ierr = NF_DEF_VAR (nid, "TEMPS", NF_FLOAT, 1,ntim, id_tim)
      ierr = NF_PUT_ATT_TEXT (nid, id_tim, "title", 17,
     .                        "Jour dans l annee")
      ierr = NF_DEF_VAR (nid, "NAT", NF_FLOAT, 2,dims, id_NAT)
      ierr = NF_PUT_ATT_TEXT (nid, id_NAT, "title", 23,
     .                        "Nature du sol (0,1,2,3)")
      ierr = NF_DEF_VAR (nid, "SST", NF_FLOAT, 2,dims, id_SST)
      ierr = NF_PUT_ATT_TEXT (nid, id_SST, "title", 35,
     .                        "Temperature superficielle de la mer")
      ierr = NF_DEF_VAR (nid, "BILS", NF_FLOAT, 2,dims, id_BILS)
      ierr = NF_PUT_ATT_TEXT (nid, id_BILS, "title", 32,
     .                        "Reference flux de chaleur au sol")
      ierr = NF_DEF_VAR (nid, "ALB", NF_FLOAT, 2,dims, id_ALB)
      ierr = NF_PUT_ATT_TEXT (nid, id_ALB, "title", 19,
     .                        "Albedo a la surface")
      ierr = NF_DEF_VAR (nid, "RUG", NF_FLOAT, 2,dims, id_RUG)
      ierr = NF_PUT_ATT_TEXT (nid, id_RUG, "title", 8,
     .                        "Rugosite")
c
      ierr = NF_ENDDEF(nid)
c
      DO k = 1, jours
c
      debut(1) = 1
      debut(2) = k
      epais(1) = klon
      epais(2) = 1
c
      ierr = NF_PUT_VAR1_REAL (nid,id_tim,k,temps(k))
      ierr = NF_PUT_VARA_REAL (nid,id_NAT,debut,epais,nat(1,k))
      ierr = NF_PUT_VARA_REAL (nid,id_SST,debut,epais,sst(1,k))
      ierr = NF_PUT_VARA_REAL (nid,id_BILS,debut,epais,bil(1,k))
      ierr = NF_PUT_VARA_REAL (nid,id_ALB,debut,epais,alb(1,k))
      ierr = NF_PUT_VARA_REAL (nid,id_RUG,debut,epais,rug(1,k))
c
      ENDDO
c
      ierr = NF_CLOSE(nid)
c
      RETURN
      END
c
      SUBROUTINE lirlim(klon, jours, temps, lmt_nat,
     s                    lmt_sst,lmt_alb,lmt_rug,lmt_bils )
      IMPLICIT none
c
c Lire les conditions aux limites du modele.
c
#include "netcdf.inc"
      INTEGER nid, nvarid
      INTEGER debut(2)
      INTEGER epais(2)
c
      INTEGER klon
      INTEGER jours
c
      REAL temps(jours)
      REAL lmt_nat(klon,jours) ! indicateur de la nature du sol
      REAL lmt_sst(klon,jours) ! temperature de la surface oceanique
      REAL lmt_alb(klon,jours) ! albedo du sol
      REAL lmt_rug(klon,jours) ! longeur de rugosite du sol
      REAL lmt_bils(klon,jours)
c
c Variables locales:
      INTEGER ierr
c
c Ouvrir le fichier en format NetCDF:
c
      ierr = NF_OPEN ("limit.nc", NF_NOWRITE,nid)
      IF (ierr.NE.NF_NOERR) THEN
        WRITE(6,*)' Pb d ouverture du fichier limit.nc'
        WRITE(6,*)' ierr = ', ierr
        CALL abort
      ENDIF
c
c La tranche de donnees a lire:
c
      ierr = NF_INQ_VARID (nid, "TEMPS", nvarid)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "condsurf: Le champ <TEMPS> est absent"
         CALL abort
      ENDIF
      ierr = NF_GET_VARA_REAL(nid, nvarid,1,jours,temps)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "condsurf: Lecture echouee pour <TEMPS>"
         CALL abort
      ENDIF
c
      debut(1) = 1
      debut(2) = 1
      epais(1) = klon
      epais(2) = jours
c
c Indicateur de la nature du sol (0,1,2,3):
      ierr = NF_INQ_VARID (nid, "NAT", nvarid)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "condsurf: Le champ <NAT> est absent"
         CALL abort
      ENDIF
      ierr = NF_GET_VARA_REAL(nid, nvarid,debut,epais,lmt_nat)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "condsurf: Lecture echouee pour <NAT>"
         CALL abort
      ENDIF
c
c Sea surface temperature:
      ierr = NF_INQ_VARID (nid, "SST", nvarid)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "condsurf: Le champ <SST> est absent"
         CALL abort
      ENDIF
      ierr = NF_GET_VARA_REAL(nid, nvarid,debut,epais,lmt_sst)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "condsurf: Lecture echouee pour <SST>"
         CALL abort
      ENDIF
c
c Albedo de surface:
      ierr = NF_INQ_VARID (nid, "ALB", nvarid)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "condsurf: Le champ <ALB> est absent"
         CALL abort
      ENDIF
      ierr = NF_GET_VARA_REAL(nid, nvarid,debut,epais,lmt_alb)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "condsurf: Lecture echouee pour <ALB>"
         CALL abort
      ENDIF
c
c Longueur de rugosite au sol:
      ierr = NF_INQ_VARID (nid, "RUG", nvarid)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "condsurf: Le champ <RUG> est absent"
         CALL abort
      ENDIF
      ierr = NF_GET_VARA_REAL(nid, nvarid,debut,epais,lmt_rug)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "condsurf: Lecture echouee pour <RUG>"
         CALL abort
      ENDIF
c
c Bilan flux de chaleur au sol:
      ierr = NF_INQ_VARID (nid, "BILS", nvarid)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "condsurf: Le champ <BILS> est absent"
         CALL abort
      ENDIF
      ierr = NF_GET_VARA_REAL(nid, nvarid,debut,epais,lmt_bils)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "condsurf: Lecture echouee pour <BILS>"
         CALL abort
      ENDIF
c
c Fermer le fichier:
c
      ierr = NF_CLOSE(nid)
c
c
      PRINT*, 'SST, ALB, RUG, etc. sont lus'
c
      RETURN
      END
      SUBROUTINE aqua_sst (iim,jjm,x,y,f)
      IMPLICIT none
c
      INTEGER iim, jjm
      REAL x(iim), y(jjm)
      REAL f(iim,jjm)
      REAL fx(iim), fy(jjm)
c
      REAL xtmp1, ytmp1, xtmp, ytmp
      REAL pi
      INTEGER i, j
c
c Longitudes:
      REAL x0 ! centre
      REAL ax ! amplitude
      REAL onde
      PARAMETER (x0=0.0, ax=0.01, onde=3.0)
c
c Latitudes:
      REAL y0 ! centre
      REAL dt_equameteo_polehiver ! amplitude
      PARAMETER (y0=-15.0, dt_equameteo_polehiver=60.0)
      REAL t_equameteo
      PARAMETER (t_equameteo=304.15)
      REAL dy
c
c Angle de rotation:
      REAL angle
      PARAMETER (angle=0.0)
c
      pi = 4.0 * ATAN(1.0)
c
      dy = 1.0-COS((y(1)-y0)*pi/180.0)
      dy = MAX (dy, 1.0-COS((y(jjm)-y0)*pi/180.0))
c
      DO j = 1, jjm
         fy(j) = t_equameteo - (1.0-COS((y(j)-y0)*pi/180.0))
     .                         *dt_equameteo_polehiver
      ENDDO
c
      DO i = 1, iim
         fx(i) = 1.0 + ax*SIN((x(i)-x0)*pi/180.*onde)
      ENDDO
c
      DO j = 1, jjm
      DO i = 1, iim
      f(i,j) = fx(i) * fy(j)
      ENDDO
      ENDDO
c
      RETURN
      END
      SUBROUTINE ecrit_netcdf2d(ficnom,iim,jjm,x,y,mask,missing,nb,vari)
      IMPLICIT none
c
      CHARACTER*(*) ficnom
      INTEGER iim, jjm, nb
      REAL x(iim), y(jjm), mask(iim,jjm)
      REAL vari(iim,jjm,nb)
      REAL missing
c
#include "netcdf.inc"
c
      INTEGER ierr, mid, varid
      INTEGER idim_x, idim_y, idim_t
      INTEGER dims2(2), dims3(3)
c
      INTEGER id_time, id_vari, n
c
      INTEGER debu3(3), epai3(3)
c
c Ouvrir le fichier a ecrire:
c
      ierr = NF_CREATE(ficnom, NF_CLOBBER, mid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme d ouverture du fichier:"//ficnom
         CALL abort
      ENDIF
c
c Preciser quelques attributs globaux:
c
      ierr = NF_PUT_ATT_TEXT (mid, NF_GLOBAL, "title", 29,
     .                       "Ecriture rapide d un champ 2D")
      ierr = NF_PUT_ATT_TEXT (mid, NF_GLOBAL, "model", 33,
     .                       "Resultats issus d un diagnostique")
c
c Definir les dimensions du fichier:
c
      ierr = NF_DEF_DIM(mid,"x",iim,idim_x)
      ierr = NF_DEF_DIM(mid,"y",jjm,idim_y)
      ierr = NF_DEF_DIM(mid, "time", NF_UNLIMITED, idim_t)
c
      ierr = NF_ENDDEF(mid) ! sortir du mode de definition
c
c Definir et enregistrer certains champs invariants:
c
      ierr = NF_REDEF (mid)
      ierr = NF_DEF_VAR (mid,"x",NF_FLOAT,1,idim_x,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir x"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (mid, varid, "long_name", 10,"Longitudes")
      ierr = NF_PUT_ATT_TEXT (mid, varid, "short_name", 1,"x")
      ierr = NF_PUT_ATT_TEXT (mid, varid, "units", 12,"degrees_east")
      ierr = NF_ENDDEF(mid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE(mid,varid,x)
#else
      ierr = NF_PUT_VAR_REAL(mid,varid,x)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer x"
         CALL abort
      ENDIF
c
      ierr = NF_REDEF (mid)
      ierr = NF_DEF_VAR (mid,"y",NF_FLOAT,1,idim_y,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir y"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (mid, varid, "long_name", 9,"Latitudes")
      ierr = NF_PUT_ATT_TEXT (mid, varid, "short_name", 1,"y")
      ierr = NF_PUT_ATT_TEXT (mid, varid, "units", 13,"degrees_north")
      ierr = NF_ENDDEF(mid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE(mid,varid,y)
#else
      ierr = NF_PUT_VAR_REAL(mid,varid,y)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer y"
         CALL abort
      ENDIF
c
      dims2(1) = idim_x
      dims2(2) = idim_y
c
      ierr = NF_REDEF (mid)
      ierr = NF_DEF_VAR (mid,"mask",NF_FLOAT,2,dims2,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir mask"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (mid,varid,"long_name",6,"Masque")
      ierr = NF_PUT_ATT_TEXT (mid, varid, "short_name", 4,"mask")
      ierr = NF_PUT_ATT_TEXT (mid, varid, "units", 1,"-")
      ierr = NF_ENDDEF(mid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE(mid,varid,mask)
#else
      ierr = NF_PUT_VAR_REAL(mid,varid,mask)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer mask"
         CALL abort
      ENDIF
c
c Definir les variables pour enregistrement ulterieur:
c
      ierr = NF_REDEF (mid)
c
      ierr = NF_DEF_VAR (mid,"time", NF_FLOAT,1,idim_t,id_time)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir time"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT(mid,id_time,"long_name",12,"time counter")
      ierr = NF_PUT_ATT_TEXT(mid,id_time,"short_name",4,"time")
      ierr = NF_PUT_ATT_TEXT(mid,id_time,"units",16,"days since 1-1-1")
      ierr = NF_PUT_ATT_TEXT(mid,id_time,"note",27,
     .                       "Il peut etre n importe quoi")
c
      dims3(1) = idim_x
      dims3(2) = idim_y
      dims3(3) = idim_t
c
      ierr = NF_DEF_VAR (mid,"vari",NF_FLOAT,3,dims3,id_vari)
      ierr = NF_PUT_ATT_TEXT(mid,id_vari,"long_name",8,"Variable")
      ierr = NF_PUT_ATT_TEXT(mid,id_vari,"short_name",4,"vari")
      ierr = NF_PUT_ATT_TEXT(mid,id_vari,"units",1,"-")
#ifdef NC_DOUBLE
      ierr = NF_PUT_ATT_DOUBLE(mid,id_vari,"missing_value",
     .                                   NF_FLOAT,1,missing)
#else
      ierr = NF_PUT_ATT_REAL(mid,id_vari,"missing_value",
     .                                   NF_FLOAT,1,missing)
#endif
c
      ierr = NF_ENDDEF(mid)
c
      DO 99999 n = 1, nb
c
#ifdef NC_DOUBLE
        ierr = NF_PUT_VAR1_DOUBLE(mid,id_time,n,FLOAT(n))
#else
        ierr = NF_PUT_VAR1_REAL(mid,id_time,n,FLOAT(n))
#endif
        IF (ierr.NE.NF_NOERR) THEN
           PRINT*, "Probleme pour enregistrer time"
           CALL abort
        ENDIF
c
        debu3(1) = 1
        debu3(2) = 1
        debu3(3) = n
        epai3(1) = iim
        epai3(2) = jjm
        epai3(3) = 1
c
#ifdef NC_DOUBLE
        ierr = NF_PUT_VARA_DOUBLE(mid,id_vari,debu3,epai3,vari(1,1,n))
#else
        ierr = NF_PUT_VARA_REAL(mid,id_vari,debu3,epai3,vari(1,1,n))
#endif
        IF (ierr.NE.NF_NOERR) THEN
           PRINT*, "Probleme pour enregistrer vari"
           CALL abort
        ENDIF
c
99999 CONTINUE
      ierr = NF_CLOSE(mid)
c
      RETURN
      END
