      PROGRAM limite
      IMPLICIT none
c
c Convert some variables of "limit.nc" from its 1-D grid
c into a latitude-longitude grid, which can then be used
c in the graphic tool GRADS.
c
c g95 tracer_limit.F -I$HOME/netcdf/include -L$HOME/netcdf/lib -lnetcdf
c
      INTEGER iim, jjm
      PARAMETER (iim=72, jjm=45)
      INTEGER klon
      PARAMETER (klon=iim*(jjm-1)+2)
      INTEGER jours
      PARAMETER (jours=1)
c
      REAL nat_day(klon,jours)
      REAL sst_day(klon,jours)
      REAL alb_day(klon,jours)
      REAL rug_day(klon,jours)
      REAL bil_day(klon,jours)
      REAL temps(jours)
c
      REAL rlon(klon), rlat(klon)
      REAL xlon(iim,jjm+1), ylat(iim,jjm+1)
c
      REAL bils(iim,jjm+1,jours)
      REAL natu(iim,jjm+1,jours)
      REAL sste(iim,jjm+1,jours)
      REAL x(iim), y(jjm+1)
      REAL mask(iim,jjm+1)
      REAL ordre(iim,jjm+1)
c
      REAL change(iim,jjm+1)
c
#include "netcdf.inc"
      INTEGER ierr, nid, nvarid
c
      INTEGER i, j, ig, jr
c
c ****************************************************************
c
      ierr = NF_OPEN ("startphy.nc", NF_NOWRITE,nid)
      IF (ierr.NE.NF_NOERR) THEN
        PRINT*, "Probleme pour ouvrir le fichier startphy.nc"
        CALL abort
      ENDIF
c
      ierr = NF_INQ_VARID (nid, "longitude", nvarid)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur longitude"
         CALL abort
      ENDIF
      ierr = NF_GET_VAR_REAL(nid, nvarid,rlon)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "Probleme pour lire rlon"
         CALL abort
      ENDIF
c
      ierr = NF_INQ_VARID (nid, "latitude", nvarid)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur latitude"
         CALL abort
      ENDIF
      ierr = NF_GET_VAR_REAL(nid, nvarid,rlat)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "Probleme pour lire rlat"
         CALL abort
      ENDIF
c
      ierr = NF_CLOSE(nid)
c
c
      CALL lirlim(klon,jours,temps,nat_day,
     .            sst_day,alb_day,rug_day,bil_day)
c
c
      DO j = 1, jjm+1
      DO i = 1, iim
         mask(i,j) = -1.0
      ENDDO
      ENDDO
c
      ig = 1
      DO i = 1, iim
         IF (NINT(nat_day(ig,1)).EQ.0 .OR. NINT(nat_day(ig,1)).EQ.3)
     .   mask(i,1) = 1.0
      ENDDO
      DO j = 2, jjm
      DO i = 1, iim
         ig = ig + 1
         IF (NINT(nat_day(ig,1)).EQ.0 .OR. NINT(nat_day(ig,1)).EQ.3)
     .   mask(i,j) = 1.0
      ENDDO
      ENDDO
      ig = ig + 1
      DO i = 1, iim
         IF (NINT(nat_day(ig,1)).EQ.0 .OR. NINT(nat_day(ig,1)).EQ.3)
     .   mask(i,jjm+1) = 1.0
      ENDDO
c
      ig = 1
      DO i = 1, iim
         xlon(i,1) = rlon(ig)
         ylat(i,1) = rlat(ig)
         ordre(i,1) = ig
      ENDDO
      DO j = 2, jjm
      DO i = 1, iim
         ig = ig + 1
         xlon(i,j) = rlon(ig)
         ylat(i,j) = rlat(ig)
         ordre(i,j) = ig
      ENDDO
      ENDDO
      ig = ig + 1
      DO i = 1, iim
         xlon(i,jjm+1) = rlon(ig)
         ylat(i,jjm+1) = rlat(ig)
         ordre(i,jjm+1) = ig
      ENDDO
c
      DO jr = 1, jours
      ig = 1
      DO i = 1, iim
         bils(i,1,jr) = bil_day(ig,jr)
         natu(i,1,jr) = nat_day(ig,jr)
         sste(i,1,jr) = sst_day(ig,jr)
      ENDDO
      DO j = 2, jjm
      DO i = 1, iim
         ig = ig + 1
         bils(i,j,jr) = bil_day(ig,jr)
         natu(i,j,jr) = nat_day(ig,jr)
         sste(i,j,jr) = sst_day(ig,jr)
      ENDDO
      ENDDO
      ig = ig + 1
      DO i = 1, iim
         bils(i,jjm+1,jr) = bil_day(ig,jr)
         natu(i,jjm+1,jr) = nat_day(ig,jr)
         sste(i,jjm+1,jr) = sst_day(ig,jr)
      ENDDO
      ENDDO
c
      DO i = 1, iim
         x(i) = xlon(i,2)
      ENDDO
      DO j = 1, jjm+1
         y(j) = ylat(1,j)
      ENDDO
c
      DO j = 1, jjm+1
      DO i = 1, iim
         change(i,j) = 0.0
      ENDDO
      ENDDO
c
      IF (jours.GE.2) THEN
      DO jr = 1, jours-1
      DO j = 1, jjm+1
      DO i = 1, iim
      IF (NINT(natu(i,j,jr)).EQ.1 .OR. NINT(natu(i,j,jr)).EQ.2) THEN
         IF (NINT(natu(i,j,jr)).NE.NINT(natu(i,j,jr+1)))change(i,j)=1.0
      ENDIF
      ENDDO
      ENDDO
      ENDDO
      ENDIF
c
      CALL ecrit_netcdf("bils.nc",iim,jjm+1,x,y,mask,1.0e+30,jours,bils)
      CALL ecrit_netcdf("natu.nc",iim,jjm+1,x,y,mask,1.0e+30,jours,natu)
      CALL ecrit_netcdf("sste.nc",iim,jjm+1,x,y,mask,1.0e+30,jours,sste)
      CALL ecrit_netcdf("ordre.nc",iim,jjm+1,x,y,mask,1.0e+30,1,ordre)
      CALL ecrit_netcdf("change.nc",iim,jjm+1,x,y,mask,1.0e+30,1,change)
c
      STOP
      END
      SUBROUTINE lirlim(klon, jours, temps, lmt_nat,
     s                    lmt_sst,lmt_alb,lmt_rug,lmt_bils )
      IMPLICIT none
c
c Lire les conditions aux limites du modele.
c
#include "netcdf.inc"
      INTEGER nid, nvarid
      INTEGER debut(2)
      INTEGER epais(2)
c
      INTEGER klon
      INTEGER jours
c
      REAL lmt_nat(klon,jours) ! indicateur de la nature du sol
      REAL lmt_sst(klon,jours) ! temperature de la surface oceanique
      REAL lmt_alb(klon,jours) ! albedo du sol
      REAL lmt_rug(klon,jours) ! longeur de rugosite du sol
      REAL lmt_bils(klon,jours)
      REAL temps(jours)
c
c Variables locales:
      INTEGER ierr
      INTEGER iargc, nbtape
      EXTERNAL iargc
      CHARACTER*40 tapename
c
      nbtape = iargc()
      IF (nbtape.NE.1) THEN
         PRINT*, "Argument (nom de fichier) manquant"
         CALL abort
      ENDIF
c
      CALL getarg(1,tapename)
c
c Ouvrir le fichier en format NetCDF:
c
      ierr = NF_OPEN (tapename, NF_NOWRITE,nid)
      IF (ierr.NE.NF_NOERR) THEN
        WRITE(6,*)' Pb d ouverture du fichier limit.nc'
        WRITE(6,*)' ierr = ', ierr
        CALL abort
      ENDIF
c
c La tranche de donnees a lire:
c
      ierr = NF_INQ_VARID (nid, "TEMPS", nvarid)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "condsurf: Le champ <TEMPS> est absent"
         CALL abort
      ENDIF
      ierr = NF_GET_VARA_REAL(nid, nvarid,1,jours,temps)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "condsurf: Lecture echouee pour <TEMPS>"
         CALL abort
      ENDIF
c
      debut(1) = 1
      debut(2) = 1
      epais(1) = klon
      epais(2) = jours
c
c Indicateur de la nature du sol (0,1,2,3):
      ierr = NF_INQ_VARID (nid, "NAT", nvarid)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "condsurf: Le champ <NAT> est absent"
         CALL abort
      ENDIF
      ierr = NF_GET_VARA_REAL(nid, nvarid,debut,epais,lmt_nat)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "condsurf: Lecture echouee pour <NAT>"
         CALL abort
      ENDIF
c
c Sea surface temperature:
      ierr = NF_INQ_VARID (nid, "SST", nvarid)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "condsurf: Le champ <SST> est absent"
         CALL abort
      ENDIF
      ierr = NF_GET_VARA_REAL(nid, nvarid,debut,epais,lmt_sst)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "condsurf: Lecture echouee pour <SST>"
         CALL abort
      ENDIF
c
c Albedo de surface:
      ierr = NF_INQ_VARID (nid, "ALB", nvarid)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "condsurf: Le champ <ALB> est absent"
         CALL abort
      ENDIF
      ierr = NF_GET_VARA_REAL(nid, nvarid,debut,epais,lmt_alb)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "condsurf: Lecture echouee pour <ALB>"
         CALL abort
      ENDIF
c
c Longueur de rugosite au sol:
      ierr = NF_INQ_VARID (nid, "RUG", nvarid)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "condsurf: Le champ <RUG> est absent"
         CALL abort
      ENDIF
      ierr = NF_GET_VARA_REAL(nid, nvarid,debut,epais,lmt_rug)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "condsurf: Lecture echouee pour <RUG>"
         CALL abort
      ENDIF
c
c Bilan flux de chaleur au sol:
      ierr = NF_INQ_VARID (nid, "BILS", nvarid)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "condsurf: Le champ <BILS> est absent"
         CALL abort
      ENDIF
      ierr = NF_GET_VARA_REAL(nid, nvarid,debut,epais,lmt_bils)
      IF (ierr .NE. NF_NOERR) THEN
         PRINT*, "condsurf: Lecture echouee pour <BILS>"
         CALL abort
      ENDIF
c
c Fermer le fichier:
c
      ierr = NF_CLOSE(nid)
c
c
      PRINT*, 'SST, ALB, RUG, etc. sont lus'
c
      RETURN
      END
      SUBROUTINE ecrit_netcdf(ficnom,iim,jjm,x,y,mask,missing,nb,vari)
      IMPLICIT none
c
      CHARACTER*(*) ficnom
      INTEGER iim, jjm, nb
      REAL x(iim), y(jjm), mask(iim,jjm)
      REAL vari(iim,jjm,nb)
      REAL missing
c
#include "netcdf.inc"
c
      INTEGER ierr, mid, varid
      INTEGER idim_x, idim_y, idim_t
      INTEGER dims2(2), dims3(3)
c
      INTEGER id_time, id_vari, n
c
      INTEGER debu3(3), epai3(3)
c
c Ouvrir le fichier a ecrire:
c
      ierr = NF_CREATE(ficnom, NF_CLOBBER, mid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme d ouverture du fichier a ecrire"
         CALL abort
      ENDIF
c
c Preciser quelques attributs globaux:
c
      ierr = NF_PUT_ATT_TEXT (mid, NF_GLOBAL, "title", 29,
     .                       "Ecriture rapide d un champ 2D")
      ierr = NF_PUT_ATT_TEXT (mid, NF_GLOBAL, "model", 33,
     .                       "Resultats issus d un diagnostique")
c
c Definir les dimensions du fichier:
c
      ierr = NF_DEF_DIM(mid,"x",iim,idim_x)
      ierr = NF_DEF_DIM(mid,"y",jjm,idim_y)
      ierr = NF_DEF_DIM(mid, "time", NF_UNLIMITED, idim_t)
c
      ierr = NF_ENDDEF(mid) ! sortir du mode de definition
c
c Definir et enregistrer certains champs invariants:
c
      ierr = NF_REDEF (mid)
      ierr = NF_DEF_VAR (mid,"x",NF_FLOAT,1,idim_x,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir x"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (mid, varid, "long_name", 10,"Longitudes")
      ierr = NF_PUT_ATT_TEXT (mid, varid, "short_name", 1,"x")
      ierr = NF_PUT_ATT_TEXT (mid, varid, "units", 12,"degrees_east")
      ierr = NF_ENDDEF(mid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE(mid,varid,x)
#else
      ierr = NF_PUT_VAR_REAL(mid,varid,x)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer x"
         CALL abort
      ENDIF
c
      ierr = NF_REDEF (mid)
      ierr = NF_DEF_VAR (mid,"y",NF_FLOAT,1,idim_y,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir y"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (mid, varid, "long_name", 9,"Latitudes")
      ierr = NF_PUT_ATT_TEXT (mid, varid, "short_name", 1,"y")
      ierr = NF_PUT_ATT_TEXT (mid, varid, "units", 13,"degrees_north")
      ierr = NF_ENDDEF(mid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE(mid,varid,y)
#else
      ierr = NF_PUT_VAR_REAL(mid,varid,y)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer y"
         CALL abort
      ENDIF
c
      dims2(1) = idim_x
      dims2(2) = idim_y
c
      ierr = NF_REDEF (mid)
      ierr = NF_DEF_VAR (mid,"mask",NF_FLOAT,2,dims2,varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir mask"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (mid,varid,"long_name",6,"Masque")
      ierr = NF_PUT_ATT_TEXT (mid, varid, "short_name", 4,"mask")
      ierr = NF_PUT_ATT_TEXT (mid, varid, "units", 1,"-")
      ierr = NF_ENDDEF(mid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE(mid,varid,mask)
#else
      ierr = NF_PUT_VAR_REAL(mid,varid,mask)
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer mask"
         CALL abort
      ENDIF
c
c Definir les variables pour enregistrement ulterieur:
c
      ierr = NF_REDEF (mid)
c
      ierr = NF_DEF_VAR (mid,"time", NF_FLOAT,1,idim_t,id_time)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir time"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT(mid,id_time,"long_name",12,"time counter")
      ierr = NF_PUT_ATT_TEXT(mid,id_time,"short_name",4,"time")
      ierr = NF_PUT_ATT_TEXT(mid,id_time,"units",16,"days since 1-1-1")
      ierr = NF_PUT_ATT_TEXT(mid,id_time,"note",27,
     .                       "Il peut etre n importe quoi")
c
      dims3(1) = idim_x
      dims3(2) = idim_y
      dims3(3) = idim_t
c
      ierr = NF_DEF_VAR (mid,"vari",NF_FLOAT,3,dims3,id_vari)
      ierr = NF_PUT_ATT_TEXT(mid,id_vari,"long_name",8,"Variable")
      ierr = NF_PUT_ATT_TEXT(mid,id_vari,"short_name",4,"vari")
      ierr = NF_PUT_ATT_TEXT(mid,id_vari,"units",1,"-")
#ifdef NC_DOUBLE
      ierr = NF_PUT_ATT_DOUBLE(mid,id_vari,"missing_value",
     .                                   NF_FLOAT,1,missing)
#else
      ierr = NF_PUT_ATT_REAL(mid,id_vari,"missing_value",
     .                                   NF_FLOAT,1,missing)
#endif
c
      ierr = NF_ENDDEF(mid)
c
      DO 99999 n = 1, nb
c
#ifdef NC_DOUBLE
        ierr = NF_PUT_VAR1_DOUBLE(mid,id_time,n,FLOAT(n))
#else
        ierr = NF_PUT_VAR1_REAL(mid,id_time,n,FLOAT(n))
#endif
        IF (ierr.NE.NF_NOERR) THEN
           PRINT*, "Probleme pour enregistrer time"
           CALL abort
        ENDIF
c
        debu3(1) = 1
        debu3(2) = 1
        debu3(3) = n
        epai3(1) = iim
        epai3(2) = jjm
        epai3(3) = 1
c
#ifdef NC_DOUBLE
        ierr = NF_PUT_VARA_DOUBLE(mid,id_vari,debu3,epai3,vari(1,1,n))
#else
        ierr = NF_PUT_VARA_REAL(mid,id_vari,debu3,epai3,vari(1,1,n))
#endif
        IF (ierr.NE.NF_NOERR) THEN
           PRINT*, "Probleme pour enregistrer vari"
           CALL abort
        ENDIF
c
99999 CONTINUE
      ierr = NF_CLOSE(mid)
c
      RETURN
      END
