      SUBROUTINE buildop(str, ex_topps, topp, nbops_max, missing_val, 
     $           opps, scal, nbops)
C
C
C     This subroutine decomposes the input string in the elementary functions
C     which need to be applied to the vector of data. This vector is 
C     represented by X in the string. This subroutine is the driver of the
C     decomposition and gets the time operation but then call decoop for the
C     other operations
C
C     INPUT
C
C     str      : String containing the operaitons
C     ex_toops : The time operaitons that can be expected within the string
C
C     OUTPUT
C
C
C
      IMPLICIT NONE
C
      CHARACTER*80 str
      CHARACTER*(*) ex_topps
      CHARACTER*7 topp
      INTEGER nbops_max, nbops
      CHARACTER*7 opps(nbops_max)
      REAL scal(nbops_max), missing_val

      CHARACTER*80 new_str

      INTEGER len, ind_opb, ind_clb

      LOGICAL check

      INTEGER lnblnk
      EXTERNAL lnblnk

      check = .FALSE.

      len = lnblnk(str)

      IF (check) WRITE(*,*) 'Starting to test the various options'

      IF (len .LE. 5 .AND. index(ex_topps, str(1:len)) .GT. 0) THEN

         IF (check) WRITE(*,*) 'Time operation only'

         nbops = 0
         topp = str(1:len)

      ELSE

         IF (check) WRITE(*,*) 'Time operation and something else'

         ind_opb = index(str(1:len), '(')

         ind_clb = len
         DO WHILE ( str(ind_clb:ind_clb) .NE. ')')
            ind_clb = ind_clb - 1
         ENDDO

         IF ( ind_opb .GT. 0) THEN

            IF ( index(ex_topps, str(1:ind_opb-1)) .GT. 0) THEN

               IF (check) WRITE(*,'(2a)')
     $              'Extract time opperation from : ', str

               topp = str(1:ind_opb-1)

               new_str = str(ind_opb+1:ind_clb-1)

               IF (check) WRITE(*,'(2a,2I3)') 'Call decoop ',
     $              new_str, ind_opb, ind_clb  

               CALL decoop(new_str, nbops_max, missing_val, 
     $              opps, scal, nbops)

            ELSE
               CALL histerr(3,'buildop',
     $              'time opperation does not exist',
     $              str(1:ind_opb-1), ' ')
            ENDIF
         ELSE
            CALL histerr(3,'buildop',
     $           'some long opperation exists but wihtout parenthesis',
     $           str(1:len), ' ')
            
         ENDIF
      ENDIF

      RETURN

      END


      SUBROUTINE decoop(pstr, nbops_max, missing_val, 
     $           opps, scal, nbops)
C
      IMPLICIT NONE
C
      CHARACTER*80 pstr
      INTEGER nbops_max, nbops 
      CHARACTER*7 opps(nbops_max)
      REAL scal(nbops_max), missing_val

      CHARACTER*1 f_char(2), s_char(2)
      INTEGER nbsep, f_pos(2), s_pos(2)
      CHARACTER*20 opp_str, scal_str
      CHARACTER*80 str

      CHARACTER*80 ops, mima
      CHARACTER*250 funcs
      INTEGER xpos, len, ppos, epos, int_tmp
      CHARACTER*3 tl,dl
      CHARACTER*10 fmt

      LOGICAL check, prio
      
      INTEGER lnblnk
      EXTERNAL lnblnk
      check = .FALSE.

      ops = '+ - * / ^'
      mima = 'min max'
      funcs ='sin cos tan asin acos atan exp log sqrt chs abs cels
     $     kelv deg rad gather scatter fill coll undef only ident'

      IF ( check ) WRITE(*,'(2a)') 'Incoming string : ', pstr

      nbops = 0
      str = pstr

      CALL findsep(str, nbsep, f_char, f_pos, s_char, s_pos)

      IF ( check ) WRITE(*,*) 'Out of findsep', nbsep

      DO WHILE (nbsep .GT. 0) 

         xpos = index(str, 'X')
         len = lnblnk(str)
         nbops = nbops + 1
C
         IF ( check) THEN
            WRITE(*,*) 'str -->', str(1:len)
            WRITE(*,*) s_char(1),'-',f_char(1),'|',f_char(2),
     $           '-',s_char(2)
            WRITE(*,*) s_pos(1),'-',f_pos(1),'|',f_pos(2),
     $           '-',s_pos(2)
         ENDIF
C
         IF ( nbops .GT. nbops_max-1) THEN
            CALL histerr(3, 'decoop', 'Expression too complex',
     $           str, ' ')
         ENDIF
C
         IF ( check ) WRITE(*,*) '--',nbops,' ',str(1:len)
C
C     Start the analysis of the syntax. 3 types of constructs are recognized.
C     They are scanned sequentialy
C
         IF ( nbsep .EQ. 1) THEN

            IF ( check ) WRITE(*,*) 'Only one operation'

            IF (index(ops, f_char(1)) .GT. 0) THEN
C
C     Type : scal+X
C
               IF (f_char(1) .EQ. '-' .OR. f_char(1) .EQ. '/') THEN
                  opp_str = f_char(1)//'I'
               ELSE
                  opp_str = f_char(1)
               ENDIF
               scal_str = str(s_pos(1)+1:f_pos(1)-1)
               str = 'X'

            ELSE IF (index(ops, f_char(2)) .GT. 0) THEN
C
C     Type : X+scal
C
               opp_str = f_char(2)
               scal_str = str(f_pos(2)+1:s_pos(2)-1)
               str = 'X'

            ELSE
               CALL histerr(3, 'decoop', 'Unknown operations',
     $              f_char, pstr)
            ENDIF

         ELSE

            IF ( check ) WRITE(*,*) 'More complex operation'

            IF ( f_char(1) .EQ. '(' .AND. f_char(2) .EQ. ')' ) THEN
C
C     Type : sin(X)
C
               opp_str = str(s_pos(1)+1:f_pos(1)-1)
               scal_str = '?'
               str = str(1:s_pos(1))//'X'//str(f_pos(2)+1:len)

            ELSE IF ((f_char(1) .EQ. '(' .AND. f_char(2) .EQ. ',')
     $              .OR.
     $               (f_char(1) .EQ. ',' .AND. f_char(2) .EQ. ')'))
     $              THEN
C
C     Type : max(X,scal) or max(scal,X)
C
               IF ( f_char(1) .EQ. '(' .AND.
     $              s_char(2) .EQ. ')') THEN
C
C     Type : max(X,scal)
C
                  opp_str = str(f_pos(1)-3:f_pos(1)-1)
                  scal_str = str(f_pos(2)+1:s_pos(2)-1)
                  str = str(1:f_pos(1)-4)//'X'//str(s_pos(2)+1:len)

               ELSE IF ( f_char(1) .EQ. ',' .AND.
     $                 s_char(1) .EQ. '(') THEN
C
C     Type : max(scal,X)
C
                  opp_str = str(s_pos(1)-3:s_pos(1)-1)
                  scal_str = str(s_pos(1)+1:f_pos(1)-1)
                  str = str(1:s_pos(1)-4)//'X'//str(f_pos(2)+1:len)

               ELSE

                  CALL histerr(3, 'decoop', 'Syntax error 1',
     $                 str, ' ')

               ENDIF

            ELSE 

               prio = (f_char(2) .EQ. '*') .OR. (f_char(2) .EQ. '^')
               IF ( index(ops, f_char(1)) .GT. 0 .AND.
     $              xpos - f_pos(1) .EQ. 1 .AND. .NOT. prio) THEN
C
C     Type : ... scal+X ...
C
                  IF (f_char(1) .EQ. '-' .OR. f_char(1) .EQ. '/') THEN
                     opp_str = f_char(1)//'I'
                  ELSE
                     opp_str = f_char(1)
                  ENDIF
                  scal_str = str(s_pos(1)+1:f_pos(1)-1)
                  str = str(1:s_pos(1))//'X'//str(f_pos(1)+2:len)
                  
               ELSE IF ( index(ops, f_char(2)) .GT. 0 .AND.
     $                 f_pos(2) - xpos .EQ. 1) THEN
C     
C     Type : ... X+scal ...
C     
                  opp_str = f_char(2)
                  scal_str = str(f_pos(2)+1:s_pos(2)-1)
                  str = str(1:f_pos(2)-2)//'X'//str(s_pos(2):len)
                  
               ELSE
                  CALL histerr(3, 'decoop', 'Syntax error 2',
     $                 str, ' ')
                  
               ENDIF
C
            ENDIF
C
         ENDIF
C
         IF ( check ) WRITE(*,*) 'Finished syntax, str = ',
     $        str(1:lnblnk(str))
C
C
C     Now that the different components of the operation are identified
C     we transform them into what is going to be used in the program
C
C
         IF ( index(scal_str, '?') .GT. 0) THEN

            IF (index(funcs,opp_str(1:lnblnk(opp_str))) .GT. 0) THEN
               opps(nbops) = opp_str(1:lnblnk(opp_str))
               scal(nbops) =  missing_val
            ELSE
               CALL histerr(3, 'decoop', 'Unknown function',
     $              opp_str(1:lnblnk(opp_str)), ' ')
            ENDIF

         ELSE

            len = lnblnk(opp_str)
            IF (index(mima,opp_str(1:len)) .GT. 0) THEN
               opps(nbops) = 'fu'//opp_str(1:len)
            ELSE
               IF (index(opp_str(1:len),'+') .GT. 0) THEN
                  opps(nbops) = 'add'
               ELSE IF (index(opp_str(1:len),'-I') .GT. 0) THEN
                  opps(nbops) = 'subi'
               ELSE IF (index(opp_str(1:len),'-') .GT. 0) THEN
                  opps(nbops) = 'sub'
               ELSE IF (index(opp_str(1:len),'*') .GT. 0) THEN
                  opps(nbops) = 'mult'
               ELSE IF (index(opp_str(1:len),'/') .GT. 0) THEN
                  opps(nbops) = 'div'
               ELSE IF (index(opp_str(1:len),'/I') .GT. 0) THEN
                  opps(nbops) = 'divi'
               ELSE IF (index(opp_str(1:len),'^') .GT. 0) THEN
                  opps(nbops) = 'power'
               ELSE
                  CALL histerr(3, 'decoop', 'Unknown operation',
     $                 opp_str(1:len), ' ')
               ENDIF
            ENDIF
C
            len = lnblnk(scal_str)
            ppos = index(scal_str,'.')
            epos = index(scal_str,'e')
            IF ( epos .EQ. 0) epos = index(scal_str,'E')
C
C     Try to catch a few errors
C
            IF ( index(ops, scal_str) .GT. 0) THEN
               CALL histerr(3, 'decoop',
     $              'Strange scalar you have here ',
     $              scal_str, pstr)
            ENDIF

            IF (epos .GT. 0) THEN
               WRITE(tl,'(I3.3)') len
               WRITE(dl,'(I3.3)') epos-ppos-1
               fmt='(e'//tl//'.'//dl//')'
               READ(scal_str,fmt) scal(nbops)
            ELSE IF (ppos .GT. 0) THEN
               WRITE(tl,'(I3.3)') len
               WRITE(dl,'(I3.3)') len-ppos
               fmt='(f'//tl//'.'//dl//')'
               READ(scal_str,fmt) scal(nbops)
            ELSE
               WRITE(tl,'(I3.3)') len
               fmt = '(I'//tl//')'
               READ(scal_str,fmt) int_tmp
               scal(nbops) = float(int_tmp)
            ENDIF
C
         ENDIF
C
         IF ( check ) WRITE(*,*) 'Finished interpretation'
C
         CALL findsep(str, nbsep, f_char, f_pos, s_char, s_pos)

      ENDDO

C
      RETURN

      END


      SUBROUTINE findsep(str, nbsep, f_char, f_pos, s_char, s_pos)
C
      IMPLICIT NONE
C
      CHARACTER*80 str
      INTEGER nbsep
      CHARACTER*1 f_char(2), s_char(2)
      INTEGER f_pos(2), s_pos(2)

      CHARACTER*80 seps
      CHARACTER*70 str_tmp
      LOGICAL f_found, s_found
      INTEGER ind, xpos, len, i

      LOGICAL check

      INTEGER lnblnk
      EXTERNAL lnblnk

      check = .FALSE.

      seps = '( ) , + - / * ^'

      IF ( check ) WRITE(*,*) 'call cleanstr: ',str(1:lnblnk(str))

      CALL cleanstr(str)

      IF ( check ) WRITE(*,*) 'out of cleanstr: ',str(1:lnblnk(str))

      xpos = index(str,'X')
      len = lnblnk(str)

      f_pos(1) = 0
      f_pos(2) = len+1
      f_char(1) = '?'
      f_char(2) = '?'
      s_pos(1) = 0
      s_pos(2) = len+1
      s_char(1) = '?'
      s_char(2) = '?'

      f_found = .FALSE.
      s_found = .FALSE.
      nbsep = 0

      IF ( xpos .GT. 1) THEN
         DO i=xpos-1,1,-1
            ind = index(seps,str(i:i))
            IF (ind .GT. 0) THEN
               IF (.NOT. f_found) THEN
                  f_char(1) = str(i:i)
                  f_pos(1) = i
                  nbsep = nbsep + 1
                  f_found = .TRUE.
               ELSE IF (.NOT. s_found) THEN
                  s_char(1) = str(i:i)
                  s_pos(1) = i
                  nbsep = nbsep + 1
                  s_found = .TRUE.
               ENDIF
            ENDIF
         ENDDO
      ENDIF

      f_found = .FALSE.
      s_found = .FALSE.

      IF ( xpos .LT. len) THEN
         DO i=xpos+1,len
            ind = index(seps,str(i:i))
            IF (ind .GT. 0) THEN
               IF (.NOT. f_found) THEN
                  f_char(2) = str(i:i)
                  f_pos(2) = i
                  nbsep = nbsep + 1
                  f_found = .TRUE.
               ELSE IF (.NOT. s_found) THEN
                  s_char(2) = str(i:i)
                  s_pos(2) = i
                  nbsep = nbsep + 1
                  s_found = .TRUE.
               ENDIF
            ENDIF
         ENDDO
      ENDIF
C
      IF ( nbsep .GT. 4) THEN
         WRITE(str_tmp,'("number :",I3)') nbsep
         CALL histerr(3, 'findsep',
     $        'How can I find that many separators', str_tmp, str)
      ENDIF
C
      IF ( check ) WRITE(*,*) 'Finished findsep : ', nbsep, len
C
      RETURN

      END

      SUBROUTINE cleanstr(str)
C
      IMPLICIT NONE
C
      CHARACTER*80 str

      CHARACTER*80 seps
      INTEGER ind, len

      INTEGER lnblnk
      EXTERNAL lnblnk

      seps = '( ) , + - / * ^'

      len = lnblnk(str)

      ind = index(str, 'x')
      IF (ind .GT. 0 .AND. str(ind-2:ind) .NE. 'max') THEN
         str(ind:ind) = 'X'
      ENDIF

      ind = index(str, '(X)')
      IF ( ind .GT. 0 .AND. ind+3 .LT. len) THEN
         IF ( index(seps,str(ind-1:ind-1)) .GT. 0 .OR.
     $        index(seps,str(ind+3:ind+3)) .GT. 0) THEN
            str=str(1:ind-1)//'X'//str(ind+3:len)//'  '
         ENDIF
      ENDIF

      len = lnblnk(str)
      ind = index(str(1:len),' ')
      DO WHILE (ind .GT. 0)
         str=str(1:ind-1)//str(ind+1:len)//' '
         len = lnblnk(str)
         ind = index(str(1:len),' ')
      ENDDO


      RETURN

      END

      SUBROUTINE cmpblank(str)
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/cmpblank.F,v 1.4 1998/01/30 10:07:01 polcher Exp $
C
C
      CHARACTER*100 str

      INTEGER len, ipos

      INTEGER lnblnk, findpos
      EXTERNAL lnblnk, findpos

      ipos = 1
      len = lnblnk(str)

      DO WHILE(ipos .LT. len) 

         IF (str(ipos:ipos+1) .EQ. '  ') THEN

            str = str(1:ipos)//str(ipos+2:len)
            len = len - 1

         ELSE

            ipos = ipos + 1

         ENDIF
         

      ENDDO

      RETURN

      END
      
      INTEGER FUNCTION cntpos(str, len, char, clen)
C
C     Finds position of char in str
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/cntpos.F,v 1.4 1998/01/30 10:07:02 polcher Exp $
C
C
      IMPLICIT NONE
C
      CHARACTER*(*) str
      INTEGER len
      CHARACTER*(*) char
      INTEGER clen
C
      INTEGER i, ires
      
      i = len-clen+1
      ires = 0
      DO WHILE (i .GT. 0) 
         IF (char(1:clen) .EQ. str(i:i+clen-1)) THEN
            ires = ires + 1
         ENDIF
         i = i - 1
      ENDDO

      cntpos = ires

      RETURN

      END

      SUBROUTINE delblank(str)
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/delblank.F,v 1.1 1998/03/04 18:51:09 polcher Exp $
C
C
      CHARACTER*(*) str

      INTEGER len

      INTEGER lnblnk
      EXTERNAL lnblnk

      len = lnblnk(str)

      IF ( len .GT. 0) THEN
         DO WHILE(str(1:1) .EQ. ' ') 
            
            str = str(2:len)
            len = len - 1
            
         ENDDO
      ENDIF

      RETURN

      END
C
      SUBROUTINE find_str(nb_str, str_tab, str, pos)
C
      IMPLICIT NONE
C
C     This subroutine looks for a string in a table
C
C     INPUT
C          nb_str  : length of table
C          str_tab : Table of strings
C          str     : Target we are looking for
C
C     OUTPUT
C          pos : -1 if str not found, else value in the table
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/find_str.F,v 1.4 1998/01/30 10:07:02 polcher Exp $
C
C
C     ARGUMENTS
C
      INTEGER nb_str
      CHARACTER*(*) str_tab(nb_str), str
      INTEGER pos
C
C     LOCAL
C
      INTEGER i
      CHARACTER*125 str_tmp
C
      INTEGER lnblnk
      EXTERNAL lnblnk
C
      IF (nb_str .EQ. 0) THEN
         pos = -1
      ELSE
         pos = -1
         DO i=1, nb_str
            str_tmp = str_tab(i)
            IF (str_tmp(:lnblnk(str_tmp)) .EQ. 
     &          str(:lnblnk(str))) THEN
               pos = i
            ENDIF
         ENDDO
      ENDIF
C
      END
      
      INTEGER FUNCTION findpos(str, len, char, clen)
C
C     Finds position of char in str
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/findpos.F,v 1.4 1998/01/30 10:07:03 polcher Exp $
C
C
      IMPLICIT NONE
C
      CHARACTER*(*) str
      INTEGER len
      CHARACTER*(*) char
      INTEGER clen
C
      INTEGER i, ires
      
      i = len-clen+1
      ires = -1
      DO WHILE (i .GT. 0) 
         IF (char(1:clen) .EQ. str(i:i+clen-1)) THEN
            ires = i
         ENDIF
         i = i - 1
      ENDDO

      findpos = ires

      RETURN

      END

      SUBROUTINE flinclose(fid)
C
      IMPLICIT NONE
C
C     fid    : File id to close
C
      INTEGER fid
C
      INTEGER iret
C
      CALL ncclos(fid,iret)
C
      RETURN
C
      END
C

      SUBROUTINE flincre(filename, iim1, jjm1, lon1, lat1,
     $     llm1, lev1, ttm1, itaus, time0, dt,
     $     fid, nlonid1, nlatid1, zdimid1, tdimid1)
C
      IMPLICIT NONE
C
C     This is a "low level" subroutine for opening netCDF files wich
C     contain the major coordinate system of the model. Other coordinates 
C     needed for other variables will be added as they are needed.  
C
C     INPUT
C
C     filename    : Name of the file to be created
C     iim1, jjm1  : Horizontal size of the grid which will be stored in the
C                   file
C     lon1, lat1  : Horizontal grids
C     llm1        : Size of the vertical grid
C     lev1        : Vertical grid
C     ttm1        : Size of time axis
C     itaus       : time steps on the time axis
C     time0       : Time in julian days at which itau = 0
C     dt          : time step in seconds between itaus (one step of itau)
C
C     OUTPUT
C
C     fid         : File identification
C     nlonid1     : Identification of longitudinal axis
C     nlatid1     : Identification of latitudinal axis
C     zdimid1     : ID of vertical axis
C     tdimid1     : ID of time axis
C
C
C     ARGUMENTS
C
      CHARACTER*(*) filename
      INTEGER iim1, jjm1, llm1, ttm1
      REAL lon1(iim1,jjm1)   
      REAL lat1(iim1,jjm1)
      REAL lev1(llm1)
      INTEGER itaus(ttm1)
      REAL time0
      REAL dt
      INTEGER fid, zdimid1, nlonid1, nlatid1, tdimid1
C
C
C     LOCAL
C
#include "netcdf.inc"
C
      INTEGER tmmax
      PARAMETER (tmmax = 1000000)
C
      INTEGER iret, it, len
      INTEGER ndim, dims(4)
      INTEGER corner(4), edges(4)
      INTEGER lonid, latid, levid, timeid
      INTEGER year, month, day
      REAL r_year, r_month, r_day
      REAL sec
      REAL tmp_itaus(tmmax)
      CHARACTER*70 str1
      CHARACTER*250 name
C
      LOGICAL verbose
      INTEGER lnblnk
      EXTERNAL lnblnk
C
C
C
      verbose = .FALSE.
C
      IF ( ttm1 .GT. tmmax) THEN
         str1 = 'Time axis in file '//filename//' is '
         CALL histerr(3, 'flincre',str1,
     $           'larger than what is allowed in flinopen.', 
     $           'Please increase the value of tmmax. ')
      ENDIF
C
      len = lnblnk(filename)
      IF ( filename(len-2:len) .NE. '.nc') THEN
         name=filename(1:len)//'.nc'
      ELSE
         name=filename(1:len)
      ENDIF
C
      iret = NF_CREATE(name, NF_CLOBBER, fid)
C
      iret = NF_DEF_DIM(fid, 'x', iim1, nlonid1)
      iret = NF_DEF_DIM(fid, 'y', jjm1, nlatid1)
      iret = NF_DEF_DIM(fid, 'lev', llm1, zdimid1)
      iret = NF_DEF_DIM(fid, 'tstep', ttm1, tdimid1)
C
C
C     Vertical axis
C
      IF ( verbose ) WRITE(*,*) 'flincre Vertical axis'
C
      iret = NF_DEF_VAR(fid, 'lev', NF_FLOAT, 1, zdimid1, levid)
      iret = NF_PUT_ATT_TEXT(fid, levid, 'units', 1, '-')
      iret = NF_PUT_ATT_TEXT(fid, levid, 'title', 6, 'levels')
      iret = NF_PUT_ATT_TEXT(fid, levid, 'long_name',
     $     12, 'Sigma Levels')
C
C     Time axis
C
      IF ( verbose ) WRITE(*,*) 'flincre time axis'
C
      iret =  NF_DEF_VAR(fid, 'tstep', NF_FLOAT, 1, tdimid1, timeid)
      iret = NF_PUT_ATT_TEXT(fid, timeid, 'units', 1, '-')
      iret = NF_PUT_ATT_TEXT(fid, timeid, 'title', 4, 'time')
      iret = NF_PUT_ATT_TEXT(fid, timeid, 'long_name',
     $     10, 'time steps')
C
C    The longitude
C
      IF ( verbose ) WRITE(*,*) 'flincre Longitude axis'
C
      ndim = 2
      dims(1) = nlonid1
      dims(2) = nlatid1

      iret = NF_DEF_VAR(fid, "nav_lon", NF_FLOAT, ndim, dims, lonid)
      iret = NF_PUT_ATT_TEXT(fid, lonid, 'units', 12,
     $     "degrees_east")
      iret = NF_PUT_ATT_REAL(fid, lonid, 'valid_min',
     $     NF_FLOAT, 1, -180.)
      iret = NF_PUT_ATT_REAL(fid, lonid, 'valid_max',
     $     NF_FLOAT, 1, 180.)
      iret = NF_PUT_ATT_TEXT(fid, lonid, 'title', 9, "Longitude")
      iret = NF_PUT_ATT_TEXT(fid, lonid, 'nav_model',
     $     28, "Lambert projection of PROMES")

C
C    The Latitude
C
      IF ( verbose ) WRITE(*,*) 'flincre Latitude axis'
C
      ndim = 2
      dims(1) = nlonid1
      dims(2) = nlatid1

      iret = NF_DEF_VAR(fid, "nav_lat", NF_FLOAT, ndim, dims, latid)
      iret = NF_PUT_ATT_TEXT(fid, latid, 'units', 12,
     $     "degrees_north")
      iret = NF_PUT_ATT_REAL(fid, latid, 'valid_min',
     $     NF_FLOAT, 1, -90.)
      iret = NF_PUT_ATT_REAL(fid, latid, 'valid_max',
     $     NF_FLOAT, 1, 90.)
      iret = NF_PUT_ATT_TEXT(fid, latid, 'title', 8, "Latitude")
      iret = NF_PUT_ATT_TEXT(fid, latid, 'nav_model',
     $     28, "Lambert projection of PROMES")
C
C     The time coordinates
C
      iret = NF_PUT_ATT_REAL(fid, NF_GLOBAL, 'delta_tstep_sec',
     $     NF_FLOAT, 1, dt)

      CALL ju2ymds(time0, year, month, day, sec) 

      r_year=year
      iret = NF_PUT_ATT_REAL(fid, NF_GLOBAL, 'year0',
     $     NF_FLOAT, 1, r_year)

      r_month = month
      iret = NF_PUT_ATT_REAL(fid, NF_GLOBAL, 'month0',
     $     NF_FLOAT, 1, r_month)

      r_day = day
      iret = NF_PUT_ATT_REAL(fid, NF_GLOBAL, 'day0',
     $     NF_FLOAT, 1, r_day)

      iret = NF_PUT_ATT_REAL(fid, NF_GLOBAL, 'sec0',
     $     NF_FLOAT, 1, sec)
C
      iret = NF_ENDDEF(fid)
C
      IF ( verbose ) WRITE(*,*) 'flincre Variable'
C
      corner(1) = 1
      edges(1) = llm1
      iret = NF_PUT_VARA_REAL(fid, levid, corner, edges, lev1)
C
      IF ( verbose ) WRITE(*,*) 'flincre Time Variable'
C
      corner(1) = 1
      edges(1) = ttm1
      DO it=1,ttm1
         tmp_itaus(it) = itaus(it)
      ENDDO
      iret = NF_PUT_VARA_REAL(fid, timeid, corner, edges, tmp_itaus)
C
      IF ( verbose ) WRITE(*,*) 'flincre Longitude'
C
      corner(1) = 1
      corner(2) = 1
      edges(1) = iim1
      edges(2) = jjm1
      iret = NF_PUT_VARA_REAL(fid, lonid, corner, edges, lon1)
C
      IF ( verbose ) WRITE(*,*) 'flincre Latitude'
C
      corner(1) = 1
      corner(2) = 1
      edges(1) = iim1
      edges(2) = jjm1
      iret = NF_PUT_VARA_REAL(fid, latid, corner, edges, lat1)
C
C
      RETURN
C
      END

C
      SUBROUTINE flinget(fid, varname, iim, jjm, llm, ttm, itau_dep,
     $    itau_fin, var)
C     
      IMPLICIT NONE
C     
C     
C	This subroutine will read the variable named varname fomr
C       the file previously opened by flinopen and identified by fid
C
C	If variable is of size zero a global attribute is read. This
C       global attribute will be of type real
C
C     INPUT
C
C     fid     : File ID returned by flinopen
C     varname : Name of the variable to be read from the file
C     iim     : | These three variables give the size of the variables
C     jjm     : | to be read. It will be verified that the variables
C     llm     : | fits in there.
C     ttm     : |
C     itau_dep: Time step at which we will start to read
C     itau_fin: Time step until which we are going to read 
C               For the moment this is done on indeces but it should be
C               in the physical space
C               If there is no time-axis in the file then use a 
C               itau_fin < itau_dep, this will tell flinget not to 
C               expect a time-axis in the file.
C
C     OUTPUT
C
C     var     : array that will contain the data
C
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/flinget.F,v 1.7 1998/02/17 19:29:40 polcher Exp $
C
C     
C
C     ARGUMENTS
C
      INTEGER fid
      CHARACTER*(*) varname
      INTEGER iim, jjm, llm, ttm, itau_dep, itau_fin
      REAL var(iim,jjm,llm, ttm)
C
C     LOCAL
C
      INTEGER iret
      INTEGER vid
      CHARACTER*70 str1
      CHARACTER*250 tmp_name, name
      INTEGER ndims, dims(4), dimids(4), vtype, nb_atts
      INTEGER i
      INTEGER index_sta(4), index_len(4)
C
      LOGICAL check
C
#include "netcdf.inc"
C
      INTEGER lnblnk
      EXTERNAL  lnblnk
 
      check = .FALSE.

      IF (iim + jjm + llm .GT. 0) THEN
C
C     1.0 We get first all the details on this variable from the file
C
         iret = NF_INQ_VARID(fid, varname, vid)
C
         iret = NF_INQ_VAR(fid, vid, tmp_name, vtype, ndims, dimids, 
     $        nb_atts)
C
         DO i=1,nb_atts
            iret = NF_INQ_ATTNAME(fid, vid, i, tmp_name)
            iret = NF_GET_ATT_TEXT(fid, vid, tmp_name, name)
            IF ( check ) THEN
               WRITE(*,*) '--------------------------'
               WRITE(*,*) tmp_name(1:lnblnk(tmp_name)),' : ',
     $              name(1:lnblnk(name))
               WRITE(*,*) '--------------------------'
            ENDIF
         ENDDO
C
C!!!!!!!!! We will need a verification on the type of the variable
C

         DO i=1,ndims
            iret = NF_INQ_DIM(fid, dimids(i), tmp_name, dims(i))
         ENDDO
C
C     2.0 The dimensions are anaysed to determine what is to be read
C
C     2.1 the longitudes
C
C
         IF ( dims(1) .NE. iim) THEN
            str1 = 'The longitude dimension of '//varname 
            CALL histerr(3, 'flinget', str1,
     $           'in the file is not equal to the dimension',
     $           'that should be read')
         ELSE
            index_sta(1) = 1
            index_len(1) = iim
         ENDIF
C
C     2.2 The latitude
C
         IF ( dims(2) .NE. jjm) THEN
            str1 = 'The latitude dimension of '//varname 
            CALL histerr(3, 'flinget', str1,
     $           'in the file is not equal to the dimension',
     $           'that should be read')
         ELSE
            index_sta(2) = 1
            index_len(2) = jjm
         ENDIF
C     
C     2.3 Now the difficult part, the 3rd dimension which can be 
C     time or levels. 
C
C     2.3.1 We have a vetical axis
C
         IF (llm .NE. 0) THEN
C     
            IF (dims(3) .NE. llm) THEN
               str1 = 'The vertical dimension of '//varname 
               CALL histerr(3, 'flinget', str1,
     $              'in the file is not equal to the dimension',
     $              'that should be read')
            ELSE
               index_sta(3) = 1
               index_len(3) = llm
            ENDIF
C     
            IF ( itau_fin - itau_dep .GE. 0 ) THEN
               IF (ndims .NE. 4) THEN
                  CALL histerr(3, 'flinget', 
     $                 'You attempt to read a time slab but there',
     $                 'there is not time axis in the file', varname)
               ELSE
                  IF ( itau_fin - itau_dep .LE. dims(4) ) THEN
                     index_sta(4) = itau_dep
                     index_len(4) = itau_fin
                  ELSE
                     CALL histerr(3, 'flinget',
     $                    'The time step you try to read is not',
     $                    'in the file (1)', varname)
                  ENDIF
               ENDIF
            ELSE
               IF (ndims .EQ. 4 .AND. dims(4) .GT. 1) THEN
                  CALL histerr(3, 'flinget',
     $                 'There is a time axis in the file but no',
     $                 'time step give in the call', varname)
               ELSE
                  index_sta(4) = 1
                  index_len(4) = 1
               ENDIF
            ENDIF
C     
C     2.3.2 We do not have any vertical axis
C
         ELSE
            
            IF (ndims .EQ. 4) THEN
               CALL histerr(3, 'flinget',
     $              'The file contains 4 dimensions but',
     $              'but only 3 are requestes for variable ', varname)
            ENDIF
            
            IF ( itau_fin - itau_dep .GE. 0) THEN
               
               IF ( ndims .EQ. 3) THEN
                  IF ( itau_fin - itau_dep .LT. dims(3) ) THEN
                     index_sta(3) = itau_dep
                     index_len(3) = itau_fin
                  ELSE
                     CALL histerr(3, 'flinget',
     $                    'The time step you try to read is not',
     $                    'in the file(2)', varname)
                  ENDIF
               ELSE
                  CALL histerr(3, 'flinget',
     $                 'From your input you sould have at 3 dims',
     $                 'in the file but there are 4',
     $                 varname)
               ENDIF
               
            ELSE
               
               IF (ndims .EQ. 3 .AND. dims(3) .GT. 1) THEN
                  CALL histerr(3, 'flinget',
     $                 'There is a time axis in the file but no',
     $                 'time step given in the call', varname)
               ELSE
                  index_sta(3) = 1
                  index_len(3) = 1
               ENDIF
            ENDIF
            
         ENDIF
C
C     3.0 Reading the data
C

         iret = NF_GET_VARA_REAL(fid, vid, index_sta, index_len, var)

C     
C     4.0 Reading a global attribute
C
      ELSE
         
         iret = NF_GET_ATT_REAL(fid, NF_GLOBAL, varname, var)
         
      ENDIF
C
      RETURN
      
      END
C
      SUBROUTINE flinopen(filename, do_test, iim, jjm, llm, 
     $     lon, lat, lev, ttm, itaus, date0, dt, fid)
C     
      IMPLICIT NONE
C     
C     
C	This subroutine opens an input file for the PROMES model
C
C     INPUT
C
C       filename   : Name of the netCDF file to be opened
C       do_test    : A flag that anables the testing of the content
C                    of the file against the input from the model
C
C     INPUT if do_test=TRUE OUTPUT else
C 
C       iim        : size in the x direction (longitude)
C       jjm        : size in y
C       llm        : number of levels
C                  : llm = 0 means no axis to be expected
C       lon        : array of (iim,jjm) that contains the longitude of
C                    each point
C       lat        : same for latitude
C       lev        : An array of llm for the latitude
C
C	WARNING : In the case of do_test=FALSE it is for the user to check
C       that the dimensions of lon lat and lev are correct when passed to
C 	flinopen. This can be done after the call when iim and jjm have
C	been retrieved from the netCDF file. In F90 this problem will
C	be solved with an internal assign
C       IF iim, jjm, llm or ttm are parameters in the calling program and
C       you use the option do_test=FALSE it will create a segmentation fault
C
C
C     OUTPUT
C
C       ttm        : size of time axis
C       itaus      : Time steps within this file
C       date0      : Julian date at which itau = 0
C       dt         : length of the time steps of the data 
C       fid        : returned file ID which is later used to read the data
C
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/flinopen.F,v 1.7 1998/02/17 19:29:41 polcher Exp $
C
C
C     ARGUMENTS
C
C
      CHARACTER*(*) filename
      LOGICAL do_test
      INTEGER iim, jjm, llm, ttm
      REAL lon(iim,jjm), lat(iim,jjm), lev(llm)
      INTEGER itaus(ttm)
      REAL date0, dt
      INTEGER fid
C
C     LOCAL
C
      INTEGER tmmax
      PARAMETER (tmmax = 1000000)
C
      REAL eps
      PARAMETER (eps = 1.e-4)
C
      INTEGER iret, vid
      INTEGER xid, yid, levid, tid
      INTEGER ndims, nvars, nb_glat, id_unlim
      INTEGER it, len
      REAL itaus_tmp(tmmax)
      CHARACTER*250 name
      CHARACTER*70 str1
      INTEGER tmp_iim, tmp_jjm, tmp_llm, tmp_ttm
      INTEGER index_sta(4), index_len(4)
      REAL x_first, x_last
      INTEGER year, month, day
      REAL r_year, r_month, r_day
      REAL sec
C
      LOGICAL verbose
      INTEGER lnblnk
      EXTERNAL lnblnk
C
#include "netcdf.inc"
C
      verbose = .FALSE.
C
C     1.0 get all IDs we need
C
      IF ( verbose) WRITE(*,*) 'flinopen 1.0 get all IDs we need'
C
      len = lnblnk(filename)
      IF ( filename(len-2:len) .NE. '.nc') THEN
         name=filename(1:len)//'.nc'
      ELSE
         name=filename(1:len)
      ENDIF
C
      iret = NF_OPEN(name, NF_NOWRITE, fid) 
C
      iret = NF_INQ(fid, ndims, nvars, nb_glat, id_unlim)
C
C
      iret = NF_INQ_DIMID(fid, 'x', xid)
      iret = NF_INQ_DIMID(fid, 'y', yid)

      IF ( ndims .GT. 2) THEN
         iret = NF_INQ_DIMID(fid, 'lev', levid)
         IF ( NDIMS .GT. 3) THEN
            iret = NF_INQ_DIMID(fid, 'tstep', tid)
         ELSE
            tid = -1   
         ENDIF
      ELSE
         levid = -1
         tid = -1
      ENDIF
C
C     2.0 get the sizes and names of the different coordinates
C         and do a first set of verification. 
C
C     2.1    Geting the name. If the name of the third coordinate 
C            does not begin with 'lev' then it is a time coordinate
C
      IF ( verbose) WRITE(*,*) 'flinopen 2.1 geting the third coord'
C
      iret = NF_INQ_DIM(fid, xid, name, tmp_iim)
      iret = NF_INQ_DIM(fid, yid, name, tmp_jjm)
      IF ( levid .GE. 0) THEN
         iret = NF_INQ_DIM(fid, levid, name, tmp_llm)
         IF ( name(1:3) .NE. 'lev') THEN
            tid = levid
            levid = -1
            tmp_ttm = tmp_llm
            tmp_llm = 0
         ELSE
            IF (tid .GE. 0) THEN
               iret = NF_INQ_DIM(fid, tid, name, tmp_ttm)
            ELSE
               tmp_ttm = 0
            ENDIF
         ENDIF
      ELSE
         tmp_llm = 0
         tmp_ttm = 0
      ENDIF

C
C     2.2 We test the axis if we have to.
C
      IF ( verbose) WRITE(*,*) 'flinopen 2.2 We test if we have to',
     $     do_test
C
      IF ( do_test ) THEN

         str1 = 'file '//filename//' does not have the '

         IF ( iim .NE. tmp_iim ) THEN
            WRITE(*,*) 'iim, tmp_iim :',iim, tmp_iim
            CALL histerr(3, 'flinopen',str1,
     $           'required dimension in x direction (longitude)', ' ')

         ENDIF

         IF ( jjm .NE. tmp_jjm ) THEN

            CALL histerr(3, 'flinopen',str1,
     $           'required dimension in y direction (latitude)', ' ')

         ENDIF

         IF ( llm .NE. tmp_llm .AND. llm .GT. 0 ) THEN

            CALL histerr(3, 'flinopen',str1,
     $           'required dimension in the vertical', ' ')

         ENDIF
C
C     2.3 Else the sizes of the axes are returned to the user
C
      IF ( verbose) WRITE(*,*) 'flinopen 2.3 Else sizes are returned'
C
      ELSE 
         
         iim = tmp_iim
         jjm = tmp_jjm
         llm = tmp_llm

      ENDIF

      IF ( tmp_ttm .LE. tmmax) THEN
         ttm = tmp_ttm
      ELSE
         str1 = 'Time axis in file '//filename//' is '
         CALL histerr(3, 'flinopen',str1,
     $           'larger than what is allowed in flinopen.', 
     $           'Please increase the value of tmmax. ')
      ENDIF
C
C     3.0 Check if we are realy talking about the same coodinate system
C         if not then we get the lon, lat and lev variables from the file
C
      IF ( verbose) WRITE(*,*) 'flinopen 3.0 we are realy talking'
C
      IF ( do_test ) THEN

         iret = NF_INQ_VARID(fid, 'nav_lon', vid)
         index_sta(1) = 1
         index_sta(2) = 1
         index_len(1) = 1
         index_len(2) = 1
         iret = NF_GET_VARA_REAL(fid, vid, index_sta, index_len,
     $        x_first)

         index_sta(1) = iim
         index_sta(2) = jjm
         index_len(1) = 1
         index_len(2) = 1
         iret = NF_GET_VARA_REAL(fid, vid, index_sta, index_len,
     $        x_last)

         IF ( abs(x_first - lon(1,1)) .GT. eps .AND.
     $        abs(x_last - lon(iim,jjm)) .GT. eps ) THEN

            str1 = 'file '//filename//' and the model do not'
            CALL histerr(3, 'flinopen',str1,
     $           'share the same longitude coordinate', 
     $           'Obtained by comparing the first and last values ')

         ENDIF

         iret = NF_INQ_VARID(fid, 'nav_lat', vid)
         index_sta(1) = 1
         index_sta(2) = 1
         index_len(1) = 1
         index_len(2) = 1
         iret = NF_GET_VARA_REAL(fid, vid, index_sta, index_len,
     $        x_first)

         index_sta(1) = iim
         index_sta(2) = jjm
         index_len(1) = 1
         index_len(2) = 1
         iret = NF_GET_VARA_REAL(fid, vid, index_sta, index_len,
     $        x_last)

         IF ( abs(x_first - lat(1,1)) .GT. eps .AND.
     $        abs(x_last - lat(iim,jjm)) .GT. eps ) THEN

            str1 = 'file '//filename//' and the model do not'
            CALL histerr(3, 'flinopen',str1,
     $           'share the same latitude coordinate', 
     $           'Obtained by comparing the first and last values ')

         ENDIF

         IF ( llm .GT. 0) THEN

            iret = NF_INQ_VARID(fid, 'lev', vid)
            index_sta(1) = 1
            index_len(1) = 1
            iret = NF_GET_VARA_REAL(fid, vid, index_sta, index_len,
     $           x_first)

            index_sta(1) = llm
            index_len(1) = 1
            iret = NF_GET_VARA_REAL(fid, vid, index_sta, index_len,
     $           x_last)

            IF ( abs(x_first - lev(1)) .GT. eps .AND.
     $           abs(x_last - lev(llm)) .GT. eps ) THEN
               str1 = 'file '//filename//' and the model do not'
               CALL histerr(3, 'flinopen',str1,
     $              'share the same vertical coordinate', 
     $              'Obtained by comparing the first and last values')
            ENDIF

         ENDIF

      ELSE
C
C     4.0 extracting the coordinates if we do not check
C
      IF ( verbose) WRITE(*,*) 'flinopen 4.0 extracting the coordinates'
C
         iret = NF_INQ_VARID(fid, 'nav_lon', vid)
         index_sta(1) = 1
         index_sta(2) = 1
         index_len(1) = iim
         index_len(2) = jjm
         iret = NF_GET_VARA_REAL(fid, vid, index_sta, index_len, lon)

         iret = NF_INQ_VARID(fid, 'nav_lat', vid)
         index_sta(1) = 1
         index_sta(2) = 1
         index_len(1) = iim
         index_len(2) = jjm
         iret = NF_GET_VARA_REAL(fid, vid, index_sta, index_len, lat)

         IF ( llm .GT. 0 ) THEN
            iret = NF_INQ_VARID(fid, 'lev', vid)
            index_sta(1) = 1
            index_len(1) = llm
            iret = NF_GET_VARA_REAL(fid, vid, index_sta, index_len,
     $           lev)
         ENDIF

      ENDIF
C
C     5.0 Get all the details for the time if possible needed
C
      IF ( verbose) WRITE(*,*) 'flinopen 5.0 Get time'
C
      IF ( ttm .GT. 0 ) THEN
C
         iret = NF_INQ_VARID(fid, 'tstep', vid)
         index_sta(1) = 1
         index_len(1) = ttm
         iret = NF_GET_VARA_REAL(fid, vid, index_sta, index_len,
     $        itaus_tmp)
C
         DO it=1,ttm
            itaus(it) = NINT(itaus_tmp(it))
         ENDDO
C
C     Getting all the details for the time axis
C         
         iret = NF_GET_ATT_REAL(fid, NF_GLOBAL, 'delta_tstep_sec', dt)
         iret = NF_GET_ATT_REAL(fid, NF_GLOBAL, 'day0', r_day)
         iret = NF_GET_ATT_REAL(fid, NF_GLOBAL, 'sec0', sec)
         iret = NF_GET_ATT_REAL(fid, NF_GLOBAL, 'year0', r_year)
         iret = NF_GET_ATT_REAL(fid, NF_GLOBAL, 'month0', r_month)

         day = INT(r_day)
         month = INT(r_month)
         year = INT(r_year)
C
         CALL ymds2ju(year, month, day, sec, date0)
C
      ENDIF
C
      RETURN

      END
C
      SUBROUTINE flinput(fid, varname, iim, nlonid, jjm, nlatid, 
     $     llm, zdimid, ttm, tdimid, var)
C
      IMPLICIT NONE
C
C     This variable will put a variable on the netCDF file created by flincr. 
C     If the sizes of the axis do not match the one of the IDs then a new
C     axis is created. That is we loose the possibility of writting hyperslabs
C     of data. 
C     Again here if iim = jjm = llm = ttm = 0 then a global attribute is
C     added to the file.
C
C     INPUT
C
C     fid      : Identification of the file in which we will write
C     varname  : Name of variable to be written
C     iim      : size in x of variable
C     nlonid   : ID of x axis which could fit for this axis
C     jjm      : size in y of variable
C     nlatid   : ID of y axis which could fit for this axis
C     llm      : size in z of variable
C     zdimid   : ID of z axis which could fit for this axis
C     ttm      : size in t of variable
C     tdimid   : ID of t axis which could fit for this axis
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/flinput.F,v 1.6 1998/02/13 18:11:13 polcher Exp $
C
C
C     OUTPUT
C
C     NONE
C
      INTEGER fid
      CHARACTER*(*) varname
      INTEGER iim, nlonid, jjm, nlatid, llm, zdimid, ttm, tdimid
      REAL var(iim,jjm,llm,ttm)
C
C
C
C     LOCAL
C
#include "netcdf.inc"
C
      INTEGER ndim, dims(4), len, iret
      INTEGER ncvarid
      INTEGER corner(4), edges(4)
C
      INTEGER lnblnk
      EXTERNAL lnblnk
C
      iret = NF_REDEF(fid)
C
      IF (iim + jjm + llm .GT. 0 ) THEN

         corner(1) = 1
         corner(2) = 1
         corner(3) = 1
         corner(4) = 1

         IF ( llm .GT. 0) THEN

            ndim = 3
            dims(1) = nlonid
            dims(2) = nlatid
            dims(3) = zdimid

            edges(1) = iim
            edges(2) = jjm
            edges(3) = llm

            IF ( ttm .GT. 0) THEN
               ndim = 4
               dims(4) = tdimid
               edges(4) = ttm
            ENDIF

         ELSE

            ndim = 2
            dims(1) = nlonid
            dims(2) = nlatid

            edges(1) = iim
            edges(2) = jjm

            IF ( ttm .GT. 0) THEN
               ndim = 3
               dims(3) = tdimid
               edges(3) = ttm
            ENDIF

         ENDIF
C
         iret = NF_DEF_VAR(fid, varname, NF_FLOAT, ndim, dims,ncvarid)
C
         len = lnblnk(varname)
         
         iret = NF_PUT_ATT_TEXT(fid, ncvarid,'short_name', len, varname)
C
         iret = NF_ENDDEF(fid)
C
         iret = NF_PUT_VARA_REAL(fid, ncvarid, corner, edges, var)
C
      ELSE

         iret = NF_PUT_ATT_REAL(fid, NF_GLOBAL, varname,
     $        NF_FLOAT, 1, var)

         iret = NF_ENDDEF(fid)

      ENDIF
C
C
      RETURN
C
      END
C
      SUBROUTINE getinc(target, nb_to_ret, ret_val)
C
      IMPLICIT NONE
C
C  Subroutine that will extract from the file the values 
C  attributed to the keyword target
C
C                REALS
C                --------
C
C        target    : in  : CHARACTER*(*)      target for which we will
C                                             look in the file
C        nb_to_ret : in  : INTEGER            number of values to be expected
C        ret_val   : out : CHARACTER(nb_to_ret) values read
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/getinc.F,v 1.7 1998/03/19 18:40:38 polcher Exp $
C
C
C
      CHARACTER*(*) target
      INTEGER nb_to_ret
      CHARACTER*(*) ret_val(nb_to_ret)
C
#include "getincom.h"
C
      INTEGER nbretmax, nb_read
      PARAMETER (nbretmax=100)
      LOGICAL found(nbretmax)
C
      INTEGER nbch
      INTEGER i
      INTEGER ind_col
      CHARACTER*80 str_tmp, str_read, str_tmp2
      CHARACTER*10 fmt
C
      INTEGER lnblnk, findpos, cntpos
      EXTERNAL lnblnk, findpos, cntpos
C
      CALL getinread
C
      nb_read = 0
      nbch  = len(target)
C
      IF ( nb_to_ret .GT. nbretmax) THEN
         WRITE(*,*) 'ERROR you are asking for too many variables'
         WRITE(*,*) 'Please increase nbretmax in getinc'
         WRITE(*,*) target
         STOP      
      ENDIF
      DO i=1,nb_to_ret
         found(i) = .FALSE.
      ENDDO
C
      DO i=1,nb_lines
C
         str_tmp=fichier(i)
C
         IF ( index(str_tmp, target(1:nbch)) .EQ. 1 .AND.
     $        (str_tmp(nbch+1:nbch+1) .EQ. ' ' .OR.
     $         str_tmp(nbch+1:nbch+2) .EQ. '__')) THEN
C
C     Check if it is vector Keyword
C
            ind_col = index(str_tmp(1:p_egal(i)),'__')
            IF ( ind_col .GT. 0) THEN
               IF ( nb_to_ret .GT. 1) THEN
                  WRITE(fmt,'("(I",I7.7,")")') p_egal(i)-ind_col-3
                  READ(str_tmp(ind_col+2:p_egal(i)-1),fmt) nb_read
               ELSE
                  WRITE(*,*) "ERROR : getinc : TARGET ", 
     $                 target(1:nbch)
                  WRITE(*,*) "This Key is for a vector but only
     $                 a scalar value is requested "
                  STOP
               ENDIF
            ELSE
               nb_read = 1
            ENDIF
C
C     Should we expect a vector ?
C
            IF ( nb_to_ret .GT. 1 .AND. ind_col .EQ. 0) THEN
                  WRITE(*,*) "ERROR : getinc : TARGET = ",
     $                 target(1:nbch)
                  WRITE(*,*) "A vector is expected but only a scalar
     $                 Key exists", nb_to_ret
                  STOP
            ENDIF
C
C     Would that vector element fit into the array provided ?
C
            IF (nb_read .GT. nb_to_ret) THEN
               WRITE(*,*) "ERROR : getinc : TARGET", 
     $              target(1:nbch)
               WRITE(*,*) "For this Key there are more values in the
     $              run.def than expacted by the program" 
                  STOP
            ENDIF
C
C     Let's decode it now !
C
            str_read = str_tmp(p_egal(i)+2:lnblnk(str_tmp))
            CALL delblank(str_read)
            IF ( index(str_read,'def') .LE. 0 .AND.
     $           index(str_read,'Def') .LE. 0) THEN
C
               found(nb_read) = .TRUE.
               str_read = str_tmp(p_egal(i)+2:lnblnk(str_tmp))
C
C     Take out the quotes if needed
C
               IF (index(str_read,'"') .GT. 0 .OR.
     $              index(str_read,"'") .GT. 0) THEN
                  str_tmp2 = str_read(2:lnblnk(str_read)-1)
                  str_read = str_tmp2
               ENDIF
C
               ret_val(nb_read) = str_read(:lnblnk(str_read))
C
            ENDIF
C
         ENDIF
C
      ENDDO
C
C     Finaly do we have all we need ? 
C
      DO i=1,nb_to_ret 
         IF ( .NOT. found(i)) THEN
            IF ( nb_to_ret .GT. 1) THEN
               WRITE(str_tmp,'(a,"__",I3.3)')
     $              target(1:nbch), i
            ELSE
               str_tmp = target(1:nbch)
            ENDIF
            WRITE(*,*) 'USING DEFAULTS : ',
     $           str_tmp(1:lnblnk(str_tmp)),'=',ret_val(i)
         ENDIF
      ENDDO
C
      RETURN
C
      END
C
      SUBROUTINE getini(target, nb_to_ret, ret_val)
C
      IMPLICIT NONE
C
C  Subroutine that will extract from the file the values 
C  attributed to the keyword target
C
C                INTEGER
C                --------
C
C        target    : in  : CHARACTER*(*)      target for which we will
C                                             look in the file
C        nb_to_ret : in  : INTEGER            number of values to be expected
C        ret_val   : out : INTEGER(nb_to_ret) values read
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/getini.F,v 1.6 1998/03/19 18:40:38 polcher Exp $
C
C
C
      CHARACTER*(*) target
      INTEGER nb_to_ret
      INTEGER ret_val(nb_to_ret)
C
#include "getincom.h"
C
      INTEGER nbretmax, nb_read
      PARAMETER (nbretmax=100)
      LOGICAL found(nbretmax)
C
      INTEGER nbch
      INTEGER i, len_str
      INTEGER ind_col
      CHARACTER*3 chlen
      CHARACTER*10 fmt
      CHARACTER*80 str_tmp, str_read
C
      INTEGER lnblnk, findpos, cntpos
      EXTERNAL lnblnk, findpos, cntpos
C
      CALL getinread
C
      nb_read = 0
      nbch  = len(target)
C
      IF ( nb_to_ret .GT. nbretmax) THEN
         WRITE(*,*) 'ERROR you are asking for too many variables'
         WRITE(*,*) 'Please increase nbretmax in getini'
         WRITE(*,*) target
         STOP      
      ENDIF
      DO i=1,nb_to_ret
         found(i) = .FALSE.
      ENDDO
C
      DO i=1,nb_lines
C
         str_tmp=fichier(i)
C
         IF ( index(str_tmp, target(1:nbch)) .EQ. 1 .AND.
     $        (str_tmp(nbch+1:nbch+1) .EQ. ' ' .OR.
     $         str_tmp(nbch+1:nbch+2) .EQ. '__')) THEN
C
C     Check if it is vector Keyword
C
            ind_col = index(str_tmp(1:p_egal(i)),'__')
            IF ( ind_col .GT. 0) THEN
               IF ( nb_to_ret .GT. 1) THEN
                  WRITE(fmt,'("(I",I7.7,")")') p_egal(i)-ind_col-3
                  READ(str_tmp(ind_col+2:p_egal(i)-1),fmt) nb_read
               ELSE
                  WRITE(*,*) "ERROR : getini : TARGET ", 
     $                 target(1:nbch)
                  WRITE(*,*) "This Key is for a vector but only
     $                 a scalar value is requested "
                  STOP
               ENDIF
            ELSE
               nb_read = 1
            ENDIF
C
C     Should we expect a vector ?
C
            IF ( nb_to_ret .GT. 1 .AND. ind_col .EQ. 0) THEN
                  WRITE(*,*) "ERROR : getini : TARGET = ",
     $                 target(1:nbch)
                  WRITE(*,*) "A vector is expected but only a scalar
     $                 Key exists", nb_to_ret
                  STOP
            ENDIF
C
C     Would that vector element fit into the array provided ?
C
            IF (nb_read .GT. nb_to_ret) THEN
               WRITE(*,*) "ERROR : getini : TARGET", 
     $              target(1:nbch)
               WRITE(*,*) "For this Key there are more values in the
     $              run.def than expacted by the program" 
                  STOP
            ENDIF
C
C     Let's decode it now !
C

            str_read = str_tmp(p_egal(i)+2:lnblnk(str_tmp))
            CALL delblank(str_read)
            IF ( index(str_read,'Def') .LE. 0 .AND.
     $           index(str_read,'def') .LE. 0) THEN
C
               found(nb_read) = .TRUE.
C     
               len_str = lnblnk(str_read)
               WRITE(chlen,'(I3.3)') len_str
               fmt = '(I'//chlen//')'
               READ(str_read,fmt) ret_val(nb_read)
C     
            ENDIF
C
         ENDIF
C     
      ENDDO
C     
C     Finaly do we have all we need ? 
C     
      DO i=1,nb_to_ret 
         IF ( .NOT. found(i)) THEN
            IF ( nb_to_ret .GT. 1) THEN
               WRITE(str_tmp,'(a,"__",I3.3)')
     $              target(1:nbch), i
            ELSE
               str_tmp = target(1:nbch)
            ENDIF
            WRITE(*,*) 'USING DEFAULTS : ',
     $           str_tmp(1:lnblnk(str_tmp)),'=',ret_val(i)
         ENDIF
      ENDDO
C     
      RETURN
C
      END
C
      SUBROUTINE getinl(target, nb_to_ret, ret_val)
C
      IMPLICIT NONE
C
C  Subroutine that will extract from the file the values 
C  attributed to the keyword target
C
C                LOGICAL
C                --------
C
C        target    : in  : CHARACTER*(*)      target for which we will
C                                             look in the file
C        nb_to_ret : in  : INTEGER            number of values to be expected
C        ret_val   : out : INTEGER(nb_to_ret) values read
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/getinl.F,v 1.6 1998/03/19 18:40:39 polcher Exp $
C
C
C
      CHARACTER*(*) target
      INTEGER nb_to_ret
      LOGICAL ret_val(nb_to_ret)
C
#include "getincom.h"
C
      INTEGER nbretmax, nb_read
      PARAMETER (nbretmax=100)
      LOGICAL found(nbretmax)
C
      INTEGER nbch
      INTEGER i, ipos_tr, ipos_fl, len_str
      INTEGER ind_col
      CHARACTER*80 str_tmp, str_read
      CHARACTER*10 fmt
C
      INTEGER lnblnk, cntpos
      EXTERNAL lnblnk, cntpos
C
      CALL getinread
C
      nb_read = 0
      nbch  = len(target)
C
      IF ( nb_to_ret .GT. nbretmax) THEN
         WRITE(*,*) 'ERROR you are asking for too many variables'
         WRITE(*,*) 'Please increase nbretmax in getinl'
         WRITE(*,*) target
         STOP      
      ENDIF
      DO i=1,nb_to_ret
         found(i) = .FALSE.
      ENDDO
C
      DO i=1,nb_lines
C
         str_tmp=fichier(i)
C
         IF ( index(str_tmp, target(1:nbch)) .EQ. 1 .AND.
     $        (str_tmp(nbch+1:nbch+1) .EQ. ' ' .OR.
     $         str_tmp(nbch+1:nbch+2) .EQ. '__')) THEN
C
C     Check if it is vector Keyword
C
            ind_col = index(str_tmp(1:p_egal(i)),'__')
            IF ( ind_col .GT. 0) THEN
               IF ( nb_to_ret .GT. 1) THEN
                  WRITE(fmt,'("(I",I7.7,")")') p_egal(i)-ind_col-3
                  READ(str_tmp(ind_col+2:p_egal(i)-1),fmt) nb_read
               ELSE
                  WRITE(*,*) "ERROR : getinl : TARGET ", 
     $                 target(1:nbch)
                  WRITE(*,*) "This Key is for a vector but only
     $                 a scalar value is requested "
                  STOP
               ENDIF
            ELSE
               nb_read = 1
            ENDIF
C
C     Should we expect a vector ?
C
            IF ( nb_to_ret .GT. 1 .AND. ind_col .EQ. 0) THEN
                  WRITE(*,*) "ERROR : getinl : TARGET = ",
     $                 target(1:nbch)
                  WRITE(*,*) "A vector is expected but only a scalar
     $                 Key exists", nb_to_ret
                  STOP
            ENDIF
C
C     Would that vector element fit into the array provided ?
C
            IF (nb_read .GT. nb_to_ret) THEN
               WRITE(*,*) "ERROR : getinl : TARGET", 
     $              target(1:nbch)
               WRITE(*,*) "For this Key there are more values in the
     $              run.def than expacted by the program" 
                  STOP
            ENDIF
C
C     Let's decode it now !
C
            str_read = str_tmp(p_egal(i)+2:lnblnk(str_tmp))
            CALL delblank(str_read)
            IF ( index(str_read,'Def') .LE. 0 .AND.
     $           index(str_read,'def') .LE. 0) THEN
C
               found(nb_read) = .TRUE.
C     
               len_str = lnblnk(str_read)
               
               ipos_tr = -1
               ipos_fl = -1
               
               ipos_tr = max(index(str_read,'tru'),
     $              index(str_read,'TRU'), index(str_read,'y'),
     $              index(str_read,'Y'))
               ipos_fl = max(index(str_read,'fal'),
     $              index(str_read,'FAL'), index(str_read,'n'),
     $              index(str_read,'N'))
C     
               IF (ipos_tr .GT. 0 ) THEN
                  ret_val(nb_read) = .TRUE.
               ELSE IF (ipos_fl .GT. 0 ) THEN
                  ret_val(nb_read) = .FALSE.
               ELSE
                  WRITE(*,*) "ERROR : getinl : TARGET ", 
     $                 target(1:nbch), " is not of logical value"
                  STOP
               ENDIF
C
            ENDIF
C     
         ENDIF
C
      ENDDO
C
C     Finaly do we have all we need ? 
C
      DO i=1,nb_to_ret 
         IF ( .NOT. found(i)) THEN
            IF ( nb_to_ret .GT. 1) THEN
               WRITE(str_tmp,'(a,"__",I3.3)')
     $              target(1:nbch), i
            ELSE
               str_tmp = target(1:nbch)
            ENDIF
            WRITE(*,*) 'USING DEFAULTS : ',
     $           str_tmp(1:lnblnk(str_tmp)),'=',ret_val(i)
         ENDIF
      ENDDO
C
      RETURN
C
      END
C
      SUBROUTINE getinr(target, nb_to_ret, ret_val)
C
      IMPLICIT NONE
C
C  Subroutine that will extract from the file the values 
C  attributed to the keyword target
C
C                REALS
C                --------
C
C        target    : in  : CHARACTER*(*)      target for which we will
C                                             look in the file
C        nb_to_ret : in  : INTEGER            number of values to be expected
C        ret_val   : out : INTEGER(nb_to_ret) values read
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/getinr.F,v 1.6 1998/03/19 18:40:40 polcher Exp $
C
C
C
      CHARACTER*(*) target
      INTEGER nb_to_ret
      REAL ret_val(nb_to_ret)
C
#include "getincom.h"
C
      INTEGER nbretmax, nb_read
      PARAMETER (nbretmax=100)
      LOGICAL found(nbretmax)
C
      INTEGER nbch
      INTEGER i, ppos, epos, len_str, int_tmp
      INTEGER ind_col
      CHARACTER*3 tl,dl
      CHARACTER*80 str_tmp, str_read
      CHARACTER*10 fmt
C
      INTEGER lnblnk, findpos, cntpos
      EXTERNAL lnblnk, findpos, cntpos
C
      CALL getinread
C
      nb_read = 0
      nbch  = len(target)
C
      IF ( nb_to_ret .GT. nbretmax) THEN
         WRITE(*,*) 'ERROR you are asking for too many variables'
         WRITE(*,*) 'Please increase nbretmax in getinr'
         WRITE(*,*) target
         STOP      
      ENDIF
      DO i=1,nb_to_ret
         found(i) = .FALSE.
      ENDDO
C
      DO i=1,nb_lines
C
         str_tmp=fichier(i)
C
         IF ( index(str_tmp, target(1:nbch)) .EQ. 1 .AND.
     $        (str_tmp(nbch+1:nbch+1) .EQ. ' ' .OR.
     $         str_tmp(nbch+1:nbch+2) .EQ. '__')) THEN
C
C     Check if it is vector Keyword
C
            ind_col = index(str_tmp(1:p_egal(i)),'__')
            IF ( ind_col .GT. 0) THEN
               IF ( nb_to_ret .GT. 1) THEN
                  WRITE(fmt,'("(I",I7.7,")")') p_egal(i)-ind_col-3
                  READ(str_tmp(ind_col+2:p_egal(i)-1),fmt) nb_read
               ELSE
                  WRITE(*,*) "ERROR : getinr : TARGET ", 
     $                 target(1:nbch)
                  WRITE(*,*) "This Key is for a vector but only
     $                 a scalar value is requested "
                  STOP
               ENDIF
            ELSE
               nb_read = 1
            ENDIF
C
C     Should we expect a vector ?
C
            IF ( nb_to_ret .GT. 1 .AND. ind_col .EQ. 0) THEN
                  WRITE(*,*) "ERROR : getinr : TARGET = ",
     $                 target(1:nbch)
                  WRITE(*,*) "A vector is expected but only a scalar
     $                 Key exists", nb_to_ret
                  STOP
            ENDIF
C
C     Would that vector element fit into the array provided ?
C
            IF (nb_read .GT. nb_to_ret) THEN
               WRITE(*,*) "ERROR : getinr : TARGET", 
     $              target(1:nbch)
               WRITE(*,*) "For this Key there are more values in the
     $              run.def than expacted by the program" 
                  STOP
            ENDIF
C
C     Let's decode it now if it is not the default value !
C
            str_read = str_tmp(p_egal(i)+2:lnblnk(str_tmp))
            CALL delblank(str_read)
            IF ( index(str_read,'Def') .LE. 0 .AND.
     $           index(str_read,'def') .LE. 0) THEN
C
               found(nb_read) = .TRUE.
C
               len_str = lnblnk(str_read)
               epos = findpos(str_read,len_str,'e',1)
               ppos = findpos(str_read,len_str,'.',1)
               
               IF (epos .GT. 0) THEN
                  WRITE(tl,'(I3.3)') len_str
                  WRITE(dl,'(I3.3)') epos-ppos-1
                  fmt='(e'//tl//'.'//dl//')'
                  READ(str_read,fmt) ret_val(nb_read)
               ELSE IF (ppos .GT. 0) THEN
                  WRITE(tl,'(I3.3)') len_str
                  WRITE(dl,'(I3.3)') len_str-ppos
                  fmt='(f'//tl//'.'//dl//')'
                  READ(str_read,fmt) ret_val(nb_read)
               ELSE
                  WRITE(tl,'(I3.3)') len_str
                  fmt = '(I'//tl//')'
                  READ(str_read,fmt) int_tmp
                  ret_val(nb_read) = float(int_tmp)
               ENDIF
C
            ENDIF
C
         ENDIF
C
      ENDDO
C
C     Finaly do we have all we need ? 
C
      DO i=1,nb_to_ret 
         IF ( .NOT. found(i)) THEN
            IF ( nb_to_ret .GT. 1) THEN
               WRITE(str_tmp,'(a,"__",I3.3)')
     $              target(1:nbch), i
            ELSE
               str_tmp = target(1:nbch)
            ENDIF
            WRITE(*,*) 'USING DEFAULTS : ',
     $           str_tmp(1:lnblnk(str_tmp)),'=',ret_val(i)
         ENDIF
      ENDDO
C
      RETURN
C
      END

      SUBROUTINE getinread
C
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/getinread.F,v 1.4 1998/01/30 10:07:08 polcher Exp $
C
      IMPLICIT NONE
C
#include "getincom.h"
C
      INTEGER allread
C
      DATA allread/0/
C
      SAVE allread
C
      IF (allread .EQ. 0) THEN

         CALL readdef (max_lines, fichier, p_egal, nb_lines) 
         allread = 1

      ENDIF
C
      RETURN

      END
C
      SUBROUTINE histbeg(pfilename, pim, plon, pjm, plat,
     $     par_orix, par_szx, par_oriy, par_szy, 
     $     pitau0, pdate0, pdeltat, phoriid, pfileid)
C
      IMPLICIT NONE
C
C      This subroutine initializes a netcdf file and returns the ID.
C      It will set up the geographical space on which the data will be
C      stored and offers the possibility of seting a zoom.
C      It also gets the global parameters into the I/O subsystem.
C
C
C      INPUT
C
C          pfilename : Name of the netcdf file to be created
C          pim       : Size of arrays in longitude direction
C          plon      : Coordinates of points in longitude
C          pjm       : Size of arrays in latitude direction
C          plat      : Coordinates of points in latitude
C
C                      The next 4 arguments allow to define a horizontal
C                      zoom for this file. It is assumed that all variables
C                      to come have the same index space. This can not be
C                      assumed for the z axis and thus we define the zoom
C                      in histdef.
C
C          par_orix  : Origin of the slab of data within the X axis (pim)
C          par_szx   : Size of the slab of data in X
C          par_orix  : Origin of the slab of data within the Y axis (pjm)
C          par_szx   : Size of the slab of data in Y
C
C          pitau0    : time step at which the history tape starts
C          pdate0    : The Julian date at which the itau was equal to 0
C          pdeltat   : Time step in seconds. Time step of the counter itau
C                      used in histwrt for instance
C
C     OUTPUT
C
C          phoriid   : ID of the horizontal grid
C          pfileid   : ID of the netcdf file
C
C
C     TO DO
C
C          This package should be written in F90 and use the following 
C          feature :
C               - structures for the meta-data of the files and variables
C               - memory allocation as needed
C               - Pointers
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/histbeg.F,v 1.7 1998/03/19 18:40:40 polcher Exp $
C
C     ARGUMENTS
C
      CHARACTER*(*) pfilename

      INTEGER pim,pjm
      INTEGER par_orix, par_szx, par_oriy, par_szy 
      REAL plon(pim), plat(pjm)

      INTEGER pitau0, phoriid, pfileid
      REAL pdate0, pdeltat
C
#include "histcom.h"
C
CMAF to be in blockdata
CMAF      DATA nb_files /0/
C
C     LOCAL
C
#include "netcdf.inc"
C
      INTEGER ncid, iret, ndim
      INTEGER dims(4)
      INTEGER len
      INTEGER nlonid, nlatid
      INTEGER corner(4), edges(4)
      CHARACTER*120 file, tfile
c
      REAL x(pim), y(pjm)
C
      LOGICAL check
C     
      INTEGER lnblnk
      EXTERNAL lnblnk
C
      check = .FALSE.
C
      nb_files = nb_files + 1
      pfileid = nb_files
C
C     1.0 Transfering into the common for future use
C
      IF (check) WRITE(*,*) "histbeg 1.0"
C
      itau0(pfileid) = pitau0
      date0(pfileid) = pdate0
      deltat(pfileid) = pdeltat
C
C     2.0 Initializes all variables for this file
C
      IF (check) WRITE(*,*) "histbeg 2.0"
C
      IF (nb_files .GT. nb_files_max) THEN
         CALL histerr (3, "histbeg",
     &   'Table of files too small. You should increase nb_files_max',
     &   'in histcom.h in order to accomodate all these files', ' ')
      ENDIF
C
      nb_var(pfileid) = 0
      nb_tax(pfileid) = 0
      buff_pos(pfileid) = 0
      nb_hax(pfileid) = 0
      nb_zax(pfileid) = 0
C
      slab_ori(pfileid,1) = par_orix
      slab_ori(pfileid,2) = par_oriy
      slab_sz(pfileid,1) = par_szx
      slab_sz(pfileid,2) = par_szy
C
C     3.0 Opening netcdf file and defining dimensions
C
      IF (check) WRITE(*,*) "histbeg 3.0"
C
      tfile = pfilename
      len = lnblnk(tfile)
      IF ( tfile(len-2:len) .NE. '.nc') THEN
         file=tfile(1:len)//'.nc'
      ELSE
         file=tfile(1:len)
      ENDIF
C
      iret = NF_CREATE(file, NF_CLOBBER, ncid)
C
      iret = NF_DEF_DIM(ncid, 'x', par_szx, xid(nb_files))
      iret = NF_DEF_DIM(ncid, 'y', par_szy, yid(nb_files))
C
C     4.0 Declaring the geographical coordinates and other attributes
C
      IF (check) WRITE(*,*) "histbeg 4.0"
C
C     4.3 Global attributes
C     
      len=lnblnk(file)
      iret = NF_PUT_ATT_TEXT(ncid, NF_GLOBAL, 'file_name', len, file)
      iret = NF_PUT_ATT_TEXT(ncid, NF_GLOBAL, 'model_name',
     $     13, 'An IPSL model')
C
C     5.0 Saving some important information on this file in the common
C
      IF (check) WRITE(*,*) "histbeg 6.0"
C
      ncdf_ids(pfileid) = ncid
      full_size(pfileid,1) = pim
      full_size(pfileid,2) = pjm
C
C     6.0 storing the geographical coordinates
C
      CALL histhori(pfileid,plon,pim,plat,pjm,phoriid)
C
      END







C
      SUBROUTINE histclo
C
C     This subroutine will close all openend files.
C
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/histclo.F,v 1.8 1998/03/19 18:40:41 polcher Exp $
C
#include "histcom.h"
C
C     LOCAL
C
      LOGICAL check
C
#include "netcdf.inc"
C
      INTEGER if, ncid, iret, iv, ncvarid
C
      check = .FALSE.
C
      IF ( check ) WRITE(*,*) 'Entering loop on files :', nb_files 
C
      DO if=1, nb_files
C
         ncid = ncdf_ids(if)
C
         iret = NF_REDEF(ncid)
C
C    1.   The loop on the number of variables to add some final information
C
         IF ( check ) WRITE(*,*) 'Entering loop on vars :', nb_var(if) 
C
         DO iv = 1, nb_var(if)
C
            ncvarid = ncvar_ids(if,iv)
C
C     1.1 Put the min and max values on the file
C
#ifdef NC_REAL
            iret = NF_PUT_ATT_REAL(ncid, ncvarid, 'valid_min',
     $           NF_FLOAT, 1, minmax(if,iv,1))
            iret = NF_PUT_ATT_REAL(ncid, ncvarid, 'valid_max',
     $           NF_FLOAT, 1, minmax(if,iv,2))
#elif defined NC_DOUBLE
            iret = NF_PUT_ATT_DOUBLE(ncid, ncvarid, 'valid_min',
     $           NF_FLOAT, 1, minmax(if,iv,1))
            iret = NF_PUT_ATT_DOUBLE(ncid, ncvarid, 'valid_max',
     $           NF_FLOAT, 1, minmax(if,iv,2))
#else
FORCED COMPILER ERROR, PLEASE ADD A COMPILER OPTION (i.e. NC_REAL)
#endif
C     
         ENDDO
C
         IF ( check ) WRITE(*,*) 'close file :', ncid
C
         iret = NF_CLOSE(ncid)
C
      ENDDO
C
      END


      SUBROUTINE histdef(pfileid, pvarname, ptitle, punit,
     $     pxsize, pysize, phoriid, pzsize, par_oriz, par_szz, pzid,
     $     pnbbyt, popp, pfreq_opp, pfreq_wrt)
C
      IMPLICIT NONE
C
C     With this subroutine each variable to be archived on the history 
C     tape should be decalred. 
C
C     It gives the user the choise of operation 
C     to be performed on the variables, the frequency of this operation 
C     and finaly the frequency of the archiving.
C
C     INPUT
C
C          pfileid  : ID of the file the variable should be archived in 
C          pvarname : Name of the variable, short and easy to remember
C          ptitle   : Full name of the variable
C          punit    : Units of the variable
C
C                     The next 3 arguments give the size of that data
C                     that will be passed to histwrite. The zoom will be 
C                     done there with the horizontal information obtained 
C                     in histbeg and the vertical information to follow.
C          pxsize   : Size in X direction (size of the data that will be 
C                     given to histwrite)
C          pysize   : Size in Y direction
C          phoriid  : ID of the horizontal axis
C
C                     The next two arguments give the vertical zoom to use.
C
C          pzsize   : Size in Z direction (If 1 then no axis is declared 
C                     for this variable and pzid is not used)
C          par_oriz : Off set of the zoom
C          par_szz  : Size of the zoom
C          
C          pzid     : ID of the vertical axis to use. It has to have 
C                     the size of the zoom.
C          pnbbyt   : Number of bytes on which to store in netCDF (Not opp.)
C          popp     : Operation to be performed. The following options
C                     exist today :
C                     inst : keeps instantaneous values for writting
C                     ave  : Computes the average from call between writes
C          pfreq_opp: Frequency of this operation (in seconds)
C          pfreq_wrt: Frequency at which the variable should be 
C                    written (in seconds)
C
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/histdef.F,v 1.9 1998/03/23 17:53:08 polcher Exp $
C
C
C     ARGUMENTS
C
      INTEGER pfileid, pxsize, pysize, pzsize, pzid
      INTEGER par_oriz, par_szz, pnbbyt, phoriid
      CHARACTER*(*) pvarname, punit, popp 
      CHARACTER*(*) ptitle
      REAL pfreq_opp, pfreq_wrt
C
#include "histcom.h"
C
C     LOCAL
C
      INTEGER iv, i, nb
      CHARACTER*70 str70, str71, str72
      CHARACTER*20 tmp_name
      CHARACTER*20 str20, tab_str20(nb_var_max)
      CHARACTER*40 str40, tab_str40(nb_var_max)
      CHARACTER*10 str10
      CHARACTER*80 tmp_str80
      CHARACTER*7 tmp_topp, tmp_sopp(nbopp_max)
      CHARACTER*120 ex_topps
      REAL tmp_scal(nbopp_max)
      INTEGER pos, buff_sz, full_sz
C
      LOGICAL check
C
      INTEGER lnblnk
      EXTERNAL lnblnk
C
      check = .FALSE.
      ex_topps = 'ave, inst, t_min, t_max, once'
C
      nb_var(pfileid) = nb_var(pfileid) + 1
      iv = nb_var(pfileid)
C
      IF ( iv .GT. nb_var_max) THEN
         CALL histerr (3, "histdef",
     &   'Table of variables too small. You should increase nb_var_max',
     &   'in histcom.h in order to accomodate all these variables', ' ')
      ENDIF
C
C     1.0 Transfer informations on the variable to the common
C         and verify that it does not already exist
C
      IF (check) WRITE(*,*) "histdef : 1.0"
C
      IF ( iv .GT. 1) THEN
         str20 = pvarname
         nb = iv-1
         DO i=1,nb
            tab_str20(i) = name(pfileid,i)
         ENDDO
         CALL find_str (nb, tab_str20, str20, pos)
      ELSE
         pos = 0
      ENDIF
C
      IF ( pos .GT. 0) THEN
         str70 = "Variable already exists"
         WRITE(str71,'("Check variable  ", a, " in file", I3)') 
     &         str20, pfileid
         str72 = "Can also be a wrong file ID in another declaration"
C
         CALL histerr(3,"histdef", str70, str71, str72)
      ENDIF
C
      name(pfileid,iv) = pvarname
      title(pfileid,iv) = ptitle
      unit(pfileid,iv) = punit
      tmp_name =  name(pfileid,iv)
C
C     1.1 decode the operations
C
      fullop(pfileid,iv) = popp
      tmp_str80 = popp
      CALL buildop(tmp_str80, ex_topps, tmp_topp, nbopp_max,
     $     missing_val, tmp_sopp, tmp_scal, nbopp(pfileid,iv))
C
      topp(pfileid,iv) = tmp_topp
      DO i=1,nbopp(pfileid,iv)
         sopps(pfileid,iv,i) = tmp_sopp(i)
         scal(pfileid,iv,i) = tmp_scal(i)
      ENDDO
C
C     1.2 If we have an even number of operations then we need to add 
C         identity
C
      IF ( 2*INT(nbopp(pfileid,iv)/2.0) .EQ. nbopp(pfileid,iv)) THEN
         nbopp(pfileid,iv) = nbopp(pfileid,iv) + 1
         sopps(pfileid,iv,nbopp(pfileid,iv)) = 'ident'
         scal(pfileid,iv,nbopp(pfileid,iv)) = missing_val
      ENDIF
C
C     2.0 Put the size of the variable in the common and check
C
      IF (check) WRITE(*,*) "histdef : 2.0"
C
      size(pfileid,iv,1) = pxsize
      size(pfileid,iv,2) = pysize
      size(pfileid,iv,3) = pzsize
C
      zorig(pfileid,iv,1) = slab_ori(pfileid,1)
      zorig(pfileid,iv,2) = slab_ori(pfileid,2)
      zorig(pfileid,iv,3) = par_oriz
C
      zsize(pfileid,iv,1) = slab_sz(pfileid,1)
      zsize(pfileid,iv,2) = slab_sz(pfileid,2)
      zsize(pfileid,iv,3) = par_szz
C
C     Is the size of the full array the same as that of the coordinates  ?
C
      IF ( pxsize .NE. full_size(pfileid,1) .OR.
     &     pysize .NE. full_size(pfileid,2)) THEN

          str70 = "The size of the variable is different from the "//
     $        "one of the coordinates "
          WRITE(str71,'("Size of coordinates :", 2I4)')
     $         full_size(pfileid,1), full_size(pfileid,2)
          WRITE(str72,'("Size decalred for variable ",a," :",2I4)')
     $         tmp_name(:lnblnk(tmp_name)), pxsize, pysize
          CALL histerr(3,"histdef", str70, str71, str72)
      ENDIF
C
C     Is the size of the zoom smaler than the coordinates ?
C
      IF ( pxsize .LT. slab_sz(pfileid,1) .OR.
     &     pysize .LT. slab_sz(pfileid,2) ) THEN
C
         str70 = "Size of variable should be greater or equal to"//
     &           "those of the zoom"
         WRITE(str71,'("Size of XY zoom :", 2I4)') 
     &         slab_sz(pfileid,1),slab_sz(pfileid,1)
         WRITE(str72,'("Size decalred for variable ",a," :",2I4)')
     &     tmp_name(:lnblnk(tmp_name)), pxsize, pysize
C
         CALL histerr(3,"histdef", str70, str71, str72)
C
      ENDIF
C
C     2.1 We store the horizontal grid information with minimal
C         and a fall back onto the default grid
C
      IF ( phoriid .GT. 0 .AND. phoriid .LE. nb_hax(pfileid)) THEN
         var_haxid(pfileid,iv) = phoriid
      ELSE
         var_haxid(pfileid,iv) = 1
         CALL histerr(2,"histdef",
     $        'We use the default grid for variable as an invalide',
     $        'ID was provided for variable : ',
     $        pvarname)
      ENDIF
C
C     2.2 Check the vertical coordinates if needed
C
      IF ( par_szz .GT. 1) THEN
C
C     Does the vertical coordinate exist ?
C
         IF ( pzid .GT. nb_zax(pfileid)) THEN
C
            WRITE(str70,'("The vertical coordinate chosen for",
     $           " variable ",a)') tmp_name(:lnblnk(tmp_name))
            str71 = " Does not exist."
C
            CALL histerr(3,"histdef", str70, str71, " ")
C 
         ENDIF
C
C     Is the vertical size of the variable equal to that of the axis ? 
C
         IF ( par_szz .NE. zax_size(pfileid,pzid)) THEN

            str20 = zax_name(pfileid,pzid)
            str70 = "The size of the zoom does not correspond to the "//
     $           "size of the chosen vertical axis"       
            WRITE(str71,'("Size of zoom in z :", I4)') par_szz
            WRITE(str72,'("Size declared for axis ",a," :",I4)')
     $           str20(:lnblnk(str20)), zax_size(pfileid,pzid)
C
            CALL histerr(3,"histdef", str70, str71, str72)
C
         ENDIF
C     
C     Is the zoom smaler that the total size of the variable ?
C
         IF ( pzsize .LT. par_szz ) THEN
C     
            str20 = zax_name(pfileid,pzid)
            str70 = "The vertical size of variable is smaller than "//
     $           " that of the zoom."
            WRITE(str71,'("Declared vertical size of data :", I5)') 
     $           pzsize
            WRITE(str72,'("Size of zoom for variable ",a," = ",I5)')
     $           tmp_name(:lnblnk(tmp_name)), par_szz
C     
            CALL histerr(3,"histdef", str70, str71, str72)
C     
         ENDIF
C
         var_zaxid(pfileid,iv) = pzid
C
      ELSE
C
         var_zaxid(pfileid,iv) = -99
C
      ENDIF
C
C     3.0 Determine the position of the variable in the buffer
C         If it is instantaneous output then we do not use the buffer
C
      IF (check) WRITE(*,*) "histdef : 3.0"
C
C
C     3.1 We get the size of the arrays histwrite will get and check 
C         that they fit into the tmp_buffer
C
      buff_sz = zsize(pfileid, iv, 1) * zsize(pfileid, iv, 2) *
     $     zsize(pfileid, iv, 3)
      full_sz = size(pfileid, iv, 1) * size(pfileid, iv, 2) *
     $     size(pfileid, iv, 3)
C
      IF ( full_sz .GT. bufftmp_max) THEN
         str70 = "This variable will not fit into"//
     $        " the buffer of histwrite"
         WRITE(str71,'("Increase bufftmp_max in histcom.h to a ",
     $        "value larger than ", I8)') full_sz
C
         CALL histerr(3,"histdef", str70, str71, ' ')
C
      ENDIF
C
C     3.2 move the pointer of the buffer array
C
      IF ( tmp_topp(:lnblnk(tmp_topp)) .NE. "inst") THEN
         point(pfileid,iv) = buff_pos(pfileid) + 1
         buff_pos(pfileid) = buff_pos(pfileid) + buff_sz
      ENDIF
C
      IF (buff_pos(pfileid) .GE. buffsz_max) THEN
         WRITE(str70,'("fileid, varname, buff_pos:",I3,a20,I10)')
     &         pfileid, pvarname, buff_pos(pfileid)
         CALL histerr(3,'histdef',
     &   'I/O buffer too small for all these variables',
     &   'Plase increase the size of buffsz_max in histcom.h', str70) 
      ENDIF
C
C     4.0 Transfer the frequency of the operations and check for validity
C
      IF (check) WRITE(*,*) "histdef : 4.0"
C
      freq_opp(pfileid,iv) = pfreq_opp
      freq_wrt(pfileid,iv) = pfreq_wrt
C
C
C     4.1 Frequency of operations and output should be larger than deltat !
C
      IF (pfreq_opp .LT. deltat(pfileid)) THEN
         str70 = 'Frequency of operations should be larger than deltat'
         WRITE(str71,
     $        '("It is not the case for variable ",a," :",F10.4)') 
     $         tmp_name(:lnblnk(tmp_name)), pfreq_opp
         str72 = "PATCH : frequency set to deltat"
C
         CALL histerr(2,"histdef", str70, str71, str72)
C
         freq_opp(pfileid,iv) = deltat(pfileid)
      ENDIF
C
      IF (pfreq_wrt .LT. deltat(pfileid)) THEN
         str70 = 'Frequency of output should be larger than deltat'
         WRITE(str71,
     $        '("It is not the case for variable ",a," :",F10.4)') 
     $         tmp_name(:lnblnk(tmp_name)), pfreq_wrt
         str71 = "PATCH : frequency set to deltat"
C
         CALL histerr(2,"histdef", str70, str71, str72)
C
         freq_wrt(pfileid,iv) = deltat(pfileid)
      ENDIF  
C
C     4.2 First the existence of the operation is tested and then
C         its compaticility with the choice of frequencies
C
      IF ( tmp_topp(:lnblnk(tmp_topp)) .EQ. "inst" ) THEN
C
         IF (pfreq_opp .NE. pfreq_wrt) THEN
C
            str70 = 'For instantaneous output the'//
     &              ' frequency of operations and output'
            WRITE(str71,
     &  '("should be the same, this was not case for variable ",a)') 
     &  tmp_name(:lnblnk(tmp_name))
            str72 = "PATCH : The smalest frequency of both is used"
C
            CALL histerr(2,"histdef", str70, str71, str72)
C
            freq_opp(pfileid,iv) = MIN(pfreq_opp, pfreq_wrt)
            freq_wrt(pfileid,iv) = MIN(pfreq_opp, pfreq_wrt)
         ENDIF
C
      ELSE IF ( index(ex_topps,tmp_topp(:lnblnk(tmp_topp)))
     $        .GT. 0) THEN
C
         IF (pfreq_opp .GT. pfreq_wrt) THEN
C
            str70 = 'For averages the frequency of'//
     &              ' operations should be smaller or equal'
            WRITE(str71,
     & '("to that of output. It is not the case for variable ",a)') 
     &  tmp_name(:lnblnk(tmp_name))
            str72 = 'PATCH : The output frequency is used for both'
C
            CALL histerr(2,"histdef", str70, str71, str72)
C
            freq_opp(pfileid,iv) = pfreq_wrt
         ENDIF
C
      ELSE
C
         WRITE (str70, '("Operation on variable ",a," is unknown")')
     &        tmp_name(:lnblnk(tmp_name))
         WRITE (str71, '("operation requested is :",a)') tmp_topp
         WRITE (str72, '("File ID :",I3)') pfileid
C
         CALL histerr(3,"histdef", str70, str71, str72)
      ENDIF
C
C     5.0 Initialize other variables of the common
C
      IF (check) WRITE(*,*) "histdef : 5.0"
C
      minmax(pfileid,iv,1) = missing_val
      minmax(pfileid,iv,2) = -missing_val
C
      last_opp(pfileid,iv) = itau0(pfileid) 
C     $     - freq_opp(pfileid,iv)/2./deltat(pfileid)
      last_wrt(pfileid,iv) = itau0(pfileid) 
C     $     - freq_wrt(pfileid,iv)/2./deltat(pfileid)
      last_opp_chk(pfileid,iv) = itau0(pfileid) 
C     $     - freq_opp(pfileid,iv)/2./deltat(pfileid)
      last_wrt_chk(pfileid,iv) = itau0(pfileid) 
C     $     - freq_wrt(pfileid,iv)/2./deltat(pfileid)
      nb_opp(pfileid,iv) = 0
      nb_wrt(pfileid,iv) = 0
C
C     6.0 Get the time axis for this variable
C
      IF (check) WRITE(*,*) "histdef : 6.0"
C
      WRITE(str10,'(I8.8)') INT(freq_wrt(pfileid,iv)) 
      str40 = tmp_topp(:lnblnk(tmp_topp))//"_"//str10
C
      DO i=1,nb_tax(pfileid)
         tab_str40(i) = tax_name(pfileid,i)
      ENDDO
C
      CALL find_str (nb_tax(pfileid), tab_str40, str40, pos)
C
      IF ( tmp_topp(:lnblnk(tmp_topp)) .NE. 'once') THEN
         IF ( pos .LT. 0) THEN
            nb_tax(pfileid) = nb_tax(pfileid) + 1
            tax_name(pfileid, nb_tax(pfileid)) = str40
            tax_last(pfileid, nb_tax(pfileid)) = 0
            var_axid(pfileid, iv) = nb_tax(pfileid)
         ELSE
            var_axid(pfileid, iv) = pos
         ENDIF
      ELSE
         var_axid(pfileid, iv) = -99
      ENDIF
C
      END
 




C
      SUBROUTINE histend(pfileid)
C
      IMPLICIT NONE
C
C     This subroutine end the decalaration of variables and sets the 
C     time axes in the netcdf file and puts it into the write mode.
C
C     INPUT
C          pfileid : ID of the file to be worked on
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/histend.F,v 1.8 1998/03/23 17:53:09 polcher Exp $
C
C     ARGUMENTS
C    
      INTEGER pfileid
C
C
#include "histcom.h"
C
C     LOCAL
C
#include "netcdf.inc"
C
      INTEGER ncid, ncvarid
      INTEGER iret, ndim, iv, itx, ziv, hiv
      INTEGER itax
      INTEGER dims(4)
      INTEGER len
      INTEGER year, month, day, hours, minutes
      REAL sec
      REAL rtime0
      CHARACTER*20 tname, tunit
      CHARACTER*30 str30
      CHARACTER*80 ttitle
      CHARACTER*70 str70, str71
      CHARACTER*3 cal(12)
      CHARACTER*7 tmp_opp
C
      LOGICAL check
C
      INTEGER lnblnk
      REAL itau2date
      EXTERNAL lnblnk, itau2date
C
      check = .FALSE.
C
      cal(1) = 'JAN'
      cal(2) = 'FEB'
      cal(3) = 'MAR'
      cal(4) = 'APR'
      cal(5) = 'MAY'
      cal(6) = 'JUN'
      cal(7) = 'JUL'
      cal(8) = 'AUG'
      cal(9) = 'SEP'
      cal(10) = 'OCT'
      cal(11) = 'NOV'
      cal(12) = 'DEC'
C
      ncid = ncdf_ids(pfileid)
C
C     1.0 Create the time axes
C
      IF (check) WRITE(*,*) "histend : 1.0"
C
      iret = NF_DEF_DIM(ncid, 'time_counter', NF_UNLIMITED,
     $     tid(pfileid))
C
C     1.1 Define all the time axes needed for this file
C      
      DO itx=1,nb_tax(pfileid)
C
         dims(1) = tid(pfileid)
         IF ( nb_tax(pfileid) .GT. 1) THEN
            str30 = "t_"//tax_name(pfileid,itx)
         ELSE
            str30 = "time_counter"
         ENDIF
C
         iret = NF_DEF_VAR(ncid, str30,
     &          NF_FLOAT, 1, dims, tdimid(pfileid, itx))
C
         rtime0 = itau2date(itau0(pfileid), date0(pfileid),
     $        deltat(pfileid))
C
         CALL ju2ymds(rtime0, year, month, day, sec)
C
C     Catch any error induced by a change in calendar !
C
         IF ( year .LT. 0) THEN
            year = 2000 + year
         ENDIF
C
         hours = INT(sec/(60.*60.))
         minutes = INT((sec - hours*60.*60.)/60.)
         sec = sec - (hours*60.*60. + minutes*60.)
C
         WRITE(str70,7000) year, month, day, hours, minutes,
     $        INT(sec)
         len = lnblnk(str70)
         iret = NF_PUT_ATT_TEXT(ncid, tdimid(pfileid, itx), 'units',
     $        len, str70)
C
         iret = NF_PUT_ATT_TEXT(ncid, tdimid(pfileid, itx), 'title',
     $        4, 'Time')
C
         iret = NF_PUT_ATT_TEXT(ncid, tdimid(pfileid, itx),
     $        'long_name', 9, 'Time axis')
C
         WRITE(str70,7001) year, cal(month), day, hours, minutes,
     $        INT(sec)
         len = lnblnk(str70)
         iret = NF_PUT_ATT_TEXT(ncid, tdimid(pfileid, itx),
     $        'time_origin', len, str70)
C
      ENDDO
C
C     The formats we need
C
 7000 FORMAT('seconds since ',
     $     I4.4,'-',I2.2,'-',I2.2,' ',I2.2,':',I2.2,':',I2.2)
 7001 FORMAT(' ',
     $     I4.4,'-',A3,'-',I2.2,' ',I2.2,':',I2.2,':',I2.2)
C
C     2.0 declare the variables
C
      IF (check) WRITE(*,*) "histend : 2.0"
C
      DO iv=1,nb_var(pfileid)
C
         itax = var_axid(pfileid, iv)
C
         tname = name(pfileid,iv)
         tunit = unit(pfileid,iv)
         ttitle = title(pfileid,iv)
C
         dims(1) = xid(pfileid)
         dims(2) = yid(pfileid)
C
         tmp_opp = topp(pfileid,iv)
         ziv = var_zaxid(pfileid,iv)
         IF ( tmp_opp(1:lnblnk(tmp_opp)) .NE. 'once') THEN
            IF (ziv .EQ. -99) THEN
               ndim = 3
               dims(3) = tid(pfileid)
            ELSE
               ndim = 4
               dims(3) = zax_ids(pfileid,ziv)
               dims(4) = tid(pfileid)
            ENDIF
         ELSE
            IF (ziv .EQ. -99) THEN
               ndim = 2
               dims(3) = 0
            ELSE
               ndim = 3
               dims(3) = zax_ids(pfileid,ziv)
               dims(4) = 0
            ENDIF
         ENDIF
C
         iret = NF_DEF_VAR(ncid, tname, NF_FLOAT, ndim, dims, ncvarid)
         ncvar_ids(pfileid,iv) = ncvarid
C
         len = lnblnk(tunit)

         iret = NF_PUT_ATT_TEXT(ncid, ncvarid, 'units', len, tunit)
#ifdef NC_REAL
         iret = NF_PUT_ATT_REAL(ncid, ncvarid, 'missing_value',
     $        NF_FLOAT, 1, missing_val)
         iret = NF_PUT_ATT_REAL(ncid, ncvarid, 'valid_min',
     $        NF_FLOAT, 1, minmax(pfileid,iv,1))
         iret = NF_PUT_ATT_REAL(ncid, ncvarid, 'valid_max',
     $        NF_FLOAT, 1, minmax(pfileid,iv,2))
#endif
#ifdef NC_DOUBLE
         iret = NF_PUT_ATT_DOUBLE(ncid, ncvarid, 'missing_value',
     $        NF_FLOAT, 1, missing_val)
         iret = NF_PUT_ATT_DOUBLE(ncid, ncvarid, 'valid_min',
     $        NF_FLOAT, 1, minmax(pfileid,iv,1))
         iret = NF_PUT_ATT_DOUBLE(ncid, ncvarid, 'valid_max',
     $        NF_FLOAT, 1, minmax(pfileid,iv,2))
#endif


         len = lnblnk(ttitle)
         iret = NF_PUT_ATT_TEXT(ncid, ncvarid, 'title', len, ttitle)

         len = lnblnk(tname)
         iret = NF_PUT_ATT_TEXT(ncid, ncvarid, 'short_name',
     $        len, tname)
         
         hiv = var_haxid(pfileid, iv)
         str30 =  hax_name(pfileid, hiv, 1)
         len = lnblnk(str30)
         iret = NF_PUT_ATT_TEXT(ncid, ncvarid, 'Longitude', len, str30)
         
         str30 =  hax_name(pfileid, hiv, 2)
         len = lnblnk(str30)
         iret = NF_PUT_ATT_TEXT(ncid, ncvarid, 'Latitude', len, str30)
         
         ziv = var_zaxid(pfileid, iv)
         IF ( ziv .GT. 0) THEN
            str30 =  zax_name(pfileid, ziv)
            len = lnblnk(str30)
            iret = NF_PUT_ATT_TEXT(ncid, ncvarid, 'Z-axis', len, str30)
         ENDIF
 
         IF ( itax .GT. 0) THEN
            str30 = "time_"//tax_name(pfileid, itax)
            len = lnblnk(str30)
            iret = NF_PUT_ATT_TEXT(ncid, ncvarid, 'time_axis',
     $           len, str30)
            
            len = lnblnk(fullop(pfileid,iv))
            iret = NF_PUT_ATT_TEXT(ncid, ncvarid, 'online_operation',
     $           len, fullop(pfileid,iv))
C     
            IF (check) WRITE(*,*) "histend : 2.0.n, freq_opp,
     $           freq_wrt", freq_opp(pfileid, iv),
     $           freq_wrt(pfileid, iv)
C     
#ifdef REAL
            iret = NF_PUT_ATT_REAL(ncid, ncvarid,
     $           'interval_operation', NF_FLOAT, 1,
     $           freq_opp(pfileid, iv))
            iret = NF_PUT_ATT_REAL(ncid, ncvarid,
     $           'interval_write', NF_FLOAT, 1,
     $           freq_wrt(pfileid, iv))
#endif
#ifdef DOUBLE
            iret = NF_PUT_ATT_DOUBLE(ncid, ncvarid,
     $           'interval_operation', NF_FLOAT, 1,
     $           freq_opp(pfileid, iv))
            iret = NF_PUT_ATT_DOUBLE(ncid, ncvarid,
     $           'interval_write', NF_FLOAT, 1,
     $           freq_wrt(pfileid, iv))
#endif
         ENDIF
      ENDDO
C
C     3.0 Put the netcdf file into wrte mode
C
      IF (check) WRITE(*,*) "histend : 3.0"
C
      iret = NF_ENDDEF(ncid)
C
C     4.0 Give some informations to the user
C
      IF (check) WRITE(*,*) "histend : 4.0"
C
      WRITE(str70,
     &     '("All variables have been initialized on file :",I3)')
     &     pfileid
      WRITE(str71,'(f5.1, "% of the buffer is beeing used")') 
     &    (float(buff_pos(pfileid))/buffsz_max)*100.
      CALL histerr(1,'histend',str70,str71,' ')
C
      END

















C
      SUBROUTINE histerr (plev, pcname, pstr1, pstr2, pstr3)
C
      IMPLICIT NONE
C
C
C     INPUT
C          plev   : Category of message to be reported to the user
C                   1 = Note to the user
C                   2 = Warning to the user
C                   3 = Fatal error
C          pcname : Name of subroutine which has called histerr
C          str1   
C          str2   : String containing the explanations to the user
C          str3
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/histerr.F,v 1.4 1998/01/30 10:07:12 polcher Exp $
C
C     ARGUMENTS
C
      INTEGER plev
      CHARACTER*(*) pcname
      CHARACTER*(*) pstr1, pstr2, pstr3
C
      IF (plev .EQ. 1) THEN
         WRITE(6,'("     ")')
         WRITE(6,'("NOTE TO THE USER FROM ROUTINE ",a20)') pcname
         WRITE(6,'(" --> ",a)') pstr1
         WRITE(6,'(" --> ",a)') pstr2
         WRITE(6,'(" --> ",a)') pstr3
      ENDIF
C
      IF (plev .EQ. 2) THEN
         WRITE(6,'("     ")')
         WRITE(6,'("WARNING FROM ROUTINE ",a20)') pcname
         WRITE(6,'(" --> ",a)') pstr1
         WRITE(6,'(" --> ",a)') pstr2
         WRITE(6,'(" --> ",a)') pstr3
      ENDIF
C
      IF (plev .EQ. 3) THEN
         WRITE(6,'("     ")')
         WRITE(6,'("FATAL ERROR FROM ROUTINE ",a20)') pcname
         WRITE(6,'(" --> ",a)') pstr1
         WRITE(6,'(" --> ",a)') pstr2
         WRITE(6,'(" --> ",a)') pstr3
         STOP
      ENDIF
C
      END

      SUBROUTINE histhori(pfileid, x,iim, y,jjm, phid)
C
      IMPLICIT NONE
C
C
      INTEGER pfileid, iim, jjm
      REAL x(iim), y(jjm)
      INTEGER phid
C
#include "histcom.h"  
C
C     LOCAL
C
#include "netcdf.inc"
C
      INTEGER ierr, nid, varid
C
      nid = ncdf_ids(pfileid)
c
      phid = 1
      nb_hax(pfileid) = phid
C
      hax_name(pfileid, phid, 1) = "x"
      hax_name(pfileid, phid, 2) = "y"
c
      ierr = NF_DEF_VAR (nid,"x",NF_FLOAT,1,xid(pfileid),varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir x"
         CALL abort
      ENDIF
      ierr = NF_PUT_ATT_TEXT (nid, varid, "long_name", 10,"Longitudes")
      ierr = NF_PUT_ATT_TEXT (nid, varid, "units", 12,"degrees_east")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VARA_DOUBLE(nid,varid,1,
     .                          slab_sz(pfileid,1),
     .                          x(slab_ori(pfileid,1)))
#else
      ierr = NF_PUT_VARA_REAL(nid,varid,1,
     .                        slab_sz(pfileid,1),
     .                        x(slab_ori(pfileid,1)))
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer x"
         CALL abort
      ENDIF
c
      ierr = NF_REDEF (nid)
c
      ierr = NF_DEF_VAR (nid,"y",NF_FLOAT,1,yid(pfileid),varid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour definir y"
         CALL abort
      ENDIF   
      ierr = NF_PUT_ATT_TEXT (nid, varid, "long_name", 9,"Latitudes")
      ierr = NF_PUT_ATT_TEXT (nid, varid, "units", 13,"degrees_north")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VARA_DOUBLE(nid,varid,1,
     .                          slab_sz(pfileid,2),
     .                          y(slab_ori(pfileid,2)))
#else
      ierr = NF_PUT_VARA_REAL(nid,varid,1,
     .                        slab_sz(pfileid,2),
     .                        y(slab_ori(pfileid,2)))
#endif
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour enregistrer y"
         CALL abort
      ENDIF
c
      ierr = NF_REDEF (nid)
C
      RETURN

      END

C
      SUBROUTINE histvert(pfileid, pzaxname, pzaxtitle, pzaxunit,
     $     pzsize, pzvalues, pzaxid)
C
      IMPLICIT NONE
C
C     This subroutine defines a vertical axis and returns it's id.
C     It gives the user the possibility to the user to define many 
C     different vertical axes. For each variable defined with histdef a 
C     vertical axis can be specified with by it's ID.
C
C     INPUT
C     
C          pfileid  : ID of the file the variable should be archived in 
C          pzaxname : Name of the vertical axis
C          pzaxtitle: title of the vertical axis
C          pzaxunit : Units of the vertical axis
C          pzsize   : size of the vertical axis
C          pzvalues : Coordinate values of the vetical axis
C          
C     OUTPUT
C
C          pzaxid   : Returns the ID of the axis. Note that this is not the 
C                     netCDF ID !
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/histvert.F,v 1.4 1998/03/19 18:40:44 polcher Exp $
C
C
C     ARGUMENTS
C
      INTEGER pfileid, pzaxid, pzsize
      CHARACTER*(*) pzaxname, pzaxunit, pzaxtitle
      REAL pzvalues(pzsize)
C
#include "histcom.h"
C
C     LOCAL
C
#include "netcdf.inc"
C
      INTEGER pos, iv, nb, i, zdimid, zaxid_tmp
      CHARACTER*20 str20, tab_str20(nb_zax_max)
      CHARACTER*70 str70, str71, str72
      CHARACTER*80 str80
      INTEGER iret, len, ncid, im
      INTEGER corner(4), edges(4)
      LOGICAL check
C
      INTEGER lnblnk
      EXTERNAL lnblnk
#ifdef CRAY
      INTEGER ismin, ismax
      EXTERNAL ismin, ismax
#else
      REAL zmin, zmax
#endif
C
      check = .FALSE.
C
C     1.0 Verifications :
C          Do we have enough space for an extra axis ?
C          Is the name already in use ?
C
      IF ( check) WRITE(*,*) "1.0 Verifications", pzaxname,
     $     pzaxunit, pzaxtitle
C
      IF ( nb_zax(pfileid)+1 .GT. nb_zax_max) THEN
         CALL histerr (3, "histvert",
     &   'Table of vertical axes too small. You should increase ',
     &   'nb_zax_max in histcom.h in order to accomodate all ',
     $   'these variables ')
      ENDIF
C
      iv = nb_zax(pfileid)
      IF ( iv .GT. 1) THEN
         str20 = pzaxname
         nb = iv-1
         DO i=1,nb
            tab_str20(i) = zax_name(pfileid,i)
         ENDDO
         CALL find_str(nb, tab_str20, str20, pos)
      ELSE
         pos = 0
      ENDIF
C
      IF ( pos .GT. 0) THEN
         str70 = "Vertical axis already exists"
         WRITE(str71,'("Check variable  ", a, " in file", I3)') 
     &         str20, pfileid
         str72 = "Can also be a wrong file ID in another declaration"
C
         CALL histerr(3,"histdef", str70, str71, str72)
      ENDIF
C
      iv = nb_zax(pfileid) + 1
C
C     2.0 Add the information to the file
C
      IF (check) WRITE(*,*) "2.0 Add the information to the file"
C
      ncid = ncdf_ids(pfileid) 
C
      str20 = pzaxname
      len = lnblnk(str20)
      iret = NF_DEF_DIM(ncid, str20(1:len), pzsize, zaxid_tmp)
C
      iret = NF_DEF_VAR(ncid, str20(1:len), NF_FLOAT, 1, zaxid_tmp,
     $     zdimid)
C
      str20 = pzaxunit
      len = lnblnk(str20)
      iret =  NF_PUT_ATT_TEXT(ncid, zdimid, 'units', len, str20)

#ifdef NC_REAL
#ifdef CRAY
      im = ismin(pzsize, pzvalues,1)
      iret = NF_PUT_ATT_REAL(ncid, zdimid, 'valid_min',
     $     NF_FLOAT, 1, pzvalues(im))
      im = ismax(pzsize, pzvalues,1)
      iret = NF_PUT_ATT_REAL(ncid, zdimid, 'valid_max',
     $     NF_FLOAT, 1, pzvalues(im))
#else
      zmin = pzvalues(1)
      zmax = pzvalues(1)
      DO im = 1, pzsize
         zmin = MIN(zmin,pzvalues(im))
         zmax = MAX(zmax,pzvalues(im))
      ENDDO
      iret = NF_PUT_ATT_REAL(ncid, zdimid, 'valid_min',
     $     NF_FLOAT, 1, zmin)
      iret = NF_PUT_ATT_REAL(ncid, zdimid, 'valid_max',
     $     NF_FLOAT, 1, zmax)
#endif
#elif defined NC_DOUBLE
#ifdef CRAY
      im = ismin(pzsize, pzvalues,1)
      iret = NF_PUT_ATT_DOUBLE(ncid, zdimid, 'valid_min',
     $     NF_FLOAT, 1, pzvalues(im))
      im = ismax(pzsize, pzvalues,1)
      iret = NF_PUT_ATT_DOUBLE(ncid, zdimid, 'valid_max',
     $     NF_FLOAT, 1, pzvalues(im))
#else
      zmin = pzvalues(1)
      zmax = pzvalues(1)
      DO im = 1, pzsize
         zmin = MIN(zmin,pzvalues(im))
         zmax = MAX(zmax,pzvalues(im))
      ENDDO
      iret = NF_PUT_ATT_DOUBLE(ncid, zdimid, 'valid_min',
     $     NF_FLOAT, 1, zmin)
      iret = NF_PUT_ATT_DOUBLE(ncid, zdimid, 'valid_max',
     $     NF_FLOAT, 1, zmax)
#endif
#else
FORCED COMPILER ERROR, PLEASE ADD A COMPILER OPTION (i.e. NC_REAL)
#endif

      str20 = pzaxname
      len = lnblnk(str20)
      iret =  NF_PUT_ATT_TEXT(ncid, zdimid, 'title', len, str20)
      str80 = pzaxtitle
      len = lnblnk(str80)
      iret =  NF_PUT_ATT_TEXT(ncid, zdimid, 'long_name', len,
     $     str80)
C
      iret = NF_ENDDEF(ncid)
C
      corner(1) = 1
      edges(1) = pzsize
#ifdef NC_REAL
      iret = NF_PUT_VARA_REAL(ncid, zdimid, corner, edges, pzvalues)
#elif defined NC_DOUBLE
      iret = NF_PUT_VARA_DOUBLE(ncid, zdimid, corner, edges, pzvalues)
#else
FORCED COMPILER ERROR, PLEASE ADD A COMPILER OPTION (i.e. NC_REAL)
#endif
C
      iret = NF_REDEF(ncid)
C
C     3.0 add the information to the common
C
      IF ( check) WRITE(*,*) "3.0 add the information to the common"
C
      nb_zax(pfileid) = iv
      zax_size(pfileid, iv) = pzsize
      zax_name(pfileid, iv) = pzaxname
      zax_ids(pfileid, iv) = zaxid_tmp
      pzaxid =  iv
C
      RETURN
C
      END
C
C
      SUBROUTINE histwrite(pfileid, pvarname, pitau, pdata,
     $     nbindex, nindex)
C
      IMPLICIT NONE
C
C     This subroutine will give the data to the I/O system. It will
C     trigger the operations to be performed, and the writting to the
C     file if needed
C
C     INPUT
C          pfileid  : The ID of the file on which this variable is to be,
C                     written. The variable should have been defined in 
C                     this file before.
C          pvarname : The short name of the variable
C          pitau    : Current timestep
C          pdata    : The variable, I mean the real data !
C          nbindex  : The number of indexes provided. If it is equal to 
C                     the size of the full field as provided in histdef 
C                     then nothing is done.
C          nindex    : The indices used to expand the variable (pdata) 
C                     onto the full field.
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/histwrite.F,v 1.8 1998/03/19 18:40:45 polcher Exp $
C
C
C     ARGUMENTS
C
      INTEGER pfileid, pitau, nbindex, nindex(nbindex)
      REAL pdata(1)
      CHARACTER*(*) pvarname
C
#include "histcom.h"
C
C     LOCAL
C
#include "netcdf.inc"
C
      INTEGER varid, tsz, fsz, ncid, ncvarid
      INTEGER i, iret, ipt, itax
      INTEGER nb, pos
      INTEGER io, nbin, nbout
      LOGICAL do_oper, do_write
      INTEGER corner(4), edges(4)
      INTEGER itime
C
      REAL dt_opp, dt_chk
      REAL rtime
      CHARACTER*20 str20, tab_str20(nb_var_max)
      CHARACTER*7 tmp_opp
      REAL mindata, maxdata
      REAL buff_tmp(bufftmp_max),  buff_tmp2(bufftmp_max)
      CHARACTER*120 indchfun, fuchnbout
C
      LOGICAL check, found
C     
#ifdef CRAY
      INTEGER ismin, ismax
      EXTERNAL ismin, ismax
#endif
      INTEGER lnblnk
      REAL itau2date
      EXTERNAL itau2date, lnblnk
C
      check = .FALSE.
C
C     Functions which require that the input data is of the same length as
C     the index field:
      fuchnbout = 'scatter, fill'
      indchfun = 'scatter, fill, gather, coll'
C
C     1.0 Find the id of the variable to be written and the real time
C
      IF (check) WRITE(*,*) "histwrite: 1.0", pfileid, pvarname 
C
      str20 = pvarname
      nb = nb_var(pfileid)
C
      DO i=1,nb
         tab_str20(i) = name(pfileid,i)
      ENDDO
C
      CALL find_str (nb, tab_str20, str20, pos)
C
      IF (pos .GT. 0) THEN
         varid = pos
      ELSE
         CALL histerr(3, "histwrite",
     &   'The name of the variable you gave has not been declared',
     &   'You should use subroutine histdef for declaring variable',
     &   str20)
      ENDIF
C
      rtime = pitau * deltat(pfileid)
      tmp_opp = topp(pfileid,varid)
C
      IF (check) WRITE(*,*) "Seconds since itau0 :", rtime
C
C     2.0 Determine what has to be done
C
      IF (check) WRITE(*,*) "histwrite: 2.0", pfileid, varid
C
C
C     2.1 Do we need to do an operation on the data ?
C
      dt_opp = (pitau - last_opp(pfileid,varid))*deltat(pfileid)
      dt_chk = (pitau - last_opp_chk(pfileid,varid))*deltat(pfileid)
C
      IF (check) WRITE(*,*) "histwrite: 2.0 OPP dt_opp, dt_chk",
     $     dt_opp, dt_chk, last_opp_chk(pfileid,varid)
C
      IF (last_opp_chk(pfileid,varid) .EQ. pitau) THEN
         CALL histerr(3, "histwrite",
     &   'This variable as already been analysed at the present',
     &   'time step',
     &   str20)
      ENDIF
C
      do_oper = .FALSE.
      IF ( ABS(dt_opp - freq_opp(pfileid,varid)) .LE.
     &     ABS(dt_opp + dt_chk - freq_opp(pfileid,varid)) ) THEN
         do_oper = .TRUE.
      ENDIF
      IF ( tmp_opp(:lnblnk(tmp_opp)) .NE. "once" ) THEN
         last_opp_chk(pfileid,varid) = pitau
      ELSE
         last_opp_chk(pfileid,varid) = pitau + 10
      ENDIF
C
C     2.2 Do we need to write the data ?
C
      dt_opp = (pitau - last_wrt(pfileid,varid))*deltat(pfileid)
      dt_chk = (pitau - last_wrt_chk(pfileid,varid))*deltat(pfileid)
C
      IF (check) WRITE(*,*) "histwrite: 2.0 WRITE dt_opp, dt_chk",
     $     dt_opp, dt_chk, last_wrt(pfileid,varid)
C
      IF (last_wrt_chk(pfileid,varid) .EQ. pitau) THEN
         CALL histerr(3, "histwrite",
     &   'This variable as already been written for the present',
     &   'time step',
     &   str20)
      ENDIF
C
      do_write = .FALSE.
      IF ( ABS(dt_opp - freq_wrt(pfileid,varid)) .LE.
     $     ABS(dt_opp + dt_chk - freq_wrt(pfileid,varid)) ) THEN
         do_write = .TRUE.
      ENDIF
      IF (tmp_opp(:lnblnk(tmp_opp)) .NE. "once") THEN
         last_wrt_chk(pfileid,varid) = pitau
      ELSE
         last_wrt_chk(pfileid,varid) = pitau + 10
      ENDIF
C
C     3.0 Do the operations or transfer the slab of data into buff_tmp
C
      IF (check) WRITE(*,*) "histwrite: 3.0", pfileid
C
      fsz = size(pfileid,varid,1) * size(pfileid,varid,2) *
     $     size(pfileid,varid,3)
      tsz = zsize(pfileid,varid,1) * zsize(pfileid,varid,2) *
     $     zsize(pfileid,varid,3)
C
C     3. DO the Operations only if needed
C
      IF ( do_oper ) THEN
C     
C     3.1 First we have to guess the number of points in the input data
C
         i = pfileid
C
         found = .FALSE.
         DO io = 1, nbopp(i,varid)
            IF ( index(indchfun, sopps(i,varid,io)) .GT. 0) THEN
               found = .TRUE.
            ENDIF
         ENDDO
C     
         IF ( found ) THEN 
C
            IF ( nbindex .GT. bufftmp_max) THEN
               CALL histerr(3, "histwrite",
     &              'The buffer is too small to do the re-indexing',
     &              'Please increase bufftmp_max',' ')
            ENDIF
C
            nbin = nbindex
C
         ELSE
            nbin = fsz
         ENDIF
C     
         nbout = fsz

C
C     3.2 Do the first operation what ever happens (We have made sure 
C         in hist def to have an uneven number or operations)
C
         CALL mathop(sopps(i,varid,1), nbin, pdata, missing_val,
     $        nbindex, nindex, scal(i,varid,1), nbout, buff_tmp2)
C
C     3.3 If needed we continue with the operations
C
         DO io = 2, nbopp(i,varid),2
C
            nbin = nbout
            IF (index(fuchnbout, sopps(i,varid,io)) .GT. 0)
     $           nbout = fsz
C     
            CALL mathop(sopps(i,varid,io), nbin, buff_tmp2, 
     $           missing_val, nbindex, nindex, scal(i,varid,io),
     $           nbout, buff_tmp)
C
            nbin = nbout
            IF (index(fuchnbout, sopps(i,varid,io)) .GT. 0)
     $           nbout = fsz
C     
            CALL mathop(sopps(i,varid,io+1), nbin, buff_tmp, 
     $           missing_val, nbindex, nindex, scal(i,varid,io+1),
     $           nbout, buff_tmp2)
C     
         ENDDO
C     
C    3.3 Zoom into the data
C
         CALL trans_buff(zorig(i,varid,1), zsize(i,varid,1),
     $        zorig(i,varid,2), zsize(i,varid,2),
     $        zorig, zsize(i,varid,3),
     $        size(i,varid,1), size(i,varid,2), size(i,varid,3),
     $        buff_tmp2, tsz, buff_tmp)
C
C
C     4.0 Do the operations if needed. In the case of instantaneous 
C         output we do not transfer to the buffer.
C
         IF (check) WRITE(*,*) "histwrite: 4.0", pfileid
C
         ipt = point(pfileid,varid)
C
C         WRITE(*,*) 'OPE ipt, buffer :', pvarname, ipt, varid
C
         IF ( tmp_opp(:lnblnk(tmp_opp)) .NE. "inst" .AND.
     $        tmp_opp(:lnblnk(tmp_opp)) .NE. "once") THEN
C
            CALL moycum(tmp_opp, tsz, buffer(ipt,pfileid), buff_tmp, 
     $           nb_opp(pfileid,varid), 1, buffer(ipt,pfileid))
C     
         ENDIF
C
         last_opp(pfileid,varid) = pitau
         nb_opp(pfileid,varid) = nb_opp(pfileid,varid) + 1
C
C     5.0 Get the min and the max of the field weather it is written or not
C
         IF (check) WRITE(*,*) "histwrite: 5.0", pfileid
C
#ifdef CRAY
         maxdata = buff_tmp(ismax(tsz, buff_tmp, 1))
         mindata = buff_tmp(ismin(tsz, buff_tmp, 1))
#else
         maxdata = buff_tmp(1)
         mindata = buff_tmp(1)
         DO i = 1, tsz
            maxdata = MAX(maxdata,buff_tmp(i))
            mindata = MIN(mindata,buff_tmp(i))
         ENDDO
#endif
C     
         minmax(pfileid,varid,1) = MIN(minmax(pfileid,varid,1), mindata)
         minmax(pfileid,varid,2) = MAX(minmax(pfileid,varid,2), maxdata)
C
      ENDIF
C
C     6.0 Write to file if needed
C
      IF (check) WRITE(*,*) "histwrite: 6.0", pfileid
C
      IF ( do_write ) THEN
C
         ncvarid = ncvar_ids(pfileid,varid)
         ncid = ncdf_ids(pfileid)

C     6.1 Do the operations that are needed before writting
C      
         IF (check) WRITE(*,*) "histwrite: 6.2", pfileid
C
         IF ( tmp_opp(:lnblnk(tmp_opp)) .NE. "inst" .AND.
     $        tmp_opp(:lnblnk(tmp_opp)) .NE. "once") THEN
C
            rtime = (rtime + last_wrt(pfileid,varid) *
     $           deltat(pfileid))/2.0
C
         ENDIF
C     
C     6.2 Add a value to the time axis of this variable if needed
C      
         IF (check) WRITE(*,*) "histwrite: 6.3", pfileid
C
         itax = var_axid(pfileid, varid)
         itime = nb_wrt(pfileid, varid)+1
C         
         IF (tax_last(pfileid, itax) .LT. itime) THEN
C
            corner(1) = itime
            edges(1) = 1
C
#ifdef NC_REAL
            iret = NF_PUT_VARA_REAL(ncid, tdimid(pfileid,itax), corner, 
     &                 edges, rtime)
#elif defined NC_DOUBLE
            iret = NF_PUT_VARA_DOUBLE(ncid, tdimid(pfileid,itax), corner
     $          ,edges, rtime)
#else
FORCED COMPILER ERROR, PLEASE ADD A COMPILER OPTION (i.e. NC_REAL)
#endif
            tax_last(pfileid, itax) = itime
         ENDIF
C
C     6.3 Write the data. Only in the case of instantaneous output
C         we do not write the buffer.
C      
         IF (check) WRITE(*,*) "histwrite: 6.4", pfileid, ncid, ncvarid
C
         corner(1) = 1
         corner(2) = 1
         edges(1) = zsize(pfileid,varid,1)
         edges(2) = zsize(pfileid,varid,2)
         IF (size(pfileid,varid,3) .EQ. 1) THEN
            corner(3) = itime
            corner(4) = 0
            edges(3) = 1
            edges(4) = 0
         ELSE
            corner(3) = 1
            corner(4) = itime
            edges(3) = zsize(pfileid,varid,3)
            edges(4) = 1
         ENDIF
C
         ipt = point(pfileid,varid)
C         
         IF ( tmp_opp(:lnblnk(tmp_opp)) .NE. "inst" .AND.
     $        tmp_opp(:lnblnk(tmp_opp)) .NE. "once") THEN
#ifdef NC_REAL
            iret = NF_PUT_VARA_REAL(ncid, ncvarid, corner, edges, 
     $           buffer(ipt,pfileid))
#elif defined NC_DOUBLE
            iret = NF_PUT_VARA_DOUBLE(ncid, ncvarid, corner, edges, 
     $           buffer(ipt,pfileid))
#else
FORCED COMPILER ERROR, PLEASE ADD A COMPILER OPTION (i.e. NC_REAL)
#endif
         ELSE
#ifdef NC_REAL
            iret = NF_PUT_VARA_REAL(ncid, ncvarid, corner, edges, 
     $           buff_tmp)
#elif defined NC_DOUBLE
            iret = NF_PUT_VARA_DOUBLE(ncid, ncvarid, corner, edges, 
     $           buff_tmp)
#else
FORCED COMPILER ERROR, PLEASE ADD A COMPILER OPTION (i.e. NC_REAL)
#endif
         ENDIF
C
         last_wrt(pfileid,varid) = pitau
         nb_wrt(pfileid,varid) = nb_wrt(pfileid,varid) + 1
         nb_opp(pfileid,varid) = 0
C
C     After the write the file can be syncronizd so that no data is
C     lost in case of a crash. This feature gives up on the benefits of 
C     buffering and should only be used in debuging mode. A flag is 
C     needed here to switch to this mode.
C
C         iret = NF_SYNC(ncid)
C
      ENDIF
C
      END

      REAL function itau2date(itau, date0, deltat)
C
      IMPLICIT NONE
C
C     This function transforms itau into a date. The date whith which
C     the time axis is going to be labeled
C
C     INPUT 
C          itau   : current time step
C          date0  : Date at which itau was equal to 0
C          deltat : time step between itau s
C
C     OUTPUT
C          itau2date : Date for the given itau
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/itau2date.F,v 1.5 1998/01/30 10:07:15 polcher Exp $
C
C
      INTEGER one_day
      PARAMETER (one_day = 86400)
C
      INTEGER itau
      REAL date0, deltat
C
      itau2date = float(itau)*deltat/one_day + date0
C
      END

      SUBROUTINE ju2ymds(julian, year, month, day, sec)
C
C     This subroutine computes from the julian day hte year, month, day and
C     seconds
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/ju2ymds.F,v 1.5 1998/03/19 18:40:45 polcher Exp $
C
C     INPUT
C     
      REAL julian
C
C     OUTPUT
C
      INTEGER year, month, day
      REAL sec
C
C     LOCAL
C
#include "calendar.h"
C
      INTEGER Z, W, X, A, B, C, D, E
C

      sec = (julian - INT(julian)) * un_jour

      Z = INT(julian + 1)
      W = (Z - 1867216.25) / (un_an*100.)
      X = W / 4
      A = Z + 1 + W -X 
      B = A + 1524
      C = (B - 122.1) / un_an
      D = un_an * C
      E = (B - D) / un_mois
      day = B - D - (un_mois * E) + 1
C
      IF ( E .GT. 13) THEN
         month = E - 13 
         year = C - 4715 
      ELSE
         month = E - 1 
         year = C - 4716 
      ENDIF
C
      RETURN

      END

      INTEGER FUNCTION lnblnk (letter)

C--------------------------------------------------------
C Fonction qui determine la longeur d un string sans les
C blancs qui suivent. Le critere pour determiner la fin du
C string est, trois blancs de suite
C---------------------------------------------------------
C     ARGUMENTS
C     +++++++++
C     letter: CHARACTER*xxx (xxx < imax)
C             le string dont on determine la longuer
C     lnblnk: INTEGER
C             le nombre de characteres
C
C     PARAMETER
C     +++++++++
C     imax : INTEGER
C            le nombre maximale de character que peut contenir le string
C            a traiter
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/lnblnk.F,v 1.5 1998/03/04 18:51:13 polcher Exp $
C
      IMPLICIT NONE
      INTEGER i
      CHARACTER*(*) letter

      i=len(letter)

10    i=i-1
        IF (letter(i:i) .NE. ' ' .OR. i .EQ. 0) GOTO 20
      GOTO 10
    
20    lnblnk=i


      RETURN
      END

C
      SUBROUTINE mathop(fun, nb, work_in, miss_val, nb_index,
     $     nindex, scal, nb_max, work_out)
C
      IMPLICIT NONE
C
C
C     This soubroutines gives an interface to the various operation 
C     which are allowed. The interface is general enough to allow its use 
C     for other cases.
C
C     INPUT
C
C     fun      : function to be applied to the vector of data
C     nb       : Length of input vector
C     work_in  : Input vector of data (REAL)
C     miss_val : The value of the missing data flag (it has to be a 
C                maximum value, this can be changed with F90 (epsilon))
C     nb_index : Length of index vector
C     nindex   : Vector of indeces
C     scal     : A scalar value for vector/scalar operations
C     nb_max   : maximum length of output vector
C
C     OUTPUT
C
C     nb_max   : Actual length of output variable
C     work_out : Output vector after the operation was applied 
C
C
      CHARACTER*7 fun
      INTEGER nb, nb_max, nb_index
      INTEGER nindex(nb_index)
      REAL work_in(nb), scal, miss_val
      REAL work_out(nb_max)
C
      INTEGER ierr
      CHARACTER*120 indexfu
C
      INTRINSIC sin, cos, tan, asin, acos, atan, exp, alog, sqrt
      INTRINSIC abs
C
      INTEGER lnblnk
      EXTERNAL lnblnk
C
      INTEGER ma_add, ma_sub, ma_subi, ma_mult, ma_div, ma_divi,
     $     ma_power, ma_fumin, ma_fumax
      INTEGER ma_fuscat, ma_fugath, ma_fufill, ma_fucoll, ma_fuundef,
     $     ma_fuonly
      INTEGER ma_sin, ma_cos, ma_tan, ma_asin, ma_acos, ma_atan 
      INTEGER ma_exp, ma_alog, ma_sqrt, ma_abs
      INTEGER ma_chs, ma_cels, ma_kelv, ma_deg, ma_rad, ma_ident
C
      EXTERNAL ma_chs, ma_cels, ma_kelv, ma_deg, ma_rad, ma_fumin,
     $     ma_fumax, ma_add, ma_subi
      EXTERNAL ma_sub, ma_mult, ma_div, ma_divi, ma_power, ma_ident,
     $     ma_fugath, ma_fuscat
      EXTERNAL ma_fufill, ma_fucoll, ma_fuundef, ma_fuonly
C
      INTEGER ma_singop, ma_dblop, ma_indexop
      EXTERNAL ma_singop, ma_dblop, ma_indexop
C
      indexfu = 'gather, scatter fill, coll, undef, only'
      ierr = 0
C
      IF ( scal .GE. miss_val - 1. ) THEN

         IF ( index(indexfu, fun(1:lnblnk(fun))) .EQ. 0) THEN         

            IF ( index(fun, 'sin') .EQ. 1) THEN
               ierr = ma_singop(ma_sin, nb, work_in, nb_max, work_out)
            ELSE IF ( index(fun, 'cos') .EQ. 1) THEN
               ierr = ma_singop(ma_cos, nb, work_in, nb_max, work_out)
            ELSE IF ( index(fun, 'tan') .EQ. 1) THEN
               ierr = ma_singop(ma_tan, nb, work_in, nb_max, work_out)         
            ELSE IF ( index(fun, 'asin') .EQ. 1) THEN
               ierr = ma_singop(ma_asin, nb, work_in, nb_max, work_out)
            ELSE IF ( index(fun, 'acos') .EQ. 1) THEN
               ierr = ma_singop(ma_acos, nb, work_in, nb_max, work_out)
            ELSE IF ( index(fun, 'atan') .EQ. 1) THEN
               ierr = ma_singop(ma_atan, nb, work_in, nb_max, work_out)
            ELSE IF ( index(fun, 'exp') .EQ. 1) THEN
               ierr = ma_singop(ma_exp, nb, work_in, nb_max, work_out)
            ELSE IF ( index(fun, 'log') .EQ. 1) THEN
               ierr = ma_singop(ma_alog, nb, work_in, nb_max, work_out)
            ELSE IF ( index(fun, 'sqrt') .EQ. 1) THEN
               ierr = ma_singop(ma_sqrt, nb, work_in, nb_max, work_out)
            ELSE IF ( index(fun, 'chs') .EQ. 1) THEN
               ierr = ma_singop(ma_chs, nb, work_in, nb_max, work_out)
            ELSE IF ( index(fun, 'abs') .EQ. 1) THEN
               ierr = ma_singop(ma_abs, nb, work_in, nb_max, work_out)
            ELSE IF ( index(fun, 'cels') .EQ. 1) THEN
               ierr = ma_singop(ma_cels, nb, work_in, nb_max, work_out)
            ELSE IF ( index(fun, 'kelv') .EQ. 1) THEN
               ierr = ma_singop(ma_kelv, nb, work_in, nb_max, work_out)
            ELSE IF ( index(fun, 'deg') .EQ. 1) THEN
               ierr = ma_singop(ma_deg, nb, work_in, nb_max, work_out)
            ELSE IF ( index(fun, 'rad') .EQ. 1) THEN
               ierr = ma_singop(ma_rad, nb, work_in, nb_max, work_out)
            ELSE IF ( index(fun, 'ident') .EQ. 1) THEN
               ierr = ma_singop(ma_ident, nb, work_in, nb_max, work_out)
            ELSE
               CALL histerr(3,"mathop",
     $              'scalar variable undefined and no indexing',
     $              'but still unknown function', fun)
            ENDIF
            
            IF ( ierr .GT. 0) THEN
               CALL histerr(3, "mathop",
     $              'Error while executing a simple function'
     $              ,fun, ' ')
            ENDIF
            
         ELSE
            
            IF ( index(fun, 'gather') .EQ. 1) THEN
               ierr = ma_indexop(ma_fugath, nb, work_in, nb_index,
     $              nindex, miss_val, nb_max, work_out)
               WRITE(*,*) 'output :', ierr
            ELSE IF ( index(fun, 'scatter') .EQ. 1) THEN
               ierr = ma_indexop(ma_fuscat, nb, work_in, nb_index,
     $              nindex, miss_val, nb_max, work_out)
            ELSE IF ( index(fun, 'coll') .EQ. 1) THEN
               ierr = ma_indexop(ma_fucoll, nb, work_in, nb_index,
     $              nindex, miss_val, nb_max, work_out)
            ELSE IF ( index(fun, 'fill') .EQ. 1) THEN
               ierr = ma_indexop(ma_fufill, nb, work_in, nb_index,
     $              nindex, miss_val, nb_max, work_out)
            ELSE IF ( index(fun, 'undef') .EQ. 1) THEN
               ierr = ma_indexop(ma_fuundef, nb, work_in, nb_index,
     $              nindex, miss_val, nb_max, work_out)
            ELSE IF ( index(fun, 'only') .EQ. 1) THEN
               ierr = ma_indexop(ma_fuonly, nb, work_in, nb_index,
     $              nindex, miss_val, nb_max, work_out)
            ELSE
               CALL histerr(3,"mathop",
     $              'scalar variable undefined  and indexing',
     $              'was requested but with unknown function',
     $              fun)
            ENDIF
            
            IF ( ierr .GT. 0) THEN
               CALL histerr(3, "mathop",
     $              'Error while executing an indexing function'
     $              ,fun,' ')
            ENDIF
            
         ENDIF
         
      ELSE
         IF ( index(fun, 'fumin') .EQ. 1) THEN
            ierr = ma_dblop(ma_fumin, nb, work_in, scal, nb_max,
     $           work_out)
         ELSE IF ( index(fun, 'fumax') .EQ. 1) THEN
            ierr = ma_dblop(ma_fumax, nb, work_in, scal, nb_max,
     $           work_out)         
         ELSE IF ( index(fun, 'add') .EQ. 1) THEN
            ierr = ma_dblop(ma_add, nb, work_in, scal, nb_max,
     $           work_out)
         ELSE IF ( index(fun, 'subi') .EQ. 1) THEN
            ierr = ma_dblop(ma_subi, nb, work_in, scal, nb_max,
     $           work_out)
         ELSE IF ( index(fun, 'sub') .EQ. 1) THEN
            ierr = ma_dblop(ma_sub, nb, work_in, scal, nb_max,
     $           work_out)
         ELSE IF ( index(fun, 'mult') .EQ. 1) THEN
            ierr = ma_dblop(ma_mult, nb, work_in, scal, nb_max,
     $           work_out)
         ELSE IF ( index(fun, 'div') .EQ. 1) THEN
            ierr = ma_dblop(ma_div, nb, work_in, scal, nb_max,
     $           work_out)
         ELSE IF ( index(fun, 'divi') .EQ. 1) THEN
            ierr = ma_dblop(ma_divi, nb, work_in, scal, nb_max,
     $           work_out)
         ELSE IF ( index(fun, 'power') .EQ. 1) THEN
            ierr = ma_dblop(ma_power, nb, work_in, scal, nb_max,
     $           work_out)
         ELSE
            CALL histerr(3, "mathop",'Unknown operation with a scalar',
     $           fun,' ')
         ENDIF

         IF ( ierr .GT. 0) THEN
            CALL histerr(3, "mathop",
     $           'Error while executing a scalar function',
     $           fun,' ')
         ENDIF

      ENDIF
C
      RETURN
C
      END
C     
      INTEGER FUNCTION ma_singop(fun, nb, work, nb_max, work_out)

      IMPLICIT NONE

      INTEGER nb, nb_max
      REAL work(nb), work_out(nb_max)

      INTEGER FUN
      EXTERNAL FUN

      ma_singop = fun(nb, work, nb_max, work_out)

      RETURN

      END
C
C
C
      INTEGER FUNCTION ma_dblop(fun, nb, work, scal, nb_max, work_out)

      IMPLICIT NONE

      INTEGER nb, nb_max
      REAL work(nb), work_out(nb_max), scal

      INTEGER FUN
      EXTERNAL FUN

      ma_dblop = fun(nb, work, scal, nb_max, work_out)

      RETURN

      END
C
C
C     
      INTEGER FUNCTION ma_indexop(fun, nb, work, nb_index,
     $           index, miss_val, nb_max, work_out)

      IMPLICIT NONE

      INTEGER nb, nb_index, nb_max
      INTEGER index(nb_index)
      REAL work(nb), miss_val, work_out(nb_max)

      INTEGER FUN
      EXTERNAL FUN

      ma_indexop = fun(nb, work, nb_index, index, miss_val,
     $     nb_max, work_out)

      RETURN

      END
C
C
C     FUNCTIONS (only one argument)
C
C
      INTEGER FUNCTION ma_sin(nb, x, nbo, y)

      IMPLICIT NONE

      INTEGER nb, nbo, i
      REAL x(nb), y(nbo)

      DO i=1,nb
        y(i) = sin(x(i))
      ENDDO

      nbo = nb
      ma_sin = 0

      RETURN

      END
C
C
C
      INTEGER FUNCTION ma_cos(nb, x, nbo, y)

      IMPLICIT NONE

      INTEGER nb, nbo, i
      REAL x(nb), y(nbo)

      DO i=1,nb
        y(i) = cos(x(i))
      ENDDO

      nbo = nb
      ma_cos = 0

      RETURN

      END
C
C
C
      INTEGER FUNCTION ma_tan(nb, x, nbo, y)

      IMPLICIT NONE

      INTEGER nb, nbo, i
      REAL x(nb), y(nbo)

      DO i=1,nb
        y(i) = tan(x(i))
      ENDDO

      nbo = nb
      ma_tan = 0

      RETURN

      END
C
C
C
      INTEGER FUNCTION ma_asin(nb, x, nbo, y)

      IMPLICIT NONE

      INTEGER nb, nbo, i
      REAL x(nb), y(nbo)

      DO i=1,nb
        y(i) = asin(x(i))
      ENDDO

      nbo = nb
      ma_asin = 0

      RETURN

      END
C
C
C
      INTEGER FUNCTION ma_acos(nb, x, nbo, y)

      IMPLICIT NONE

      INTEGER nb, nbo, i
      REAL x(nb), y(nbo)

      DO i=1,nb
        y(i) = acos(x(i))
      ENDDO

      nbo = nb
      ma_acos = 0

      RETURN

      END
C
C
C
      INTEGER FUNCTION ma_atan(nb, x, nbo, y)

      IMPLICIT NONE

      INTEGER nb, nbo, i
      REAL x(nb), y(nbo)

      DO i=1,nb
        y(i) = atan(x(i))
      ENDDO

      nbo = nb
      ma_atan = 0

      RETURN

      END
C
C
C
      INTEGER FUNCTION ma_exp(nb, x, nbo, y)

      IMPLICIT NONE

      INTEGER nb, nbo, i
      REAL x(nb), y(nbo)

      DO i=1,nb
        y(i) = exp(x(i))
      ENDDO

      nbo = nb
      ma_exp = 0

      RETURN

      END
C
C
C
      INTEGER FUNCTION ma_alog(nb, x, nbo, y)

      IMPLICIT NONE

      INTEGER nb, nbo, i
      REAL x(nb), y(nbo)

      DO i=1,nb
        y(i) = alog(x(i))
      ENDDO

      nbo = nb
      ma_alog = 0

      RETURN

      END
C
C
C
      INTEGER FUNCTION ma_sqrt(nb, x, nbo, y)

      IMPLICIT NONE

      INTEGER nb, nbo, i
      REAL x(nb), y(nbo)

      DO i=1,nb
        y(i) = sqrt(x(i))
      ENDDO

      nbo = nb
      ma_sqrt = 0

      RETURN

      END
C
C
C
      INTEGER FUNCTION ma_abs(nb, x, nbo, y)

      IMPLICIT NONE

      INTEGER nb, nbo, i
      REAL x(nb), y(nbo)

      DO i=1,nb
        y(i) = abs(x(i))
      ENDDO

      nbo = nb
      ma_abs = 0

      RETURN

      END
C
C
C
      INTEGER FUNCTION ma_chs(nb, x, nbo, y)

      IMPLICIT NONE

      INTEGER nb, nbo, i
      REAL x(nb), y(nbo)

      DO i=1,nb
        y(i) = x(i) * (-1.)
      ENDDO

      nbo = nb
      ma_chs = 0

      RETURN

      END
C
C
C
      INTEGER FUNCTION ma_cels(nb, x, nbo, y)

      IMPLICIT NONE

      INTEGER nb, nbo, i
      REAL x(nb), y(nbo)

      DO i=1,nb
        y(i) = x(i) - 273.15
      ENDDO

      nbo = nb
      ma_cels = 0

 
      RETURN

      END
C
C
C
      INTEGER FUNCTION ma_kelv(nb, x, nbo, y)

      IMPLICIT NONE

      INTEGER nb, nbo, i
      REAL x(nb), y(nbo)

      DO i=1,nb
        y(i) = x(i) + 273.15
      ENDDO

      nbo = nb
      ma_kelv = 0

      RETURN

      END
C
C
C
      INTEGER FUNCTION ma_deg(nb, x, nbo, y)

      IMPLICIT NONE

      INTEGER nb, nbo, i
      REAL x(nb), y(nbo)
      DO i=1,nb
        y(i) = x(i) * 57.29577951
      ENDDO

      nbo = nb
      ma_deg = 0

      RETURN

      END
C
C
C
      INTEGER FUNCTION ma_rad(nb, x, nbo, y)

      IMPLICIT NONE

      INTEGER nb, nbo, i
      REAL x(nb), y(nbo)

      DO i=1,nb
        y(i) = x(i) * 0.01745329252
      ENDDO

      nbo = nb
      ma_rad = 0

      RETURN

      END
C
C
C
      INTEGER FUNCTION ma_ident(nb, x, nbo, y)

      IMPLICIT NONE

      INTEGER nb, nbo, i
      REAL x(nb), y(nbo)

      DO i=1,nb
        y(i) = x(i)
      ENDDO

      nbo = nb
      ma_ident = 0

      RETURN

      END
C
C
C     OPERATIONS (two argument)
C
C
      INTEGER FUNCTION ma_add(nb, x, s, nbo, y)

      IMPLICIT NONE

      INTEGER nb, nbo
      REAL x(nb), s, y(nbo)

      INTEGER i

      DO i = 1, nb
         y(i) = x(i) + s
      ENDDO

      nbo = nb
      ma_add = 0

      RETURN

      END
C
C
C
      INTEGER FUNCTION ma_sub(nb, x, s, nbo, y)

      IMPLICIT NONE

      INTEGER nb, nbo
      REAL x(nb), s, y(nbo)

      INTEGER i

      DO i = 1, nb
         y(i) = x(i) - s
      ENDDO

      nbo = nb
      ma_sub = 0

      RETURN

      END
C
C
C
      INTEGER FUNCTION ma_subi(nb, x, s, nbo, y)

      IMPLICIT NONE

      INTEGER nb, nbo
      REAL x(nb), s, y(nbo)

      INTEGER i

      DO i = 1, nb
         y(i) =  s - x(i)
      ENDDO

      nbo = nb
      ma_subi = 0

      RETURN

      END
C
C
C
      INTEGER FUNCTION ma_mult(nb, x, s, nbo, y)

      IMPLICIT NONE

      INTEGER nb, nbo
      REAL x(nb), s, y(nbo)

      INTEGER i

      DO i = 1, nb
         y(i) = x(i) * s
      ENDDO

      nbo = nb
      ma_mult = 0

      RETURN

      END
C
C
C
      INTEGER FUNCTION ma_div(nb, x, s, nbo, y)

      IMPLICIT NONE

      INTEGER nb, nbo
      REAL x(nb), s, y(nbo)

      INTEGER i

      DO i = 1, nb
         y(i) = x(i) / s
      ENDDO

      nbo = nb
      ma_div = 0

      RETURN

      END
C
C
C
      INTEGER FUNCTION ma_divi(nb, x, s, nbo, y)

      IMPLICIT NONE

      INTEGER nb, nbo
      REAL x(nb), s, y(nbo)

      INTEGER i

      DO i = 1, nb
         y(i) = s / x(i) 
      ENDDO

      nbo = nb
      ma_divi = 0

      RETURN

      END
C
C
C
      INTEGER FUNCTION ma_power(nb, x, s, nbo, y)

      IMPLICIT NONE

      INTEGER nb, nbo
      REAL x(nb), s, y(nbo)

      INTEGER i

      DO i = 1, nb
         y(i) = x(i) ** s
      ENDDO

      nbo = nb
      ma_power = 0

      RETURN

      END
C
C
C
      INTEGER FUNCTION ma_fumin(nb, x, s, nbo, y)

      IMPLICIT NONE

      INTEGER nb, nbo
      REAL x(nb), s, y(nbo)

      INTEGER i

      DO i = 1, nb
         y(i) = amin1(x(i), s)
      ENDDO

      nbo = nb
      ma_fumin = 0

      RETURN

      END
C
C
C
      INTEGER FUNCTION ma_fumax(nb, x, s, nbo, y)

      IMPLICIT NONE

      INTEGER nb, nbo
      REAL x(nb), s, y(nbo)

      INTEGER i

      DO i = 1, nb
         y(i) = amax1(x(i), s)
      ENDDO

      nbo = nb
      ma_fumax = 0

      RETURN

      END
C
C
C
      INTEGER FUNCTION ma_fuscat(nb, x, nbi, ind, miss_val, nbo, y)

      IMPLICIT NONE

      INTEGER nb, nbo, nbi
      INTEGER ind(nbi)
      REAL x(nb), miss_val, y(nbo)

      INTEGER i
      
      ma_fuscat = 0

      DO i = 1, nbo
         y(i) = miss_val
      ENDDO

      IF ( nbi .LE. nb) THEN

         DO i = 1, nbi
            IF (ind(i) .LE. nbo) THEN
               y(ind(i)) = x(i)
            ELSE
               ma_fuscat  = ma_fuscat + 1
            ENDIF
         ENDDO

      ELSE

         ma_fuscat  = 1

      ENDIF

      RETURN

      END             
C
C
C
      INTEGER FUNCTION ma_fugath(nb, x, nbi, ind, miss_val, nbo, y)

      IMPLICIT NONE

      INTEGER nb, nbo, nbi
      INTEGER ind(nbi)
      REAL x(nb), miss_val, y(nbo)

      INTEGER i

      IF (nbi .LE. nbo) THEN

         ma_fugath = 0

         DO i=1,nbo
            y(i) = miss_val
         ENDDO

         nbo = nbi

         DO i = 1, nbi
            IF (ind(i) .LE. nb) THEN
               y(i) = x(ind(i))
            ELSE
               ma_fugath  = ma_fugath + 1
            ENDIF
         ENDDO

      ELSE

         ma_fugath = 1

      ENDIF


      RETURN

      END
C
C
C
      INTEGER FUNCTION ma_fufill(nb, x, nbi, ind, miss_val, nbo, y)

      IMPLICIT NONE

      INTEGER nb, nbo, nbi
      INTEGER ind(nbi)
      REAL x(nb), miss_val, y(nbo)

      INTEGER i
      
      ma_fufill = 0

      IF ( nbi .LE. nb) THEN

         DO i = 1, nbi
            IF (ind(i) .LE. nbo) THEN
               y(ind(i)) = x(i)
            ELSE
               ma_fufill  = ma_fufill + 1
            ENDIF
         ENDDO

      ELSE

         ma_fufill  = 1

      ENDIF

      RETURN

      END             
C
C
C
      INTEGER FUNCTION ma_fucoll(nb, x, nbi, ind, miss_val, nbo, y)

      IMPLICIT NONE

      INTEGER nb, nbo, nbi
      INTEGER ind(nbi)
      REAL x(nb), miss_val, y(nbo)

      INTEGER i

      IF (nbi .LE. nbo) THEN

         ma_fucoll = 0

         nbo = nbi

         DO i = 1, nbi
            IF (ind(i) .LE. nb) THEN
               y(i) = x(ind(i))
            ELSE
               ma_fucoll  = ma_fucoll + 1
            ENDIF
         ENDDO

      ELSE

         ma_fucoll = 1

      ENDIF


      RETURN

      END
C
C
C
C
      INTEGER FUNCTION ma_fuundef(nb, x, nbi, ind, miss_val, nbo, y)

      IMPLICIT NONE

      INTEGER nb, nbo, nbi
      INTEGER ind(nbi)
      REAL x(nb), miss_val, y(nbo)

      INTEGER i
      
      IF (nbi .LE. nbo .AND. nbo .EQ. nb) THEN

         ma_fuundef = 0

         DO i=1,nbo
            y(i) = x(i)
         ENDDO

         DO i = 1, nbi
            IF (ind(i) .LE. nbo) THEN
               y(ind(i)) =  miss_val
            ELSE
               ma_fuundef  = ma_fuundef + 1
            ENDIF
         ENDDO

      ELSE

         ma_fuundef = 1

      ENDIF


      RETURN

      END
C
C
C
      INTEGER FUNCTION ma_fuonly(nb, x, nbi, ind, miss_val, nbo, y)

      IMPLICIT NONE

      INTEGER nb, nbo, nbi
      INTEGER ind(nbi)
      REAL x(nb), miss_val, y(nbo)

      INTEGER i

      IF (nbi .LE. nbo .AND. nbo .EQ. nb) THEN

         ma_fuonly = 0

         DO i=1,nbo
            y(i) = miss_val
         ENDDO

         DO i = 1, nbi
            IF (ind(i) .LE. nbo) THEN
               y(ind(i)) =  x(ind(i))
            ELSE
               ma_fuonly  = ma_fuonly + 1
            ENDIF
         ENDDO

      ELSE

         ma_fuonly = 1

      ENDIF


      RETURN

      END
      SUBROUTINE moycum(opp,np,px,py,pwx,pwy,pz)

c=======================================================================
c
c   calcul de la moyenne ponderee de deux champs
c   z (i) = [ wx*x(i) + wy*y(i) ] / [ wx + wy ]
c
c   F. Hourdin
c=======================================================================
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/moycum.F,v 1.5 1998/02/13 18:11:18 polcher Exp $
C
      IMPLICIT NONE
      INTEGER np
      REAL px(np),py(np),pz(np)
      INTEGER pwx,pwy
      CHARACTER*5 opp

      REAL zwx,zwy
      INTEGER i

      zwx=pwx/FLOAT(pwx+pwy)
      zwy=pwy/FLOAT(pwx+pwy)
C
      IF ( pwx .NE. 0 ) THEN
         IF ( opp .EQ. 'ave') THEN
            DO i=1,np
               pz(i)=px(i)*zwx+py(i)*zwy
            ENDDO
         ELSE IF ( opp .EQ. 't_min') THEN
            DO i=1,np
               pz(i)=AMIN1(px(i), py(i))
            ENDDO
         ELSE IF ( opp .EQ. 't_max') THEN
            DO i=1,np
               pz(i)=AMAX1(px(i), py(i))
            ENDDO
         ELSE
            CALL histerr(3, "moycum",
     &           'Unknown time operation',
     &           opp,' ')
         ENDIF   
      ELSE
         DO i=1,np
            pz(i)=py(i)
         ENDDO
      ENDIF
C
      RETURN
C
      END
C
      SUBROUTINE nocomma(str)
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/nocomma.F,v 1.4 1998/01/30 10:07:17 polcher Exp $
C
      IMPLICIT NONE
C
      CHARACTER*100 str
C
      INTEGER len, i
C
      INTEGER lnblnk
      EXTERNAL lnblnk
C
      len=lnblnk(str)
      DO i=1,len
         IF (str(i:i) .EQ. ",") THEN
            str(i:i) = " "
         ENDIF
      ENDDO
C
      RETURN
C
      END
C
      SUBROUTINE readdef(max_lines, fichier, p_egal, nb_lines)
C
      IMPLICIT NONE
C
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/readdef.F,v 1.6 1998/03/19 18:40:46 polcher Exp $
C
      INTEGER max_lines, nb_lines, i
      CHARACTER*100 fichier(max_lines)
      CHARACTER*100 read_str, new_str, tmp_str, tmp_str2
      CHARACTER*3 cnt
      INTEGER p_egal(max_lines)
C
      INTEGER eof, ptn, len_str, blk, nbve
      LOGICAL check
C
      INTEGER lnblnk, findpos
      EXTERNAL lnblnk, findpos
C
      check = .FALSE.
      nb_lines = 0
      eof = 0
      ptn = 1
C
      OPEN (22, file="run.def", ERR=9997)
C
      DO WHILE (eof .NE. 1) 

         CALL skipafew(22, read_str, eof)
         len_str = lnblnk(read_str)
         ptn = index(read_str, '=')

         IF (ptn .GT. 0) THEN

            new_str = read_str(1:ptn-1)//' = '//
     $           read_str(ptn+1:len_str)

            CALL nocomma(new_str)
            CALL cmpblank(new_str)
C
C     Take out leading blanks
C
            DO WHILE (new_str(1:1) .EQ. ' ')
               tmp_str2 = new_str(2:lnblnk(new_str))
               new_str = tmp_str2
            ENDDO

            len_str = lnblnk(new_str)
            ptn = index(new_str, '=')
            tmp_str = new_str(ptn+2:len_str)
            len_str = lnblnk(tmp_str)
            blk = index(tmp_str(1:len_str), ' ')
            nbve = 0
C
C     If there is no space wthin the line then the tragert is a scalar
C     or the element of a properly written vector. (ie of the type 
C     TARGET__1)
C
            IF ( blk .LE. 1 .OR.
     $           tmp_str(1:1) .EQ. '"' .OR.
     $           tmp_str(1:1) .EQ. "'") THEN
               nb_lines = nb_lines + 1
               fichier(nb_lines) = new_str
               p_egal(nb_lines) = index(new_str, '=')
            ELSE
C
C     If there are blanks whithin the line then we a re dealing with a
C     vector and we need to split it in many entries with the TRAGET__1 
C     ntation.
C
C
C
C     Test if the targer is not already a vector targe !
C
               IF (index(read_str(1:ptn-1), '__') .GT. 0) THEN
                  WRITE(*,*) 'ERROR : readdef'
                  WRITE(*,*) 'We have found a mixed vector notation'
                  WRITE(*,*) 'If a target is of the type TARGET__1'
                  WRITE(*,*) 'then only a scalar value is allowed'
                  STOP
               ENDIF
C
               DO WHILE (blk .GT. 0) 
                  nb_lines = nb_lines + 1
                  nbve = nbve + 1
                  WRITE(cnt,'(I3.3)') nbve
                  new_str = read_str(1:ptn-2)//'__'//cnt//' = '//
     $                 tmp_str(1:blk)
                  fichier(nb_lines) = new_str
                  p_egal(nb_lines) = index(new_str,'=')
                  tmp_str = tmp_str(blk+1:lnblnk(tmp_str))
                  blk = index(tmp_str(1:lnblnk(tmp_str)), ' ')
               ENDDO
               nb_lines = nb_lines + 1
               nbve = nbve + 1
               WRITE(cnt,'(I3.3)') nbve
               new_str = read_str(1:ptn-2)//'__'//cnt//' = '//
     $              tmp_str(1:lnblnk(tmp_str))
               fichier(nb_lines) = new_str
               p_egal(nb_lines) = index(new_str,'=')
            ENDIF

         ENDIF
      ENDDO
C
      CLOSE(22)
C
      IF ( check) THEN

         OPEN (22, file='run.def.test')
         DO i=1,nb_lines
            WRITE(22,'(I3," : ",a)') p_egal(i), fichier(i)
         ENDDO
         CLOSE(22)

      ENDIF
C
      RETURN
C
C
 9997 WRITE(*,*) " READREF : Could not open file run.def "
      STOP
C
      END 
C
      SUBROUTINE restclo( )
C
      IMPLICIT NONE
C
C     This subroutine closes any opened restart file.
C
C     INPUT
C
C     file          : Name of the file in which we will write the variable
C     varname_in    : Name of the variable to be written
C     iim, jjm, llm : Size in 3D of the variable
C     itau          : Time step at which the variable is written
C     var           : Variable
C
C     OUTPUT
C
C     NONE
C
C     ARGUMENTS
C

C
#include "restcom.h"
C
C     LOCAL
C
#include "netcdf.inc"
C
      INTEGER iret
C
      IF ( file_open .GT. 0 ) THEN
         iret = NF_CLOSE(file_open)
      ENDIF
C
      file_open = -1
C
      RETURN

      END
C
      SUBROUTINE restget(fid, varname_in, iim, jjm, llm, itau, 
     $     def_beha, var)
C
      IMPLICIT NONE
C
C     This subroutine is for getting a variable from the restart file.
C     A number of verifications will be made :
C     - is this the first time we read this variable ?
C     - are the dimensions correct ?
C     - Is the correct time step present in the file
C     - is a default behaviour possible. If not the model is stoped.
C       Default procedure is to write 999999. on all values.
C
C     INPUT
C
C     fid           : Identification of the file
C     varname_in    : Name of the variable to be read
C     iim, jjm ,llm : Dimensions of the variable that should be read
C     itau          : Time step at whcih we are when we want to read the
C                     variable
C     def_beha      : If the model can restart without this variable then
C                     some strange value is given.
C
C     OUTPUT
C
C     var           : Variable in which the data is put
C
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/restget.F,v 1.6 1998/02/17 19:29:45 polcher Exp $
C
C     ARGUMENTS
C
      INTEGER fid
      CHARACTER*(*) varname_in
      INTEGER iim, jjm, llm, itau
      LOGICAL def_beha
      REAL var(iim,jjm,llm)
C
#include "restcom.h"
C
C     LOCAL
C
#include "netcdf.inc"
C
      INTEGER vid
      INTEGER i, j, l, iret
      CHARACTER*70 str, str2
      CHARACTER*80 varname_tmp
      INTEGER index_sta(1), index_len(1)
      REAL tstep
C
      INTEGER lnblnk
      EXTERNAL lnblnk
C
      varname_tmp = varname_in(1:lnblnk(varname_in))
      CALL find_str(nb_var, var_name, varname_tmp, vid)
C
C     1.0 If the variable is not present then ERROR or filled up
C         by default values if allowed
C
      IF ( vid .LT. 0) THEN
         IF ( def_beha) THEN
            DO i=1,iim
               DO j=1,jjm
                  DO l=1,max(llm,1)
                     var(i,j,l) = 999999.
                  ENDDO
               ENDDO
            ENDDO
C
            str='Variable '//varname_in(:lnblnk(varname_in))//
     $           ' is not present in the restart file'
            CALL histerr(1, 'restget',str,
     $           'but default values are used to fill in', ' ')
C
            nb_var = nb_var + 1
            var_name(nb_var) = varname_tmp
            nb_var_read = nb_var_read + 1
            retrieved(nb_var) = .TRUE.
C
         ELSE
            str='Variable '//varname_in(:lnblnk(varname_in))//
     $           ' is not present in the restart file'
            CALL histerr(3, 'restget',str,
     $           'but it is need to restart the model', ' ')
         ENDIF
      ELSE
C
C     1.0 Check if the variable has not yet been read and that the time
C         is OK
C
         IF ( retrieved(vid)) THEN
            str='Variable '//varname_in(:lnblnk(varname_in))//
     $           ' has already been read from file'
            CALL histerr(3, 'restget',str,' ',' ')
         ENDIF
C
         IF ( itau .NE. read_itau) THEN
            str='Variable '//varname_in(:lnblnk(varname_in))//
     $           ' is not available for '
            WRITE(str2,'("time step ",I6)') itau
            CALL histerr(3, 'restget',str,str2 ,' ')
         ENDIF
C
C     2.0 get the time step of the restart file and check if it is correct
C

         iret = NF_INQ_VARID(fid,'tstep', vid)
         index_sta(1) = 1
         index_len(1) = 1
         iret = NF_GET_VARA_REAL(fid, vid,index_sta, index_len, tstep)
C
         IF ( NINT(tstep) .NE. itau) THEN
            CALL histerr(3, 'restget',
     $           'You do not have the right time step',
     $           'in the retart file.', ' ')
         ENDIF

C 
C     
C     3.0 Read the data. Note that the variables in the restart files have 
C     no time axis is and thus we write -1
C
C     
         CALL flinget(fid, varname_in, iim, jjm, llm, 1,
     $        1, 1, var)

         nb_var_read = nb_var_read + 1
         retrieved(vid) = .TRUE.
C
      ENDIF
C
      RETURN

      END




C
      SUBROUTINE restini(filename, iim, jjm, lon, lat, llm, lev, 
     $     itau, date0, dt, fid)
C
      IMPLICIT NONE
C
C     This surtoutine will open the file in which the restart data are
C     to be found. It will then get the list of variables, the time-step
C     the date and the total number of dimensions
C
C     A special mode can be switched in with filename='NONE'. This means 
C     that no restart file is present. Usefull for creating the first
C     restart file
C
C     INPUT
C
C     filename : name of the file for the restart
C     iim      : Dimension in x
C     jjm      : Dimension in y
C     lon      : Longitude in the x,y domaine
C     lat      : Latitude in the x, y domaine
C     llm      : Dimension in the vertical
C     lev      : Positions of the levels
C     
C     OUTPUT
C
C     itau     : Time step of the restart file and at which the model
C                should restart
C     date0    : Time at which itau = 0
C     dt       : time step in seconds between two succesiv itaus
C     fid      : File identification of the restart file
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/restini.F,v 1.7 1998/02/17 19:29:46 polcher Exp $
C
C     ARGUMENTS
C
      CHARACTER*(*) filename
      INTEGER iim, jjm, llm, fid, itau
      REAL lon(iim,jjm), lat(iim,jjm), lev(llm)
      REAL date0, dt
C
#include "restcom.h"
C
      INTEGER first
      DATA first /-1/
C
C     LOCAL
C
#include "netcdf.inc"
C
      INTEGER one_day
      PARAMETER (one_day = 86400)
C
      INTEGER ttm
      INTEGER nb_glob, id_unl, imi, ima
      INTEGER iv, vartype, nv_tmp
      INTEGER i, j, l, iret
      INTEGER var_nbdim, var_dims(4)
      REAL tmp_dt
      INTEGER itau_tmp
      LOGICAL check, verbose
C
      INTEGER lnblnk, ismin, ismax
      EXTERNAL lnblnk, ismin, ismax
C
      verbose = .FALSE.
C
      IF ( first .EQ. -1 ) THEN
         file_open = -1
         first = 0
      ENDIF
C         
      IF (filename(:lnblnk(filename)) .NE. 'NONE') THEN
C
C     1.0 Open the file. The coordinates are not checked if the input 
C     is constant. This is only checked for the moment on the longitude ! 
C
         IF (verbose) WRITE(*,*) 'restini 1.0'
C
         imi = ismin(iim*jjm,lon,1) 
         ima = ismax(iim*jjm,lon,1)
         IF ( imi .EQ. ima ) THEN
            check = .FALSE.
         ELSE
            check = .TRUE.
            iread = iim
            jread = jjm
            lread = llm
            DO i=1,iim
               DO j=1,jjm
                  lon_read(i,j) = lon(i,j)
                  lat_read(i,j) = lat(i,j)
               ENDDO
            ENDDO
            DO l=1,llm
               lev_read(l) = lev(l)
            ENDDO
         ENDIF
C
         ttm = 1
         CALL flinopen(filename, check, iread, jread, lread, 
     $        lon_read, lat_read, lev_read, 
     $        ttm, itau_tmp, judate0, tmp_dt, fid)
         file_open = fid
C
         IF ( iread .NE. iim .OR. jread .NE. jjm 
     $        .OR. lread .NE. llm) THEN
            CALL histerr(3, 'restini',
     $      ' The grid of the restart file does not correspond',
     $      ' to that of the model', ' ')
         ENDIF
C
         IF ( iread .GT. imax .OR. jread .GT. jmax 
     $        .OR. lread .GT. lmax) THEN
            CALL histerr(3, 'restini',
     $      'Please increase the parameters imax, jmax or lmax',
     $      'in the common restini. The grid can not be stores',
     $      'in the restart module' )
         ENDIF
C
         IF ( ttm .NE. 1) THEN
            CALL histerr(3, 'restini',
     $      'Only one time-step is allowed in restart file',
     $      'Please check your restart file',
     $      '   ' )
         ENDIF
C
         IF ( .NOT. check ) THEN
            DO i=1,iread
               DO j=1,jread
                  lon(i,j) = lon_read(i,j)
                  lat(i,j) = lat_read(i,j)
               ENDDO
            ENDDO

            DO l=1,lread
               lev(l) = lev_read(l)
            ENDDO
         ENDIF
C
         iret = NF_INQ(fid, nb_dim, nb_var, nb_glob, id_unl)
C
         IF ( nb_dim .GT. max_dim) THEN
            CALL histerr(3, 'restini',
     $           'More dimensions present in file that can be store',
     $           'Please increase max_dim in common restini.h',
     $           ' ')
         ENDIF
         IF (nb_var .GT. max_var) THEN
            CALL histerr(3, 'restini',
     $           'More variables present in file that can be store',
     $           'Please increase max_var in common restini.h',
     $           ' ')
         ENDIF
C
C     1.2 Get the list of variables
C         
         IF (verbose) WRITE(*,*) 'restini 1.2'
C
         DO iv = 1, nb_var
            iret = NF_INQ_VAR(fid, iv, var_name(iv), vartype, 
     $           var_nbdim, var_dims, nv_tmp) 
            retrieved(iv) = .FALSE.
         ENDDO
C     
C     1.3 Check the global attributes linked to the time axis  
C
         IF (verbose) WRITE(*,*) 'restini 1.3'
C
         itau = itau_tmp
         read_itau = itau
         deltat = dt
C
         IF ( tmp_dt .EQ. dt) THEN
            date0 = judate0
         ELSE
            CALL  histerr(1, 'restini',
     $           'Time step in the restart file is different from',
     $           'the one in the model. We are updating initial date',
     $           'so we can preserve the time step.')
            date0 = judate0 + itau*tmp_dt/one_day
            judate0 = date0 - itau*dt/one_day
            date0 = judate0
         ENDIF
C
         nb_var_read = 0
C     
      ELSE
C
C     2.0 Put some specific definitions into the common for later use
C         this can only be done if coordinates are provided
C
         IF (verbose) WRITE(*,*) 'restini 2.0'
C
         imi = ismin(iim*jjm,lon,1) 
         ima = ismax(iim*jjm,lon,1)
         IF ( imi .EQ. ima .AND. iim .GT. 1) THEN
            CALL histerr(3, 'restini', 
     $           'For creating a restart file the longitudes of the',
     $           'grid need to be provided to restini. This ',
     $           'information is needed for the restart files')
         ENDIF
         imi = ismin(iim*jjm,lat,1) 
         ima = ismax(iim*jjm,lat,1)
         IF ( imi .EQ. ima .AND. jjm .GT. 1) THEN
            CALL histerr(3, 'restini', 
     $           'For creating a restart file the latitudes of the',
     $           'grid need to be provided to restini. This ',
     $           'information is needed for the restart files')
         ENDIF
         imi = ismin(llm,lev,1) 
         ima = ismax(llm,lev,1)
         IF ( imi .EQ. ima .AND. llm .GT. 1 ) THEN
            CALL histerr(3, 'restini', 
     $           'For creating a restart file the levels of the',
     $           'grid need to be provided to restini. This',
     $           'information is needed for the restart files')
         ENDIF
C
         judate0 = date0
         deltat = dt
         file_itau = itau
C
         IF (verbose) WRITE(*,*) 'restini 2.2'
C
         nb_dim = 0
         nb_var = 0
C
         iread = iim
         jread = jjm
         lread = llm
C
         DO i=1,iread
            DO j=1,jread
               lon_read(i,j) = lon(i,j)
               lat_read(i,j) = lat(i,j)
            ENDDO
         ENDDO
         
         DO l=1,lread
            lev_read(l) = lev(l)
         ENDDO
C
         nb_var_read = 999
         read_itau = 999
C
      ENDIF
C
      RETURN

      END
C
      SUBROUTINE restput(file, varname_in, iim, jjm, llm, itau, var)
C
      IMPLICIT NONE
C
C     This subroutine will put a variable into the restart file. 
C     But it will do alot of other things if needed :
C     - Open a file if non is opened for this time-step and all variables
C     were written.
C     - Add an axis if needed
C     - verify that the variable has the right time step for this file
C     - If it is time for a new file then it is opened and the old one closed
C       This requires that variables read from the last restart file were all
C       written
C
C     INPUT
C
C     file          : Name of the file in which we will write the variable
C     varname_in    : Name of the variable to be written
C     iim, jjm, llm : Size in 3D of the variable
C     itau          : Time step at which the variable is written
C     var           : Variable
C
C     OUTPUT
C
C     NONE
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/restput.F,v 1.6 1998/02/13 18:11:19 polcher Exp $
C
C     ARGUMENTS
C
      CHARACTER*(*) file, varname_in
      INTEGER iim, jjm, llm, itau
      REAL var(iim,jjm,llm)
C
#include "restcom.h"
C
C     LOCAL
C
#include "netcdf.inc"
C
      CHARACTER*80 filename, varname_tmp
      CHARACTER*70 str, str1
      CHARACTER*6 name
      INTEGER fid, id, iret, vid
      INTEGER nlonid, nlatid, zdimid, tdimid
      LOGICAL create_axe, verbose
C
      INTEGER ax1, ax2, ax3, ax4
C
      INTEGER lnblnk
      EXTERNAL lnblnk
C
      varname_tmp = varname_in(1:lnblnk(varname_in))
C
C     1.0 Check if the time step is correct. If not then all variables
C         need to be in the file so that it can be close
C
      verbose = .FALSE.
C
      IF ( verbose ) WRITE(*,*) 'restput, 1.0 : file_open :', file_open
C
      IF ( file_open .GT. 0 .AND. itau .NE. file_itau) THEN

         IF ( nb_var_write .EQ. 0) THEN
C
C           We have the variables which are linked to the dimensions !
C
            IF ( nb_var_read .LT. nb_var-nb_dim) THEN 
               CALL histerr(1, 'restput', 
     $              'Start-up file is closed but',
     $              'but not all variables have been read. Please',
     $              'check that you have not forgoten something')
            ENDIF
C
            iret = NF_CLOSE(file_open)
            file_open = -1

         ELSE IF ( nb_var_write .LT. nb_var-nb_dim) THEN
C
            CALL histerr(1, 'restput', 
     $           'You may be here because you changed the model or the',
     $           'restart file and you forgot to run just one time', 
     $           'before the longuer integration')
C
            WRITE (str,
     $           '("The currently opened file is for time step",I6)')
     $           file_itau
            WRITE (str1,'("An attemp is made to write time step",I6)') 
     $           itau
            CALL histerr(3, 'restput', str, str1, 
     $           'while not all variable read have yet been written ')

         ELSE
C
            iret = NF_CLOSE(file_open)
            file_open = -1
C
         ENDIF

      ENDIF

C
C     2.0 Open the file if needed
C
      IF ( verbose ) WRITE(*,*) 'restput, 2.0 : file_open', file_open
C
      IF ( file_open .LT. 0) THEN

         filename = file
C
         CALL flincre(filename, iread, jread, lon_read, lat_read,
     $        lread, lev_read, 1, itau, judate0, deltat,
     $        fid, nlonid, nlatid, zdimid, tdimid)
         file_open = fid
         file_itau = itau

         axe_id(1) = nlonid
         axe_size(1) = iread
         axe_id(2) = nlatid
         axe_size(2) = jread
         axe_id(3) = zdimid
         axe_size(3) = lread
         axe_id(4) = tdimid
         axe_size(4) = 1
         nb_dim = 4

         nb_var_write = 0
C
         iret = NF_REDEF(fid)

         iret =  NF_PUT_ATT_TEXT( fid, NF_GLOBAL, 'file_type',
     $        23, 'Restart file for PROMES')
         iret =  NF_PUT_ATT_TEXT( fid, NF_GLOBAL, 'model_name',
     $        31, 'PROMES, Universidad Complutense')

         iret = NF_ENDDEF(fid)
C
      ENDIF
C
C     3.0 Verify that the variable was not already written on the file
C
      IF ( verbose ) WRITE(*,*) 'restput, 3.0'
C
      CALL find_str(nb_var_write, var_name_write, varname_tmp, vid)
C
      IF ( vid .GT. 0) THEN

         str='variable '//varname_tmp(:lnblnk(varname_tmp))//
     $        'is already present'
         CALL histerr(3, 'restput', str,
     $        'in the file for the current time step',' ')

      ENDIF
C
C     4.0 Check for axis in longitude of length iim. If it does not exist
C         it is created
C
      IF ( verbose ) WRITE(*,*) 'restput, 4.0'
C
      iret = NF_REDEF(fid)
C
      IF (iim .GT. 0) THEN
         create_axe=.TRUE.
         DO id=1, nb_dim
            IF ( axe_size(id) .EQ. iim .AND. create_axe) THEN
               create_axe=.FALSE.
               ax1 = axe_id(id)
            ENDIF
         ENDDO
C
         IF ( create_axe ) THEN
            WRITE (name,'("x_",I4.4)') iim
            iret = NF_DEF_DIM(fid, name, iim, ax1)
            nb_dim = nb_dim + 1
            axe_id(nb_dim) = ax1
            axe_size(nb_dim) = iim
         ENDIF
      ENDIF
C
C     4.1 Check for axis in latitudee of length jjm. If it does not exist
C     it is created
C
      IF ( verbose ) WRITE(*,*) 'restput, 4.1'
C
      IF (jjm .GT. 0) THEN
         create_axe=.TRUE.
         DO id=1, nb_dim
            IF ( axe_size(id) .EQ. jjm .AND. create_axe) THEN
               create_axe=.FALSE.
               ax2 = axe_id(id)
            ENDIF
         ENDDO
C
         IF ( create_axe ) THEN
            WRITE (name,'("y_",I4.4)') jjm
            iret = NF_DEF_DIM(fid, name, jjm, ax2)
            nb_dim = nb_dim + 1
            axe_id(nb_dim) = ax2
            axe_size(nb_dim) = jjm
         ENDIF
      ENDIF
C
C     4.2 Check for axis in lev of length llm. If it does not exist
C     it is created
C
      IF ( verbose ) WRITE(*,*) 'restput, 4.2'
C
      IF (llm .GT. 0) THEN
         create_axe=.TRUE.
         DO id=1, nb_dim
            IF ( axe_size(id) .EQ. llm .AND. create_axe) THEN
               create_axe=.FALSE.
               ax3 = axe_id(id)
            ENDIF
         ENDDO
C
         IF ( create_axe ) THEN
            WRITE (name,'("l_",I4.4)') llm
            iret = NF_DEF_DIM(fid, name, llm, ax3)
            nb_dim = nb_dim + 1
            axe_id(nb_dim) = ax3
            axe_size(nb_dim) = llm
         ENDIF
      ENDIF
C
C     4.3 Time is not checked as it was created in flincre and it will
C         have dimension 1
C     
C
      IF ( verbose ) WRITE(*,*) 'restput, 4.3'
      ax4 = axe_id(4)
C
      iret = NF_ENDDEF(fid)
C
C     5.0 Finaly everything is OK for writting the var into the file
C
      IF ( verbose ) WRITE(*,*) 'restput, 5.0'
C
      CALL flinput(file_open, varname_tmp, iim, ax1, jjm, ax2, 
     $     llm, ax3, 1, ax4, var)
      nb_var_write = nb_var_write + 1
      var_name_write(nb_var_write) = varname_in
C
      RETURN
C
      END





C
      SUBROUTINE skipafew(unit, out_string, eof)
C
      IMPLICIT NONE
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/skipafew.F,v 1.4 1998/01/30 10:07:20 polcher Exp $
C
      INTEGER unit, eof
      CHARACTER*100 dummy
      CHARACTER*100 out_string
      CHARACTER*1 first

      first="#"
      eof = 0
      out_string = "    "
C
      DO WHILE (first .EQ. "#") 
         READ (unit,'(a100)',ERR=9998,END=7778) dummy
         first=dummy(1:1)
      ENDDO
      out_string=dummy
C
      RETURN
C
 9998 WRITE(*,*) " SKIPAFEW : Error while reading file "
      STOP
C
 7778 eof = 1
C
      END

      SUBROUTINE tlen2itau(input_str, dt, itau)
C
      IMPLICIT NONE
C
C     This subroutine transforms a sting containing a time length
C     into a number of time steps.
C     The following convention is used :
C
C         n   : n time steps
C         nS  : n seconds is transformed into itaus
C         nH  : n hours
C         nD  : n days 
C         nM  : n month  (year of 365.24 days)
C         nY  : n years  (year of 365.24 days)
C     Combinations are also possible
C         nYmD : nyears plus m days !
C
C     INPUT
C
      CHARACTER*(*) input_str
      REAL dt
      INTEGER itau
C
C     LOCAL
C
#include "calendar.h"
C
      INTEGER y_pos, m_pos, d_pos, h_pos, s_pos
      INTEGER read_time
      CHARACTER*13 fmt
      CHARACTER*80 tmp_str
C
      INTEGER lnblnk
      EXTERNAL lnblnk
C
C
      itau = 0
C
      y_pos = MAX(index(input_str,'y'),index(input_str,'Y'))
      m_pos = MAX(index(input_str,'m'),index(input_str,'M'))
      d_pos = MAX(index(input_str,'d'),index(input_str,'D'))
      h_pos = MAX(index(input_str,'h'),index(input_str,'H'))
      s_pos = MAX(index(input_str,'s'),index(input_str,'S'))
C
      IF ( MAX(y_pos,m_pos,d_pos,s_pos) .GT. 0) THEN
C
         tmp_str = input_str
C
         DO WHILE ( MAX(y_pos,m_pos,d_pos,s_pos) .GT. 0)
            
            WRITE(*,*) tmp_str
            WRITE(*,*) y_pos,m_pos,d_pos,s_pos

            IF (y_pos .GT. 0) THEN
               WRITE(fmt,'("(I",I10.10,")")') y_pos-1
               READ(tmp_str(1:y_pos-1),fmt) read_time
               itau = itau + NINT(read_time*un_an*un_jour/dt)
               tmp_str = tmp_str(y_pos+1:lnblnk(tmp_str))
            ELSE IF (m_pos .GT. 0) THEN
               WRITE(fmt,'("(I",I10.10,")")') m_pos-1
               READ(tmp_str(1:m_pos-1),fmt) read_time
               itau = itau + NINT(read_time*un_mois*un_jour/dt)
               tmp_str = tmp_str(m_pos+1:lnblnk(tmp_str))
            ELSE IF (d_pos .GT. 0) THEN
               WRITE(fmt,'("(I",I10.10,")")') d_pos-1
               READ(tmp_str(1:d_pos-1),fmt) read_time
               itau = itau + NINT(read_time*un_jour/dt)
               tmp_str = tmp_str(d_pos+1:lnblnk(tmp_str))
            ELSE IF (h_pos .GT. 0) THEN
               WRITE(fmt,'("(I",I10.10,")")') h_pos-1
               READ(tmp_str(1:h_pos-1),fmt) read_time
               itau = itau + NINT(read_time*60.*60./dt)
               tmp_str = tmp_str(d_pos+1:lnblnk(tmp_str))
            ELSE IF  (s_pos .GT. 0) THEN
               WRITE(fmt,'("(I",I10.10,")")') s_pos-1
               READ(tmp_str(1:s_pos-1),fmt) read_time
               itau = itau + NINT(read_time/dt)
               tmp_str = tmp_str(s_pos+1:lnblnk(tmp_str))
            ENDIF
C
            y_pos = MAX(index(tmp_str,'y'),index(tmp_str,'Y'))
            m_pos = MAX(index(tmp_str,'m'),index(tmp_str,'M'))
            d_pos = MAX(index(tmp_str,'d'),index(tmp_str,'D'))
            h_pos = MAX(index(tmp_str,'h'),index(tmp_str,'H'))
            s_pos = MAX(index(tmp_str,'s'),index(tmp_str,'S'))
C

C
         ENDDO
C
      ELSE
         WRITE(fmt,'("(I",I10.10,")")') lnblnk(input_str)
         READ(input_str(1:lnblnk(input_str)),fmt) itau
      ENDIF
C


      RETURN

      END
C
      SUBROUTINE trans_buff(ox, sx, oy, sy, oz, sz,
     $                      xsz, ysz, zsz, v3d, sl, v1d)
C
      IMPLICIT NONE
C
C     This subroutine extracts from the full 3D variable the slab of
C     data that will be used later. Perhaps there are hardware routines
C     for this task on some computers. This routine will be obsolete in
C     a F90 environnement
C
C     INPUT
C          ox  : Origin of slab of data in X
C          sx  : Size of slab in X
C          oy  : Origin of slab of data in Y
C          sy  : Size of slab in Y
C          oz  : Origin of slab of data in Z
C          sz  : Size of slab in Z
C          xsz, ysz, zsz : 3 sizes of full variable v3d
C          v3d : The full 3D variable
C          sl  : size of variable v1d
C          v1d : The 1D variable containing the slab
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/trans_buff.F,v 1.4 1998/01/30 10:07:20 polcher Exp $
C
C     INPUT
C
      INTEGER ox, sx, oy, sy, oz, sz
      INTEGER xsz, ysz, zsz
      INTEGER sl
      REAL v3d(xsz, ysz, zsz) 
      REAL v1d(sl)
C
C     LOCAL
C
      INTEGER ix, iy, iz, ic
C
      ic = 0
      DO iz = oz, (oz - 1 + sz)
         DO iy = oy, (oy - 1 + sy)
            DO ix = ox, (ox - 1 + sx)
               ic = ic + 1
               v1d(ic) = v3d(ix, iy, iz)
            ENDDO
         ENDDO
      ENDDO
C
      END
C


C
      SUBROUTINE ymds2ju(year, month, day, sec, julian)
C
C     Converts year, month, day and seconds into a julian day
C
C
C     VERSION
C
C     $Header: /users/polcher/CVSREP/IOIPSL/ymds2ju.F,v 1.6 1998/03/19 18:40:47 polcher Exp $
C
C     INPUT
C
      INTEGER year, month, day
      REAL sec
C
C     OUTPUT
C     
      REAL julian
C
C     LOCAL
C
#include "calendar.h"
C
      INTEGER a, b, c, e, f
C
      IF ( month .LT. 3) THEN
         m = month + 12
         y = year - 1
      ELSE
         m = month
         y = year
      ENDIF
C
      A = Y / 100
      B = A / 4
      C = 2 - A + B
      E = INT(un_an * (Y + 4716))
      F = INT(un_mois * (M + 1))
      julian= C + day + E + F - 1525.
C
      julian = julian + sec / un_jour
C
      RETURN
C
      END
#ifdef CRAY
c
#else
      FUNCTION ismin(n,sx,incx)
c
      IMPLICIT NONE
c
      integer n,i,incx,ismin,ix
      real sx((n-1)*incx+1),sxmin
c
      ix=1
      ismin=1
      sxmin=sx(1)
      DO i=1,n-1
         ix=ix+incx
         if(sx(ix).lt.sxmin) then
         sxmin=sx(ix)
         ismin=i+1
         endif
      ENDDO
c
      return
      end
      function ismax(n,sx,incx)
c
      IMPLICIT NONE
c
      INTEGER n,i,incx,ismax,ix
      real sx((n-1)*incx+1),sxmax
c
      ix=1
      ismax=1
      sxmax=sx(1)
      do 10 i=1,n-1
         ix=ix+incx
         if(sx(ix).gt.sxmax) then
         sxmax=sx(ix)
         ismax=i+1
         endif
10    continue
c
      return
      end
#endif
