      PROGRAM initial

      IMPLICIT none
c-------------------------------------------------------------
C Author : L. Fairhead
C Date   : 27/01/94
C Objet  : Construction des etats initiaux pour le nouveau
C          modele a partir de fichiers de climatologie et du
C          Centre Europeen. Les deux
C          grilles doivent etre regulieres
c
c Modifie par z.x.li (le23mars1994)
c Modifie par F.Lott, les parametre de l'orographie 
c a l'echelle sous maille sont stockes sur la base de donnee
c physique.
c-------------------------------------------------------------
c
c
c
      INTEGER ivap
      PARAMETER (ivap=1)
c
      REAL qsolmax
      PARAMETER ( qsolmax = 150.0 )
c
#include "dimensions.h"
#include "paramet.h"
c-----------------------------------------------------------------------
      INTEGER KIDIA, KFDIA, KLON, KLEV
      PARAMETER (KIDIA=1,KFDIA=iim*(jjm-1)+2,
     .           KLON=KFDIA-KIDIA+1,KLEV=llm)
c-----------------------------------------------------------------------
#include "comconst.h"
#include "comvert.h"
#include "comgeom2.h"
#include "control.h"
#include "comdissnew.h"
#include "logic.h"
#include "ener.h"
#include "netcdf.inc"
c
      INTEGER nid

C Declarations pour le champ de depart
      INTEGER imdep, jmdep, lmdep
      INTEGER ibid, jbid, lbid
      PARAMETER (ibid = 400,
     .           jbid = 200,
     .           lbid = 30)
      REAL champ(ibid*jbid), champ3d(ibid*jbid*lbid)
      REAL dlon(ibid), dlat(jbid), plev(lbid)
c
      INTEGER ibid_msk, jbid_msk
      PARAMETER (ibid_msk=2200, jbid_msk=1100)
      REAL champ_msk(ibid_msk*jbid_msk)
      REAL dlon_msk(ibid_msk), dlat_msk(jbid_msk)

C Declarations pour le champ interpole 2D
      REAL champint(iim,jjp1)
      REAL champecrit(iip1,jjp1)
      REAL masque(iip1,jjp1)
      REAL psol(iip1,jjp1), tsol(iip1,jjp1), phisol(iip1,jjp1)
      REAL phis(iip1,jjp1)

c Ajout de quelques parametres orographiques (F. LOTT janvier 1995)

      REAL zphi(iip1,jjp1),zmea(iip1,jjp1),zstd(iip1,jjp1)
      REAL zsig(iip1,jjp1),zgam(iip1,jjp1),zthe(iip1,jjp1)
      REAL zpic(iip1,jjp1),zval(iip1,jjp1)
      REAL rugsrel(iip1,jjp1)
      REAL zfil(iip1,jjp1,0:7)

C Declarations pour le champ interpole 3D
      REAL champhor(iip1,jjp1,lbid)
      REAL champ3decr(iip1,jjp1,llm)
      REAL ucov(iip1,jjp1,llm)
      REAL vcov(iip1,jjm,llm),p(iip1,jjp1,llmp1)
      REAL temp(iip1,jjp1,llm),scratch(iip1,jjp1,llm)
      REAL scrat(ip1jmp1,llm)
      EQUIVALENCE(scratch,scrat)
      REAL q(iip1,jjp1,llm,nqmx),pk(iip1,jjp1,llm)
      REAL uucov(iip1*jjp1,llm),vvcov(iip1*jjm,llm),ttemp(iip1*jjp1,
     ,llm),qq(iip1*jjp1,llm,nqmx),masse(iip1*jjp1,llm)
      REAL ppsol(iip1*jjp1),phisoll(iip1*jjp1)
      REAL champecrii(iip1*jjp1)
      EQUIVALENCE(ucov,uucov),(vcov,vvcov),(temp,ttemp),(q,qq)
      EQUIVALENCE(scratch,masse),(ppsol,psol),(phisol,phisoll)
      EQUIVALENCE(champecrii, champecrit)
     
      REAL alpha(iip1,jjp1,llm),beta(iip1,jjp1,llm)

C Declarations pour l'interpolation verticale
      REAL ax(lbid), ay(lbid)
      REAL bx, by
      REAL yder(lbid)

      INTEGER ierr
      INTEGER nvarid, idim1, idim2

      INTEGER  k
      INTEGER size

c
      INTEGER i,j,l,ig, jr, iq
      REAL xpi, qsat, ttt, millibar(iip1,jjp1), q_sat, xfact
      EXTERNAL q_sat
c
      REAL phystep
      INTEGER radpas
      REAL co2_ppm
      REAL solaire
      REAL latfi(klon), lonfi(klon)
      REAL champhys(klon)
      REAL ts(klon)
      REAL tslab(klon)
      REAL seaice(klon)
      REAL ws(klon)
      REAL sn(klon)
      REAL radsol(klon)
      REAL rugmer(klon)
      REAL agesno(klon)
      INTEGER length
      PARAMETER (length=100)
      REAL tab_cntrl(length)

c
      REAL pls(iip1,jjp1,llm),prefkap,unskap
      REAL plls(ip1jmp1,llm)
      EQUIVALENCE(plls,pls)

      INTEGER ij
      REAL seuil_vap
      INTEGER itau
      INTEGER*4 iday
      REAL time
      REAL pks(ip1jmp1)
      REAL phi(ip1jmp1,llm)
      REAL pbaru(ip1jmp1,llm),pbarv(ip1jm,llm)
      REAL w(ip1jmp1,llm)
      INTEGER ismooth,ismo
      REAL rasmoo
      REAL zlat,cozlat,zsmooth(-iim:2*iim)
      REAL champmin,champmax

      INTEGER idum
      REAL xppn(iim),xpps(iim),xpn,xps, SSUM

      INTEGER          longcles
      PARAMETER      ( longcles  = 20 )
      REAL  clesphy0 ( longcles        )

      EXTERNAL defrun_new,iniconst,geopot,inigeom,massdair,pression
      EXTERNAL exner_hyb , SSUM
c
#include "serre.h"
#include "clesph0.h"
#include "fxyprim.h"
c-----------------------------------------------------------------------
c initialisations:
      OPEN (8,file='run.def',form='formatted')
      CALL defrun_new(8,.TRUE., clesphy0)
      CLOSE(8)
         print *,' Apres  defrun '

      rad    = 6 371 229.
      omeg   = 4.* ASIN(1.) / (24.*3600.)
      g      = 9.8
      kappa  = 0.2857143
      cpp    = 1004.70885
      unskap = 1./kappa
      daysec = 86400.
c
      dtvr   = daysec/FLOAT(day_step)

      CALL inicons0
      CALL inigeom
      PRINT*,'dtvr ',dtvr
c
c creer l'etat initial pour la physique
c
      phystep   = dtvr * FLOAT(iphysiq)
      radpas    = NINT (86400./phystep/ FLOAT(nbapp_rad) )
      co2_ppm   = 353.0
      solaire   = 1370.0
      PRINT *,' Radpas ', nbapp_rad,radpas
c
      latfi(1) = ASIN(1.0)
      DO j = 2, jjm
      DO i = 1, iim
          latfi((j-2)*iim+1+i)=  rlatu(j)
      ENDDO
      ENDDO
      latfi(klon) = - ASIN(1.0)
c
      lonfi(1) = 0.0
      DO j = 2, jjm
      DO i = 1, iim
         lonfi((j-2)*iim+1+i) =  rlonv(i)
      ENDDO
      ENDDO
      lonfi(klon) = 0.0
c
      xpi = 2.0 * ASIN(1.0)
      DO ig = 1, klon
         latfi(ig) = latfi(ig) * 180.0 / xpi
         lonfi(ig) = lonfi(ig) * 180.0 / xpi
      ENDDO
c

c
      ierr = NF_OPEN("ECPHY.nc",NF_NOWRITE,nid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme d ouverture du fichier ECPHY.nc"
         CALL abort
      ENDIF
c
      ierr = NF_INQ_DIMID(nid,"longitude",nvarid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur de longitude"
         CALL abort
      ENDIF
      ierr = NF_INQ_DIMLEN(nid,nvarid,imdep)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir la taille de longitude"
         CALL abort
      ENDIF
      ierr = NF_INQ_VARID (nid,"longitude",nvarid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur longitude"
         CALL abort
      ENDIF
      ierr = NF_GET_VAR_REAL(nid, nvarid, dlon)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour extraire longitude"
         CALL abort
      ENDIF
c
      ierr = NF_INQ_DIMID(nid,"latitude",nvarid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur de latitude"
         CALL abort
      ENDIF
      ierr = NF_INQ_DIMLEN(nid,nvarid,jmdep)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir la taille de latitude"
         CALL abort
      ENDIF
      ierr = NF_INQ_VARID (nid,"latitude",nvarid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur latitude"
         CALL abort
      ENDIF
      ierr = NF_GET_VAR_REAL(nid, nvarid, dlat)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour extraire latitude"
         CALL abort
      ENDIF
c
      ierr = NF_INQ_VARID (nid,"ST",nvarid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur ST"
         CALL abort
      ENDIF
      ierr = NF_GET_VAR_REAL(nid, nvarid, champ)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour extraire ST"
         CALL abort
      ENDIF
c
      CALL grille_m(imdep, jmdep, dlon, dlat, champ,
     .             iim, jjp1, rlonv, rlatu, champint)
      CALL gr_int_dyn(champint, champecrit, iim, jjp1)
      CALL gr_int_dyn(champint, tsol, iim, jjp1)
      CALL gr_dyn_fi(1, iip1, jjp1, klon, champecrit, ts)
c
      CALL minmax( klon,champ,champmin,champmax )
c
      PRINT*,' Ts  = ', champmin,champmax
c
      ierr = NF_INQ_VARID (nid,"CDSW",nvarid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur CDSW"
         CALL abort
      ENDIF
      ierr = NF_GET_VAR_REAL(nid, nvarid, champ)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour extraire CDSW"
         CALL abort
      ENDIF
c
      CALL grille_m(imdep, jmdep, dlon, dlat, champ,
     .             iim, jjp1, rlonv, rlatu, champint)
      CALL gr_int_dyn(champint, champecrit, iim, jjp1)
      CALL gr_dyn_fi(1, iip1, jjp1, klon, champecrit, ws)
c
      Call minmax( klon,ws, champmin,champmax )
      PRINT*,'ws = ', champmin, champmax
c
      xfact =  champmax
c
      DO ig = 1, klon
         ws(ig) = ws(ig) * qsolmax / xfact
      ENDDO

      Call minmax( klon,ws, champmin,champmax )
      PRINT*,'ws = ', champmin, champmax
c
      ierr = NF_CLOSE(nid)
c
      DO ig = 1, klon
         radsol(ig) = 0.0
         sn(ig)     = 0.0
         tslab(ig) = ts(ig)
         seaice(ig) = 0.0
         rugmer(ig) = 0.001
         agesno(ig) = 50.0
      ENDDO
c
cmod F.Lott (Janvier 1995)
c
c traitement des donnees orographiques deduites de la base USN:
c  phis, masque, zmea, zstd, zsig, zgam, zthe,zpic,zval
c
c  Ouverture du fichier de l'USN
c
      ierr = NF_OPEN("Relief.nc",NF_NOWRITE,nid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme d ouverture du fichier ECPHY.nc"
         CALL abort
      ENDIF
c
      ierr = NF_INQ_DIMID(nid,"longitude",nvarid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur de longitude"
         CALL abort
      ENDIF
      ierr = NF_INQ_DIMLEN(nid,nvarid,imdep)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir la taille de longitude"
         CALL abort
      ENDIF
      ierr = NF_INQ_VARID (nid,"longitude",nvarid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur longitude"
         CALL abort
      ENDIF
      ierr = NF_GET_VAR_REAL(nid, nvarid, dlon_msk)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour extraire longitude"
         CALL abort
      ENDIF
c
      ierr = NF_INQ_DIMID(nid,"latitude",nvarid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur de latitude"
         CALL abort
      ENDIF
      ierr = NF_INQ_DIMLEN(nid,nvarid,jmdep)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir la taille de latitude"
         CALL abort
      ENDIF
      ierr = NF_INQ_VARID (nid,"latitude",nvarid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur latitude"
         CALL abort
      ENDIF
      ierr = NF_GET_VAR_REAL(nid, nvarid, dlat_msk)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour extraire latitude"
         CALL abort
      ENDIF
c
      ierr = NF_INQ_VARID (nid,"RELIEF",nvarid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur RELIEF"
         CALL abort
      ENDIF
      ierr = NF_GET_VAR_REAL(nid, nvarid, champ_msk)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour extraire RELIEF"
         CALL abort
      ENDIF
c
      ierr = NF_CLOSE(nid)
c
c  calcul des parametres de l'orographie a l'echelle sous maille
c
       CALL grid_noro(imdep, jmdep, dlon_msk, dlat_msk, champ_msk,
     .         iim, jjp1, rlonv, rlatu,
     .         zphi,zmea,zstd,zsig,zgam,zthe,zpic,zval)

cccccccccc Z.X. Li cccccccccccccccccccccccccccccccccccccccccccc

        CALL rugsoro(imdep, jmdep, dlon_msk, dlat_msk, champ_msk,
     .             iim, jjp1, rlonv, rlatu, champint )

c    Modif.  P. Le Van  ( 20/01/99 )
c
       DO j = 1, jjp1
         DO i = 1, iim
          rugsrel(i,j) = champint(i,j)
         ENDDO
          rugsrel(iip1,j) = rugsrel(1,j)
       ENDDO
c
cccccccccc Z.X. Li ccccccccccccccccccccccccccccccccccccccccccccc
c
c  calcul des masques et du geopotentiel au sol

      PRINT*, 'Traitement du relief pour fabriquer masque'

      CALL grille_m(imdep, jmdep, dlon_msk, dlat_msk, champ_msk,
     ,             iim, jjp1, rlonv, rlatu, champint)
      CALL gr_int_dyn(champint, phis, iim, jjp1)
      CALL mask_c_o(imdep, jmdep, dlon_msk, dlat_msk, champ_msk,
     ,             iim, jjp1, rlonv, rlatu, champint)
      CALL gr_int_dyn(champint, masque, iim, jjp1)
c
c
C-------------------DEBUT DU FILTRE------------------------------
CDEB FILTRE
ccccccccccccc F. LOTT cccccccccccccccccccccccccc
C
C  FILTRAGE DES DIFFERENTES VARIABLES DE L'OROGRAPHIE POUR
C  AVOIR UNE RESOLUTION UNIFORME AU DELA D'UNE LATITUDE
C  FIXEE:
C
      DO l = 0, 7
      DO j=1,jjp1
      DO i=1,iip1
         zfil(i,j,l)= 0.0
      ENDDO
      ENDDO
      ENDDO

      DO j=1,jjp1
      DO i=1,iip1
         IF (NINT(masque(i,j)) .NE. 0)THEN
         zfil(i,j,0)= zphi(i,j)
         zfil(i,j,1)= zmea(i,j)
         zfil(i,j,2)= zstd(i,j)
         zfil(i,j,3)= zsig(i,j)
         zfil(i,j,4)= zgam(i,j)
         zfil(i,j,5)= zthe(i,j)
         zfil(i,j,6)= zpic(i,j)
         zfil(i,j,7)= zval(i,j)
         ENDIF
      ENDDO
      ENDDO

C
C  FILTRAGE POUR LES HAUTE LATITUDES F. LOTT (FENETRE GLISSANTE)
C
      DO l = 0,7
      DO j = 2,jjm

      zlat=xpi*(1-j)/FLOAT(jjm)+xpi/2.
      cozlat=cos(zlat)
      rasmoo= 0.707/ cozlat
      ismooth=nint(rasmoo)

      IF(ismooth.GT.1)THEN
         ismooth=ismooth+mod(ismooth,2)
C        print *,' j ismooth',j,ismooth
         ismooth=min(ismooth,iim)
         DO i=1,iim
            zsmooth(i)    = zfil(i,j,l)
            zsmooth(i-iim)= zfil(i,j,l)
            zsmooth(i+iim)= zfil(i,j,l)
         ENDDO
         DO i=1,iip1
            zfil(i,j,l) = 0.
            DO ismo = -ismooth/2, ismooth/2
            zfil(i,j,l)=zfil(i,j,l)+zsmooth(i+ismo)
            ENDDO
            zfil(i,j,l)=zfil(i,j,l)/FLOAT(ismooth+1)
            IF (NINT(masque(i,j)) .EQ. 0) zfil(i,j,l) = 0.
         ENDDO
      ENDIF

      ENDDO
      ENDDO
C
CFIN FILTRE
C---------------------FIN DU FILTRE------------------------------


      DO j=1,jjp1
      DO i=1,iip1

c F. LOTT: phis(i,j) = phis(i,j) * 9.81
ccc
         phis(i,j) = zfil(i,j,0) * 9.81
         zmea(i,j) = zfil(i,j,1)
         zstd(i,j) = zfil(i,j,2)
         zsig(i,j) = zfil(i,j,3)
         zgam(i,j) = zfil(i,j,4)
         zthe(i,j) = zfil(i,j,5)
         zpic(i,j) = zfil(i,j,6)
         zval(i,j) = zfil(i,j,7)

         IF ( NINT(masque(i,j)) .EQ. 0 ) THEN
            phis(i,j)    = 0.
            zmea(i,j)    = 0.
            zstd(i,j)    = 0.
            zsig(i,j)    = 0.
            zgam(i,j)    = 0.
            zthe(i,j)    = 0.
            rugsrel(i,j) = 0.
            zpic(i,j)    = 0.
            zval(i,j)    = 0.
cmodfin
         ENDIF
      ENDDO
      ENDDO

c
c
c  stockage sur le fichier Physique:
c
      ierr = NF_CREATE("startphy.nc", NF_CLOBBER, nid)
      IF (ierr.NE.NF_NOERR) THEN
        WRITE(6,*)' Pb d''ouverture du fichier startphy.nc'
        WRITE(6,*)' ierr = ', ierr
        CALL ABORT
      ENDIF
c
      ierr = NF_PUT_ATT_TEXT (nid, NF_GLOBAL, "title", 28,
     .                       "Fichier demmarage physique")
c
      ierr = NF_DEF_DIM (nid, "index", length, idim1)
      ierr = NF_DEF_DIM (nid, "points_physiques", klon, idim2)
c
      ierr = NF_ENDDEF(nid)
c
      DO ierr = 1, length
         tab_cntrl(ierr) = 0.0
      ENDDO
      tab_cntrl(1)  = phystep
      tab_cntrl(2)  = radpas
      tab_cntrl(3)  = co2_ppm
      tab_cntrl(4)  = solaire
      tab_cntrl(5)  = iflag_con
      tab_cntrl(6)  = nbapp_rad
c
cc     Modif ( P. Le Van )
c
       tab_cntrl( 7 ) = 0. 
       tab_cntrl( 8 ) = 0. 
       tab_cntrl( 9 ) = 0. 
       tab_cntrl(10 ) = 0. 
       tab_cntrl(11 ) = 0. 
       tab_cntrl(12 ) = 0. 

      IF(  cycle_diurne )  tab_cntrl( 7 ) = 1. 
      IF(   soil_model  )  tab_cntrl( 8 ) = 1. 
      IF(    new_oliq   )  tab_cntrl( 9 ) = 1. 
      IF(    ok_orodr   )  tab_cntrl(10 ) = 1. 
      IF(    ok_orolf   )  tab_cntrl(11 ) = 1. 
      IF(  ok_limitvrai )  tab_cntrl(12 ) = 1. 


cc   ***    new_oliq   (  commentaires de L. LI dans routine physique ) 
cc   ***  ok_orodr  et ok_orolf   si on appelle l'orographie      ****

c
      ierr = NF_REDEF (nid)
#ifdef NC_DOUBLE
      ierr = NF_DEF_VAR (nid, "controle", NF_DOUBLE, 1, idim1,nvarid)
#else
      ierr = NF_DEF_VAR (nid, "controle", NF_FLOAT, 1, idim1,nvarid)
#endif
      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 22,
     .                        "Parametres de controle")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,tab_cntrl)
#else
      ierr = NF_PUT_VAR_REAL (nid,nvarid,tab_cntrl)
#endif
c
      ierr = NF_REDEF (nid)
#ifdef NC_DOUBLE
      ierr = NF_DEF_VAR (nid, "longitude", NF_DOUBLE, 1, idim2,nvarid)
#else
      ierr = NF_DEF_VAR (nid, "longitude", NF_FLOAT, 1, idim2,nvarid)
#endif
      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 32,
     .                        "Longitudes de la grille physique")
      ierr = NF_ENDDEF(nid)

#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,lonfi)
#else
      ierr = NF_PUT_VAR_REAL (nid,nvarid,lonfi)
#endif
c
      ierr = NF_REDEF (nid)
#ifdef NC_DOUBLE
      ierr = NF_DEF_VAR (nid, "latitude", NF_DOUBLE, 1, idim2,nvarid)
#else
      ierr = NF_DEF_VAR (nid, "latitude", NF_FLOAT, 1, idim2,nvarid)
#endif
      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 31,
     .                        "Latitudes de la grille physique")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,latfi)
#else
      ierr = NF_PUT_VAR_REAL (nid,nvarid,latfi)
#endif
c
      ierr = NF_REDEF (nid)
#ifdef NC_DOUBLE
      ierr = NF_DEF_VAR (nid, "TS", NF_DOUBLE, 1, idim2,nvarid)
#else
      ierr = NF_DEF_VAR (nid, "TS", NF_FLOAT, 1, idim2,nvarid)
#endif
      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 25,
     .                        "Temperature de la surface")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,ts)
#else
      ierr = NF_PUT_VAR_REAL (nid,nvarid,ts)
#endif
c
      ierr = NF_REDEF (nid)
#ifdef NC_DOUBLE
      ierr = NF_DEF_VAR (nid, "QS", NF_DOUBLE, 1, idim2,nvarid)
#else
      ierr = NF_DEF_VAR (nid, "QS", NF_FLOAT, 1, idim2,nvarid)
#endif
      ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 15,
     .                        "Humidite du sol")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,ws)
#else
      ierr = NF_PUT_VAR_REAL (nid,nvarid,ws)
#endif
c
      ierr = NF_REDEF (nid)
#ifdef NC_DOUBLE
      ierr = NF_DEF_VAR (nid, "SNOW", NF_DOUBLE, 1, idim2,nvarid)
#else
      ierr = NF_DEF_VAR (nid, "SNOW", NF_FLOAT, 1, idim2,nvarid)
#endif
      ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 5,
     .                        "Neige")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,sn)
#else
      ierr = NF_PUT_VAR_REAL (nid,nvarid,sn)
#endif
c
      ierr = NF_REDEF (nid)
#ifdef NC_DOUBLE
      ierr = NF_DEF_VAR (nid, "RADS", NF_DOUBLE, 1, idim2,nvarid)
#else
      ierr = NF_DEF_VAR (nid, "RADS", NF_FLOAT, 1, idim2,nvarid)
#endif
      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 28,
     .                        "Rayonnement net a la surface")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,radsol)
#else
      ierr = NF_PUT_VAR_REAL (nid,nvarid,radsol)
#endif
c
      ierr = NF_REDEF (nid)
#ifdef NC_DOUBLE
      ierr = NF_DEF_VAR (nid, "TSLAB", NF_DOUBLE, 1, idim2,nvarid)
#else
      ierr = NF_DEF_VAR (nid, "TSLAB", NF_FLOAT, 1, idim2,nvarid)
#endif
      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 32,
     .                        "Slab ocean SST (pour slab-ocean)")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,tslab)
#else
      ierr = NF_PUT_VAR_REAL (nid,nvarid,tslab)
#endif
c
      ierr = NF_REDEF (nid)
#ifdef NC_DOUBLE
      ierr = NF_DEF_VAR (nid, "SEAICE", NF_DOUBLE, 1, idim2,nvarid)
#else
      ierr = NF_DEF_VAR (nid, "SEAICE", NF_FLOAT, 1, idim2,nvarid)
#endif
      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 30,
     .                        "Sea-ice mass (pour slab-ocean)")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,seaice)
#else
      ierr = NF_PUT_VAR_REAL (nid,nvarid,seaice)
#endif
c
      ierr = NF_REDEF (nid)
#ifdef NC_DOUBLE
      ierr = NF_DEF_VAR (nid, "RUGMER", NF_DOUBLE, 1, idim2,nvarid)
#else
      ierr = NF_DEF_VAR (nid, "RUGMER", NF_FLOAT, 1, idim2,nvarid)
#endif
      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 28,
     .                        "Longueur de rugosite sur mer")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,rugmer)
#else
      ierr = NF_PUT_VAR_REAL (nid,nvarid,rugmer)
#endif
c
      ierr = NF_REDEF (nid)
#ifdef NC_DOUBLE
      ierr = NF_DEF_VAR (nid, "AGESNO", NF_DOUBLE, 1, idim2,nvarid)
#else
      ierr = NF_DEF_VAR (nid, "AGESNO", NF_FLOAT, 1, idim2,nvarid)
#endif
      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 15,
     .                        "Age de la neige")
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,agesno)
#else
      ierr = NF_PUT_VAR_REAL (nid,nvarid,agesno)
#endif
c
      CALL gr_dyn_fi(1, iip1, jjp1, klon, zmea, champhys)
      ierr = NF_REDEF (nid)
#ifdef NC_DOUBLE
      ierr = NF_DEF_VAR (nid, "ZMEA", NF_DOUBLE, 1, idim2,nvarid)
#else
      ierr = NF_DEF_VAR (nid, "ZMEA", NF_FLOAT, 1, idim2,nvarid)
#endif
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,champhys)
#else
      ierr = NF_PUT_VAR_REAL (nid,nvarid,champhys)
#endif
c
      CALL gr_dyn_fi(1, iip1, jjp1, klon, zstd, champhys)
      ierr = NF_REDEF (nid)
#ifdef NC_DOUBLE
      ierr = NF_DEF_VAR (nid, "ZSTD", NF_DOUBLE, 1, idim2,nvarid)
#else
      ierr = NF_DEF_VAR (nid, "ZSTD", NF_FLOAT, 1, idim2,nvarid)
#endif
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,champhys)
#else
      ierr = NF_PUT_VAR_REAL (nid,nvarid,champhys)
#endif

      CALL gr_dyn_fi(1, iip1, jjp1, klon, zsig, champhys)
      ierr = NF_REDEF (nid)
#ifdef NC_DOUBLE
      ierr = NF_DEF_VAR (nid, "ZSIG", NF_DOUBLE, 1, idim2,nvarid)
#else
      ierr = NF_DEF_VAR (nid, "ZSIG", NF_FLOAT, 1, idim2,nvarid)
#endif
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,champhys)
#else
      ierr = NF_PUT_VAR_REAL (nid,nvarid,champhys)
#endif

      CALL gr_dyn_fi(1, iip1, jjp1, klon, zgam, champhys)
      ierr = NF_REDEF (nid)
#ifdef NC_DOUBLE
      ierr = NF_DEF_VAR (nid, "ZGAM", NF_DOUBLE, 1, idim2,nvarid)
#else
      ierr = NF_DEF_VAR (nid, "ZGAM", NF_FLOAT, 1, idim2,nvarid)
#endif
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,champhys)
#else
      ierr = NF_PUT_VAR_REAL (nid,nvarid,champhys)
#endif

      CALL gr_dyn_fi(1, iip1, jjp1, klon, zthe, champhys)
      ierr = NF_REDEF (nid)
#ifdef NC_DOUBLE
      ierr = NF_DEF_VAR (nid, "ZTHE", NF_DOUBLE, 1, idim2,nvarid)
#else
      ierr = NF_DEF_VAR (nid, "ZTHE", NF_FLOAT, 1, idim2,nvarid)
#endif
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,champhys)
#else
      ierr = NF_PUT_VAR_REAL (nid,nvarid,champhys)
#endif

      CALL gr_dyn_fi(1, iip1, jjp1, klon, zpic, champhys)
      ierr = NF_REDEF (nid)
#ifdef NC_DOUBLE
      ierr = NF_DEF_VAR (nid, "ZPIC", NF_DOUBLE, 1, idim2,nvarid)
#else
      ierr = NF_DEF_VAR (nid, "ZPIC", NF_FLOAT, 1, idim2,nvarid)
#endif
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,champhys)
#else
      ierr = NF_PUT_VAR_REAL (nid,nvarid,champhys)
#endif

      CALL gr_dyn_fi(1, iip1, jjp1, klon, zval, champhys)
      ierr = NF_REDEF (nid)
#ifdef NC_DOUBLE
      ierr = NF_DEF_VAR (nid, "ZVAL", NF_DOUBLE, 1, idim2,nvarid)
#else
      ierr = NF_DEF_VAR (nid, "ZVAL", NF_FLOAT, 1, idim2,nvarid)
#endif
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,champhys)
#else
      ierr = NF_PUT_VAR_REAL (nid,nvarid,champhys)
#endif

      CALL gr_dyn_fi(1, iip1, jjp1, klon, rugsrel, champhys)
      ierr = NF_REDEF (nid)
#ifdef NC_DOUBLE
      ierr = NF_DEF_VAR (nid, "RUGSREL", NF_DOUBLE, 1, idim2,nvarid)
#else
      ierr = NF_DEF_VAR (nid, "RUGSREL", NF_FLOAT, 1, idim2,nvarid)
#endif
      ierr = NF_ENDDEF(nid)
#ifdef NC_DOUBLE
      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,champhys)
#else
      ierr = NF_PUT_VAR_REAL (nid,nvarid,champhys)
#endif
c
      ierr = NF_CLOSE(nid)
c
c
c  Calcul des champs dynamiques initiaux a partir de donnees issues
c  du centre Europeen.
c   ---------------------------------------------------------------------
c
      ierr = NF_OPEN("ECDYN.nc",NF_NOWRITE,nid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme d ouverture du fichier ECDYN.nc"
         CALL abort
      ENDIF
c
      ierr = NF_INQ_DIMID(nid,"longitude",nvarid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur de longitude"
         CALL abort
      ENDIF
      ierr = NF_INQ_DIMLEN(nid,nvarid,imdep)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir la taille de longitude"
         CALL abort
      ENDIF
      ierr = NF_INQ_VARID (nid,"longitude",nvarid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur longitude"
         CALL abort
      ENDIF
      ierr = NF_GET_VAR_REAL(nid, nvarid, dlon)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour extraire longitude"
         CALL abort
      ENDIF
c
      ierr = NF_INQ_DIMID(nid,"latitude",nvarid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur de latitude"
         CALL abort
      ENDIF
      ierr = NF_INQ_DIMLEN(nid,nvarid,jmdep)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir la taille de latitude"
         CALL abort
      ENDIF
      ierr = NF_INQ_VARID (nid,"latitude",nvarid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur latitude"
         CALL abort
      ENDIF
      ierr = NF_GET_VAR_REAL(nid, nvarid, dlat)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour extraire latitude"
         CALL abort
      ENDIF
c
      ierr = NF_INQ_DIMID(nid,"plev",nvarid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur de plev"
         CALL abort
      ENDIF
      ierr = NF_INQ_DIMLEN(nid,nvarid,lmdep)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir la taille de plev"
         CALL abort
      ENDIF
      ierr = NF_INQ_VARID (nid,"plev",nvarid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur plev"
         CALL abort
      ENDIF
      ierr = NF_GET_VAR_REAL(nid, nvarid, plev)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour extraire plev"
         CALL abort
      ENDIF
c
      PRINT*,'saison ',saison
      PRINT*,'Entrer le jour du debut de la simulation'

cc     PRINT*,'1er juin =151  1er janvier=1 ...'


cc**************************************************************
cc    anneeref   avec 4 chiffres , en prevision de l'an 2000  .
cc**************************************************************
cc    Modif.   ( P. Le Van )

c
c      READ(*,*) dayref
c      READ(*,*) anneeref
c
      ierr = NF_INQ_VARID (nid,"Z",nvarid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur Z"
         CALL abort
      ENDIF
      ierr = NF_GET_VAR_REAL(nid, nvarid, champ)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour extraire Z"
         CALL abort
      ENDIF
c
      print*, "dlon=", dlon
      print*, "dlat=", dlat
      print*, "plev=", plev
      print*, "rlatu=", rlatu
      print*, "rlonv=", rlonv
      CALL grille_m(imdep, jmdep, dlon, dlat, champ,
     .             iim, jjp1, rlonv, rlatu, champint)
      CALL gr_int_dyn(champint, phisol, iim, jjp1)

      CALL minmax( iip1*jjp1,phisol,champmin,champmax )
      PRINT*,'phisol = ', champmin, champmax
c
c
      ierr = NF_INQ_VARID (nid,"SP",nvarid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur SP"
         CALL abort
      ENDIF
      ierr = NF_GET_VAR_REAL(nid, nvarid, champ)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour extraire SP"
         CALL abort
      ENDIF
      CALL grille_m(imdep, jmdep, dlon, dlat, champ,
     .             iim, jjp1, rlonv, rlatu, champint)
      CALL gr_int_dyn(champint, psol, iim, jjp1)

      CALL minmax( iip1*jjp1,psol,champmin,champmax )
      PRINT*,'psol = ', champmin, champmax

c     ....     psol calcule en  Pascals  ....
c
      DO j = 1, jjp1
      DO i = 1, iim
         psol(i,j)    = psol(i,j)*(1.0+(phisol(i,j)-phis(i,j))
     .                             /287.0/tsol(i,j))
      ENDDO
         psol(iip1,j) = psol(1,j)
      ENDDO

      IF( alphax.NE.0. )   THEN
        DO  ij   = 1, iim
         xppn(ij) = aire( ij,1   ) * psol( ij,1    )
         xpps(ij) = aire( ij,jjp1) * psol( ij,jjp1 )
        ENDDO
        xpn      = SSUM(iim,xppn,1)/apoln
        xps      = SSUM(iim,xpps,1)/apols

        DO ij   = 1, iip1
        psol(ij,1    )  = xpn
        psol(ij,jjp1 )  = xps
        ENDDO
      ENDIF
c

      CALL minmax( iip1*jjp1,psol,champmin,champmax )
      PRINT*,'psol = ', champmin, champmax
c
c
c    ...........................................................
c
      CALL inifilr
        print *,' Apres inifilr '
      CALL pression( ip1jmp1, ap, bp, psol, p )

        print *,' Apres pression '
      CALL exner_hyb(ip1jmp1,psol,p,alpha,beta,pks,pk,scratch)
        print *,' Apres exner_hyb '
      
c    ....  Calcul de pls , pression au milieu des couches ,en Pascals ....
c
      PRINT *,' Pref kappa unskap  ',preff,kappa,unskap

      prefkap =  preff  ** kappa
      DO l = 1, llm
       DO j=1,jjp1
        DO i =1, iip1
        pls(i,j,l) = preff * ( pk(i,j,l)/cpp) ** unskap
        ENDDO
       ENDDO
       ENDDO

       DO l=1,llm
        CALL minmax(jjp1*iip1,pls(1,1,l),champmin,champmax )
        PRINT *,' PLS l ',l,champmin,champmax 
       ENDDO
c
      ierr = NF_INQ_VARID (nid,"U",nvarid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur U"
         CALL abort
      ENDIF
      ierr = NF_GET_VAR_REAL(nid, nvarid, champ3d)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour extraire U"
         CALL abort
      ENDIF
c
C je suppose que les niveaux de pression sont numerotes de bas en haut:
c         psol = 1
c         haut = lmdep
c Interpolation horizontale
      DO l = 1, lmdep
        DO j = 1, jmdep
          DO i = 1, imdep
            champ(imdep*(j-1)+i) =
     .            champ3d(i + (j-1)*imdep + (l-1)*jmdep*imdep)
          ENDDO
        ENDDO

      CALL minmax( imdep*jmdep,champ, champmin, champmax )

       PRINT *,' CHAMP U l ',l,champmin,champmax,imdep,jmdep
     ,,lmdep

      CALL grille_m(imdep, jmdep, dlon, dlat, champ,
     .             iim, jjp1, rlonu, rlatu, champint)
       CALL gr_int_dyn(champint, champecrit, iim, jjp1)
c
      CALL minmax( iip1*jjp1,champecrit, champmin, champmax )


       PRINT*, 'vitesse u l=', l, plev(l),champmin,champmax

        DO j = 1, jjp1
          DO i = 1, iip1
            champhor(i, j, l) = champecrit (i, j)
          ENDDO
        ENDDO
      ENDDO
c Interpolation verticale par spline
      DO j=1,jjp1
        DO  i=1,iim
          DO l=1,lmdep
            ax(l)=plev(lmdep-l+1) * 100.0
            ay(l)=champhor(i,j,lmdep-l+1)
          ENDDO
          CALL SPLINE(ax,ay,lmdep,1.e30,1.e30,yder)
          DO  l=1,llm
           bx = pls(i,j,llm-l+1)
            CALL SPLINT(ax,ay,yder,lmdep,bx,by)
            champ3decr(i,j,llm-l+1)= by
          ENDDO
        ENDDO
        DO l = 1, llm
          champ3decr(iip1, j, llm-l+1) = champ3decr(1, j, llm-l+1)
        ENDDO
      ENDDO
C Passage aux vents covariants
      DO l = 1, llm
        DO j=1,jjp1
          DO i = 1, iim
            ucov(i,j,l) = champ3decr(i,j,l) * cu (i, j)
          ENDDO
            ucov(iip1,j,l) = ucov(1,j,l)
        ENDDO
      ENDDO
C Traitement du vent meridien
c
      ierr = NF_INQ_VARID (nid,"V",nvarid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur V"
         CALL abort
      ENDIF
      ierr = NF_GET_VAR_REAL(nid, nvarid, champ3d)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour extraire V"
         CALL abort
      ENDIF
c
c Interpolation horizontale
      DO l = 1, lmdep
        DO j = 1, jmdep
          DO i = 1, imdep
            champ(imdep*(j-1)+i) =
     .            champ3d(i + (j-1)*imdep + (l-1)*jmdep*imdep)
          ENDDO
        ENDDO
        CALL grille_m(imdep, jmdep, dlon, dlat, champ,
     .             iim, jjm, rlonv, rlatv, champint)
        CALL gr_int_dyn(champint, champecrit, iim, jjm)
c
c
        CALL minmax( iip1*jjm, champecrit, champmin, champmax )

        PRINT*, 'vitesse v  l=', l, plev(l),champmin,champmax

        DO j = 1, jjm
          DO i = 1, iim
            champhor(i, j, l) = champecrit (i, j)
          ENDDO
        ENDDO
      ENDDO
c Interpolation verticale par spline
      DO j=1,jjm
        DO  i=1,iim
          DO l=1,lmdep
            ax(l)=plev(lmdep-l+1) * 100.0
            ay(l)=champhor(i,j,lmdep-l+1)
          ENDDO
          CALL SPLINE(ax,ay,lmdep,1.e30,1.e30,yder)
          DO  l=1,llm
            bx = pls(i,j,llm-l+1)
            CALL SPLINT(ax,ay,yder,lmdep,bx,by)
            vcov(i,j,llm-l+1)=by
          ENDDO
        ENDDO
        DO l = 1, llm
          vcov(iip1, j, l) = vcov(1, j, l)
        ENDDO
      ENDDO
C Passage aux vents covariants
      DO l = 1, llm
        DO j=1,jjm
          DO i = 1, iim
            vcov(i,j,l) = vcov(i,j,l) * cv (i, j)
          ENDDO
            vcov(iip1,j,l) = vcov(1,j,l)
        ENDDO
      ENDDO

C Traitement de l'enthalpie/temperature
c ........................................
c
      ierr = NF_INQ_VARID (nid,"TEMP",nvarid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur T"
         CALL abort
      ENDIF
      ierr = NF_GET_VAR_REAL(nid, nvarid, champ3d)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour extraire T"
         CALL abort
      ENDIF

      CALL minmax( imdep*jmdep*lmdep,champ3d, champmin, champmax )

      PRINT *, 'temperature lue = ', champmin, champmax


C je suppose que les niveaux de pression sont numerotes de bas en haut:
c         psol = 1
c         haut = lmdep
c Interpolation horizontale
      DO l = 1, lmdep
        DO j = 1, jmdep
          DO i = 1, imdep
            champ(imdep*(j-1)+i) =
     .            champ3d(i + (j-1)*imdep + (l-1)*jmdep*imdep)
          ENDDO
        ENDDO
      CALL grille_m(imdep, jmdep, dlon, dlat, champ,
     .             iim, jjp1, rlonv, rlatu, champint)
        CALL gr_int_dyn(champint, champecrit, iim, jjp1)

       CALL minmax( iip1*jjp1, champecrit, champmin, champmax )

        PRINT*, 'temperature l=', l, plev(l), champmin, champmax

        DO j = 1, jjp1
          DO i = 1, iip1
            champhor(i, j, l) = champecrit (i, j)
          ENDDO
        ENDDO
      ENDDO
c Interpolation verticale par spline
c
        PRINT *,'PLS '
        DO l =1,llm
         CALL minmax( iip1*jjp1, plls(1,l), champmin, champmax )
        PRINT *,l, champmin,champmax
        ENDDO

      DO j=1,jjp1
        DO  i=1,iim
          DO l=1,lmdep
            ax(l)=plev(lmdep-l+1) * 100.0
            ay(l)=champhor(i,j,lmdep-l+1)
          ENDDO
          CALL SPLINE(ax,ay,lmdep,1e30,1.e30,yder)
          DO  l=1,llm
            bx = pls(i,j,llm-l+1)
            CALL SPLINT(ax,ay,yder,lmdep,bx,by)
            scratch(i,j,llm-l+1) = by
          ENDDO
        ENDDO

        DO l = 1, llm
          scratch(iip1, j, l) = scratch(1, j, l)
        ENDDO
      ENDDO
       
       DO l =1,llm
        CALL minmax( iip1*jjp1, scrat(1,l), champmin, champmax )
       PRINT*, 'temperature natur.',l,champmin,champmax
       ENDDO

C Passage a la temperature potentielle(et non a l'enthalpie potent.)
c
c
c
c   -----------------------------------------------------------------
c    Calcul de la temperature potentielle = temp * ( preff/p)** kappa 
c                                         = temp * ( cp/exner )
c   -----------------------------------------------------------------
      DO l = 1, llm
        DO j=1,jjp1
          DO i = 1, iim
            temp(i,j,l) = scratch(i,j,l) * cpp / pk(i,j,l)
          ENDDO
            temp(iip1,j,l) = temp(1,j,l)
        ENDDO
      ENDDO

      IF( alphax.NE.0. )   THEN
        DO  l = 1, llm
          DO   i   = 1, iim
            xppn(i) = aire( i,   1  ) * temp(  i,  1  ,l )
            xpps(i) = aire( i, jjp1 ) * temp(  i, jjp1,l )
          ENDDO
            xpn      = SSUM(iim,xppn,1)/apoln
            xps      = SSUM(iim,xpps,1)/apols

          DO  i   = 1, iip1
            temp(  i,  1   ,l )  = xpn
            temp(  i, jjp1, l )  = xps
          ENDDO
        ENDDO
      ENDIF
c

      DO iq = 1, nqmx
      DO l = 1, llm
        DO j=1,jjp1
          DO i = 1, iip1
            q(i,j,l,iq)=0.0
          ENDDO
        ENDDO
      ENDDO
      ENDDO


      PRINT *,'Traitement de l humidite '

C Traitement de l'humidite
c
      ierr = NF_INQ_VARID (nid,"R",nvarid)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour avoir identificateur R"
         CALL abort
      ENDIF
      ierr = NF_GET_VAR_REAL(nid, nvarid, champ3d)
      IF (ierr.NE.NF_NOERR) THEN
         PRINT*, "Probleme pour extraire R"
         CALL abort
      ENDIF
c
C je suppose que les niveaux de pression sont numerotes de bas en haut:
c         psol = 1
c         haut = lmdep
c Interpolation horizontale
        PRINT *,' INTERP.  HORIZ . DE Q  '
      DO l = 1, lmdep
        DO j = 1, jmdep
          DO i = 1, imdep
            champ(imdep*(j-1)+i) =
     .            champ3d(i + (j-1)*imdep + (l-1)*jmdep*imdep)
          ENDDO
        ENDDO

       CALL minmax( imdep*jmdep, champ, champmin, champmax )
       PRINT *,' CHAMP Q l .',l,champmin,champmax

      CALL grille_m(imdep, jmdep, dlon, dlat, champ,
     .             iim, jjp1, rlonv, rlatu, champint)
        CALL gr_int_dyn(champint, champecrit, iim, jjp1)

       CALL minmax( iip1*jjp1, champecrit, champmin, champmax )

         PRINT*, 'humidite rel  l=', l, plev(l),champmin,champmax

        DO j = 1, jjp1
          DO i = 1, iip1
            champhor(i, j, l) = champecrit (i, j)
          ENDDO
        ENDDO
      ENDDO

c Interpolation verticale par spline
      PRINT *,' INTERP. VERTIC. DE Q .'

      DO j=1,jjp1
        DO  i=1,iim
          DO  l=1,lmdep
            ax(l) = plev(lmdep-l+1) * 100.0
            ay(l) = champhor(i,j,lmdep-l+1)
          ENDDO
          CALL SPLINE(ax,ay,lmdep,1.e30,1.e30,yder)
          DO  l=1,llm
            bx = pls(i,j,llm-l+1)
            CALL SPLINT(ax,ay,yder,lmdep,bx,by)
            champ3decr(i,j,llm-l+1)=by
          ENDDO
        ENDDO
        DO l = 1, llm
          champ3decr(iip1, j, l) = champ3decr(1, j, l)
        ENDDO
      ENDDO

c
      seuil_vap = 1.0e-10
c
C Passage au rapport de melange
      DO l = 1, llm
        DO j=1,jjp1
          DO i = 1, iim
            ttt      =  scratch(i,j,l)
            millibar(i,j) = pls(i,j,l) / 100.0
            qsat     = q_sat( ttt,millibar(i,j) )
            q(i,j,l,ivap) = 0.01*champ3decr(i,j,l) * qsat
            IF( q(i,j,l,ivap).LT.0. ) q(i,j,l,ivap) = seuil_vap
          ENDDO
            q(iip1,j,l,ivap) = q(1,j,l,ivap)
        ENDDO
      ENDDO


      IF( alphax.NE.0. )   THEN
       DO  iq = 1, nqmx
        DO  l = 1, llm
          DO   i   = 1, iim
            xppn(i) = aire( i,   1  ) * q(  i,  1  ,l, iq )
            xpps(i) = aire( i, jjp1 ) * q(  i, jjp1,l, iq )
          ENDDO
            xpn      = SSUM(iim,xppn,1)/apoln
            xps      = SSUM(iim,xpps,1)/apols

          DO  i   = 1, iip1
            q(  i,  1   ,l, iq )  = xpn
            q(  i, jjp1, l, iq )  = xps
          ENDDO
        ENDDO
       ENDDO
      ENDIF
c
       ierr = NF_CLOSE(nid)

c  .... Calcul de la masse d'air dans chaque maille   et stockage
c  ...........               dans   masse       ................. 

          CALL massdair( p, masse  )
c
      IF( alphax.NE.0. )   THEN
       DO  l = 1, llm
         DO  ij    = 1, iim
          xppn(ij) = aire( ij, 1   ) * masse(  ij     , l )
          xpps(ij) = aire( ij,jjp1 ) * masse( ij+ip1jm, l )
         ENDDO
          xpn      = SSUM(iim,xppn,1)/apoln
          xps      = SSUM(iim,xpps,1)/apols
         DO ij   = 1, iip1
          masse(   ij    ,  l )   = xpn
          masse( ij+ip1jm,  l )   = xps
         ENDDO
       ENDDO
      ENDIF
c
c
c-----------------------------------------------------------------------
c   ecriture du fichier de demarrage:
c   --------------------------------
c
      etot0 = 0.
      ptot0 = 0.
      stot0 = 0.
      ztot0 = 0.
      ang0  = 0.

      daysec= 86400.
c-----------------------------------------------------------------------
c
      DO l = 1,llm

      PRINT *, 'NIVEAU L ',l
      CALL minmax( iip1*jjp1, uucov(1,l), champmin, champmax )
      PRINT*, 'ucov = ', champmin,champmax

      CALL minmax( iip1*jjm, vvcov(1,l), champmin, champmax )
      PRINT*, 'vcov = ', champmin,champmax
c
      CALL minmax( iip1*jjp1, ttemp(1,l), champmin, champmax )
      PRINT*, 'temp. potentielle = ', champmin,champmax

      CALL minmax( iip1*jjp1, qq(1,l,ivap), champmin, champmax )
      PRINT*, 'q  = ', champmin,champmax
c
      CALL minmax( iip1*jjp1, masse(1,l), champmin, champmax )
      PRINT*, 'masse = ', champmin,champmax
c

      ENDDO

      CALL minmax( iip1*jjp1, psol, champmin, champmax )
      PRINT*, 'psol = ', champmin,champmax
c
      CALL minmax( iip1*jjp1, phis, champmin, champmax )
      PRINT*, 'phis = ', champmin,champmax

c
c-----------------------------------------------------------------------
c

      CALL inidissip( lstardis, nitergdiv, nitergrot, niterh   ,
     *                tetagdiv, tetagrot , tetatemp              )
      itau = 0
      iday = dayref +itau/day_step
      time = FLOAT(itau-(iday-dayref)*day_step)/day_step

      IF(time.GT.1)  THEN
       time = time - 1
       iday = iday + 1
      ENDIF


      CALL geopot  ( ip1jmp1, temp  , pk , pks,  phis  , phi   )
c
      CALL caldyn0 ( itau,ucov,vcov,temp,psol,masse,pk,phis ,
     *                phi,w, pbaru,pbarv,time+iday-dayref   )

      CALL dynredem0("start.nc",dayref,anneeref,phis,nqmx)
c
      CALL dynredem1("start.nc",0.0,vcov,ucov,temp,q,nqmx,masse ,
     .                            psol)


      STOP
      END

      FUNCTION q_sat(kelvin, millibar)
c
      IMPLICIT none
c======================================================================
c Autheur(s): Z.X. Li (LMD/CNRS)
c Objet: calculer la vapeur d'eau saturante (formule Centre Euro.)
c======================================================================
c Arguments:
c kelvin---input-R: temperature en Kelvin
c millibar--input-R: pression en mb
c
c q_sat----output-R: vapeur d'eau saturante en kg/kg
c======================================================================
c
      REAL q_sat, kelvin, millibar
c
      REAL r2es
      PARAMETER (r2es=611.14 *18.0153/28.9644)
c
      REAL r3les, r3ies, r3es
      PARAMETER (R3LES=17.269)
      PARAMETER (R3IES=21.875)
c
      REAL r4les, r4ies, r4es
      PARAMETER (R4LES=35.86)
      PARAMETER (R4IES=7.66)
c
      REAL rtt
      PARAMETER (rtt=273.16)
c
      REAL retv
      PARAMETER (retv=28.9644/18.0153 - 1.0)
c
      REAL zqsat
      REAL temp, pres
C     ------------------------------------------------------------------
c
c
      temp = kelvin
      pres = millibar * 100.0
c
      IF (temp .LE. rtt) THEN
         r3es = r3ies
         r4es = r4ies
      ELSE
         r3es = r3les
         r4es = r4les
      ENDIF
c
      zqsat=r2es/pres * EXP ( r3es*(temp-rtt) / (temp-r4es) )
      zqsat=MIN(0.5,ZQSAT)
      zqsat=zqsat/(1.-retv  *zqsat)
c
      q_sat = zqsat
c
      RETURN
      END
