      SUBROUTINE histday_surface(filename,itap,freq,dtime,
     &           phis,aire,rlon,rlat,
     &           tsol,psol,rain,snow,evap,tops,topl,
     &           solsup,solsdn,sollup,solldn,bils,sens,fluxg,fluxo,
     &           fder,frtu,frtv,ruis,sicf,cldl,cldm,cldh,cldt,cldq,
     &           slp,t2m,q2m,u10m,v10m,
     &           ok_slab,tslab,sice)
      IMPLICIT none
#include "dimensions.h"
#include "dimphy.h"
! Parametres d'entree
      CHARACTER*(*) filename
      INTEGER itap
      REAL freq, dtime
      REAL rlon(klon), rlat(klon), phis(klon), aire(klon)
      REAL tsol(klon),psol(klon),rain(klon),snow(klon),evap(klon)
      REAL tops(klon),topl(klon),solsup(klon),solsdn(klon)
      REAL sollup(klon),solldn(klon),bils(klon),sens(klon)
      REAL fluxg(klon),fluxo(klon),fder(klon),frtu(klon),frtv(klon)
      REAL ruis(klon),sicf(klon)
      REAL cldl(klon),cldm(klon),cldh(klon),cldt(klon),cldq(klon)
      REAL slp(klon), t2m(klon), q2m(klon),u10m(klon), v10m(klon)
      REAL temp(klon,klev), ovap(klon,klev), geop(klon,klev)
      REAL vitu(klon,klev), vitv(klon,klev), vitw(klon,klev)
      REAL pres(klon,klev)
      LOGICAL ok_slab
      REAL tslab(klon,klev), sice(klon,klev)

      LOGICAL first_appel 
      SAVE first_appel
      INTEGER nid, nhori
      SAVE nid, nhori

! variable tampon pour convertir la grille physique
      REAL tmp(iim,jjm+1)
      REAL tmp_lat(iim,jjm+1), tmp_lon(iim,jjm+1)
      REAL zx_lon(iim), zx_lat(jjm+1)
      INTEGER ndex2d(iim*(jjm+1))

      INTEGER i, j, itau_w
      REAL zjulian, zsto, zout
!
      DATA first_appel /.TRUE./

      itau_w = itap
      DO i = 1, iim*(jjm+1)
      ndex2d(i) = 0
      ENDDO

      IF (first_appel) THEN
!
! initialisation sorties netcdf
!
      CALL ymds2ju(1900, 1, 1, 0.0, zjulian) 
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,rlon,tmp_lon)
      DO i = 1, iim
        tmp_lon(i,1) = rlon(i+1)
        tmp_lon(i,jjm+1) = rlon(i+1)
      ENDDO
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,rlat,tmp_lat)
      DO i = 1, iim
         zx_lon(i) = tmp_lon(i,1)
      ENDDO
      DO j = 1, jjm+1
         zx_lat(j) = tmp_lat(1,j)
      ENDDO
      CALL histbeg(filename,iim,zx_lon,jjm+1,
     &             zx_lat,1,iim,1,jjm+1,0,zjulian,
     &             dtime,nhori,nid)

      zsto = dtime
      zout = dtime

      CALL histdef(nid, 'nav_lon','Longitudes',"Degrees",
     & iim, jjm+1, nhori, 1, 1, 1, -99, 32, "once", zsto,zout)
      CALL histdef(nid, 'nav_lat','Latitudes',"Degrees",
     & iim, jjm+1, nhori, 1, 1, 1, -99, 32, "once", zsto,zout)
      CALL histdef(nid, 'phis','Surface geopotential',"m",
     & iim, jjm+1, nhori, 1, 1, 1, -99, 32, "once(X/9.81)", zsto,zout)
      CALL histdef(nid, 'aire','Grid area',"m2",
     & iim, jjm+1, nhori, 1, 1, 1, -99, 32, "once", zsto,zout)

      zsto = dtime
      zout = dtime * FLOAT(NINT(86400./dtime*freq))

      CALL histdef(nid, "tsol", "Surface Temperature", "K",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "psol", "Surface Pressure", "Pa",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "rain", "Rainfall rate", "mm/d",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)

      CALL histdef(nid, "snow", "Snowfall rate", "mm/d",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "evap", "Evaporation", "kg/m2/s",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "tops", "Solar rad. at TOA", "W/m2",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "topl", "IR rad. at TOA", "W/m2",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "solsup", "Solar rad. at surf.", "W/m2",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "solsdn", "Solar rad. at surf.", "W/m2",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "sollup", "IR rad. at surface", "W/m2",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "solldn", "IR rad. at surface", "W/m2",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "bils", "Surf. total heat flux", "W/m2",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "sens", "Sensible heat flux", "W/m2",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "fluxg", "Sea-ice bottom flux", "W/m2",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "fluxo", "ocean Sens.+lat. heat", "W/m2",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "fder", "Heat flux derivation", "W/m2",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "frtu", "Zonal wind stress", "Pa",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "frtv", "Meridional wind stress", "Pa",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "ruis", "Runoff", "mm/day",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "sicf", "Sea-ice fraction", "-",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      IF (ok_slab) THEN
      CALL histdef(nid, "tslab", "Slab ocean temp.", "K",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
      CALL histdef(nid, "sice", "Sea-ice masse", "kg/m2",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
      ENDIF
c
      CALL histdef(nid, "cldl", "Low-level cloudiness", "-",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "cldm", "Mid-level cloudiness", "-",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "cldh", "High-level cloudiness", "-",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "cldt", "Total cloudiness", "-",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "cldq", "Cloud liquid water path", "-",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "slp", "Sea-level pressure", "Pa",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "t2m", "2-metre temperature", "K",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "q2m", "2-metre humidity", "kg/kg",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "u10m", "10-metre U wind", "m/s",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "v10m", "10-metre V wind", "m/s",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)

      CALL histend(nid) 

      CALL histwrite(nid,"nav_lon",itau_w,tmp_lon,iim*(jjm+1),ndex2d)
      CALL histwrite(nid,"nav_lat",itau_w,tmp_lat,iim*(jjm+1),ndex2d)
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,phis,tmp)
      CALL histwrite(nid,"phis",itau_w,tmp,iim*(jjm+1),ndex2d)
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,aire,tmp)
      CALL histwrite(nid,"aire",itau_w,tmp,iim*(jjm+1),ndex2d)

      first_appel = .false.

      ENDIF ! fin if (first_appel) 

      CALL gr_fi_ecrit(1,klon,iim,jjm+1,tsol,tmp)
      CALL histwrite(nid,"tsol",itau_w,tmp,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,psol,tmp)
      CALL histwrite(nid,"psol",itau_w,tmp,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,rain,tmp)
      CALL histwrite(nid,"rain",itau_w,tmp,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,snow,tmp)
      CALL histwrite(nid,"snow",itau_w,tmp,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, evap,tmp)
      CALL histwrite(nid,"evap",itap,tmp,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, tops,tmp)
      CALL histwrite(nid,"tops",itap,tmp,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, topl,tmp)
      CALL histwrite(nid,"topl",itap,tmp,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, solsup,tmp)
      CALL histwrite(nid,"solsup",itap,tmp,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, solsdn,tmp)
      CALL histwrite(nid,"solsdn",itap,tmp,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, sollup,tmp)
      CALL histwrite(nid,"sollup",itap,tmp,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, solldn,tmp)
      CALL histwrite(nid,"solldn",itap,tmp,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, bils,tmp)
      CALL histwrite(nid,"bils",itap,tmp,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, sens,tmp)
      CALL histwrite(nid,"sens",itap,tmp,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, fluxg,tmp)
      CALL histwrite(nid,"fluxg",itap,tmp,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, fluxo,tmp)
      CALL histwrite(nid,"fluxo",itap,tmp,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, fder,tmp)
      CALL histwrite(nid,"fder",itap,tmp,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, ruis,tmp)
      CALL histwrite(nid,"ruis",itap,tmp,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, frtu,tmp)
      CALL histwrite(nid,"frtu",itap,tmp,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, frtv,tmp)
      CALL histwrite(nid,"frtv",itap,tmp,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, sicf,tmp)
      CALL histwrite(nid,"sicf",itap,tmp,iim*(jjm+1),ndex2d)
c
      IF (ok_slab) THEN
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, tslab,tmp)
      CALL histwrite(nid,"tslab",itap,tmp,iim*(jjm+1),ndex2d)
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, sice,tmp)
      CALL histwrite(nid,"sice",itap,tmp,iim*(jjm+1),ndex2d)
      ENDIF
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, cldl,tmp)
      CALL histwrite(nid,"cldl",itap,tmp,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, cldm,tmp)
      CALL histwrite(nid,"cldm",itap,tmp,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, cldh,tmp)
      CALL histwrite(nid,"cldh",itap,tmp,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, cldt,tmp)
      CALL histwrite(nid,"cldt",itap,tmp,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, cldq,tmp)
      CALL histwrite(nid,"cldq",itap,tmp,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, slp,tmp)
      CALL histwrite(nid,"slp",itap,tmp,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, t2m,tmp)
      CALL histwrite(nid,"t2m",itap,tmp,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, q2m,tmp)
      CALL histwrite(nid,"q2m",itap,tmp,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, u10m,tmp)
      CALL histwrite(nid,"u10m",itap,tmp,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, v10m,tmp)
      CALL histwrite(nid,"v10m",itap,tmp,iim*(jjm+1),ndex2d)

      RETURN
      END
      SUBROUTINE histday_modlevs(filename,itap,freq,dtime,
     &           phis,aire,rlon,rlat,presnivs,
     &           psol,
     &           temp,ovap,geop,vitu,vitv,vitw,pres)
      IMPLICIT none
#include "dimensions.h"
#include "dimphy.h"
! Parametres d'entree
      CHARACTER*(*) filename
      INTEGER itap
      REAL freq, dtime
      REAL phis(klon),aire(klon),rlon(klon),rlat(klon),presnivs(klev)
      REAL psol(klon)
      REAL temp(klon,klev), ovap(klon,klev), geop(klon,klev)
      REAL vitu(klon,klev), vitv(klon,klev), vitw(klon,klev)
      REAL pres(klon,klev)

      LOGICAL first_appel 
      SAVE first_appel
      INTEGER nid, nhori, nvert
      SAVE nid, nhori, nvert

! variable tampon pour convertir la grille physique
      REAL tmp2d(iim,jjm+1), tmp3d(iim,jjm+1,klev)
      REAL tmp_lat(iim,jjm+1), tmp_lon(iim,jjm+1)
      REAL zx_lon(iim), zx_lat(jjm+1)
      INTEGER ndex2d(iim*(jjm+1)), ndex3d(iim*(jjm+1)*klev)

      INTEGER i, j, itau_w
      REAL zjulian, zsto, zout
!
      DATA first_appel /.TRUE./

      itau_w = itap
      DO i = 1, iim*(jjm+1)
      ndex2d(i) = 0
      ENDDO
      DO i = 1, iim*(jjm+1)*klev
      ndex3d(i) = 0
      ENDDO

      IF (first_appel) THEN
!
! initialisation sorties netcdf
!
      CALL ymds2ju(1900, 1, 1, 0.0, zjulian) 
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,rlon,tmp_lon)
      DO i = 1, iim
        tmp_lon(i,1) = rlon(i+1)
        tmp_lon(i,jjm+1) = rlon(i+1)
      ENDDO
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,rlat,tmp_lat)
      DO i = 1, iim
         zx_lon(i) = tmp_lon(i,1)
      ENDDO
      DO j = 1, jjm+1
         zx_lat(j) = tmp_lat(1,j)
      ENDDO
      CALL histbeg(filename,iim,zx_lon,jjm+1,
     &             zx_lat,1,iim,1,jjm+1,0,zjulian,
     &             dtime,nhori,nid)
      CALL histvert(nid, "presnivs", "Vertical levels", "mb",
     .              klev, presnivs, nvert)

      zsto = dtime
      zout = dtime

      CALL histdef(nid, 'nav_lon','Longitudes',"Degrees",
     & iim, jjm+1, nhori, 1, 1, 1, -99, 32, "once", zsto,zout)
      CALL histdef(nid, 'nav_lat','Latitudes',"Degrees",
     & iim, jjm+1, nhori, 1, 1, 1, -99, 32, "once", zsto,zout)
      CALL histdef(nid, 'phis','Surface geopotential',"m",
     & iim, jjm+1, nhori, 1, 1, 1, -99, 32, "once(X/9.81)", zsto,zout)
      CALL histdef(nid, 'aire','Grid area',"m2",
     & iim, jjm+1, nhori, 1, 1, 1, -99, 32, "once", zsto,zout)

      zsto = dtime
      zout = dtime * FLOAT(NINT(86400./dtime*freq))
c
      CALL histdef(nid, "psol", "Surface Pressure", "Pa",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
c
      CALL histdef(nid, "temp", "Air temperature", "K",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "ovap", "Specific humidity", "Kg/Kg",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "geop", "Geopotential height", "m",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "vitu", "Zonal wind", "m/s",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "vitv", "Meridional wind", "m/s",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "vitw", "Vertical wind", "m/s",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "pres", "Air pressure", "Pa",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histend(nid) 
c
      CALL histwrite(nid,"nav_lon",itau_w,tmp_lon,iim*(jjm+1),ndex2d)
      CALL histwrite(nid,"nav_lat",itau_w,tmp_lat,iim*(jjm+1),ndex2d)
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,phis,tmp2d)
      CALL histwrite(nid,"phis",itau_w,tmp2d,iim*(jjm+1),ndex2d)
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,aire,tmp2d)
      CALL histwrite(nid,"aire",itau_w,tmp2d,iim*(jjm+1),ndex2d)

      first_appel = .FALSE.

      ENDIF ! fin if (first_appel) 
c
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,psol,tmp2d)
      CALL histwrite(nid,"psol",itau_w,tmp2d,iim*(jjm+1),ndex2d)
c
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, temp, tmp3d)
      CALL histwrite(nid,"temp",itap,tmp3d,iim*(jjm+1)*klev,ndex3d)
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, ovap, tmp3d)
      CALL histwrite(nid,"ovap",itap,tmp3d,iim*(jjm+1)*klev,ndex3d)
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, geop, tmp3d)
      CALL histwrite(nid,"geop",itap,tmp3d,iim*(jjm+1)*klev,ndex3d)
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, vitu, tmp3d)
      CALL histwrite(nid,"vitu",itap,tmp3d,iim*(jjm+1)*klev,ndex3d)
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, vitv, tmp3d)
      CALL histwrite(nid,"vitv",itap,tmp3d,iim*(jjm+1)*klev,ndex3d)
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, vitw, tmp3d)
      CALL histwrite(nid,"vitw",itap,tmp3d,iim*(jjm+1)*klev,ndex3d)
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, pres, tmp3d)
      CALL histwrite(nid,"pres",itap,tmp3d,iim*(jjm+1)*klev,ndex3d)
c
      RETURN
      END
      SUBROUTINE histday_stdlevs(filename,itap,freq,dtime,
     &           lstd,tmp3d,ndex3d,
     &           phis,aire,rlon,rlat,presnivs,
     &           psol,
     &           temp,ovap,geop,vitu,vitv)
      IMPLICIT none
#include "dimensions.h"
#include "dimphy.h"
! Parametres d'entree
      CHARACTER*(*) filename
      INTEGER itap, lstd
      REAL freq, dtime
      REAL phis(klon),aire(klon),rlon(klon),rlat(klon),presnivs(lstd)
      REAL psol(klon)
      REAL temp(klon,lstd), ovap(klon,lstd), geop(klon,lstd)
      REAL vitu(klon,lstd), vitv(klon,lstd)
      INTEGER ndex3d(iim*(jjm+1)*lstd)
      REAL tmp3d(iim,jjm+1,lstd)

      LOGICAL first_appel 
      SAVE first_appel
      INTEGER nid, nhori, nvert
      SAVE nid, nhori, nvert

! variable tampon pour convertir la grille physique
      REAL tmp2d(iim,jjm+1)
      REAL tmp_lat(iim,jjm+1), tmp_lon(iim,jjm+1)
      REAL zx_lon(iim), zx_lat(jjm+1)
      INTEGER ndex2d(iim*(jjm+1))

      INTEGER i, j, itau_w
      REAL zjulian, zsto, zout
!
      DATA first_appel /.TRUE./

      itau_w = itap
      DO i = 1, iim*(jjm+1)
      ndex2d(i) = 0
      ENDDO
      DO i = 1, iim*(jjm+1)*lstd
      ndex3d(i) = 0
      ENDDO

      IF (first_appel) THEN
!
! initialisation sorties netcdf
!
      CALL ymds2ju(1900, 1, 1, 0.0, zjulian) 
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,rlon,tmp_lon)
      DO i = 1, iim
        tmp_lon(i,1) = rlon(i+1)
        tmp_lon(i,jjm+1) = rlon(i+1)
      ENDDO
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,rlat,tmp_lat)
      DO i = 1, iim
         zx_lon(i) = tmp_lon(i,1)
      ENDDO
      DO j = 1, jjm+1
         zx_lat(j) = tmp_lat(1,j)
      ENDDO
      CALL histbeg(filename,iim,zx_lon,jjm+1,
     &             zx_lat,1,iim,1,jjm+1,0,zjulian,
     &             dtime,nhori,nid)
      CALL histvert(nid, "levels", "Vertical levels", "mb",
     .              lstd, presnivs, nvert)

      zsto = dtime
      zout = dtime

      CALL histdef(nid, 'nav_lon','Longitudes',"Degrees",
     & iim, jjm+1, nhori, 1, 1, 1, -99, 32, "once", zsto,zout)
      CALL histdef(nid, 'nav_lat','Latitudes',"Degrees",
     & iim, jjm+1, nhori, 1, 1, 1, -99, 32, "once", zsto,zout)
      CALL histdef(nid, 'phis','Surface geopotential',"m",
     & iim, jjm+1, nhori, 1, 1, 1, -99, 32, "once(X/9.81)", zsto,zout)
      CALL histdef(nid, 'aire','Grid area',"m2",
     & iim, jjm+1, nhori, 1, 1, 1, -99, 32, "once", zsto,zout)

      zsto = dtime
      zout = dtime * FLOAT(NINT(86400./dtime*freq))

      CALL histdef(nid, "psol", "Surface pressure", "Pa",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)

      zsto = dtime
      zout = dtime * FLOAT(NINT(86400./dtime*freq))
c
      CALL histdef(nid, "temp", "Air temperature", "K",
     .     iim,jjm+1,nhori, lstd,1,lstd,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "ovap", "Specific humidity", "Kg/Kg",
     .     iim,jjm+1,nhori, lstd,1,lstd,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "geop", "Geopotential height", "m",
     .     iim,jjm+1,nhori, lstd,1,lstd,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "vitu", "Zonal wind", "m/s",
     .     iim,jjm+1,nhori, lstd,1,lstd,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "vitv", "Meridional wind", "m/s",
     .     iim,jjm+1,nhori, lstd,1,lstd,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histend(nid) 
c
      CALL histwrite(nid,"nav_lon",itau_w,tmp_lon,iim*(jjm+1),ndex2d)
      CALL histwrite(nid,"nav_lat",itau_w,tmp_lat,iim*(jjm+1),ndex2d)
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,phis,tmp2d)
      CALL histwrite(nid,"phis",itau_w,tmp2d,iim*(jjm+1),ndex2d)
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,aire,tmp2d)
      CALL histwrite(nid,"aire",itau_w,tmp2d,iim*(jjm+1),ndex2d)

      first_appel = .FALSE.

      ENDIF ! fin if (first_appel) 

      CALL gr_fi_ecrit(1,klon,iim,jjm+1,psol,tmp2d)
      CALL histwrite(nid,"psol",itau_w,tmp2d,iim*(jjm+1),ndex2d)
c
c
      CALL gr_fi_ecrit(lstd,klon,iim,jjm+1, temp, tmp3d)
      CALL histwrite(nid,"temp",itap,tmp3d,iim*(jjm+1)*lstd,ndex3d)
c
      CALL gr_fi_ecrit(lstd,klon,iim,jjm+1, ovap, tmp3d)
      CALL histwrite(nid,"ovap",itap,tmp3d,iim*(jjm+1)*lstd,ndex3d)
c
      CALL gr_fi_ecrit(lstd,klon,iim,jjm+1, geop, tmp3d)
      CALL histwrite(nid,"geop",itap,tmp3d,iim*(jjm+1)*lstd,ndex3d)
c
      CALL gr_fi_ecrit(lstd,klon,iim,jjm+1, vitu, tmp3d)
      CALL histwrite(nid,"vitu",itap,tmp3d,iim*(jjm+1)*lstd,ndex3d)
c
      CALL gr_fi_ecrit(lstd,klon,iim,jjm+1, vitv, tmp3d)
      CALL histwrite(nid,"vitv",itap,tmp3d,iim*(jjm+1)*lstd,ndex3d)
c
      RETURN
      END
      SUBROUTINE histmth(filename,itap,freq,dtime,
     &           phis,aire,rlon,rlat,presnivs,
     &           tsol,psol,rain,snow,evap,tops,topl,tops0,topl0,
     &           solsup,solsdn,sollup,solldn,bils,sens,fluxg,fluxo,
     &           fder,frtu,frtv,ruis,sicf,cldl,cldm,cldh,cldt,cldq,
     &           slp,t2m,q2m,u10m,v10m,
     &           temp,ovap,geop,vitu,vitv,vitw,pres,
     &           rneb,oliq,rhum,
     &           ok_slab,tslab,sice)
      IMPLICIT none
#include "dimensions.h"
#include "dimphy.h"
! Parametres d'entree
      CHARACTER*(*) filename
      INTEGER itap
      REAL freq, dtime
      REAL phis(klon),aire(klon),rlon(klon),rlat(klon),presnivs(klev)
      REAL tsol(klon),psol(klon),rain(klon),snow(klon),evap(klon)
      REAL pluc(klon), plul(klon)
      REAL ue(klon), ve(klon), uq(klon), vq(klon)
      REAL tops(klon),topl(klon),solsup(klon),solsdn(klon)
      REAL tops0(klon),topl0(klon)
      REAL sollup(klon),solldn(klon),bils(klon),sens(klon)
      REAL fluxg(klon),fluxo(klon),fder(klon),frtu(klon),frtv(klon)
      REAL ruis(klon),sicf(klon)
      REAL cldl(klon),cldm(klon),cldh(klon),cldt(klon),cldq(klon)
      REAL slp(klon), t2m(klon), q2m(klon), u10m(klon), v10m(klon)
      REAL temp(klon,klev), ovap(klon,klev), geop(klon,klev)
      REAL vitu(klon,klev), vitv(klon,klev), vitw(klon,klev)
      REAL pres(klon,klev), rneb(klon,klev), oliq(klon,klev)
      REAL rhum(klon,klev)
      LOGICAL ok_slab
      REAL tslab(klon,klev), sice(klon,klev)

      LOGICAL first_appel 
      SAVE first_appel
      INTEGER nid, nhori, nvert
      SAVE nid, nhori, nvert

! variable tampon pour convertir la grille physique
      REAL tmp2d(iim,jjm+1), tmp3d(iim,jjm+1,klev)
      REAL tmp_lat(iim,jjm+1), tmp_lon(iim,jjm+1)
      REAL zx_lon(iim), zx_lat(jjm+1)
      INTEGER ndex2d(iim*(jjm+1)), ndex3d(iim*(jjm+1)*klev)

      INTEGER i, j, itau_w
      REAL zjulian, zsto, zout
!
      DATA first_appel /.TRUE./

      itau_w = itap
      DO i = 1, iim*(jjm+1)
      ndex2d(i) = 0
      ENDDO
      DO i = 1, iim*(jjm+1)*klev
      ndex3d(i) = 0
      ENDDO

      IF (first_appel) THEN
!
! initialisation sorties netcdf
!
      CALL ymds2ju(1900, 1, 1, 0.0, zjulian) 
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,rlon,tmp_lon)
      DO i = 1, iim
        tmp_lon(i,1) = rlon(i+1)
        tmp_lon(i,jjm+1) = rlon(i+1)
      ENDDO
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,rlat,tmp_lat)
      DO i = 1, iim
         zx_lon(i) = tmp_lon(i,1)
      ENDDO
      DO j = 1, jjm+1
         zx_lat(j) = tmp_lat(1,j)
      ENDDO
      CALL histbeg(filename,iim,zx_lon,jjm+1,
     &             zx_lat,1,iim,1,jjm+1,0,zjulian,
     &             dtime,nhori,nid)
      CALL histvert(nid, "presnivs", "Vertical levels", "mb",
     .              klev, presnivs, nvert)

      zsto = dtime
      zout = dtime

      CALL histdef(nid, 'nav_lon','Longitudes',"Degrees",
     & iim, jjm+1, nhori, 1, 1, 1, -99, 32, "once", zsto,zout)
      CALL histdef(nid, 'nav_lat','Latitudes',"Degrees",
     & iim, jjm+1, nhori, 1, 1, 1, -99, 32, "once", zsto,zout)
      CALL histdef(nid, 'phis','Surface geopotential',"m",
     & iim, jjm+1, nhori, 1, 1, 1, -99, 32, "once(X/9.81)", zsto,zout)
      CALL histdef(nid, 'aire','Grid area',"m2",
     & iim, jjm+1, nhori, 1, 1, 1, -99, 32, "once", zsto,zout)

      zsto = dtime
      zout = dtime * FLOAT(NINT(86400./dtime*freq))

      CALL histdef(nid, "tsol", "Surface Temperature", "K",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "psol", "Surface Pressure", "Pa",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "rain", "Rainfall rate", "mm/s",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "snow", "Snowfall rate", "mm/s",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "plul", "Large-scale precip rate", "mm/s",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "pluc", "Convective precip rate", "mm/s",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "evap", "Evaporation", "kg/m2/s",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "tops", "Solar rad. at TOA", "W/m2",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "topl", "IR rad. at TOA", "W/m2",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "tops0", "Solar rad. at TOA", "W/m2",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "topl0", "IR rad. at TOA", "W/m2",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "solsup", "Solar rad. at surf.", "W/m2",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "solsdn", "Solar rad. at surf.", "W/m2",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "sollup", "IR rad. at surface", "W/m2",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "solldn", "IR rad. at surface", "W/m2",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "bils", "Surf. total heat flux", "W/m2",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "sens", "Sensible heat flux", "W/m2",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "fluxg", "Sea-ice bottom flux", "W/m2",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "fluxo", "ocean Sens.+lat. heat", "W/m2",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "fder", "Heat flux derivation", "W/m2",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "frtu", "Zonal wind stress", "Pa",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "frtv", "Meridional wind stress", "Pa",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "ruis", "Runoff", "mm/day",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "sicf", "Sea-ice fraction", "-",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      IF (ok_slab) THEN
      CALL histdef(nid, "tslab", "Slab ocean temp.", "K",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
      CALL histdef(nid, "sice", "Sea-ice masse", "kg/m2",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
      ENDIF
c
      CALL histdef(nid, "cldl", "Low-level cloudiness", "-",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "cldm", "Mid-level cloudiness", "-",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "cldh", "High-level cloudiness", "-",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "cldt", "Total cloudiness", "-",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "cldq", "Cloud liquid water path", "-",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "slp", "Sea-level pressure", "Pa",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "t2m", "2-metre temperature", "K",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "q2m", "2-metre humidity", "kg/kg",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "u10m", "10-metre U wind", "m/s",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "v10m", "10-metre V wind", "m/s",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "ue", "Zonal energy transport", "-",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "ve", "Merid energy transport", "-",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "uq", "Zonal humidity transport", "-",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "vq", "Merid humidity transport", "-",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
c
      CALL histdef(nid, "temp", "Air temperature", "K",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "ovap", "Specific humidity", "Kg/Kg",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "geop", "Geopotential height", "m",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "vitu", "Zonal wind", "m/s",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "vitv", "Meridional wind", "m/s",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "vitw", "Vertical wind", "m/s",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "pres", "Air pressure", "Pa",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "rneb", "Cloud fraction", "-",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "rhum", "Relative humidity", "-",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "oliq", "Liquid water content", "kg/kg",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histend(nid) 
c
      CALL histwrite(nid,"nav_lon",itau_w,tmp_lon,iim*(jjm+1),ndex2d)
      CALL histwrite(nid,"nav_lat",itau_w,tmp_lat,iim*(jjm+1),ndex2d)
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,phis,tmp2d)
      CALL histwrite(nid,"phis",itau_w,tmp2d,iim*(jjm+1),ndex2d)
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,aire,tmp2d)
      CALL histwrite(nid,"aire",itau_w,tmp2d,iim*(jjm+1),ndex2d)

      first_appel = .FALSE.

      ENDIF ! fin if (first_appel) 

      CALL gr_fi_ecrit(1,klon,iim,jjm+1,tsol,tmp2d)
      CALL histwrite(nid,"tsol",itau_w,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,psol,tmp2d)
      CALL histwrite(nid,"psol",itau_w,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,rain,tmp2d)
      CALL histwrite(nid,"rain",itau_w,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,snow,tmp2d)
      CALL histwrite(nid,"snow",itau_w,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, pluc,tmp2d)
      CALL histwrite(nid,"pluc",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, plul,tmp2d)
      CALL histwrite(nid,"plul",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, evap,tmp2d)
      CALL histwrite(nid,"evap",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, tops,tmp2d)
      CALL histwrite(nid,"tops",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, topl,tmp2d)
      CALL histwrite(nid,"topl",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, tops0,tmp2d)
      CALL histwrite(nid,"tops0",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, topl0,tmp2d)
      CALL histwrite(nid,"topl0",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, solsup,tmp2d)
      CALL histwrite(nid,"solsup",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, solsdn,tmp2d)
      CALL histwrite(nid,"solsdn",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, sollup,tmp2d)
      CALL histwrite(nid,"sollup",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, solldn,tmp2d)
      CALL histwrite(nid,"solldn",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, bils,tmp2d)
      CALL histwrite(nid,"bils",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, sens,tmp2d)
      CALL histwrite(nid,"sens",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, fluxg,tmp2d)
      CALL histwrite(nid,"fluxg",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, fluxo,tmp2d)
      CALL histwrite(nid,"fluxo",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, fder,tmp2d)
      CALL histwrite(nid,"fder",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, ruis,tmp2d)
      CALL histwrite(nid,"ruis",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, frtu,tmp2d)
      CALL histwrite(nid,"frtu",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, frtv,tmp2d)
      CALL histwrite(nid,"frtv",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, sicf,tmp2d)
      CALL histwrite(nid,"sicf",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      IF (ok_slab) THEN
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, tslab,tmp2d)
      CALL histwrite(nid,"tslab",itap,tmp2d,iim*(jjm+1),ndex2d)
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, sice,tmp2d)
      CALL histwrite(nid,"sice",itap,tmp2d,iim*(jjm+1),ndex2d)
      ENDIF
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, cldl,tmp2d)
      CALL histwrite(nid,"cldl",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, cldm,tmp2d)
      CALL histwrite(nid,"cldm",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, cldh,tmp2d)
      CALL histwrite(nid,"cldh",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, cldt,tmp2d)
      CALL histwrite(nid,"cldt",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, cldq,tmp2d)
      CALL histwrite(nid,"cldq",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, slp,tmp2d)
      CALL histwrite(nid,"slp",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, t2m,tmp2d)
      CALL histwrite(nid,"t2m",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, q2m,tmp2d)
      CALL histwrite(nid,"q2m",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, u10m,tmp2d)
      CALL histwrite(nid,"u10m",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, v10m,tmp2d)
      CALL histwrite(nid,"v10m",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, ue,tmp2d)
      CALL histwrite(nid,"ue",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, ve,tmp2d)
      CALL histwrite(nid,"ve",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, uq,tmp2d)
      CALL histwrite(nid,"uq",itap,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1, klon,iim,jjm+1, vq,tmp2d)
      CALL histwrite(nid,"vq",itap,tmp2d,iim*(jjm+1),ndex2d)
c
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, temp, tmp3d)
      CALL histwrite(nid,"temp",itap,tmp3d,iim*(jjm+1)*klev,ndex3d)
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, ovap, tmp3d)
      CALL histwrite(nid,"ovap",itap,tmp3d,iim*(jjm+1)*klev,ndex3d)
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, geop, tmp3d)
      CALL histwrite(nid,"geop",itap,tmp3d,iim*(jjm+1)*klev,ndex3d)
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, vitu, tmp3d)
      CALL histwrite(nid,"vitu",itap,tmp3d,iim*(jjm+1)*klev,ndex3d)
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, vitv, tmp3d)
      CALL histwrite(nid,"vitv",itap,tmp3d,iim*(jjm+1)*klev,ndex3d)
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, vitw, tmp3d)
      CALL histwrite(nid,"vitw",itap,tmp3d,iim*(jjm+1)*klev,ndex3d)
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, pres, tmp3d)
      CALL histwrite(nid,"pres",itap,tmp3d,iim*(jjm+1)*klev,ndex3d)
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, rneb, tmp3d)
      CALL histwrite(nid,"rneb",itap,tmp3d, iim*(jjm+1)*klev,ndex3d)
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, rhum, tmp3d)
      CALL histwrite(nid,"rhum",itap,tmp3d, iim*(jjm+1)*klev,ndex3d)
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, oliq, tmp3d)
      CALL histwrite(nid,"oliq",itap,tmp3d, iim*(jjm+1)*klev,ndex3d)
c
      RETURN
      END
      SUBROUTINE histtnd(filename,itap,freq,dtime,
     &           phis,aire,rlon,rlat,presnivs,
     &           pres,dtdyn,dqdyn,dtcon,dqcon,
     &           dtlsc,dqlsc,dtvdf,dqvdf,
     &           dteva,dqeva,dtajs,dqajs,
     &           heat,heat0,cool,cool0)
      IMPLICIT none
#include "dimensions.h"
#include "dimphy.h"
! Parametres d'entree
      CHARACTER*(*) filename
      INTEGER itap
      REAL freq, dtime
      REAL phis(klon),aire(klon),rlon(klon),rlat(klon),presnivs(klev)
      REAL dtdyn(klon,klev), dqdyn(klon,klev)
      REAL dtcon(klon,klev), dqcon(klon,klev)
      REAL dtlsc(klon,klev), dqlsc(klon,klev)
      REAL dtvdf(klon,klev), dqvdf(klon,klev)
      REAL dteva(klon,klev), dqeva(klon,klev)
      REAL dtajs(klon,klev), dqajs(klon,klev)
      REAL heat(klon,klev), heat0(klon,klev)
      REAL cool(klon,klev), cool0(klon,klev)
      REAL pres(klon,klev)

      LOGICAL first_appel 
      SAVE first_appel
      INTEGER nid, nhori, nvert
      SAVE nid, nhori, nvert

! variable tampon pour convertir la grille physique
      REAL tmp2d(iim,jjm+1), tmp3d(iim,jjm+1,klev)
      REAL tmp_lat(iim,jjm+1), tmp_lon(iim,jjm+1)
      REAL zx_lon(iim), zx_lat(jjm+1)
      INTEGER ndex2d(iim*(jjm+1)), ndex3d(iim*(jjm+1)*klev)

      INTEGER i, j, itau_w
      REAL zjulian, zsto, zout
!
      DATA first_appel /.TRUE./

      itau_w = itap
      DO i = 1, iim*(jjm+1)
      ndex2d(i) = 0
      ENDDO
      DO i = 1, iim*(jjm+1)*klev
      ndex3d(i) = 0
      ENDDO

      IF (first_appel) THEN
!
! initialisation sorties netcdf
!
      CALL ymds2ju(1900, 1, 1, 0.0, zjulian) 
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,rlon,tmp_lon)
      DO i = 1, iim
        tmp_lon(i,1) = rlon(i+1)
        tmp_lon(i,jjm+1) = rlon(i+1)
      ENDDO
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,rlat,tmp_lat)
      DO i = 1, iim
         zx_lon(i) = tmp_lon(i,1)
      ENDDO
      DO j = 1, jjm+1
         zx_lat(j) = tmp_lat(1,j)
      ENDDO
      CALL histbeg(filename,iim,zx_lon,jjm+1,
     &             zx_lat,1,iim,1,jjm+1,0,zjulian,
     &             dtime,nhori,nid)
      CALL histvert(nid, "presnivs", "Vertical levels", "mb",
     .              klev, presnivs, nvert)

      zsto = dtime
      zout = dtime

      CALL histdef(nid, 'nav_lon','Longitudes',"Degrees",
     & iim, jjm+1, nhori, 1, 1, 1, -99, 32, "once", zsto,zout)
      CALL histdef(nid, 'nav_lat','Latitudes',"Degrees",
     & iim, jjm+1, nhori, 1, 1, 1, -99, 32, "once", zsto,zout)
      CALL histdef(nid, 'phis','Surface geopotential',"m",
     & iim, jjm+1, nhori, 1, 1, 1, -99, 32, "once(X/9.81)", zsto,zout)
      CALL histdef(nid, 'aire','Grid area',"m2",
     & iim, jjm+1, nhori, 1, 1, 1, -99, 32, "once", zsto,zout)

      zsto = dtime
      zout = dtime * FLOAT(NINT(86400./dtime*freq))

c
      CALL histdef(nid, "pres", "Air pressure", "Pa",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "dtdyn", "Dynamics dT", "K/s",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "dqdyn", "Dynamics dQ", "Kg/Kg/s",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "dtcon", "Convection dT", "K/s",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "dqcon", "Convection dQ", "Kg/Kg/s",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "dtlsc", "Condensation dT", "K/s",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "dqlsc", "Condensation dQ", "Kg/Kg/s",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "dtvdf", "Boundary-layer dT", "K/s",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "dqvdf", "Boundary-layer dQ", "Kg/Kg/s",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "dteva", "Reevaporation dT", "K/s",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "dqeva", "Reevaporation dQ", "Kg/Kg/s",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "dtajs", "Dry adjust. dT", "K/s",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "dqajs", "Dry adjust. dQ", "Kg/Kg/s",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "dtswr", "SW radiation dT", "K/s",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "dtsw0", "SW radiation dT", "K/s",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "dtlwr", "LW radiation dT", "K/s",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "dtlw0", "LW radiation dT", "K/s",
     .     iim,jjm+1,nhori, klev,1,klev,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histend(nid) 
c
      CALL histwrite(nid,"nav_lon",itau_w,tmp_lon,iim*(jjm+1),ndex2d)
      CALL histwrite(nid,"nav_lat",itau_w,tmp_lat,iim*(jjm+1),ndex2d)
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,phis,tmp2d)
      CALL histwrite(nid,"phis",itau_w,tmp2d,iim*(jjm+1),ndex2d)
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,aire,tmp2d)
      CALL histwrite(nid,"aire",itau_w,tmp2d,iim*(jjm+1),ndex2d)

      first_appel = .FALSE.

      ENDIF ! fin if (first_appel) 
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, pres, tmp3d)
      CALL histwrite(nid,"pres",itap,tmp3d,iim*(jjm+1)*klev,ndex3d)
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, dtdyn, tmp3d)
      CALL histwrite(nid,"dtdyn",itap,tmp3d, iim*(jjm+1)*klev,ndex3d)
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, dqdyn, tmp3d)
      CALL histwrite(nid,"dqdyn",itap,tmp3d, iim*(jjm+1)*klev,ndex3d)
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, dtcon, tmp3d)
      CALL histwrite(nid,"dtcon",itap,tmp3d, iim*(jjm+1)*klev,ndex3d)
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, dqcon, tmp3d)
      CALL histwrite(nid,"dqcon",itap,tmp3d, iim*(jjm+1)*klev,ndex3d)
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, dtlsc, tmp3d)
      CALL histwrite(nid,"dtlsc",itap,tmp3d, iim*(jjm+1)*klev,ndex3d)
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, dqlsc, tmp3d)
      CALL histwrite(nid,"dqlsc",itap,tmp3d, iim*(jjm+1)*klev,ndex3d)
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, dtvdf, tmp3d)
      CALL histwrite(nid,"dtvdf",itap,tmp3d, iim*(jjm+1)*klev,ndex3d)
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, dqvdf, tmp3d)
      CALL histwrite(nid,"dqvdf",itap,tmp3d, iim*(jjm+1)*klev,ndex3d)
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, dteva, tmp3d)
      CALL histwrite(nid,"dteva",itap,tmp3d, iim*(jjm+1)*klev,ndex3d)
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, dqeva, tmp3d)
      CALL histwrite(nid,"dqeva",itap,tmp3d, iim*(jjm+1)*klev,ndex3d)
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, dtajs, tmp3d)
      CALL histwrite(nid,"dtajs",itap,tmp3d, iim*(jjm+1)*klev,ndex3d)
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, dqajs, tmp3d)
      CALL histwrite(nid,"dqajs",itap,tmp3d, iim*(jjm+1)*klev,ndex3d)
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, heat, tmp3d)
      CALL histwrite(nid,"dtswr",itap,tmp3d, iim*(jjm+1)*klev,ndex3d)
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, heat0, tmp3d)
      CALL histwrite(nid,"dtsw0",itap,tmp3d, iim*(jjm+1)*klev,ndex3d)
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, cool, tmp3d)
      CALL histwrite(nid,"dtlwr",itap,tmp3d, iim*(jjm+1)*klev,ndex3d)
c
      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, cool0, tmp3d)
      CALL histwrite(nid,"dtlw0",itap,tmp3d, iim*(jjm+1)*klev,ndex3d)
c
      RETURN
      END
      SUBROUTINE histins(filename,itap,freq,dtime,lstd,tmp3d,ndex3d,
     &           phis,aire,rlon,rlat,presnivs,
     &           rain,snow,psol,slp,t2m,q2m,u10m,v10m,
     &           temp,ovap,geop,vitu,vitv)
      IMPLICIT none
#include "dimensions.h"
#include "dimphy.h"
! Parametres d'entree
      CHARACTER*(*) filename
      INTEGER itap, lstd
      REAL freq, dtime
      REAL phis(klon),aire(klon),rlon(klon),rlat(klon),presnivs(lstd)
      REAL rain(klon),snow(klon)
      REAL psol(klon), slp(klon)
      REAL t2m(klon), q2m(klon), u10m(klon), v10m(klon)
      REAL temp(klon,lstd), ovap(klon,lstd), geop(klon,lstd)
      REAL vitu(klon,lstd), vitv(klon,lstd)
      INTEGER ndex3d(iim*(jjm+1)*lstd)
      REAL tmp3d(iim,jjm+1,lstd)

      LOGICAL first_appel 
      SAVE first_appel
      INTEGER nid, nhori, nvert
      SAVE nid, nhori, nvert

! variable tampon pour convertir la grille physique
      REAL tmp2d(iim,jjm+1)
      REAL tmp_lat(iim,jjm+1), tmp_lon(iim,jjm+1)
      REAL zx_lon(iim), zx_lat(jjm+1)
      INTEGER ndex2d(iim*(jjm+1))

      INTEGER i, j, itau_w
      REAL zjulian, zsto, zout
!
      DATA first_appel /.TRUE./

      itau_w = itap
      DO i = 1, iim*(jjm+1)
      ndex2d(i) = 0
      ENDDO
      DO i = 1, iim*(jjm+1)*lstd
      ndex3d(i) = 0
      ENDDO

      IF (first_appel) THEN
!
! initialisation sorties netcdf
!
      CALL ymds2ju(1900, 1, 1, 0.0, zjulian) 
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,rlon,tmp_lon)
      DO i = 1, iim
        tmp_lon(i,1) = rlon(i+1)
        tmp_lon(i,jjm+1) = rlon(i+1)
      ENDDO
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,rlat,tmp_lat)
      DO i = 1, iim
         zx_lon(i) = tmp_lon(i,1)
      ENDDO
      DO j = 1, jjm+1
         zx_lat(j) = tmp_lat(1,j)
      ENDDO
      CALL histbeg(filename,iim,zx_lon,jjm+1,
     &             zx_lat,1,iim,1,jjm+1,0,zjulian,
     &             dtime,nhori,nid)
      CALL histvert(nid, "levels", "Vertical levels", "mb",
     .              lstd, presnivs, nvert)

      zsto = dtime
      zout = dtime

      CALL histdef(nid, 'nav_lon','Longitudes',"Degrees",
     & iim, jjm+1, nhori, 1, 1, 1, -99, 32, "once", zsto,zout)
      CALL histdef(nid, 'nav_lat','Latitudes',"Degrees",
     & iim, jjm+1, nhori, 1, 1, 1, -99, 32, "once", zsto,zout)
      CALL histdef(nid, 'phis','Surface geopotential',"m",
     & iim, jjm+1, nhori, 1, 1, 1, -99, 32, "once(X/9.81)", zsto,zout)
      CALL histdef(nid, 'aire','Grid area',"m2",
     & iim, jjm+1, nhori, 1, 1, 1, -99, 32, "once", zsto,zout)

      zsto = dtime
      zout = dtime * FLOAT(NINT(86400./dtime*freq))

      CALL histdef(nid, "rain", "Rainfall rate", "mm/s",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)

      CALL histdef(nid, "snow", "Snowfall rate", "mm/s",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      zsto = dtime * FLOAT(NINT(86400./dtime*freq))
      zout = dtime * FLOAT(NINT(86400./dtime*freq))
c
      CALL histdef(nid, "psol", "Surface pressure", "Pa",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "inst(X)", zsto,zout)
c
      CALL histdef(nid, "slp", "Sea-level pressure", "Pa",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "inst(X)", zsto,zout)
c
      CALL histdef(nid, "t2m", "2-metre temperature", "K",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "inst(X)", zsto,zout)
c
      CALL histdef(nid, "q2m", "2-metre humidity", "kg/kg",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "inst(X)", zsto,zout)
c
      CALL histdef(nid, "u10m", "10-metre U wind", "m/s",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "inst(X)", zsto,zout)
c
      CALL histdef(nid, "v10m", "10-metre V wind", "m/s",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "inst(X)", zsto,zout)
c
      CALL histdef(nid, "temp", "Air temperature", "K",
     .     iim,jjm+1,nhori, lstd,1,lstd,nvert, 32, "inst(X)", zsto,zout)
c
      CALL histdef(nid, "ovap", "Specific humidity", "Kg/Kg",
     .     iim,jjm+1,nhori, lstd,1,lstd,nvert, 32, "inst(X)", zsto,zout)
c
      CALL histdef(nid, "geop", "Geopotential height", "m",
     .     iim,jjm+1,nhori, lstd,1,lstd,nvert, 32, "inst(X)", zsto,zout)
c
      CALL histdef(nid, "vitu", "Zonal wind", "m/s",
     .     iim,jjm+1,nhori, lstd,1,lstd,nvert, 32, "inst(X)", zsto,zout)
c
      CALL histdef(nid, "vitv", "Meridional wind", "m/s",
     .     iim,jjm+1,nhori, lstd,1,lstd,nvert, 32, "inst(X)", zsto,zout)
c
      CALL histend(nid) 
c
      CALL histwrite(nid,"nav_lon",itau_w,tmp_lon,iim*(jjm+1),ndex2d)
      CALL histwrite(nid,"nav_lat",itau_w,tmp_lat,iim*(jjm+1),ndex2d)
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,phis,tmp2d)
      CALL histwrite(nid,"phis",itau_w,tmp2d,iim*(jjm+1),ndex2d)
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,aire,tmp2d)
      CALL histwrite(nid,"aire",itau_w,tmp2d,iim*(jjm+1),ndex2d)

      first_appel = .FALSE.

      ENDIF ! fin if (first_appel) 

      CALL gr_fi_ecrit(1,klon,iim,jjm+1,rain,tmp2d)
      CALL histwrite(nid,"rain",itau_w,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,snow,tmp2d)
      CALL histwrite(nid,"snow",itau_w,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,psol,tmp2d)
      CALL histwrite(nid,"psol",itau_w,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,slp,tmp2d)
      CALL histwrite(nid,"slp",itau_w,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,t2m,tmp2d)
      CALL histwrite(nid,"t2m",itau_w,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,q2m,tmp2d)
      CALL histwrite(nid,"q2m",itau_w,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,u10m,tmp2d)
      CALL histwrite(nid,"u10m",itau_w,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,v10m,tmp2d)
      CALL histwrite(nid,"v10m",itau_w,tmp2d,iim*(jjm+1),ndex2d)
c
c
      CALL gr_fi_ecrit(lstd,klon,iim,jjm+1, temp, tmp3d)
      CALL histwrite(nid,"temp",itap,tmp3d,iim*(jjm+1)*lstd,ndex3d)
c
      CALL gr_fi_ecrit(lstd,klon,iim,jjm+1, ovap, tmp3d)
      CALL histwrite(nid,"ovap",itap,tmp3d,iim*(jjm+1)*lstd,ndex3d)
c
      CALL gr_fi_ecrit(lstd,klon,iim,jjm+1, geop, tmp3d)
      CALL histwrite(nid,"geop",itap,tmp3d,iim*(jjm+1)*lstd,ndex3d)
c
      CALL gr_fi_ecrit(lstd,klon,iim,jjm+1, vitu, tmp3d)
      CALL histwrite(nid,"vitu",itap,tmp3d,iim*(jjm+1)*lstd,ndex3d)
c
      CALL gr_fi_ecrit(lstd,klon,iim,jjm+1, vitv, tmp3d)
      CALL histwrite(nid,"vitv",itap,tmp3d,iim*(jjm+1)*lstd,ndex3d)
c
      RETURN
      END
      SUBROUTINE histreg(filename,itap,freq,dtime,
     &           i_deb,i_fin,j_deb,j_fin,lstd,tmp3d,ndex3d,
     &           phis,aire,rlon,rlat,presnivs,
     &           rain,snow,
     &           temp,ovap,geop,vitu,vitv)
      IMPLICIT none
#include "dimensions.h"
#include "dimphy.h"
! Parametres d'entree
      CHARACTER*(*) filename
      INTEGER itap, lstd
      INTEGER i_deb,i_fin,j_deb,j_fin
      REAL freq, dtime
      REAL phis(klon),aire(klon),rlon(klon),rlat(klon),presnivs(lstd)
      REAL rain(klon),snow(klon)
      REAL temp(klon,lstd), ovap(klon,lstd), geop(klon,lstd)
      REAL vitu(klon,lstd), vitv(klon,lstd)
      INTEGER ndex3d(iim*(jjm+1)*lstd)
      REAL tmp3d(iim,jjm+1,lstd)

      LOGICAL first_appel 
      SAVE first_appel
      INTEGER nid, nhori, nvert
      SAVE nid, nhori, nvert

! variable tampon pour convertir la grille physique
      REAL tmp2d(iim,jjm+1)
      REAL tmp_lat(iim,jjm+1), tmp_lon(iim,jjm+1)
      REAL zx_lon(iim), zx_lat(jjm+1)
      INTEGER ndex2d(iim*(jjm+1))

      INTEGER i, j, itau_w
      REAL zjulian, zsto, zout
!
      DATA first_appel /.TRUE./

      itau_w = itap
      DO i = 1, iim*(jjm+1)
      ndex2d(i) = 0
      ENDDO
      DO i = 1, iim*(jjm+1)*lstd
      ndex3d(i) = 0
      ENDDO

      IF (first_appel) THEN
!
! initialisation sorties netcdf
!
      CALL ymds2ju(1900, 1, 1, 0.0, zjulian) 
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,rlon,tmp_lon)
      DO i = 1, iim
        tmp_lon(i,1) = rlon(i+1)
        tmp_lon(i,jjm+1) = rlon(i+1)
      ENDDO
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,rlat,tmp_lat)
      DO i = 1, iim
         zx_lon(i) = tmp_lon(i,1)
      ENDDO
      DO j = 1, jjm+1
         zx_lat(j) = tmp_lat(1,j)
      ENDDO
      CALL histbeg(filename,iim,zx_lon,jjm+1,zx_lat,
     &             i_deb,i_fin-i_deb+1,j_deb,j_fin-j_deb+1,
     &             0,zjulian,dtime,nhori,nid)
      CALL histvert(nid, "levels", "Vertical levels", "mb",
     .              lstd, presnivs, nvert)

      zsto = dtime
      zout = dtime

      CALL histdef(nid, 'nav_lon','Longitudes',"Degrees",
     & iim, jjm+1, nhori, 1, 1, 1, -99, 32, "once", zsto,zout)
      CALL histdef(nid, 'nav_lat','Latitudes',"Degrees",
     & iim, jjm+1, nhori, 1, 1, 1, -99, 32, "once", zsto,zout)
      CALL histdef(nid, 'phis','Surface geopotential',"m",
     & iim, jjm+1, nhori, 1, 1, 1, -99, 32, "once(X/9.81)", zsto,zout)
      CALL histdef(nid, 'aire','Grid area',"m2",
     & iim, jjm+1, nhori, 1, 1, 1, -99, 32, "once", zsto,zout)

      zsto = dtime
      zout = dtime * FLOAT(NINT(86400./dtime*freq))

      CALL histdef(nid, "rain", "Rainfall rate", "mm/s",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)

      CALL histdef(nid, "snow", "Snowfall rate", "mm/s",
     .     iim,jjm+1,nhori, 1,1,1, -99, 32, "ave(X)", zsto,zout)
c
      zsto = dtime * FLOAT(NINT(86400./dtime*freq))
      zout = dtime * FLOAT(NINT(86400./dtime*freq))
c
      CALL histdef(nid, "temp", "Air temperature", "K",
     .     iim,jjm+1,nhori, lstd,1,lstd,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "ovap", "Specific humidity", "Kg/Kg",
     .     iim,jjm+1,nhori, lstd,1,lstd,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "geop", "Geopotential height", "m",
     .     iim,jjm+1,nhori, lstd,1,lstd,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "vitu", "Zonal wind", "m/s",
     .     iim,jjm+1,nhori, lstd,1,lstd,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histdef(nid, "vitv", "Meridional wind", "m/s",
     .     iim,jjm+1,nhori, lstd,1,lstd,nvert, 32, "ave(X)", zsto,zout)
c
      CALL histend(nid) 
c
      CALL histwrite(nid,"nav_lon",itau_w,tmp_lon,iim*(jjm+1),ndex2d)
      CALL histwrite(nid,"nav_lat",itau_w,tmp_lat,iim*(jjm+1),ndex2d)
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,phis,tmp2d)
      CALL histwrite(nid,"phis",itau_w,tmp2d,iim*(jjm+1),ndex2d)
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,aire,tmp2d)
      CALL histwrite(nid,"aire",itau_w,tmp2d,iim*(jjm+1),ndex2d)

      first_appel = .FALSE.

      ENDIF ! fin if (first_appel) 

      CALL gr_fi_ecrit(1,klon,iim,jjm+1,rain,tmp2d)
      CALL histwrite(nid,"rain",itau_w,tmp2d,iim*(jjm+1),ndex2d)
c
      CALL gr_fi_ecrit(1,klon,iim,jjm+1,snow,tmp2d)
      CALL histwrite(nid,"snow",itau_w,tmp2d,iim*(jjm+1),ndex2d)
c
c
      CALL gr_fi_ecrit(lstd,klon,iim,jjm+1, temp, tmp3d)
      CALL histwrite(nid,"temp",itap,tmp3d,iim*(jjm+1)*lstd,ndex3d)
c
      CALL gr_fi_ecrit(lstd,klon,iim,jjm+1, ovap, tmp3d)
      CALL histwrite(nid,"ovap",itap,tmp3d,iim*(jjm+1)*lstd,ndex3d)
c
      CALL gr_fi_ecrit(lstd,klon,iim,jjm+1, geop, tmp3d)
      CALL histwrite(nid,"geop",itap,tmp3d,iim*(jjm+1)*lstd,ndex3d)
c
      CALL gr_fi_ecrit(lstd,klon,iim,jjm+1, vitu, tmp3d)
      CALL histwrite(nid,"vitu",itap,tmp3d,iim*(jjm+1)*lstd,ndex3d)
c
      CALL gr_fi_ecrit(lstd,klon,iim,jjm+1, vitv, tmp3d)
      CALL histwrite(nid,"vitv",itap,tmp3d,iim*(jjm+1)*lstd,ndex3d)
c
      RETURN
      END
      SUBROUTINE gr_fi_ecrit(nfield,nlon,iim,jjmp1,fi,ecrit)
      IMPLICIT none
c
c Tranformer une variable de la grille physique a
c la grille d'ecriture
c
      INTEGER nfield,nlon,iim,jjmp1, jjm
      REAL fi(nlon,nfield), ecrit(iim,jjmp1,nfield)
c
      INTEGER i, j, n, ig
c
      jjm = jjmp1 - 1
      DO n = 1, nfield
         DO i=1,iim
            ecrit(i,1,n) = fi(1,n)
            ecrit(i,jjm+1,n) = fi(nlon,n)
         ENDDO
         DO j = 2, jjm
            ig = 2+(j-2)*iim
            DO i = 1, iim
               ecrit(i,j,n) = fi(ig-1+i,n)
            ENDDO
         ENDDO
      ENDDO
      RETURN
      END
